/*
 * @wq/leaflet 1.3.0-beta.1
 * Leaflet integration for @wq/map
 * (c) 2013-2021, S. Andrew Sheppard
 * https://wq.io/license
 */

define(['react', 'react-redux', 'redux-orm', 'redux-first-router', 'scheduler', 'react-is', 'prop-types', 'redux-first-router-link', 'regenerator-runtime', 'react-dom', 'mustache', 'leaflet', 'leaflet.markercluster'], function (React, reactRedux, reduxOrm, reduxFirstRouter, scheduler, reactIs, PropTypes, reduxFirstRouterLink, _regeneratorRuntime, ReactDOM, Mustache, L$1, leaflet_markercluster) { 'use strict';

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var React__default = /*#__PURE__*/_interopDefaultLegacy(React);
var reactIs__default = /*#__PURE__*/_interopDefaultLegacy(reactIs);
var PropTypes__default = /*#__PURE__*/_interopDefaultLegacy(PropTypes);
var _regeneratorRuntime__default = /*#__PURE__*/_interopDefaultLegacy(_regeneratorRuntime);
var ReactDOM__default = /*#__PURE__*/_interopDefaultLegacy(ReactDOM);
var Mustache__default = /*#__PURE__*/_interopDefaultLegacy(Mustache);
var L__default = /*#__PURE__*/_interopDefaultLegacy(L$1);

function _typeof(obj) {
  "@babel/helpers - typeof";

  if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
    _typeof = function (obj) {
      return typeof obj;
    };
  } else {
    _typeof = function (obj) {
      return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
    };
  }

  return _typeof(obj);
}

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
  try {
    var info = gen[key](arg);
    var value = info.value;
  } catch (error) {
    reject(error);
    return;
  }

  if (info.done) {
    resolve(value);
  } else {
    Promise.resolve(value).then(_next, _throw);
  }
}

function _asyncToGenerator(fn) {
  return function () {
    var self = this,
        args = arguments;
    return new Promise(function (resolve, reject) {
      var gen = fn.apply(self, args);

      function _next(value) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
      }

      function _throw(err) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
      }

      _next(undefined);
    });
  };
}

function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}

function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ("value" in descriptor) descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
  if (staticProps) _defineProperties(Constructor, staticProps);
  return Constructor;
}

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

function _extends() {
  _extends = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };

  return _extends.apply(this, arguments);
}

function ownKeys(object, enumerableOnly) {
  var keys = Object.keys(object);

  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    if (enumerableOnly) symbols = symbols.filter(function (sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    });
    keys.push.apply(keys, symbols);
  }

  return keys;
}

function _objectSpread2(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i] != null ? arguments[i] : {};

    if (i % 2) {
      ownKeys(Object(source), true).forEach(function (key) {
        _defineProperty(target, key, source[key]);
      });
    } else if (Object.getOwnPropertyDescriptors) {
      Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
    } else {
      ownKeys(Object(source)).forEach(function (key) {
        Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
      });
    }
  }

  return target;
}

function _inherits(subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function");
  }

  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      writable: true,
      configurable: true
    }
  });
  if (superClass) _setPrototypeOf(subClass, superClass);
}

function _getPrototypeOf(o) {
  _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
    return o.__proto__ || Object.getPrototypeOf(o);
  };
  return _getPrototypeOf(o);
}

function _setPrototypeOf(o, p) {
  _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
    o.__proto__ = p;
    return o;
  };

  return _setPrototypeOf(o, p);
}

function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !Reflect.construct) return false;
  if (Reflect.construct.sham) return false;
  if (typeof Proxy === "function") return true;

  try {
    Date.prototype.toString.call(Reflect.construct(Date, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}

function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null) return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;

  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0) continue;
    target[key] = source[key];
  }

  return target;
}

function _objectWithoutProperties(source, excluded) {
  if (source == null) return {};

  var target = _objectWithoutPropertiesLoose(source, excluded);

  var key, i;

  if (Object.getOwnPropertySymbols) {
    var sourceSymbolKeys = Object.getOwnPropertySymbols(source);

    for (i = 0; i < sourceSymbolKeys.length; i++) {
      key = sourceSymbolKeys[i];
      if (excluded.indexOf(key) >= 0) continue;
      if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
      target[key] = source[key];
    }
  }

  return target;
}

function _assertThisInitialized(self) {
  if (self === void 0) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return self;
}

function _possibleConstructorReturn(self, call) {
  if (call && (typeof call === "object" || typeof call === "function")) {
    return call;
  }

  return _assertThisInitialized(self);
}

function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();

  return function _createSuperInternal() {
    var Super = _getPrototypeOf(Derived),
        result;

    if (hasNativeReflectConstruct) {
      var NewTarget = _getPrototypeOf(this).constructor;

      result = Reflect.construct(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }

    return _possibleConstructorReturn(this, result);
  };
}

function _slicedToArray(arr, i) {
  return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest();
}

function _toConsumableArray(arr) {
  return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread();
}

function _arrayWithoutHoles(arr) {
  if (Array.isArray(arr)) return _arrayLikeToArray(arr);
}

function _arrayWithHoles(arr) {
  if (Array.isArray(arr)) return arr;
}

function _iterableToArray(iter) {
  if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter);
}

function _iterableToArrayLimit(arr, i) {
  if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return;
  var _arr = [];
  var _n = true;
  var _d = false;
  var _e = undefined;

  try {
    for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
      _arr.push(_s.value);

      if (i && _arr.length === i) break;
    }
  } catch (err) {
    _d = true;
    _e = err;
  } finally {
    try {
      if (!_n && _i["return"] != null) _i["return"]();
    } finally {
      if (_d) throw _e;
    }
  }

  return _arr;
}

function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}

function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;

  for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];

  return arr2;
}

function _nonIterableSpread() {
  throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

var _assign = function __assign() {
    _assign = Object.assign || function __assign(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];

            for (var p in s) {
                if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
        }

        return t;
    };

    return _assign.apply(this, arguments);
};

/**
 * Source: ftp://ftp.unicode.org/Public/UCD/latest/ucd/SpecialCasing.txt
 */
/**
 * Lower case as a function.
 */

function lowerCase(str) {
    return str.toLowerCase();
}

var DEFAULT_SPLIT_REGEXP = [/([a-z0-9])([A-Z])/g, /([A-Z])([A-Z][a-z])/g]; // Remove all non-word characters.

var DEFAULT_STRIP_REGEXP = /[^A-Z0-9]+/gi;
/**
 * Normalize the string into something other libraries can manipulate easier.
 */

function noCase(input, options) {
    if (options === void 0) {
        options = {};
    }

    var _a = options.splitRegexp,
        splitRegexp = _a === void 0 ? DEFAULT_SPLIT_REGEXP : _a,
        _b = options.stripRegexp,
        stripRegexp = _b === void 0 ? DEFAULT_STRIP_REGEXP : _b,
        _c = options.transform,
        transform = _c === void 0 ? lowerCase : _c,
        _d = options.delimiter,
        delimiter = _d === void 0 ? " " : _d;
    var result = replace(replace(input, splitRegexp, "$1\0$2"), stripRegexp, "\0");
    var start = 0;
    var end = result.length; // Trim the delimiter from around the output string.

    while (result.charAt(start) === "\0") {
        start++;
    }

    while (result.charAt(end - 1) === "\0") {
        end--;
    } // Transform each token independently.


    return result.slice(start, end).split("\0").map(transform).join(delimiter);
}
/**
 * Replace `re` in the input string with the replacement value.
 */

function replace(input, re, value) {
    if (re instanceof RegExp) return input.replace(re, value);
    return re.reduce(function (input, re) {
        return input.replace(re, value);
    }, input);
}

function dotCase(input, options) {
    if (options === void 0) {
        options = {};
    }

    return noCase(input, _assign({
        delimiter: "."
    }, options));
}

function paramCase(input, options) {
    if (options === void 0) {
        options = {};
    }

    return dotCase(input, _assign({
        delimiter: "-"
    }, options));
}

var isArray = Array.isArray;
var keyList = Object.keys;
var hasProp = Object.prototype.hasOwnProperty;
var hasElementType = typeof Element !== 'undefined';

function equal(a, b) {
    // fast-deep-equal index.js 2.0.1
    if (a === b) return true;

    if (a && b && _typeof(a) == 'object' && _typeof(b) == 'object') {
        var arrA = isArray(a),
            arrB = isArray(b),
            i,
            length,
            key;

        if (arrA && arrB) {
            length = a.length;
            if (length != b.length) return false;

            for (i = length; i-- !== 0;) {
                if (!equal(a[i], b[i])) return false;
            }

            return true;
        }

        if (arrA != arrB) return false;
        var dateA = a instanceof Date,
            dateB = b instanceof Date;
        if (dateA != dateB) return false;
        if (dateA && dateB) return a.getTime() == b.getTime();
        var regexpA = a instanceof RegExp,
            regexpB = b instanceof RegExp;
        if (regexpA != regexpB) return false;
        if (regexpA && regexpB) return a.toString() == b.toString();
        var keys = keyList(a);
        length = keys.length;
        if (length !== keyList(b).length) return false;

        for (i = length; i-- !== 0;) {
            if (!hasProp.call(b, keys[i])) return false;
        } // end fast-deep-equal
        // start react-fast-compare
        // custom handling for DOM elements


        if (hasElementType && a instanceof Element && b instanceof Element) return a === b; // custom handling for React

        for (i = length; i-- !== 0;) {
            key = keys[i];

            if (key === '_owner' && a.$$typeof) {
                // React-specific: avoid traversing React elements' _owner.
                //  _owner contains circular references
                // and is not needed when comparing the actual elements (and not their owners)
                // .$$typeof and ._store on just reasonable markers of a react element
                continue;
            } else {
                // all other properties should be traversed as usual
                if (!equal(a[key], b[key])) return false;
            }
        } // end react-fast-compare
        // fast-deep-equal index.js 2.0.1


        return true;
    }

    return a !== a && b !== b;
} // end fast-deep-equal


function exportedEqual(a, b) {
    try {
        return equal(a, b);
    } catch (error) {
        if (error.message && error.message.match(/stack|recursion/i) || error.number === -2146828260) {
            // warn on circular references, don't crash
            // browsers give this different errors name and messages:
            // chrome/safari: "RangeError", "Maximum call stack size exceeded"
            // firefox: "InternalError", too much recursion"
            // edge: "Error", "Out of stack space"
            console.warn('Warning: react-fast-compare does not handle circular references.', error.name, error.message);
            return false;
        } // some other error. we should definitely know about these


        throw error;
    }
}

var isMergeableObject = function isMergeableObject(value) {
    return isNonNullObject(value) && !isSpecial(value);
};

function isNonNullObject(value) {
    return !!value && _typeof(value) === 'object';
}

function isSpecial(value) {
    var stringValue = Object.prototype.toString.call(value);
    return stringValue === '[object RegExp]' || stringValue === '[object Date]' || isReactElement(value);
} // see https://github.com/facebook/react/blob/b5ac963fb791d1298e7f396236383bc955f916c1/src/isomorphic/classic/element/ReactElement.js#L21-L25


var canUseSymbol = typeof Symbol === 'function' && Symbol.for;
var REACT_ELEMENT_TYPE = canUseSymbol ? Symbol.for('react.element') : 0xeac7;

function isReactElement(value) {
    return value.$$typeof === REACT_ELEMENT_TYPE;
}

function emptyTarget(val) {
    return Array.isArray(val) ? [] : {};
}

function cloneUnlessOtherwiseSpecified(value, options) {
    return options.clone !== false && options.isMergeableObject(value) ? deepmerge(emptyTarget(value), value, options) : value;
}

function defaultArrayMerge(target, source, options) {
    return target.concat(source).map(function (element) {
        return cloneUnlessOtherwiseSpecified(element, options);
    });
}

function mergeObject(target, source, options) {
    var destination = {};

    if (options.isMergeableObject(target)) {
        Object.keys(target).forEach(function (key) {
            destination[key] = cloneUnlessOtherwiseSpecified(target[key], options);
        });
    }

    Object.keys(source).forEach(function (key) {
        if (!options.isMergeableObject(source[key]) || !target[key]) {
            destination[key] = cloneUnlessOtherwiseSpecified(source[key], options);
        } else {
            destination[key] = deepmerge(target[key], source[key], options);
        }
    });
    return destination;
}

function deepmerge(target, source, options) {
    options = options || {};
    options.arrayMerge = options.arrayMerge || defaultArrayMerge;
    options.isMergeableObject = options.isMergeableObject || isMergeableObject;
    var sourceIsArray = Array.isArray(source);
    var targetIsArray = Array.isArray(target);
    var sourceAndTargetTypesMatch = sourceIsArray === targetIsArray;

    if (!sourceAndTargetTypesMatch) {
        return cloneUnlessOtherwiseSpecified(source, options);
    } else if (sourceIsArray) {
        return options.arrayMerge(target, source, options);
    } else {
        return mergeObject(target, source, options);
    }
}

deepmerge.all = function deepmergeAll(array, options) {
    if (!Array.isArray(array)) {
        throw new Error('first argument should be an array');
    }

    return array.reduce(function (prev, next) {
        return deepmerge(prev, next, options);
    }, {});
};

var deepmerge_1 = deepmerge;

/** Detect free variable `global` from Node.js. */
var freeGlobal = (typeof global === "undefined" ? "undefined" : _typeof(global)) == 'object' && global && global.Object === Object && global;

/** Detect free variable `self`. */

var freeSelf = (typeof self === "undefined" ? "undefined" : _typeof(self)) == 'object' && self && self.Object === Object && self;
/** Used as a reference to the global object. */

var root = freeGlobal || freeSelf || Function('return this')();

/** Built-in value references. */

var _Symbol = root.Symbol;

/** Used for built-in method references. */

var objectProto = Object.prototype;
/** Used to check objects for own properties. */

var hasOwnProperty = objectProto.hasOwnProperty;
/**
 * Used to resolve the
 * [`toStringTag`](http://ecma-international.org/ecma-262/7.0/#sec-object.prototype.tostring)
 * of values.
 */

var nativeObjectToString = objectProto.toString;
/** Built-in value references. */

var symToStringTag = _Symbol ? _Symbol.toStringTag : undefined;
/**
 * A specialized version of `baseGetTag` which ignores `Symbol.toStringTag` values.
 *
 * @private
 * @param {*} value The value to query.
 * @returns {string} Returns the raw `toStringTag`.
 */

function getRawTag(value) {
    var isOwn = hasOwnProperty.call(value, symToStringTag),
        tag = value[symToStringTag];

    try {
        value[symToStringTag] = undefined;
        var unmasked = true;
    } catch (e) {}

    var result = nativeObjectToString.call(value);

    if (unmasked) {
        if (isOwn) {
            value[symToStringTag] = tag;
        } else {
            delete value[symToStringTag];
        }
    }

    return result;
}

/** Used for built-in method references. */
var objectProto$1 = Object.prototype;
/**
 * Used to resolve the
 * [`toStringTag`](http://ecma-international.org/ecma-262/7.0/#sec-object.prototype.tostring)
 * of values.
 */

var nativeObjectToString$1 = objectProto$1.toString;
/**
 * Converts `value` to a string using `Object.prototype.toString`.
 *
 * @private
 * @param {*} value The value to convert.
 * @returns {string} Returns the converted string.
 */

function objectToString(value) {
    return nativeObjectToString$1.call(value);
}

/** `Object#toString` result references. */

var nullTag = '[object Null]',
    undefinedTag = '[object Undefined]';
/** Built-in value references. */

var symToStringTag$1 = _Symbol ? _Symbol.toStringTag : undefined;
/**
 * The base implementation of `getTag` without fallbacks for buggy environments.
 *
 * @private
 * @param {*} value The value to query.
 * @returns {string} Returns the `toStringTag`.
 */

function baseGetTag(value) {
    if (value == null) {
        return value === undefined ? undefinedTag : nullTag;
    }

    return symToStringTag$1 && symToStringTag$1 in Object(value) ? getRawTag(value) : objectToString(value);
}

/**
 * Creates a unary function that invokes `func` with its argument transformed.
 *
 * @private
 * @param {Function} func The function to wrap.
 * @param {Function} transform The argument transform.
 * @returns {Function} Returns the new function.
 */
function overArg(func, transform) {
    return function (arg) {
        return func(transform(arg));
    };
}

/** Built-in value references. */

var getPrototype = overArg(Object.getPrototypeOf, Object);

/**
 * Checks if `value` is object-like. A value is object-like if it's not `null`
 * and has a `typeof` result of "object".
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is object-like, else `false`.
 * @example
 *
 * _.isObjectLike({});
 * // => true
 *
 * _.isObjectLike([1, 2, 3]);
 * // => true
 *
 * _.isObjectLike(_.noop);
 * // => false
 *
 * _.isObjectLike(null);
 * // => false
 */
function isObjectLike(value) {
    return value != null && _typeof(value) == 'object';
}

/** `Object#toString` result references. */

var objectTag = '[object Object]';
/** Used for built-in method references. */

var funcProto = Function.prototype,
    objectProto$2 = Object.prototype;
/** Used to resolve the decompiled source of functions. */

var funcToString = funcProto.toString;
/** Used to check objects for own properties. */

var hasOwnProperty$1 = objectProto$2.hasOwnProperty;
/** Used to infer the `Object` constructor. */

var objectCtorString = funcToString.call(Object);
/**
 * Checks if `value` is a plain object, that is, an object created by the
 * `Object` constructor or one with a `[[Prototype]]` of `null`.
 *
 * @static
 * @memberOf _
 * @since 0.8.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a plain object, else `false`.
 * @example
 *
 * function Foo() {
 *   this.a = 1;
 * }
 *
 * _.isPlainObject(new Foo);
 * // => false
 *
 * _.isPlainObject([1, 2, 3]);
 * // => false
 *
 * _.isPlainObject({ 'x': 0, 'y': 0 });
 * // => true
 *
 * _.isPlainObject(Object.create(null));
 * // => true
 */

function isPlainObject(value) {
    if (!isObjectLike(value) || baseGetTag(value) != objectTag) {
        return false;
    }

    var proto = getPrototype(value);

    if (proto === null) {
        return true;
    }

    var Ctor = hasOwnProperty$1.call(proto, 'constructor') && proto.constructor;
    return typeof Ctor == 'function' && Ctor instanceof Ctor && funcToString.call(Ctor) == objectCtorString;
}

/**
 * Removes all key-value entries from the list cache.
 *
 * @private
 * @name clear
 * @memberOf ListCache
 */
function listCacheClear() {
    this.__data__ = [];
    this.size = 0;
}

/**
 * Performs a
 * [`SameValueZero`](http://ecma-international.org/ecma-262/7.0/#sec-samevaluezero)
 * comparison between two values to determine if they are equivalent.
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to compare.
 * @param {*} other The other value to compare.
 * @returns {boolean} Returns `true` if the values are equivalent, else `false`.
 * @example
 *
 * var object = { 'a': 1 };
 * var other = { 'a': 1 };
 *
 * _.eq(object, object);
 * // => true
 *
 * _.eq(object, other);
 * // => false
 *
 * _.eq('a', 'a');
 * // => true
 *
 * _.eq('a', Object('a'));
 * // => false
 *
 * _.eq(NaN, NaN);
 * // => true
 */
function eq(value, other) {
    return value === other || value !== value && other !== other;
}

/**
 * Gets the index at which the `key` is found in `array` of key-value pairs.
 *
 * @private
 * @param {Array} array The array to inspect.
 * @param {*} key The key to search for.
 * @returns {number} Returns the index of the matched value, else `-1`.
 */

function assocIndexOf(array, key) {
    var length = array.length;

    while (length--) {
        if (eq(array[length][0], key)) {
            return length;
        }
    }

    return -1;
}

/** Used for built-in method references. */

var arrayProto = Array.prototype;
/** Built-in value references. */

var splice = arrayProto.splice;
/**
 * Removes `key` and its value from the list cache.
 *
 * @private
 * @name delete
 * @memberOf ListCache
 * @param {string} key The key of the value to remove.
 * @returns {boolean} Returns `true` if the entry was removed, else `false`.
 */

function listCacheDelete(key) {
    var data = this.__data__,
        index = assocIndexOf(data, key);

    if (index < 0) {
        return false;
    }

    var lastIndex = data.length - 1;

    if (index == lastIndex) {
        data.pop();
    } else {
        splice.call(data, index, 1);
    }

    --this.size;
    return true;
}

/**
 * Gets the list cache value for `key`.
 *
 * @private
 * @name get
 * @memberOf ListCache
 * @param {string} key The key of the value to get.
 * @returns {*} Returns the entry value.
 */

function listCacheGet(key) {
    var data = this.__data__,
        index = assocIndexOf(data, key);
    return index < 0 ? undefined : data[index][1];
}

/**
 * Checks if a list cache value for `key` exists.
 *
 * @private
 * @name has
 * @memberOf ListCache
 * @param {string} key The key of the entry to check.
 * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
 */

function listCacheHas(key) {
    return assocIndexOf(this.__data__, key) > -1;
}

/**
 * Sets the list cache `key` to `value`.
 *
 * @private
 * @name set
 * @memberOf ListCache
 * @param {string} key The key of the value to set.
 * @param {*} value The value to set.
 * @returns {Object} Returns the list cache instance.
 */

function listCacheSet(key, value) {
    var data = this.__data__,
        index = assocIndexOf(data, key);

    if (index < 0) {
        ++this.size;
        data.push([key, value]);
    } else {
        data[index][1] = value;
    }

    return this;
}

/**
 * Creates an list cache object.
 *
 * @private
 * @constructor
 * @param {Array} [entries] The key-value pairs to cache.
 */

function ListCache(entries) {
    var index = -1,
        length = entries == null ? 0 : entries.length;
    this.clear();

    while (++index < length) {
        var entry = entries[index];
        this.set(entry[0], entry[1]);
    }
} // Add methods to `ListCache`.


ListCache.prototype.clear = listCacheClear;
ListCache.prototype['delete'] = listCacheDelete;
ListCache.prototype.get = listCacheGet;
ListCache.prototype.has = listCacheHas;
ListCache.prototype.set = listCacheSet;

/**
 * Removes all key-value entries from the stack.
 *
 * @private
 * @name clear
 * @memberOf Stack
 */

function stackClear() {
    this.__data__ = new ListCache();
    this.size = 0;
}

/**
 * Removes `key` and its value from the stack.
 *
 * @private
 * @name delete
 * @memberOf Stack
 * @param {string} key The key of the value to remove.
 * @returns {boolean} Returns `true` if the entry was removed, else `false`.
 */
function stackDelete(key) {
    var data = this.__data__,
        result = data['delete'](key);
    this.size = data.size;
    return result;
}

/**
 * Gets the stack value for `key`.
 *
 * @private
 * @name get
 * @memberOf Stack
 * @param {string} key The key of the value to get.
 * @returns {*} Returns the entry value.
 */
function stackGet(key) {
    return this.__data__.get(key);
}

/**
 * Checks if a stack value for `key` exists.
 *
 * @private
 * @name has
 * @memberOf Stack
 * @param {string} key The key of the entry to check.
 * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
 */
function stackHas(key) {
    return this.__data__.has(key);
}

/**
 * Checks if `value` is the
 * [language type](http://www.ecma-international.org/ecma-262/7.0/#sec-ecmascript-language-types)
 * of `Object`. (e.g. arrays, functions, objects, regexes, `new Number(0)`, and `new String('')`)
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is an object, else `false`.
 * @example
 *
 * _.isObject({});
 * // => true
 *
 * _.isObject([1, 2, 3]);
 * // => true
 *
 * _.isObject(_.noop);
 * // => true
 *
 * _.isObject(null);
 * // => false
 */
function isObject(value) {
    var type = _typeof(value);

    return value != null && (type == 'object' || type == 'function');
}

/** `Object#toString` result references. */

var asyncTag = '[object AsyncFunction]',
    funcTag = '[object Function]',
    genTag = '[object GeneratorFunction]',
    proxyTag = '[object Proxy]';
/**
 * Checks if `value` is classified as a `Function` object.
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a function, else `false`.
 * @example
 *
 * _.isFunction(_);
 * // => true
 *
 * _.isFunction(/abc/);
 * // => false
 */

function isFunction(value) {
    if (!isObject(value)) {
        return false;
    } // The use of `Object#toString` avoids issues with the `typeof` operator
    // in Safari 9 which returns 'object' for typed arrays and other constructors.


    var tag = baseGetTag(value);
    return tag == funcTag || tag == genTag || tag == asyncTag || tag == proxyTag;
}

/** Used to detect overreaching core-js shims. */

var coreJsData = root['__core-js_shared__'];

/** Used to detect methods masquerading as native. */

var maskSrcKey = function () {
    var uid = /[^.]+$/.exec(coreJsData && coreJsData.keys && coreJsData.keys.IE_PROTO || '');
    return uid ? 'Symbol(src)_1.' + uid : '';
}();
/**
 * Checks if `func` has its source masked.
 *
 * @private
 * @param {Function} func The function to check.
 * @returns {boolean} Returns `true` if `func` is masked, else `false`.
 */


function isMasked(func) {
    return !!maskSrcKey && maskSrcKey in func;
}

/** Used for built-in method references. */
var funcProto$1 = Function.prototype;
/** Used to resolve the decompiled source of functions. */

var funcToString$1 = funcProto$1.toString;
/**
 * Converts `func` to its source code.
 *
 * @private
 * @param {Function} func The function to convert.
 * @returns {string} Returns the source code.
 */

function toSource(func) {
    if (func != null) {
        try {
            return funcToString$1.call(func);
        } catch (e) {}

        try {
            return func + '';
        } catch (e) {}
    }

    return '';
}

/**
 * Used to match `RegExp`
 * [syntax characters](http://ecma-international.org/ecma-262/7.0/#sec-patterns).
 */

var reRegExpChar = /[\\^$.*+?()[\]{}|]/g;
/** Used to detect host constructors (Safari). */

var reIsHostCtor = /^\[object .+?Constructor\]$/;
/** Used for built-in method references. */

var funcProto$2 = Function.prototype,
    objectProto$3 = Object.prototype;
/** Used to resolve the decompiled source of functions. */

var funcToString$2 = funcProto$2.toString;
/** Used to check objects for own properties. */

var hasOwnProperty$2 = objectProto$3.hasOwnProperty;
/** Used to detect if a method is native. */

var reIsNative = RegExp('^' + funcToString$2.call(hasOwnProperty$2).replace(reRegExpChar, '\\$&').replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, '$1.*?') + '$');
/**
 * The base implementation of `_.isNative` without bad shim checks.
 *
 * @private
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a native function,
 *  else `false`.
 */

function baseIsNative(value) {
    if (!isObject(value) || isMasked(value)) {
        return false;
    }

    var pattern = isFunction(value) ? reIsNative : reIsHostCtor;
    return pattern.test(toSource(value));
}

/**
 * Gets the value at `key` of `object`.
 *
 * @private
 * @param {Object} [object] The object to query.
 * @param {string} key The key of the property to get.
 * @returns {*} Returns the property value.
 */
function getValue(object, key) {
    return object == null ? undefined : object[key];
}

/**
 * Gets the native function at `key` of `object`.
 *
 * @private
 * @param {Object} object The object to query.
 * @param {string} key The key of the method to get.
 * @returns {*} Returns the function if it's native, else `undefined`.
 */

function getNative(object, key) {
    var value = getValue(object, key);
    return baseIsNative(value) ? value : undefined;
}

/* Built-in method references that are verified to be native. */

var Map = getNative(root, 'Map');

/* Built-in method references that are verified to be native. */

var nativeCreate = getNative(Object, 'create');

/**
 * Removes all key-value entries from the hash.
 *
 * @private
 * @name clear
 * @memberOf Hash
 */

function hashClear() {
    this.__data__ = nativeCreate ? nativeCreate(null) : {};
    this.size = 0;
}

/**
 * Removes `key` and its value from the hash.
 *
 * @private
 * @name delete
 * @memberOf Hash
 * @param {Object} hash The hash to modify.
 * @param {string} key The key of the value to remove.
 * @returns {boolean} Returns `true` if the entry was removed, else `false`.
 */
function hashDelete(key) {
    var result = this.has(key) && delete this.__data__[key];
    this.size -= result ? 1 : 0;
    return result;
}

/** Used to stand-in for `undefined` hash values. */

var HASH_UNDEFINED = '__lodash_hash_undefined__';
/** Used for built-in method references. */

var objectProto$4 = Object.prototype;
/** Used to check objects for own properties. */

var hasOwnProperty$3 = objectProto$4.hasOwnProperty;
/**
 * Gets the hash value for `key`.
 *
 * @private
 * @name get
 * @memberOf Hash
 * @param {string} key The key of the value to get.
 * @returns {*} Returns the entry value.
 */

function hashGet(key) {
    var data = this.__data__;

    if (nativeCreate) {
        var result = data[key];
        return result === HASH_UNDEFINED ? undefined : result;
    }

    return hasOwnProperty$3.call(data, key) ? data[key] : undefined;
}

/** Used for built-in method references. */

var objectProto$5 = Object.prototype;
/** Used to check objects for own properties. */

var hasOwnProperty$4 = objectProto$5.hasOwnProperty;
/**
 * Checks if a hash value for `key` exists.
 *
 * @private
 * @name has
 * @memberOf Hash
 * @param {string} key The key of the entry to check.
 * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
 */

function hashHas(key) {
    var data = this.__data__;
    return nativeCreate ? data[key] !== undefined : hasOwnProperty$4.call(data, key);
}

/** Used to stand-in for `undefined` hash values. */

var HASH_UNDEFINED$1 = '__lodash_hash_undefined__';
/**
 * Sets the hash `key` to `value`.
 *
 * @private
 * @name set
 * @memberOf Hash
 * @param {string} key The key of the value to set.
 * @param {*} value The value to set.
 * @returns {Object} Returns the hash instance.
 */

function hashSet(key, value) {
    var data = this.__data__;
    this.size += this.has(key) ? 0 : 1;
    data[key] = nativeCreate && value === undefined ? HASH_UNDEFINED$1 : value;
    return this;
}

/**
 * Creates a hash object.
 *
 * @private
 * @constructor
 * @param {Array} [entries] The key-value pairs to cache.
 */

function Hash(entries) {
    var index = -1,
        length = entries == null ? 0 : entries.length;
    this.clear();

    while (++index < length) {
        var entry = entries[index];
        this.set(entry[0], entry[1]);
    }
} // Add methods to `Hash`.


Hash.prototype.clear = hashClear;
Hash.prototype['delete'] = hashDelete;
Hash.prototype.get = hashGet;
Hash.prototype.has = hashHas;
Hash.prototype.set = hashSet;

/**
 * Removes all key-value entries from the map.
 *
 * @private
 * @name clear
 * @memberOf MapCache
 */

function mapCacheClear() {
    this.size = 0;
    this.__data__ = {
        'hash': new Hash(),
        'map': new (Map || ListCache)(),
        'string': new Hash()
    };
}

/**
 * Checks if `value` is suitable for use as unique object key.
 *
 * @private
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is suitable, else `false`.
 */
function isKeyable(value) {
    var type = _typeof(value);

    return type == 'string' || type == 'number' || type == 'symbol' || type == 'boolean' ? value !== '__proto__' : value === null;
}

/**
 * Gets the data for `map`.
 *
 * @private
 * @param {Object} map The map to query.
 * @param {string} key The reference key.
 * @returns {*} Returns the map data.
 */

function getMapData(map, key) {
    var data = map.__data__;
    return isKeyable(key) ? data[typeof key == 'string' ? 'string' : 'hash'] : data.map;
}

/**
 * Removes `key` and its value from the map.
 *
 * @private
 * @name delete
 * @memberOf MapCache
 * @param {string} key The key of the value to remove.
 * @returns {boolean} Returns `true` if the entry was removed, else `false`.
 */

function mapCacheDelete(key) {
    var result = getMapData(this, key)['delete'](key);
    this.size -= result ? 1 : 0;
    return result;
}

/**
 * Gets the map value for `key`.
 *
 * @private
 * @name get
 * @memberOf MapCache
 * @param {string} key The key of the value to get.
 * @returns {*} Returns the entry value.
 */

function mapCacheGet(key) {
    return getMapData(this, key).get(key);
}

/**
 * Checks if a map value for `key` exists.
 *
 * @private
 * @name has
 * @memberOf MapCache
 * @param {string} key The key of the entry to check.
 * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
 */

function mapCacheHas(key) {
    return getMapData(this, key).has(key);
}

/**
 * Sets the map `key` to `value`.
 *
 * @private
 * @name set
 * @memberOf MapCache
 * @param {string} key The key of the value to set.
 * @param {*} value The value to set.
 * @returns {Object} Returns the map cache instance.
 */

function mapCacheSet(key, value) {
    var data = getMapData(this, key),
        size = data.size;
    data.set(key, value);
    this.size += data.size == size ? 0 : 1;
    return this;
}

/**
 * Creates a map cache object to store key-value pairs.
 *
 * @private
 * @constructor
 * @param {Array} [entries] The key-value pairs to cache.
 */

function MapCache(entries) {
    var index = -1,
        length = entries == null ? 0 : entries.length;
    this.clear();

    while (++index < length) {
        var entry = entries[index];
        this.set(entry[0], entry[1]);
    }
} // Add methods to `MapCache`.


MapCache.prototype.clear = mapCacheClear;
MapCache.prototype['delete'] = mapCacheDelete;
MapCache.prototype.get = mapCacheGet;
MapCache.prototype.has = mapCacheHas;
MapCache.prototype.set = mapCacheSet;

/** Used as the size to enable large array optimizations. */

var LARGE_ARRAY_SIZE = 200;
/**
 * Sets the stack `key` to `value`.
 *
 * @private
 * @name set
 * @memberOf Stack
 * @param {string} key The key of the value to set.
 * @param {*} value The value to set.
 * @returns {Object} Returns the stack cache instance.
 */

function stackSet(key, value) {
    var data = this.__data__;

    if (data instanceof ListCache) {
        var pairs = data.__data__;

        if (!Map || pairs.length < LARGE_ARRAY_SIZE - 1) {
            pairs.push([key, value]);
            this.size = ++data.size;
            return this;
        }

        data = this.__data__ = new MapCache(pairs);
    }

    data.set(key, value);
    this.size = data.size;
    return this;
}

/**
 * Creates a stack cache object to store key-value pairs.
 *
 * @private
 * @constructor
 * @param {Array} [entries] The key-value pairs to cache.
 */

function Stack(entries) {
    var data = this.__data__ = new ListCache(entries);
    this.size = data.size;
} // Add methods to `Stack`.


Stack.prototype.clear = stackClear;
Stack.prototype['delete'] = stackDelete;
Stack.prototype.get = stackGet;
Stack.prototype.has = stackHas;
Stack.prototype.set = stackSet;

/**
 * A specialized version of `_.forEach` for arrays without support for
 * iteratee shorthands.
 *
 * @private
 * @param {Array} [array] The array to iterate over.
 * @param {Function} iteratee The function invoked per iteration.
 * @returns {Array} Returns `array`.
 */
function arrayEach(array, iteratee) {
    var index = -1,
        length = array == null ? 0 : array.length;

    while (++index < length) {
        if (iteratee(array[index], index, array) === false) {
            break;
        }
    }

    return array;
}

var defineProperty = function () {
    try {
        var func = getNative(Object, 'defineProperty');
        func({}, '', {});
        return func;
    } catch (e) {}
}();

/**
 * The base implementation of `assignValue` and `assignMergeValue` without
 * value checks.
 *
 * @private
 * @param {Object} object The object to modify.
 * @param {string} key The key of the property to assign.
 * @param {*} value The value to assign.
 */

function baseAssignValue(object, key, value) {
    if (key == '__proto__' && defineProperty) {
        defineProperty(object, key, {
            'configurable': true,
            'enumerable': true,
            'value': value,
            'writable': true
        });
    } else {
        object[key] = value;
    }
}

/** Used for built-in method references. */

var objectProto$6 = Object.prototype;
/** Used to check objects for own properties. */

var hasOwnProperty$5 = objectProto$6.hasOwnProperty;
/**
 * Assigns `value` to `key` of `object` if the existing value is not equivalent
 * using [`SameValueZero`](http://ecma-international.org/ecma-262/7.0/#sec-samevaluezero)
 * for equality comparisons.
 *
 * @private
 * @param {Object} object The object to modify.
 * @param {string} key The key of the property to assign.
 * @param {*} value The value to assign.
 */

function assignValue(object, key, value) {
    var objValue = object[key];

    if (!(hasOwnProperty$5.call(object, key) && eq(objValue, value)) || value === undefined && !(key in object)) {
        baseAssignValue(object, key, value);
    }
}

/**
 * Copies properties of `source` to `object`.
 *
 * @private
 * @param {Object} source The object to copy properties from.
 * @param {Array} props The property identifiers to copy.
 * @param {Object} [object={}] The object to copy properties to.
 * @param {Function} [customizer] The function to customize copied values.
 * @returns {Object} Returns `object`.
 */

function copyObject(source, props, object, customizer) {
    var isNew = !object;
    object || (object = {});
    var index = -1,
        length = props.length;

    while (++index < length) {
        var key = props[index];
        var newValue = customizer ? customizer(object[key], source[key], key, object, source) : undefined;

        if (newValue === undefined) {
            newValue = source[key];
        }

        if (isNew) {
            baseAssignValue(object, key, newValue);
        } else {
            assignValue(object, key, newValue);
        }
    }

    return object;
}

/**
 * The base implementation of `_.times` without support for iteratee shorthands
 * or max array length checks.
 *
 * @private
 * @param {number} n The number of times to invoke `iteratee`.
 * @param {Function} iteratee The function invoked per iteration.
 * @returns {Array} Returns the array of results.
 */
function baseTimes(n, iteratee) {
    var index = -1,
        result = Array(n);

    while (++index < n) {
        result[index] = iteratee(index);
    }

    return result;
}

/** `Object#toString` result references. */

var argsTag = '[object Arguments]';
/**
 * The base implementation of `_.isArguments`.
 *
 * @private
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is an `arguments` object,
 */

function baseIsArguments(value) {
    return isObjectLike(value) && baseGetTag(value) == argsTag;
}

/** Used for built-in method references. */

var objectProto$7 = Object.prototype;
/** Used to check objects for own properties. */

var hasOwnProperty$6 = objectProto$7.hasOwnProperty;
/** Built-in value references. */

var propertyIsEnumerable = objectProto$7.propertyIsEnumerable;
/**
 * Checks if `value` is likely an `arguments` object.
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is an `arguments` object,
 *  else `false`.
 * @example
 *
 * _.isArguments(function() { return arguments; }());
 * // => true
 *
 * _.isArguments([1, 2, 3]);
 * // => false
 */

var isArguments = baseIsArguments(function () {
    return arguments;
}()) ? baseIsArguments : function (value) {
    return isObjectLike(value) && hasOwnProperty$6.call(value, 'callee') && !propertyIsEnumerable.call(value, 'callee');
};

/**
 * Checks if `value` is classified as an `Array` object.
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is an array, else `false`.
 * @example
 *
 * _.isArray([1, 2, 3]);
 * // => true
 *
 * _.isArray(document.body.children);
 * // => false
 *
 * _.isArray('abc');
 * // => false
 *
 * _.isArray(_.noop);
 * // => false
 */
var isArray$1 = Array.isArray;

/**
 * This method returns `false`.
 *
 * @static
 * @memberOf _
 * @since 4.13.0
 * @category Util
 * @returns {boolean} Returns `false`.
 * @example
 *
 * _.times(2, _.stubFalse);
 * // => [false, false]
 */
function stubFalse() {
    return false;
}

/** Detect free variable `exports`. */

var freeExports = (typeof exports === "undefined" ? "undefined" : _typeof(exports)) == 'object' && exports && !exports.nodeType && exports;
/** Detect free variable `module`. */

var freeModule = freeExports && (typeof module === "undefined" ? "undefined" : _typeof(module)) == 'object' && module && !module.nodeType && module;
/** Detect the popular CommonJS extension `module.exports`. */

var moduleExports = freeModule && freeModule.exports === freeExports;
/** Built-in value references. */

var Buffer = moduleExports ? root.Buffer : undefined;
/* Built-in method references for those with the same name as other `lodash` methods. */

var nativeIsBuffer = Buffer ? Buffer.isBuffer : undefined;
/**
 * Checks if `value` is a buffer.
 *
 * @static
 * @memberOf _
 * @since 4.3.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a buffer, else `false`.
 * @example
 *
 * _.isBuffer(new Buffer(2));
 * // => true
 *
 * _.isBuffer(new Uint8Array(2));
 * // => false
 */

var isBuffer = nativeIsBuffer || stubFalse;

/** Used as references for various `Number` constants. */
var MAX_SAFE_INTEGER = 9007199254740991;
/** Used to detect unsigned integer values. */

var reIsUint = /^(?:0|[1-9]\d*)$/;
/**
 * Checks if `value` is a valid array-like index.
 *
 * @private
 * @param {*} value The value to check.
 * @param {number} [length=MAX_SAFE_INTEGER] The upper bounds of a valid index.
 * @returns {boolean} Returns `true` if `value` is a valid index, else `false`.
 */

function isIndex(value, length) {
    var type = _typeof(value);

    length = length == null ? MAX_SAFE_INTEGER : length;
    return !!length && (type == 'number' || type != 'symbol' && reIsUint.test(value)) && value > -1 && value % 1 == 0 && value < length;
}

/** Used as references for various `Number` constants. */
var MAX_SAFE_INTEGER$1 = 9007199254740991;
/**
 * Checks if `value` is a valid array-like length.
 *
 * **Note:** This method is loosely based on
 * [`ToLength`](http://ecma-international.org/ecma-262/7.0/#sec-tolength).
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a valid length, else `false`.
 * @example
 *
 * _.isLength(3);
 * // => true
 *
 * _.isLength(Number.MIN_VALUE);
 * // => false
 *
 * _.isLength(Infinity);
 * // => false
 *
 * _.isLength('3');
 * // => false
 */

function isLength(value) {
    return typeof value == 'number' && value > -1 && value % 1 == 0 && value <= MAX_SAFE_INTEGER$1;
}

/** `Object#toString` result references. */

var argsTag$1 = '[object Arguments]',
    arrayTag = '[object Array]',
    boolTag = '[object Boolean]',
    dateTag = '[object Date]',
    errorTag = '[object Error]',
    funcTag$1 = '[object Function]',
    mapTag = '[object Map]',
    numberTag = '[object Number]',
    objectTag$1 = '[object Object]',
    regexpTag = '[object RegExp]',
    setTag = '[object Set]',
    stringTag = '[object String]',
    weakMapTag = '[object WeakMap]';
var arrayBufferTag = '[object ArrayBuffer]',
    dataViewTag = '[object DataView]',
    float32Tag = '[object Float32Array]',
    float64Tag = '[object Float64Array]',
    int8Tag = '[object Int8Array]',
    int16Tag = '[object Int16Array]',
    int32Tag = '[object Int32Array]',
    uint8Tag = '[object Uint8Array]',
    uint8ClampedTag = '[object Uint8ClampedArray]',
    uint16Tag = '[object Uint16Array]',
    uint32Tag = '[object Uint32Array]';
/** Used to identify `toStringTag` values of typed arrays. */

var typedArrayTags = {};
typedArrayTags[float32Tag] = typedArrayTags[float64Tag] = typedArrayTags[int8Tag] = typedArrayTags[int16Tag] = typedArrayTags[int32Tag] = typedArrayTags[uint8Tag] = typedArrayTags[uint8ClampedTag] = typedArrayTags[uint16Tag] = typedArrayTags[uint32Tag] = true;
typedArrayTags[argsTag$1] = typedArrayTags[arrayTag] = typedArrayTags[arrayBufferTag] = typedArrayTags[boolTag] = typedArrayTags[dataViewTag] = typedArrayTags[dateTag] = typedArrayTags[errorTag] = typedArrayTags[funcTag$1] = typedArrayTags[mapTag] = typedArrayTags[numberTag] = typedArrayTags[objectTag$1] = typedArrayTags[regexpTag] = typedArrayTags[setTag] = typedArrayTags[stringTag] = typedArrayTags[weakMapTag] = false;
/**
 * The base implementation of `_.isTypedArray` without Node.js optimizations.
 *
 * @private
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a typed array, else `false`.
 */

function baseIsTypedArray(value) {
    return isObjectLike(value) && isLength(value.length) && !!typedArrayTags[baseGetTag(value)];
}

/**
 * The base implementation of `_.unary` without support for storing metadata.
 *
 * @private
 * @param {Function} func The function to cap arguments for.
 * @returns {Function} Returns the new capped function.
 */
function baseUnary(func) {
    return function (value) {
        return func(value);
    };
}

/** Detect free variable `exports`. */

var freeExports$1 = (typeof exports === "undefined" ? "undefined" : _typeof(exports)) == 'object' && exports && !exports.nodeType && exports;
/** Detect free variable `module`. */

var freeModule$1 = freeExports$1 && (typeof module === "undefined" ? "undefined" : _typeof(module)) == 'object' && module && !module.nodeType && module;
/** Detect the popular CommonJS extension `module.exports`. */

var moduleExports$1 = freeModule$1 && freeModule$1.exports === freeExports$1;
/** Detect free variable `process` from Node.js. */

var freeProcess = moduleExports$1 && freeGlobal.process;
/** Used to access faster Node.js helpers. */

var nodeUtil = function () {
    try {
        // Use `util.types` for Node.js 10+.
        var types = freeModule$1 && freeModule$1.require && freeModule$1.require('util').types;

        if (types) {
            return types;
        } // Legacy `process.binding('util')` for Node.js < 10.


        return freeProcess && freeProcess.binding && freeProcess.binding('util');
    } catch (e) {}
}();

/* Node.js helper references. */

var nodeIsTypedArray = nodeUtil && nodeUtil.isTypedArray;
/**
 * Checks if `value` is classified as a typed array.
 *
 * @static
 * @memberOf _
 * @since 3.0.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a typed array, else `false`.
 * @example
 *
 * _.isTypedArray(new Uint8Array);
 * // => true
 *
 * _.isTypedArray([]);
 * // => false
 */

var isTypedArray = nodeIsTypedArray ? baseUnary(nodeIsTypedArray) : baseIsTypedArray;

/** Used for built-in method references. */

var objectProto$8 = Object.prototype;
/** Used to check objects for own properties. */

var hasOwnProperty$7 = objectProto$8.hasOwnProperty;
/**
 * Creates an array of the enumerable property names of the array-like `value`.
 *
 * @private
 * @param {*} value The value to query.
 * @param {boolean} inherited Specify returning inherited property names.
 * @returns {Array} Returns the array of property names.
 */

function arrayLikeKeys(value, inherited) {
    var isArr = isArray$1(value),
        isArg = !isArr && isArguments(value),
        isBuff = !isArr && !isArg && isBuffer(value),
        isType = !isArr && !isArg && !isBuff && isTypedArray(value),
        skipIndexes = isArr || isArg || isBuff || isType,
        result = skipIndexes ? baseTimes(value.length, String) : [],
        length = result.length;

    for (var key in value) {
        if ((inherited || hasOwnProperty$7.call(value, key)) && !(skipIndexes && ( // Safari 9 has enumerable `arguments.length` in strict mode.
        key == 'length' || // Node.js 0.10 has enumerable non-index properties on buffers.
        isBuff && (key == 'offset' || key == 'parent') || // PhantomJS 2 has enumerable non-index properties on typed arrays.
        isType && (key == 'buffer' || key == 'byteLength' || key == 'byteOffset') || // Skip index properties.
        isIndex(key, length)))) {
            result.push(key);
        }
    }

    return result;
}

/** Used for built-in method references. */
var objectProto$9 = Object.prototype;
/**
 * Checks if `value` is likely a prototype object.
 *
 * @private
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a prototype, else `false`.
 */

function isPrototype(value) {
    var Ctor = value && value.constructor,
        proto = typeof Ctor == 'function' && Ctor.prototype || objectProto$9;
    return value === proto;
}

/* Built-in method references for those with the same name as other `lodash` methods. */

var nativeKeys = overArg(Object.keys, Object);

/** Used for built-in method references. */

var objectProto$a = Object.prototype;
/** Used to check objects for own properties. */

var hasOwnProperty$8 = objectProto$a.hasOwnProperty;
/**
 * The base implementation of `_.keys` which doesn't treat sparse arrays as dense.
 *
 * @private
 * @param {Object} object The object to query.
 * @returns {Array} Returns the array of property names.
 */

function baseKeys(object) {
    if (!isPrototype(object)) {
        return nativeKeys(object);
    }

    var result = [];

    for (var key in Object(object)) {
        if (hasOwnProperty$8.call(object, key) && key != 'constructor') {
            result.push(key);
        }
    }

    return result;
}

/**
 * Checks if `value` is array-like. A value is considered array-like if it's
 * not a function and has a `value.length` that's an integer greater than or
 * equal to `0` and less than or equal to `Number.MAX_SAFE_INTEGER`.
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is array-like, else `false`.
 * @example
 *
 * _.isArrayLike([1, 2, 3]);
 * // => true
 *
 * _.isArrayLike(document.body.children);
 * // => true
 *
 * _.isArrayLike('abc');
 * // => true
 *
 * _.isArrayLike(_.noop);
 * // => false
 */

function isArrayLike(value) {
    return value != null && isLength(value.length) && !isFunction(value);
}

/**
 * Creates an array of the own enumerable property names of `object`.
 *
 * **Note:** Non-object values are coerced to objects. See the
 * [ES spec](http://ecma-international.org/ecma-262/7.0/#sec-object.keys)
 * for more details.
 *
 * @static
 * @since 0.1.0
 * @memberOf _
 * @category Object
 * @param {Object} object The object to query.
 * @returns {Array} Returns the array of property names.
 * @example
 *
 * function Foo() {
 *   this.a = 1;
 *   this.b = 2;
 * }
 *
 * Foo.prototype.c = 3;
 *
 * _.keys(new Foo);
 * // => ['a', 'b'] (iteration order is not guaranteed)
 *
 * _.keys('hi');
 * // => ['0', '1']
 */

function keys(object) {
    return isArrayLike(object) ? arrayLikeKeys(object) : baseKeys(object);
}

/**
 * The base implementation of `_.assign` without support for multiple sources
 * or `customizer` functions.
 *
 * @private
 * @param {Object} object The destination object.
 * @param {Object} source The source object.
 * @returns {Object} Returns `object`.
 */

function baseAssign(object, source) {
    return object && copyObject(source, keys(source), object);
}

/**
 * This function is like
 * [`Object.keys`](http://ecma-international.org/ecma-262/7.0/#sec-object.keys)
 * except that it includes inherited enumerable properties.
 *
 * @private
 * @param {Object} object The object to query.
 * @returns {Array} Returns the array of property names.
 */
function nativeKeysIn(object) {
    var result = [];

    if (object != null) {
        for (var key in Object(object)) {
            result.push(key);
        }
    }

    return result;
}

/** Used for built-in method references. */

var objectProto$b = Object.prototype;
/** Used to check objects for own properties. */

var hasOwnProperty$9 = objectProto$b.hasOwnProperty;
/**
 * The base implementation of `_.keysIn` which doesn't treat sparse arrays as dense.
 *
 * @private
 * @param {Object} object The object to query.
 * @returns {Array} Returns the array of property names.
 */

function baseKeysIn(object) {
    if (!isObject(object)) {
        return nativeKeysIn(object);
    }

    var isProto = isPrototype(object),
        result = [];

    for (var key in object) {
        if (!(key == 'constructor' && (isProto || !hasOwnProperty$9.call(object, key)))) {
            result.push(key);
        }
    }

    return result;
}

/**
 * Creates an array of the own and inherited enumerable property names of `object`.
 *
 * **Note:** Non-object values are coerced to objects.
 *
 * @static
 * @memberOf _
 * @since 3.0.0
 * @category Object
 * @param {Object} object The object to query.
 * @returns {Array} Returns the array of property names.
 * @example
 *
 * function Foo() {
 *   this.a = 1;
 *   this.b = 2;
 * }
 *
 * Foo.prototype.c = 3;
 *
 * _.keysIn(new Foo);
 * // => ['a', 'b', 'c'] (iteration order is not guaranteed)
 */

function keysIn$1(object) {
    return isArrayLike(object) ? arrayLikeKeys(object, true) : baseKeysIn(object);
}

/**
 * The base implementation of `_.assignIn` without support for multiple sources
 * or `customizer` functions.
 *
 * @private
 * @param {Object} object The destination object.
 * @param {Object} source The source object.
 * @returns {Object} Returns `object`.
 */

function baseAssignIn(object, source) {
    return object && copyObject(source, keysIn$1(source), object);
}

/** Detect free variable `exports`. */

var freeExports$2 = (typeof exports === "undefined" ? "undefined" : _typeof(exports)) == 'object' && exports && !exports.nodeType && exports;
/** Detect free variable `module`. */

var freeModule$2 = freeExports$2 && (typeof module === "undefined" ? "undefined" : _typeof(module)) == 'object' && module && !module.nodeType && module;
/** Detect the popular CommonJS extension `module.exports`. */

var moduleExports$2 = freeModule$2 && freeModule$2.exports === freeExports$2;
/** Built-in value references. */

var Buffer$1 = moduleExports$2 ? root.Buffer : undefined,
    allocUnsafe = Buffer$1 ? Buffer$1.allocUnsafe : undefined;
/**
 * Creates a clone of  `buffer`.
 *
 * @private
 * @param {Buffer} buffer The buffer to clone.
 * @param {boolean} [isDeep] Specify a deep clone.
 * @returns {Buffer} Returns the cloned buffer.
 */

function cloneBuffer(buffer, isDeep) {
    if (isDeep) {
        return buffer.slice();
    }

    var length = buffer.length,
        result = allocUnsafe ? allocUnsafe(length) : new buffer.constructor(length);
    buffer.copy(result);
    return result;
}

/**
 * Copies the values of `source` to `array`.
 *
 * @private
 * @param {Array} source The array to copy values from.
 * @param {Array} [array=[]] The array to copy values to.
 * @returns {Array} Returns `array`.
 */
function copyArray(source, array) {
    var index = -1,
        length = source.length;
    array || (array = Array(length));

    while (++index < length) {
        array[index] = source[index];
    }

    return array;
}

/**
 * A specialized version of `_.filter` for arrays without support for
 * iteratee shorthands.
 *
 * @private
 * @param {Array} [array] The array to iterate over.
 * @param {Function} predicate The function invoked per iteration.
 * @returns {Array} Returns the new filtered array.
 */
function arrayFilter(array, predicate) {
    var index = -1,
        length = array == null ? 0 : array.length,
        resIndex = 0,
        result = [];

    while (++index < length) {
        var value = array[index];

        if (predicate(value, index, array)) {
            result[resIndex++] = value;
        }
    }

    return result;
}

/**
 * This method returns a new empty array.
 *
 * @static
 * @memberOf _
 * @since 4.13.0
 * @category Util
 * @returns {Array} Returns the new empty array.
 * @example
 *
 * var arrays = _.times(2, _.stubArray);
 *
 * console.log(arrays);
 * // => [[], []]
 *
 * console.log(arrays[0] === arrays[1]);
 * // => false
 */
function stubArray() {
    return [];
}

/** Used for built-in method references. */

var objectProto$c = Object.prototype;
/** Built-in value references. */

var propertyIsEnumerable$1 = objectProto$c.propertyIsEnumerable;
/* Built-in method references for those with the same name as other `lodash` methods. */

var nativeGetSymbols = Object.getOwnPropertySymbols;
/**
 * Creates an array of the own enumerable symbols of `object`.
 *
 * @private
 * @param {Object} object The object to query.
 * @returns {Array} Returns the array of symbols.
 */

var getSymbols = !nativeGetSymbols ? stubArray : function (object) {
    if (object == null) {
        return [];
    }

    object = Object(object);
    return arrayFilter(nativeGetSymbols(object), function (symbol) {
        return propertyIsEnumerable$1.call(object, symbol);
    });
};

/**
 * Copies own symbols of `source` to `object`.
 *
 * @private
 * @param {Object} source The object to copy symbols from.
 * @param {Object} [object={}] The object to copy symbols to.
 * @returns {Object} Returns `object`.
 */

function copySymbols(source, object) {
    return copyObject(source, getSymbols(source), object);
}

/**
 * Appends the elements of `values` to `array`.
 *
 * @private
 * @param {Array} array The array to modify.
 * @param {Array} values The values to append.
 * @returns {Array} Returns `array`.
 */
function arrayPush(array, values) {
    var index = -1,
        length = values.length,
        offset = array.length;

    while (++index < length) {
        array[offset + index] = values[index];
    }

    return array;
}

/* Built-in method references for those with the same name as other `lodash` methods. */

var nativeGetSymbols$1 = Object.getOwnPropertySymbols;
/**
 * Creates an array of the own and inherited enumerable symbols of `object`.
 *
 * @private
 * @param {Object} object The object to query.
 * @returns {Array} Returns the array of symbols.
 */

var getSymbolsIn = !nativeGetSymbols$1 ? stubArray : function (object) {
    var result = [];

    while (object) {
        arrayPush(result, getSymbols(object));
        object = getPrototype(object);
    }

    return result;
};

/**
 * Copies own and inherited symbols of `source` to `object`.
 *
 * @private
 * @param {Object} source The object to copy symbols from.
 * @param {Object} [object={}] The object to copy symbols to.
 * @returns {Object} Returns `object`.
 */

function copySymbolsIn(source, object) {
    return copyObject(source, getSymbolsIn(source), object);
}

/**
 * The base implementation of `getAllKeys` and `getAllKeysIn` which uses
 * `keysFunc` and `symbolsFunc` to get the enumerable property names and
 * symbols of `object`.
 *
 * @private
 * @param {Object} object The object to query.
 * @param {Function} keysFunc The function to get the keys of `object`.
 * @param {Function} symbolsFunc The function to get the symbols of `object`.
 * @returns {Array} Returns the array of property names and symbols.
 */

function baseGetAllKeys(object, keysFunc, symbolsFunc) {
    var result = keysFunc(object);
    return isArray$1(object) ? result : arrayPush(result, symbolsFunc(object));
}

/**
 * Creates an array of own enumerable property names and symbols of `object`.
 *
 * @private
 * @param {Object} object The object to query.
 * @returns {Array} Returns the array of property names and symbols.
 */

function getAllKeys(object) {
    return baseGetAllKeys(object, keys, getSymbols);
}

/**
 * Creates an array of own and inherited enumerable property names and
 * symbols of `object`.
 *
 * @private
 * @param {Object} object The object to query.
 * @returns {Array} Returns the array of property names and symbols.
 */

function getAllKeysIn(object) {
    return baseGetAllKeys(object, keysIn$1, getSymbolsIn);
}

/* Built-in method references that are verified to be native. */

var DataView = getNative(root, 'DataView');

/* Built-in method references that are verified to be native. */

var Promise$1 = getNative(root, 'Promise');

/* Built-in method references that are verified to be native. */

var Set = getNative(root, 'Set');

/* Built-in method references that are verified to be native. */

var WeakMap$1 = getNative(root, 'WeakMap');

/** `Object#toString` result references. */

var mapTag$1 = '[object Map]',
    objectTag$2 = '[object Object]',
    promiseTag = '[object Promise]',
    setTag$1 = '[object Set]',
    weakMapTag$1 = '[object WeakMap]';
var dataViewTag$1 = '[object DataView]';
/** Used to detect maps, sets, and weakmaps. */

var dataViewCtorString = toSource(DataView),
    mapCtorString = toSource(Map),
    promiseCtorString = toSource(Promise$1),
    setCtorString = toSource(Set),
    weakMapCtorString = toSource(WeakMap$1);
/**
 * Gets the `toStringTag` of `value`.
 *
 * @private
 * @param {*} value The value to query.
 * @returns {string} Returns the `toStringTag`.
 */

var getTag = baseGetTag; // Fallback for data views, maps, sets, and weak maps in IE 11 and promises in Node.js < 6.

if (DataView && getTag(new DataView(new ArrayBuffer(1))) != dataViewTag$1 || Map && getTag(new Map()) != mapTag$1 || Promise$1 && getTag(Promise$1.resolve()) != promiseTag || Set && getTag(new Set()) != setTag$1 || WeakMap$1 && getTag(new WeakMap$1()) != weakMapTag$1) {
    getTag = function getTag(value) {
        var result = baseGetTag(value),
            Ctor = result == objectTag$2 ? value.constructor : undefined,
            ctorString = Ctor ? toSource(Ctor) : '';

        if (ctorString) {
            switch (ctorString) {
                case dataViewCtorString:
                    return dataViewTag$1;

                case mapCtorString:
                    return mapTag$1;

                case promiseCtorString:
                    return promiseTag;

                case setCtorString:
                    return setTag$1;

                case weakMapCtorString:
                    return weakMapTag$1;
            }
        }

        return result;
    };
}

var getTag$1 = getTag;

/** Used for built-in method references. */
var objectProto$d = Object.prototype;
/** Used to check objects for own properties. */

var hasOwnProperty$a = objectProto$d.hasOwnProperty;
/**
 * Initializes an array clone.
 *
 * @private
 * @param {Array} array The array to clone.
 * @returns {Array} Returns the initialized clone.
 */

function initCloneArray(array) {
    var length = array.length,
        result = new array.constructor(length); // Add properties assigned by `RegExp#exec`.

    if (length && typeof array[0] == 'string' && hasOwnProperty$a.call(array, 'index')) {
        result.index = array.index;
        result.input = array.input;
    }

    return result;
}

/** Built-in value references. */

var Uint8Array = root.Uint8Array;

/**
 * Creates a clone of `arrayBuffer`.
 *
 * @private
 * @param {ArrayBuffer} arrayBuffer The array buffer to clone.
 * @returns {ArrayBuffer} Returns the cloned array buffer.
 */

function cloneArrayBuffer(arrayBuffer) {
    var result = new arrayBuffer.constructor(arrayBuffer.byteLength);
    new Uint8Array(result).set(new Uint8Array(arrayBuffer));
    return result;
}

/**
 * Creates a clone of `dataView`.
 *
 * @private
 * @param {Object} dataView The data view to clone.
 * @param {boolean} [isDeep] Specify a deep clone.
 * @returns {Object} Returns the cloned data view.
 */

function cloneDataView(dataView, isDeep) {
    var buffer = isDeep ? cloneArrayBuffer(dataView.buffer) : dataView.buffer;
    return new dataView.constructor(buffer, dataView.byteOffset, dataView.byteLength);
}

/** Used to match `RegExp` flags from their coerced string values. */
var reFlags = /\w*$/;
/**
 * Creates a clone of `regexp`.
 *
 * @private
 * @param {Object} regexp The regexp to clone.
 * @returns {Object} Returns the cloned regexp.
 */

function cloneRegExp(regexp) {
    var result = new regexp.constructor(regexp.source, reFlags.exec(regexp));
    result.lastIndex = regexp.lastIndex;
    return result;
}

/** Used to convert symbols to primitives and strings. */

var symbolProto = _Symbol ? _Symbol.prototype : undefined,
    symbolValueOf = symbolProto ? symbolProto.valueOf : undefined;
/**
 * Creates a clone of the `symbol` object.
 *
 * @private
 * @param {Object} symbol The symbol object to clone.
 * @returns {Object} Returns the cloned symbol object.
 */

function cloneSymbol(symbol) {
    return symbolValueOf ? Object(symbolValueOf.call(symbol)) : {};
}

/**
 * Creates a clone of `typedArray`.
 *
 * @private
 * @param {Object} typedArray The typed array to clone.
 * @param {boolean} [isDeep] Specify a deep clone.
 * @returns {Object} Returns the cloned typed array.
 */

function cloneTypedArray(typedArray, isDeep) {
    var buffer = isDeep ? cloneArrayBuffer(typedArray.buffer) : typedArray.buffer;
    return new typedArray.constructor(buffer, typedArray.byteOffset, typedArray.length);
}

/** `Object#toString` result references. */

var boolTag$1 = '[object Boolean]',
    dateTag$1 = '[object Date]',
    mapTag$2 = '[object Map]',
    numberTag$1 = '[object Number]',
    regexpTag$1 = '[object RegExp]',
    setTag$2 = '[object Set]',
    stringTag$1 = '[object String]',
    symbolTag = '[object Symbol]';
var arrayBufferTag$1 = '[object ArrayBuffer]',
    dataViewTag$2 = '[object DataView]',
    float32Tag$1 = '[object Float32Array]',
    float64Tag$1 = '[object Float64Array]',
    int8Tag$1 = '[object Int8Array]',
    int16Tag$1 = '[object Int16Array]',
    int32Tag$1 = '[object Int32Array]',
    uint8Tag$1 = '[object Uint8Array]',
    uint8ClampedTag$1 = '[object Uint8ClampedArray]',
    uint16Tag$1 = '[object Uint16Array]',
    uint32Tag$1 = '[object Uint32Array]';
/**
 * Initializes an object clone based on its `toStringTag`.
 *
 * **Note:** This function only supports cloning values with tags of
 * `Boolean`, `Date`, `Error`, `Map`, `Number`, `RegExp`, `Set`, or `String`.
 *
 * @private
 * @param {Object} object The object to clone.
 * @param {string} tag The `toStringTag` of the object to clone.
 * @param {boolean} [isDeep] Specify a deep clone.
 * @returns {Object} Returns the initialized clone.
 */

function initCloneByTag(object, tag, isDeep) {
    var Ctor = object.constructor;

    switch (tag) {
        case arrayBufferTag$1:
            return cloneArrayBuffer(object);

        case boolTag$1:
        case dateTag$1:
            return new Ctor(+object);

        case dataViewTag$2:
            return cloneDataView(object, isDeep);

        case float32Tag$1:
        case float64Tag$1:
        case int8Tag$1:
        case int16Tag$1:
        case int32Tag$1:
        case uint8Tag$1:
        case uint8ClampedTag$1:
        case uint16Tag$1:
        case uint32Tag$1:
            return cloneTypedArray(object, isDeep);

        case mapTag$2:
            return new Ctor();

        case numberTag$1:
        case stringTag$1:
            return new Ctor(object);

        case regexpTag$1:
            return cloneRegExp(object);

        case setTag$2:
            return new Ctor();

        case symbolTag:
            return cloneSymbol(object);
    }
}

/** Built-in value references. */

var objectCreate = Object.create;
/**
 * The base implementation of `_.create` without support for assigning
 * properties to the created object.
 *
 * @private
 * @param {Object} proto The object to inherit from.
 * @returns {Object} Returns the new object.
 */

var baseCreate = function () {
    function object() {}

    return function (proto) {
        if (!isObject(proto)) {
            return {};
        }

        if (objectCreate) {
            return objectCreate(proto);
        }

        object.prototype = proto;
        var result = new object();
        object.prototype = undefined;
        return result;
    };
}();

/**
 * Initializes an object clone.
 *
 * @private
 * @param {Object} object The object to clone.
 * @returns {Object} Returns the initialized clone.
 */

function initCloneObject(object) {
    return typeof object.constructor == 'function' && !isPrototype(object) ? baseCreate(getPrototype(object)) : {};
}

/** `Object#toString` result references. */

var mapTag$3 = '[object Map]';
/**
 * The base implementation of `_.isMap` without Node.js optimizations.
 *
 * @private
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a map, else `false`.
 */

function baseIsMap(value) {
    return isObjectLike(value) && getTag$1(value) == mapTag$3;
}

/* Node.js helper references. */

var nodeIsMap = nodeUtil && nodeUtil.isMap;
/**
 * Checks if `value` is classified as a `Map` object.
 *
 * @static
 * @memberOf _
 * @since 4.3.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a map, else `false`.
 * @example
 *
 * _.isMap(new Map);
 * // => true
 *
 * _.isMap(new WeakMap);
 * // => false
 */

var isMap = nodeIsMap ? baseUnary(nodeIsMap) : baseIsMap;

/** `Object#toString` result references. */

var setTag$3 = '[object Set]';
/**
 * The base implementation of `_.isSet` without Node.js optimizations.
 *
 * @private
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a set, else `false`.
 */

function baseIsSet(value) {
    return isObjectLike(value) && getTag$1(value) == setTag$3;
}

/* Node.js helper references. */

var nodeIsSet = nodeUtil && nodeUtil.isSet;
/**
 * Checks if `value` is classified as a `Set` object.
 *
 * @static
 * @memberOf _
 * @since 4.3.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a set, else `false`.
 * @example
 *
 * _.isSet(new Set);
 * // => true
 *
 * _.isSet(new WeakSet);
 * // => false
 */

var isSet = nodeIsSet ? baseUnary(nodeIsSet) : baseIsSet;

/** Used to compose bitmasks for cloning. */

var CLONE_DEEP_FLAG = 1,
    CLONE_FLAT_FLAG = 2,
    CLONE_SYMBOLS_FLAG = 4;
/** `Object#toString` result references. */

var argsTag$2 = '[object Arguments]',
    arrayTag$1 = '[object Array]',
    boolTag$2 = '[object Boolean]',
    dateTag$2 = '[object Date]',
    errorTag$1 = '[object Error]',
    funcTag$2 = '[object Function]',
    genTag$1 = '[object GeneratorFunction]',
    mapTag$4 = '[object Map]',
    numberTag$2 = '[object Number]',
    objectTag$3 = '[object Object]',
    regexpTag$2 = '[object RegExp]',
    setTag$4 = '[object Set]',
    stringTag$2 = '[object String]',
    symbolTag$1 = '[object Symbol]',
    weakMapTag$2 = '[object WeakMap]';
var arrayBufferTag$2 = '[object ArrayBuffer]',
    dataViewTag$3 = '[object DataView]',
    float32Tag$2 = '[object Float32Array]',
    float64Tag$2 = '[object Float64Array]',
    int8Tag$2 = '[object Int8Array]',
    int16Tag$2 = '[object Int16Array]',
    int32Tag$2 = '[object Int32Array]',
    uint8Tag$2 = '[object Uint8Array]',
    uint8ClampedTag$2 = '[object Uint8ClampedArray]',
    uint16Tag$2 = '[object Uint16Array]',
    uint32Tag$2 = '[object Uint32Array]';
/** Used to identify `toStringTag` values supported by `_.clone`. */

var cloneableTags = {};
cloneableTags[argsTag$2] = cloneableTags[arrayTag$1] = cloneableTags[arrayBufferTag$2] = cloneableTags[dataViewTag$3] = cloneableTags[boolTag$2] = cloneableTags[dateTag$2] = cloneableTags[float32Tag$2] = cloneableTags[float64Tag$2] = cloneableTags[int8Tag$2] = cloneableTags[int16Tag$2] = cloneableTags[int32Tag$2] = cloneableTags[mapTag$4] = cloneableTags[numberTag$2] = cloneableTags[objectTag$3] = cloneableTags[regexpTag$2] = cloneableTags[setTag$4] = cloneableTags[stringTag$2] = cloneableTags[symbolTag$1] = cloneableTags[uint8Tag$2] = cloneableTags[uint8ClampedTag$2] = cloneableTags[uint16Tag$2] = cloneableTags[uint32Tag$2] = true;
cloneableTags[errorTag$1] = cloneableTags[funcTag$2] = cloneableTags[weakMapTag$2] = false;
/**
 * The base implementation of `_.clone` and `_.cloneDeep` which tracks
 * traversed objects.
 *
 * @private
 * @param {*} value The value to clone.
 * @param {boolean} bitmask The bitmask flags.
 *  1 - Deep clone
 *  2 - Flatten inherited properties
 *  4 - Clone symbols
 * @param {Function} [customizer] The function to customize cloning.
 * @param {string} [key] The key of `value`.
 * @param {Object} [object] The parent object of `value`.
 * @param {Object} [stack] Tracks traversed objects and their clone counterparts.
 * @returns {*} Returns the cloned value.
 */

function baseClone(value, bitmask, customizer, key, object, stack) {
    var result,
        isDeep = bitmask & CLONE_DEEP_FLAG,
        isFlat = bitmask & CLONE_FLAT_FLAG,
        isFull = bitmask & CLONE_SYMBOLS_FLAG;

    if (customizer) {
        result = object ? customizer(value, key, object, stack) : customizer(value);
    }

    if (result !== undefined) {
        return result;
    }

    if (!isObject(value)) {
        return value;
    }

    var isArr = isArray$1(value);

    if (isArr) {
        result = initCloneArray(value);

        if (!isDeep) {
            return copyArray(value, result);
        }
    } else {
        var tag = getTag$1(value),
            isFunc = tag == funcTag$2 || tag == genTag$1;

        if (isBuffer(value)) {
            return cloneBuffer(value, isDeep);
        }

        if (tag == objectTag$3 || tag == argsTag$2 || isFunc && !object) {
            result = isFlat || isFunc ? {} : initCloneObject(value);

            if (!isDeep) {
                return isFlat ? copySymbolsIn(value, baseAssignIn(result, value)) : copySymbols(value, baseAssign(result, value));
            }
        } else {
            if (!cloneableTags[tag]) {
                return object ? value : {};
            }

            result = initCloneByTag(value, tag, isDeep);
        }
    } // Check for circular references and return its corresponding clone.


    stack || (stack = new Stack());
    var stacked = stack.get(value);

    if (stacked) {
        return stacked;
    }

    stack.set(value, result);

    if (isSet(value)) {
        value.forEach(function (subValue) {
            result.add(baseClone(subValue, bitmask, customizer, subValue, value, stack));
        });
    } else if (isMap(value)) {
        value.forEach(function (subValue, key) {
            result.set(key, baseClone(subValue, bitmask, customizer, key, value, stack));
        });
    }

    var keysFunc = isFull ? isFlat ? getAllKeysIn : getAllKeys : isFlat ? keysIn : keys;
    var props = isArr ? undefined : keysFunc(value);
    arrayEach(props || value, function (subValue, key) {
        if (props) {
            key = subValue;
            subValue = value[key];
        } // Recursively populate clone (susceptible to call stack limits).


        assignValue(result, key, baseClone(subValue, bitmask, customizer, key, value, stack));
    });
    return result;
}

/** Used to compose bitmasks for cloning. */

var CLONE_SYMBOLS_FLAG$1 = 4;
/**
 * Creates a shallow clone of `value`.
 *
 * **Note:** This method is loosely based on the
 * [structured clone algorithm](https://mdn.io/Structured_clone_algorithm)
 * and supports cloning arrays, array buffers, booleans, date objects, maps,
 * numbers, `Object` objects, regexes, sets, strings, symbols, and typed
 * arrays. The own enumerable properties of `arguments` objects are cloned
 * as plain objects. An empty object is returned for uncloneable values such
 * as error objects, functions, DOM nodes, and WeakMaps.
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Lang
 * @param {*} value The value to clone.
 * @returns {*} Returns the cloned value.
 * @see _.cloneDeep
 * @example
 *
 * var objects = [{ 'a': 1 }, { 'b': 2 }];
 *
 * var shallow = _.clone(objects);
 * console.log(shallow[0] === objects[0]);
 * // => true
 */

function clone(value) {
    return baseClone(value, CLONE_SYMBOLS_FLAG$1);
}

/**
 * A specialized version of `_.map` for arrays without support for iteratee
 * shorthands.
 *
 * @private
 * @param {Array} [array] The array to iterate over.
 * @param {Function} iteratee The function invoked per iteration.
 * @returns {Array} Returns the new mapped array.
 */
function arrayMap(array, iteratee) {
    var index = -1,
        length = array == null ? 0 : array.length,
        result = Array(length);

    while (++index < length) {
        result[index] = iteratee(array[index], index, array);
    }

    return result;
}

/** `Object#toString` result references. */

var symbolTag$2 = '[object Symbol]';
/**
 * Checks if `value` is classified as a `Symbol` primitive or object.
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a symbol, else `false`.
 * @example
 *
 * _.isSymbol(Symbol.iterator);
 * // => true
 *
 * _.isSymbol('abc');
 * // => false
 */

function isSymbol(value) {
    return _typeof(value) == 'symbol' || isObjectLike(value) && baseGetTag(value) == symbolTag$2;
}

/** Error message constants. */

var FUNC_ERROR_TEXT = 'Expected a function';
/**
 * Creates a function that memoizes the result of `func`. If `resolver` is
 * provided, it determines the cache key for storing the result based on the
 * arguments provided to the memoized function. By default, the first argument
 * provided to the memoized function is used as the map cache key. The `func`
 * is invoked with the `this` binding of the memoized function.
 *
 * **Note:** The cache is exposed as the `cache` property on the memoized
 * function. Its creation may be customized by replacing the `_.memoize.Cache`
 * constructor with one whose instances implement the
 * [`Map`](http://ecma-international.org/ecma-262/7.0/#sec-properties-of-the-map-prototype-object)
 * method interface of `clear`, `delete`, `get`, `has`, and `set`.
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Function
 * @param {Function} func The function to have its output memoized.
 * @param {Function} [resolver] The function to resolve the cache key.
 * @returns {Function} Returns the new memoized function.
 * @example
 *
 * var object = { 'a': 1, 'b': 2 };
 * var other = { 'c': 3, 'd': 4 };
 *
 * var values = _.memoize(_.values);
 * values(object);
 * // => [1, 2]
 *
 * values(other);
 * // => [3, 4]
 *
 * object.a = 2;
 * values(object);
 * // => [1, 2]
 *
 * // Modify the result cache.
 * values.cache.set(object, ['a', 'b']);
 * values(object);
 * // => ['a', 'b']
 *
 * // Replace `_.memoize.Cache`.
 * _.memoize.Cache = WeakMap;
 */

function memoize(func, resolver) {
    if (typeof func != 'function' || resolver != null && typeof resolver != 'function') {
        throw new TypeError(FUNC_ERROR_TEXT);
    }

    var memoized = function memoized() {
        var args = arguments,
            key = resolver ? resolver.apply(this, args) : args[0],
            cache = memoized.cache;

        if (cache.has(key)) {
            return cache.get(key);
        }

        var result = func.apply(this, args);
        memoized.cache = cache.set(key, result) || cache;
        return result;
    };

    memoized.cache = new (memoize.Cache || MapCache)();
    return memoized;
} // Expose `MapCache`.


memoize.Cache = MapCache;

/** Used as the maximum memoize cache size. */

var MAX_MEMOIZE_SIZE = 500;
/**
 * A specialized version of `_.memoize` which clears the memoized function's
 * cache when it exceeds `MAX_MEMOIZE_SIZE`.
 *
 * @private
 * @param {Function} func The function to have its output memoized.
 * @returns {Function} Returns the new memoized function.
 */

function memoizeCapped(func) {
    var result = memoize(func, function (key) {
        if (cache.size === MAX_MEMOIZE_SIZE) {
            cache.clear();
        }

        return key;
    });
    var cache = result.cache;
    return result;
}

/** Used to match property names within property paths. */

var rePropName = /[^.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]|(?=(?:\.|\[\])(?:\.|\[\]|$))/g;
/** Used to match backslashes in property paths. */

var reEscapeChar = /\\(\\)?/g;
/**
 * Converts `string` to a property path array.
 *
 * @private
 * @param {string} string The string to convert.
 * @returns {Array} Returns the property path array.
 */

var stringToPath = memoizeCapped(function (string) {
    var result = [];

    if (string.charCodeAt(0) === 46
    /* . */
    ) {
            result.push('');
        }

    string.replace(rePropName, function (match, number, quote, subString) {
        result.push(quote ? subString.replace(reEscapeChar, '$1') : number || match);
    });
    return result;
});

/** Used as references for various `Number` constants. */

var INFINITY = 1 / 0;
/**
 * Converts `value` to a string key if it's not a string or symbol.
 *
 * @private
 * @param {*} value The value to inspect.
 * @returns {string|symbol} Returns the key.
 */

function toKey(value) {
    if (typeof value == 'string' || isSymbol(value)) {
        return value;
    }

    var result = value + '';
    return result == '0' && 1 / value == -INFINITY ? '-0' : result;
}

/** Used as references for various `Number` constants. */

var INFINITY$1 = 1 / 0;
/** Used to convert symbols to primitives and strings. */

var symbolProto$1 = _Symbol ? _Symbol.prototype : undefined,
    symbolToString = symbolProto$1 ? symbolProto$1.toString : undefined;
/**
 * The base implementation of `_.toString` which doesn't convert nullish
 * values to empty strings.
 *
 * @private
 * @param {*} value The value to process.
 * @returns {string} Returns the string.
 */

function baseToString(value) {
    // Exit early for strings to avoid a performance hit in some environments.
    if (typeof value == 'string') {
        return value;
    }

    if (isArray$1(value)) {
        // Recursively convert values (susceptible to call stack limits).
        return arrayMap(value, baseToString) + '';
    }

    if (isSymbol(value)) {
        return symbolToString ? symbolToString.call(value) : '';
    }

    var result = value + '';
    return result == '0' && 1 / value == -INFINITY$1 ? '-0' : result;
}

/**
 * Converts `value` to a string. An empty string is returned for `null`
 * and `undefined` values. The sign of `-0` is preserved.
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to convert.
 * @returns {string} Returns the converted string.
 * @example
 *
 * _.toString(null);
 * // => ''
 *
 * _.toString(-0);
 * // => '-0'
 *
 * _.toString([1, 2, 3]);
 * // => '1,2,3'
 */

function toString(value) {
    return value == null ? '' : baseToString(value);
}

/**
 * Converts `value` to a property path array.
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Util
 * @param {*} value The value to convert.
 * @returns {Array} Returns the new property path array.
 * @example
 *
 * _.toPath('a.b.c');
 * // => ['a', 'b', 'c']
 *
 * _.toPath('a[0].b.c');
 * // => ['a', '0', 'b', 'c']
 */

function toPath(value) {
    if (isArray$1(value)) {
        return arrayMap(value, toKey);
    }

    return isSymbol(value) ? [value] : copyArray(stringToPath(toString(value)));
}

/**
 * Copyright 2015, Yahoo! Inc.
 * Copyrights licensed under the New BSD License. See the accompanying LICENSE file for terms.
 */


var REACT_STATICS = {
    childContextTypes: true,
    contextType: true,
    contextTypes: true,
    defaultProps: true,
    displayName: true,
    getDefaultProps: true,
    getDerivedStateFromError: true,
    getDerivedStateFromProps: true,
    mixins: true,
    propTypes: true,
    type: true
};
var KNOWN_STATICS = {
    name: true,
    length: true,
    prototype: true,
    caller: true,
    callee: true,
    arguments: true,
    arity: true
};
var FORWARD_REF_STATICS = {
    '$$typeof': true,
    render: true,
    defaultProps: true,
    displayName: true,
    propTypes: true
};
var MEMO_STATICS = {
    '$$typeof': true,
    compare: true,
    defaultProps: true,
    displayName: true,
    propTypes: true,
    type: true
};
var TYPE_STATICS = {};
TYPE_STATICS[reactIs__default['default'].ForwardRef] = FORWARD_REF_STATICS;
TYPE_STATICS[reactIs__default['default'].Memo] = MEMO_STATICS;

function getStatics(component) {
    // React v16.11 and below
    if (reactIs__default['default'].isMemo(component)) {
        return MEMO_STATICS;
    } // React v16.12 and above


    return TYPE_STATICS[component['$$typeof']] || REACT_STATICS;
}

var defineProperty$1 = Object.defineProperty;
var getOwnPropertyNames = Object.getOwnPropertyNames;
var getOwnPropertySymbols = Object.getOwnPropertySymbols;
var getOwnPropertyDescriptor = Object.getOwnPropertyDescriptor;
var getPrototypeOf = Object.getPrototypeOf;
var objectPrototype = Object.prototype;

function hoistNonReactStatics(targetComponent, sourceComponent, blacklist) {
    if (typeof sourceComponent !== 'string') {
        // don't hoist over string (html) components
        if (objectPrototype) {
            var inheritedComponent = getPrototypeOf(sourceComponent);

            if (inheritedComponent && inheritedComponent !== objectPrototype) {
                hoistNonReactStatics(targetComponent, inheritedComponent, blacklist);
            }
        }

        var keys = getOwnPropertyNames(sourceComponent);

        if (getOwnPropertySymbols) {
            keys = keys.concat(getOwnPropertySymbols(sourceComponent));
        }

        var targetStatics = getStatics(targetComponent);
        var sourceStatics = getStatics(sourceComponent);

        for (var i = 0; i < keys.length; ++i) {
            var key = keys[i];

            if (!KNOWN_STATICS[key] && !(blacklist && blacklist[key]) && !(sourceStatics && sourceStatics[key]) && !(targetStatics && targetStatics[key])) {
                var descriptor = getOwnPropertyDescriptor(sourceComponent, key);

                try {
                    // Avoid failures from read-only properties
                    defineProperty$1(targetComponent, key, descriptor);
                } catch (e) {}
            }
        }
    }

    return targetComponent;
}

var hoistNonReactStatics_cjs = hoistNonReactStatics;

/** Used to compose bitmasks for cloning. */

var CLONE_DEEP_FLAG$1 = 1,
    CLONE_SYMBOLS_FLAG$2 = 4;
/**
 * This method is like `_.clone` except that it recursively clones `value`.
 *
 * @static
 * @memberOf _
 * @since 1.0.0
 * @category Lang
 * @param {*} value The value to recursively clone.
 * @returns {*} Returns the deep cloned value.
 * @see _.clone
 * @example
 *
 * var objects = [{ 'a': 1 }, { 'b': 2 }];
 *
 * var deep = _.cloneDeep(objects);
 * console.log(deep[0] === objects[0]);
 * // => false
 */

function cloneDeep(value) {
    return baseClone(value, CLONE_DEEP_FLAG$1 | CLONE_SYMBOLS_FLAG$2);
}

function _extends$1() {
    _extends$1 = Object.assign || function (target) {
        for (var i = 1; i < arguments.length; i++) {
            var source = arguments[i];

            for (var key in source) {
                if (Object.prototype.hasOwnProperty.call(source, key)) {
                    target[key] = source[key];
                }
            }
        }

        return target;
    };

    return _extends$1.apply(this, arguments);
}

function _inheritsLoose(subClass, superClass) {
    subClass.prototype = Object.create(superClass.prototype);
    subClass.prototype.constructor = subClass;
    subClass.__proto__ = superClass;
}

function _objectWithoutPropertiesLoose$1(source, excluded) {
    if (source == null) return {};
    var target = {};
    var sourceKeys = Object.keys(source);
    var key, i;

    for (i = 0; i < sourceKeys.length; i++) {
        key = sourceKeys[i];
        if (excluded.indexOf(key) >= 0) continue;
        target[key] = source[key];
    }

    return target;
}

function _assertThisInitialized$1(self) {
    if (self === void 0) {
        throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }

    return self;
}
/** @private is the value an empty array? */


var isEmptyArray = function isEmptyArray(value) {
    return Array.isArray(value) && value.length === 0;
};
/** @private is the given object a Function? */


var isFunction$1 = function isFunction(obj) {
    return typeof obj === 'function';
};
/** @private is the given object an Object? */


var isObject$1 = function isObject(obj) {
    return obj !== null && _typeof(obj) === 'object';
};
/** @private is the given object an integer? */


var isInteger = function isInteger(obj) {
    return String(Math.floor(Number(obj))) === obj;
};
/** @private is the given object a string? */


var isString = function isString(obj) {
    return Object.prototype.toString.call(obj) === '[object String]';
};
/** @private Does a React component have exactly 0 children? */


var isEmptyChildren = function isEmptyChildren(children) {
    return React.Children.count(children) === 0;
};
/** @private is the given object/value a promise? */


var isPromise = function isPromise(value) {
    return isObject$1(value) && isFunction$1(value.then);
};
/**
 * Deeply get a value from an object via its path.
 */


function getIn(obj, key, def, p) {
    if (p === void 0) {
        p = 0;
    }

    var path = toPath(key);

    while (obj && p < path.length) {
        obj = obj[path[p++]];
    }

    return obj === undefined ? def : obj;
}
/**
 * Deeply set a value from in object via it's path. If the value at `path`
 * has changed, return a shallow copy of obj with `value` set at `path`.
 * If `value` has not changed, return the original `obj`.
 *
 * Existing objects / arrays along `path` are also shallow copied. Sibling
 * objects along path retain the same internal js reference. Since new
 * objects / arrays are only created along `path`, we can test if anything
 * changed in a nested structure by comparing the object's reference in
 * the old and new object, similar to how russian doll cache invalidation
 * works.
 *
 * In earlier versions of this function, which used cloneDeep, there were
 * issues whereby settings a nested value would mutate the parent
 * instead of creating a new object. `clone` avoids that bug making a
 * shallow copy of the objects along the update path
 * so no object is mutated in place.
 *
 * Before changing this function, please read through the following
 * discussions.
 *
 * @see https://github.com/developit/linkstate
 * @see https://github.com/jaredpalmer/formik/pull/123
 */


function setIn(obj, path, value) {
    var res = clone(obj); // this keeps inheritance when obj is a class

    var resVal = res;
    var i = 0;
    var pathArray = toPath(path);

    for (; i < pathArray.length - 1; i++) {
        var currentPath = pathArray[i];
        var currentObj = getIn(obj, pathArray.slice(0, i + 1));

        if (currentObj && (isObject$1(currentObj) || Array.isArray(currentObj))) {
            resVal = resVal[currentPath] = clone(currentObj);
        } else {
            var nextPath = pathArray[i + 1];
            resVal = resVal[currentPath] = isInteger(nextPath) && Number(nextPath) >= 0 ? [] : {};
        }
    } // Return original object if new value is the same as current


    if ((i === 0 ? obj : resVal)[pathArray[i]] === value) {
        return obj;
    }

    if (value === undefined) {
        delete resVal[pathArray[i]];
    } else {
        resVal[pathArray[i]] = value;
    } // If the path array has a single element, the loop did not run.
    // Deleting on `resVal` had no effect in this scenario, so we delete on the result instead.


    if (i === 0 && value === undefined) {
        delete res[pathArray[i]];
    }

    return res;
}
/**
 * Recursively a set the same value for all keys and arrays nested object, cloning
 * @param object
 * @param value
 * @param visited
 * @param response
 */


function setNestedObjectValues(object, value, visited, response) {
    if (visited === void 0) {
        visited = new WeakMap();
    }

    if (response === void 0) {
        response = {};
    }

    for (var _i = 0, _Object$keys = Object.keys(object); _i < _Object$keys.length; _i++) {
        var k = _Object$keys[_i];
        var val = object[k];

        if (isObject$1(val)) {
            if (!visited.get(val)) {
                visited.set(val, true); // In order to keep array values consistent for both dot path  and
                // bracket syntax, we need to check if this is an array so that
                // this will output  { friends: [true] } and not { friends: { "0": true } }

                response[k] = Array.isArray(val) ? [] : {};
                setNestedObjectValues(val, value, visited, response[k]);
            }
        } else {
            response[k] = value;
        }
    }

    return response;
}

var FormikContext = /*#__PURE__*/React.createContext(undefined);
var FormikProvider = FormikContext.Provider;
var FormikConsumer = FormikContext.Consumer;

function useFormikContext() {
    var formik = React.useContext(FormikContext);
    return formik;
}

function formikReducer(state, msg) {
    switch (msg.type) {
        case 'SET_VALUES':
            return _extends$1({}, state, {
                values: msg.payload
            });

        case 'SET_TOUCHED':
            return _extends$1({}, state, {
                touched: msg.payload
            });

        case 'SET_ERRORS':
            if (exportedEqual(state.errors, msg.payload)) {
                return state;
            }

            return _extends$1({}, state, {
                errors: msg.payload
            });

        case 'SET_STATUS':
            return _extends$1({}, state, {
                status: msg.payload
            });

        case 'SET_ISSUBMITTING':
            return _extends$1({}, state, {
                isSubmitting: msg.payload
            });

        case 'SET_ISVALIDATING':
            return _extends$1({}, state, {
                isValidating: msg.payload
            });

        case 'SET_FIELD_VALUE':
            return _extends$1({}, state, {
                values: setIn(state.values, msg.payload.field, msg.payload.value)
            });

        case 'SET_FIELD_TOUCHED':
            return _extends$1({}, state, {
                touched: setIn(state.touched, msg.payload.field, msg.payload.value)
            });

        case 'SET_FIELD_ERROR':
            return _extends$1({}, state, {
                errors: setIn(state.errors, msg.payload.field, msg.payload.value)
            });

        case 'RESET_FORM':
            return _extends$1({}, state, msg.payload);

        case 'SET_FORMIK_STATE':
            return msg.payload(state);

        case 'SUBMIT_ATTEMPT':
            return _extends$1({}, state, {
                touched: setNestedObjectValues(state.values, true),
                isSubmitting: true,
                submitCount: state.submitCount + 1
            });

        case 'SUBMIT_FAILURE':
            return _extends$1({}, state, {
                isSubmitting: false
            });

        case 'SUBMIT_SUCCESS':
            return _extends$1({}, state, {
                isSubmitting: false
            });

        default:
            return state;
    }
} // Initial empty states // objects


var emptyErrors = {};
var emptyTouched = {};

function useFormik(_ref) {
    var _ref$validateOnChange = _ref.validateOnChange,
        validateOnChange = _ref$validateOnChange === void 0 ? true : _ref$validateOnChange,
        _ref$validateOnBlur = _ref.validateOnBlur,
        validateOnBlur = _ref$validateOnBlur === void 0 ? true : _ref$validateOnBlur,
        _ref$validateOnMount = _ref.validateOnMount,
        validateOnMount = _ref$validateOnMount === void 0 ? false : _ref$validateOnMount,
        isInitialValid = _ref.isInitialValid,
        _ref$enableReinitiali = _ref.enableReinitialize,
        enableReinitialize = _ref$enableReinitiali === void 0 ? false : _ref$enableReinitiali,
        onSubmit = _ref.onSubmit,
        rest = _objectWithoutPropertiesLoose$1(_ref, ["validateOnChange", "validateOnBlur", "validateOnMount", "isInitialValid", "enableReinitialize", "onSubmit"]);

    var props = _extends$1({
        validateOnChange: validateOnChange,
        validateOnBlur: validateOnBlur,
        validateOnMount: validateOnMount,
        onSubmit: onSubmit
    }, rest);

    var initialValues = React.useRef(props.initialValues);
    var initialErrors = React.useRef(props.initialErrors || emptyErrors);
    var initialTouched = React.useRef(props.initialTouched || emptyTouched);
    var initialStatus = React.useRef(props.initialStatus);
    var isMounted = React.useRef(false);
    var fieldRegistry = React.useRef({});

    React.useEffect(function () {
        isMounted.current = true;
        return function () {
            isMounted.current = false;
        };
    }, []);

    var _React$useReducer = React.useReducer(formikReducer, {
        values: props.initialValues,
        errors: props.initialErrors || emptyErrors,
        touched: props.initialTouched || emptyTouched,
        status: props.initialStatus,
        isSubmitting: false,
        isValidating: false,
        submitCount: 0
    }),
        state = _React$useReducer[0],
        dispatch = _React$useReducer[1];

    var runValidateHandler = React.useCallback(function (values, field) {
        return new Promise(function (resolve, reject) {
            var maybePromisedErrors = props.validate(values, field);

            if (maybePromisedErrors == null) {
                // use loose null check here on purpose
                resolve(emptyErrors);
            } else if (isPromise(maybePromisedErrors)) {
                maybePromisedErrors.then(function (errors) {
                    resolve(errors || emptyErrors);
                }, function (actualException) {

                    reject(actualException);
                });
            } else {
                resolve(maybePromisedErrors);
            }
        });
    }, [props.validate]);
    /**
     * Run validation against a Yup schema and optionally run a function if successful
     */

    var runValidationSchema = React.useCallback(function (values, field) {
        var validationSchema = props.validationSchema;
        var schema = isFunction$1(validationSchema) ? validationSchema(field) : validationSchema;
        var promise = field && schema.validateAt ? schema.validateAt(field, values) : validateYupSchema(values, schema);
        return new Promise(function (resolve, reject) {
            promise.then(function () {
                resolve(emptyErrors);
            }, function (err) {
                // Yup will throw a validation error if validation fails. We catch those and
                // resolve them into Formik errors. We can sniff if something is a Yup error
                // by checking error.name.
                // @see https://github.com/jquense/yup#validationerrorerrors-string--arraystring-value-any-path-string
                if (err.name === 'ValidationError') {
                    resolve(yupToFormErrors(err));
                } else {

                    reject(err);
                }
            });
        });
    }, [props.validationSchema]);
    var runSingleFieldLevelValidation = React.useCallback(function (field, value) {
        return new Promise(function (resolve) {
            return resolve(fieldRegistry.current[field].validate(value));
        });
    }, []);
    var runFieldLevelValidations = React.useCallback(function (values) {
        var fieldKeysWithValidation = Object.keys(fieldRegistry.current).filter(function (f) {
            return isFunction$1(fieldRegistry.current[f].validate);
        }); // Construct an array with all of the field validation functions

        var fieldValidations = fieldKeysWithValidation.length > 0 ? fieldKeysWithValidation.map(function (f) {
            return runSingleFieldLevelValidation(f, getIn(values, f));
        }) : [Promise.resolve('DO_NOT_DELETE_YOU_WILL_BE_FIRED')]; // use special case ;)

        return Promise.all(fieldValidations).then(function (fieldErrorsList) {
            return fieldErrorsList.reduce(function (prev, curr, index) {
                if (curr === 'DO_NOT_DELETE_YOU_WILL_BE_FIRED') {
                    return prev;
                }

                if (curr) {
                    prev = setIn(prev, fieldKeysWithValidation[index], curr);
                }

                return prev;
            }, {});
        });
    }, [runSingleFieldLevelValidation]); // Run all validations and return the result

    var runAllValidations = React.useCallback(function (values) {
        return Promise.all([runFieldLevelValidations(values), props.validationSchema ? runValidationSchema(values) : {}, props.validate ? runValidateHandler(values) : {}]).then(function (_ref2) {
            var fieldErrors = _ref2[0],
                schemaErrors = _ref2[1],
                validateErrors = _ref2[2];
            var combinedErrors = deepmerge_1.all([fieldErrors, schemaErrors, validateErrors], {
                arrayMerge: arrayMerge
            });
            return combinedErrors;
        });
    }, [props.validate, props.validationSchema, runFieldLevelValidations, runValidateHandler, runValidationSchema]); // Run validations and dispatching the result as low-priority via rAF.
    //
    // The thinking is that validation as a result of onChange and onBlur
    // should never block user input. Note: This method should never be called
    // during the submission phase because validation prior to submission
    // is actaully high-priority since we absolutely need to guarantee the
    // form is valid before executing props.onSubmit.

    var validateFormWithLowPriority = useEventCallback(function (values) {
        if (values === void 0) {
            values = state.values;
        }

        return scheduler.unstable_runWithPriority(scheduler.unstable_LowPriority, function () {
            return runAllValidations(values).then(function (combinedErrors) {
                if (!!isMounted.current) {
                    dispatch({
                        type: 'SET_ERRORS',
                        payload: combinedErrors
                    });
                }

                return combinedErrors;
            })["catch"](function (actualException) {
            });
        });
    }); // Run all validations methods and update state accordingly

    var validateFormWithHighPriority = useEventCallback(function (values) {
        if (values === void 0) {
            values = state.values;
        }

        dispatch({
            type: 'SET_ISVALIDATING',
            payload: true
        });
        return runAllValidations(values).then(function (combinedErrors) {
            if (!!isMounted.current) {
                dispatch({
                    type: 'SET_ISVALIDATING',
                    payload: false
                });

                if (!exportedEqual(state.errors, combinedErrors)) {
                    dispatch({
                        type: 'SET_ERRORS',
                        payload: combinedErrors
                    });
                }
            }

            return combinedErrors;
        });
    });
    React.useEffect(function () {
        if (validateOnMount && isMounted.current === true && exportedEqual(initialValues.current, props.initialValues)) {
            validateFormWithLowPriority(initialValues.current);
        }
    }, [validateOnMount, validateFormWithLowPriority]);
    var resetForm = React.useCallback(function (nextState) {
        var values = nextState && nextState.values ? nextState.values : initialValues.current;
        var errors = nextState && nextState.errors ? nextState.errors : initialErrors.current ? initialErrors.current : props.initialErrors || {};
        var touched = nextState && nextState.touched ? nextState.touched : initialTouched.current ? initialTouched.current : props.initialTouched || {};
        var status = nextState && nextState.status ? nextState.status : initialStatus.current ? initialStatus.current : props.initialStatus;
        initialValues.current = values;
        initialErrors.current = errors;
        initialTouched.current = touched;
        initialStatus.current = status;

        var dispatchFn = function dispatchFn() {
            dispatch({
                type: 'RESET_FORM',
                payload: {
                    isSubmitting: !!nextState && !!nextState.isSubmitting,
                    errors: errors,
                    touched: touched,
                    status: status,
                    values: values,
                    isValidating: !!nextState && !!nextState.isValidating,
                    submitCount: !!nextState && !!nextState.submitCount && typeof nextState.submitCount === 'number' ? nextState.submitCount : 0
                }
            });
        };

        if (props.onReset) {
            var maybePromisedOnReset = props.onReset(state.values, imperativeMethods);

            if (isPromise(maybePromisedOnReset)) {
                maybePromisedOnReset.then(dispatchFn);
            } else {
                dispatchFn();
            }
        } else {
            dispatchFn();
        }
    }, [props.initialErrors, props.initialStatus, props.initialTouched]);
    React.useEffect(function () {
        if (isMounted.current === true && !exportedEqual(initialValues.current, props.initialValues)) {
            if (enableReinitialize) {
                initialValues.current = props.initialValues;
                resetForm();
            }

            if (validateOnMount) {
                validateFormWithLowPriority(initialValues.current);
            }
        }
    }, [enableReinitialize, props.initialValues, resetForm, validateOnMount, validateFormWithLowPriority]);
    React.useEffect(function () {
        if (enableReinitialize && isMounted.current === true && !exportedEqual(initialErrors.current, props.initialErrors)) {
            initialErrors.current = props.initialErrors || emptyErrors;
            dispatch({
                type: 'SET_ERRORS',
                payload: props.initialErrors || emptyErrors
            });
        }
    }, [enableReinitialize, props.initialErrors]);
    React.useEffect(function () {
        if (enableReinitialize && isMounted.current === true && !exportedEqual(initialTouched.current, props.initialTouched)) {
            initialTouched.current = props.initialTouched || emptyTouched;
            dispatch({
                type: 'SET_TOUCHED',
                payload: props.initialTouched || emptyTouched
            });
        }
    }, [enableReinitialize, props.initialTouched]);
    React.useEffect(function () {
        if (enableReinitialize && isMounted.current === true && !exportedEqual(initialStatus.current, props.initialStatus)) {
            initialStatus.current = props.initialStatus;
            dispatch({
                type: 'SET_STATUS',
                payload: props.initialStatus
            });
        }
    }, [enableReinitialize, props.initialStatus, props.initialTouched]);
    var validateField = useEventCallback(function (name) {
        // This will efficiently validate a single field by avoiding state
        // changes if the validation function is synchronous. It's different from
        // what is called when using validateForm.
        if (fieldRegistry.current[name] && isFunction$1(fieldRegistry.current[name].validate)) {
            var value = getIn(state.values, name);
            var maybePromise = fieldRegistry.current[name].validate(value);

            if (isPromise(maybePromise)) {
                // Only flip isValidating if the function is async.
                dispatch({
                    type: 'SET_ISVALIDATING',
                    payload: true
                });
                return maybePromise.then(function (x) {
                    return x;
                }).then(function (error) {
                    dispatch({
                        type: 'SET_FIELD_ERROR',
                        payload: {
                            field: name,
                            value: error
                        }
                    });
                    dispatch({
                        type: 'SET_ISVALIDATING',
                        payload: false
                    });
                });
            } else {
                dispatch({
                    type: 'SET_FIELD_ERROR',
                    payload: {
                        field: name,
                        value: maybePromise
                    }
                });
                return Promise.resolve(maybePromise);
            }
        } else if (props.validationSchema) {
            dispatch({
                type: 'SET_ISVALIDATING',
                payload: true
            });
            return runValidationSchema(state.values, name).then(function (x) {
                return x;
            }).then(function (error) {
                dispatch({
                    type: 'SET_FIELD_ERROR',
                    payload: {
                        field: name,
                        value: error[name]
                    }
                });
                dispatch({
                    type: 'SET_ISVALIDATING',
                    payload: false
                });
            });
        }

        return Promise.resolve();
    });
    var registerField = React.useCallback(function (name, _ref3) {
        var validate = _ref3.validate;
        fieldRegistry.current[name] = {
            validate: validate
        };
    }, []);
    var unregisterField = React.useCallback(function (name) {
        delete fieldRegistry.current[name];
    }, []);
    var setTouched = useEventCallback(function (touched, shouldValidate) {
        dispatch({
            type: 'SET_TOUCHED',
            payload: touched
        });
        var willValidate = shouldValidate === undefined ? validateOnBlur : shouldValidate;
        return willValidate ? validateFormWithLowPriority(state.values) : Promise.resolve();
    });
    var setErrors = React.useCallback(function (errors) {
        dispatch({
            type: 'SET_ERRORS',
            payload: errors
        });
    }, []);
    var setValues = useEventCallback(function (values, shouldValidate) {
        var resolvedValues = isFunction$1(values) ? values(state.values) : values;
        dispatch({
            type: 'SET_VALUES',
            payload: resolvedValues
        });
        var willValidate = shouldValidate === undefined ? validateOnChange : shouldValidate;
        return willValidate ? validateFormWithLowPriority(resolvedValues) : Promise.resolve();
    });
    var setFieldError = React.useCallback(function (field, value) {
        dispatch({
            type: 'SET_FIELD_ERROR',
            payload: {
                field: field,
                value: value
            }
        });
    }, []);
    var setFieldValue = useEventCallback(function (field, value, shouldValidate) {
        dispatch({
            type: 'SET_FIELD_VALUE',
            payload: {
                field: field,
                value: value
            }
        });
        var willValidate = shouldValidate === undefined ? validateOnChange : shouldValidate;
        return willValidate ? validateFormWithLowPriority(setIn(state.values, field, value)) : Promise.resolve();
    });
    var executeChange = React.useCallback(function (eventOrTextValue, maybePath) {
        // By default, assume that the first argument is a string. This allows us to use
        // handleChange with React Native and React Native Web's onChangeText prop which
        // provides just the value of the input.
        var field = maybePath;
        var val = eventOrTextValue;
        var parsed; // If the first argument is not a string though, it has to be a synthetic React Event (or a fake one),
        // so we handle like we would a normal HTML change event.

        if (!isString(eventOrTextValue)) {
            // If we can, persist the event
            // @see https://reactjs.org/docs/events.html#event-pooling
            if (eventOrTextValue.persist) {
                eventOrTextValue.persist();
            }

            var target = eventOrTextValue.target ? eventOrTextValue.target : eventOrTextValue.currentTarget;
            var type = target.type,
                name = target.name,
                id = target.id,
                value = target.value,
                checked = target.checked,
                outerHTML = target.outerHTML,
                options = target.options,
                multiple = target.multiple;
            field = maybePath ? maybePath : name ? name : id;

            if (!field && "production" !== "production") {
                warnAboutMissingIdentifier({
                    htmlContent: outerHTML,
                    documentationAnchorLink: 'handlechange-e-reactchangeeventany--void',
                    handlerName: 'handleChange'
                });
            }

            val = /number|range/.test(type) ? (parsed = parseFloat(value), isNaN(parsed) ? '' : parsed) : /checkbox/.test(type) // checkboxes
            ? getValueForCheckbox(getIn(state.values, field), checked, value) : !!multiple // <select multiple>
            ? getSelectedValues(options) : value;
        }

        if (field) {
            // Set form fields by name
            setFieldValue(field, val);
        }
    }, [setFieldValue, state.values]);
    var handleChange = useEventCallback(function (eventOrPath) {
        if (isString(eventOrPath)) {
            return function (event) {
                return executeChange(event, eventOrPath);
            };
        } else {
            executeChange(eventOrPath);
        }
    });
    var setFieldTouched = useEventCallback(function (field, touched, shouldValidate) {
        if (touched === void 0) {
            touched = true;
        }

        dispatch({
            type: 'SET_FIELD_TOUCHED',
            payload: {
                field: field,
                value: touched
            }
        });
        var willValidate = shouldValidate === undefined ? validateOnBlur : shouldValidate;
        return willValidate ? validateFormWithLowPriority(state.values) : Promise.resolve();
    });
    var executeBlur = React.useCallback(function (e, path) {
        if (e.persist) {
            e.persist();
        }

        var _e$target = e.target,
            name = _e$target.name,
            id = _e$target.id,
            outerHTML = _e$target.outerHTML;
        var field = path ? path : name ? name : id;

        if (!field && "production" !== "production") {
            warnAboutMissingIdentifier({
                htmlContent: outerHTML,
                documentationAnchorLink: 'handleblur-e-any--void',
                handlerName: 'handleBlur'
            });
        }

        setFieldTouched(field, true);
    }, [setFieldTouched]);
    var handleBlur = useEventCallback(function (eventOrString) {
        if (isString(eventOrString)) {
            return function (event) {
                return executeBlur(event, eventOrString);
            };
        } else {
            executeBlur(eventOrString);
        }
    });
    var setFormikState = React.useCallback(function (stateOrCb) {
        if (isFunction$1(stateOrCb)) {
            dispatch({
                type: 'SET_FORMIK_STATE',
                payload: stateOrCb
            });
        } else {
            dispatch({
                type: 'SET_FORMIK_STATE',
                payload: function payload() {
                    return stateOrCb;
                }
            });
        }
    }, []);
    var setStatus = React.useCallback(function (status) {
        dispatch({
            type: 'SET_STATUS',
            payload: status
        });
    }, []);
    var setSubmitting = React.useCallback(function (isSubmitting) {
        dispatch({
            type: 'SET_ISSUBMITTING',
            payload: isSubmitting
        });
    }, []);
    var submitForm = useEventCallback(function () {
        dispatch({
            type: 'SUBMIT_ATTEMPT'
        });
        return validateFormWithHighPriority().then(function (combinedErrors) {
            // In case an error was thrown and passed to the resolved Promise,
            // `combinedErrors` can be an instance of an Error. We need to check
            // that and abort the submit.
            // If we don't do that, calling `Object.keys(new Error())` yields an
            // empty array, which causes the validation to pass and the form
            // to be submitted.
            var isInstanceOfError = combinedErrors instanceof Error;
            var isActuallyValid = !isInstanceOfError && Object.keys(combinedErrors).length === 0;

            if (isActuallyValid) {
                // Proceed with submit...
                //
                // To respect sync submit fns, we can't simply wrap executeSubmit in a promise and
                // _always_ dispatch SUBMIT_SUCCESS because isSubmitting would then always be false.
                // This would be fine in simple cases, but make it impossible to disable submit
                // buttons where people use callbacks or promises as side effects (which is basically
                // all of v1 Formik code). Instead, recall that we are inside of a promise chain already,
                //  so we can try/catch executeSubmit(), if it returns undefined, then just bail.
                // If there are errors, throw em. Otherwise, wrap executeSubmit in a promise and handle
                // cleanup of isSubmitting on behalf of the consumer.
                var promiseOrUndefined;

                try {
                    promiseOrUndefined = executeSubmit(); // Bail if it's sync, consumer is responsible for cleaning up
                    // via setSubmitting(false)

                    if (promiseOrUndefined === undefined) {
                        return;
                    }
                } catch (error) {
                    throw error;
                }

                return Promise.resolve(promiseOrUndefined).then(function (result) {
                    if (!!isMounted.current) {
                        dispatch({
                            type: 'SUBMIT_SUCCESS'
                        });
                    }

                    return result;
                })["catch"](function (_errors) {
                    if (!!isMounted.current) {
                        dispatch({
                            type: 'SUBMIT_FAILURE'
                        }); // This is a legit error rejected by the onSubmit fn
                        // so we don't want to break the promise chain

                        throw _errors;
                    }
                });
            } else if (!!isMounted.current) {
                // ^^^ Make sure Formik is still mounted before updating state
                dispatch({
                    type: 'SUBMIT_FAILURE'
                }); // throw combinedErrors;

                if (isInstanceOfError) {
                    throw combinedErrors;
                }
            }

            return;
        });
    });
    var handleSubmit = useEventCallback(function (e) {
        if (e && e.preventDefault && isFunction$1(e.preventDefault)) {
            e.preventDefault();
        }

        if (e && e.stopPropagation && isFunction$1(e.stopPropagation)) {
            e.stopPropagation();
        } // Warn if form submission is triggered by a <button> without a

        submitForm()["catch"](function (reason) {
            console.warn("Warning: An unhandled error was caught from submitForm()", reason);
        });
    });
    var imperativeMethods = {
        resetForm: resetForm,
        validateForm: validateFormWithHighPriority,
        validateField: validateField,
        setErrors: setErrors,
        setFieldError: setFieldError,
        setFieldTouched: setFieldTouched,
        setFieldValue: setFieldValue,
        setStatus: setStatus,
        setSubmitting: setSubmitting,
        setTouched: setTouched,
        setValues: setValues,
        setFormikState: setFormikState,
        submitForm: submitForm
    };
    var executeSubmit = useEventCallback(function () {
        return onSubmit(state.values, imperativeMethods);
    });
    var handleReset = useEventCallback(function (e) {
        if (e && e.preventDefault && isFunction$1(e.preventDefault)) {
            e.preventDefault();
        }

        if (e && e.stopPropagation && isFunction$1(e.stopPropagation)) {
            e.stopPropagation();
        }

        resetForm();
    });
    var getFieldMeta = React.useCallback(function (name) {
        return {
            value: getIn(state.values, name),
            error: getIn(state.errors, name),
            touched: !!getIn(state.touched, name),
            initialValue: getIn(initialValues.current, name),
            initialTouched: !!getIn(initialTouched.current, name),
            initialError: getIn(initialErrors.current, name)
        };
    }, [state.errors, state.touched, state.values]);
    var getFieldHelpers = React.useCallback(function (name) {
        return {
            setValue: function setValue(value, shouldValidate) {
                return setFieldValue(name, value, shouldValidate);
            },
            setTouched: function setTouched(value, shouldValidate) {
                return setFieldTouched(name, value, shouldValidate);
            },
            setError: function setError(value) {
                return setFieldError(name, value);
            }
        };
    }, [setFieldValue, setFieldTouched, setFieldError]);
    var getFieldProps = React.useCallback(function (nameOrOptions) {
        var isAnObject = isObject$1(nameOrOptions);
        var name = isAnObject ? nameOrOptions.name : nameOrOptions;
        var valueState = getIn(state.values, name);
        var field = {
            name: name,
            value: valueState,
            onChange: handleChange,
            onBlur: handleBlur
        };

        if (isAnObject) {
            var type = nameOrOptions.type,
                valueProp = nameOrOptions.value,
                is = nameOrOptions.as,
                multiple = nameOrOptions.multiple;

            if (type === 'checkbox') {
                if (valueProp === undefined) {
                    field.checked = !!valueState;
                } else {
                    field.checked = !!(Array.isArray(valueState) && ~valueState.indexOf(valueProp));
                    field.value = valueProp;
                }
            } else if (type === 'radio') {
                field.checked = valueState === valueProp;
                field.value = valueProp;
            } else if (is === 'select' && multiple) {
                field.value = field.value || [];
                field.multiple = true;
            }
        }

        return field;
    }, [handleBlur, handleChange, state.values]);
    var dirty = React.useMemo(function () {
        return !exportedEqual(initialValues.current, state.values);
    }, [initialValues.current, state.values]);
    var isValid = React.useMemo(function () {
        return typeof isInitialValid !== 'undefined' ? dirty ? state.errors && Object.keys(state.errors).length === 0 : isInitialValid !== false && isFunction$1(isInitialValid) ? isInitialValid(props) : isInitialValid : state.errors && Object.keys(state.errors).length === 0;
    }, [isInitialValid, dirty, state.errors, props]);

    var ctx = _extends$1({}, state, {
        initialValues: initialValues.current,
        initialErrors: initialErrors.current,
        initialTouched: initialTouched.current,
        initialStatus: initialStatus.current,
        handleBlur: handleBlur,
        handleChange: handleChange,
        handleReset: handleReset,
        handleSubmit: handleSubmit,
        resetForm: resetForm,
        setErrors: setErrors,
        setFormikState: setFormikState,
        setFieldTouched: setFieldTouched,
        setFieldValue: setFieldValue,
        setFieldError: setFieldError,
        setStatus: setStatus,
        setSubmitting: setSubmitting,
        setTouched: setTouched,
        setValues: setValues,
        submitForm: submitForm,
        validateForm: validateFormWithHighPriority,
        validateField: validateField,
        isValid: isValid,
        dirty: dirty,
        unregisterField: unregisterField,
        registerField: registerField,
        getFieldProps: getFieldProps,
        getFieldMeta: getFieldMeta,
        getFieldHelpers: getFieldHelpers,
        validateOnBlur: validateOnBlur,
        validateOnChange: validateOnChange,
        validateOnMount: validateOnMount
    });

    return ctx;
}

function Formik(props) {
    var formikbag = useFormik(props);
    var component = props.component,
        children = props.children,
        render = props.render,
        innerRef = props.innerRef; // This allows folks to pass a ref to <Formik />

    React.useImperativeHandle(innerRef, function () {
        return formikbag;
    });

    return /*#__PURE__*/React.createElement(FormikProvider, {
        value: formikbag
    }, component ? /*#__PURE__*/React.createElement(component, formikbag) : render ? render(formikbag) : children // children come last, always called
    ? isFunction$1(children) ? children(formikbag) : !isEmptyChildren(children) ? React.Children.only(children) : null : null);
}

function warnAboutMissingIdentifier(_ref4) {
    var htmlContent = _ref4.htmlContent,
        documentationAnchorLink = _ref4.documentationAnchorLink,
        handlerName = _ref4.handlerName;
    console.warn("Warning: Formik called `" + handlerName + "`, but you forgot to pass an `id` or `name` attribute to your input:\n    " + htmlContent + "\n    Formik cannot determine which value to update. For more info see https://github.com/jaredpalmer/formik#" + documentationAnchorLink + "\n  ");
}
/**
 * Transform Yup ValidationError to a more usable object
 */


function yupToFormErrors(yupError) {
    var errors = {};

    if (yupError.inner) {
        if (yupError.inner.length === 0) {
            return setIn(errors, yupError.path, yupError.message);
        }

        for (var _iterator = yupError.inner, _isArray = Array.isArray(_iterator), _i = 0, _iterator = _isArray ? _iterator : _iterator[Symbol.iterator]();;) {
            var _ref5;

            if (_isArray) {
                if (_i >= _iterator.length) break;
                _ref5 = _iterator[_i++];
            } else {
                _i = _iterator.next();
                if (_i.done) break;
                _ref5 = _i.value;
            }

            var err = _ref5;

            if (!getIn(errors, err.path)) {
                errors = setIn(errors, err.path, err.message);
            }
        }
    }

    return errors;
}
/**
 * Validate a yup schema.
 */


function validateYupSchema(values, schema, sync, context) {
    if (sync === void 0) {
        sync = false;
    }

    if (context === void 0) {
        context = {};
    }

    var validateData = prepareDataForValidation(values);
    return schema[sync ? 'validateSync' : 'validate'](validateData, {
        abortEarly: false,
        context: context
    });
}
/**
 * Recursively prepare values.
 */


function prepareDataForValidation(values) {
    var data = Array.isArray(values) ? [] : {};

    for (var k in values) {
        if (Object.prototype.hasOwnProperty.call(values, k)) {
            var key = String(k);

            if (Array.isArray(values[key]) === true) {
                data[key] = values[key].map(function (value) {
                    if (Array.isArray(value) === true || isPlainObject(value)) {
                        return prepareDataForValidation(value);
                    } else {
                        return value !== '' ? value : undefined;
                    }
                });
            } else if (isPlainObject(values[key])) {
                data[key] = prepareDataForValidation(values[key]);
            } else {
                data[key] = values[key] !== '' ? values[key] : undefined;
            }
        }
    }

    return data;
}
/**
 * deepmerge array merging algorithm
 * https://github.com/KyleAMathews/deepmerge#combine-array
 */


function arrayMerge(target, source, options) {
    var destination = target.slice();
    source.forEach(function merge(e, i) {
        if (typeof destination[i] === 'undefined') {
            var cloneRequested = options.clone !== false;
            var shouldClone = cloneRequested && options.isMergeableObject(e);
            destination[i] = shouldClone ? deepmerge_1(Array.isArray(e) ? [] : {}, e, options) : e;
        } else if (options.isMergeableObject(e)) {
            destination[i] = deepmerge_1(target[i], e, options);
        } else if (target.indexOf(e) === -1) {
            destination.push(e);
        }
    });
    return destination;
}
/** Return multi select values based on an array of options */


function getSelectedValues(options) {
    return Array.from(options).filter(function (el) {
        return el.selected;
    }).map(function (el) {
        return el.value;
    });
}
/** Return the next value for a checkbox */


function getValueForCheckbox(currentValue, checked, valueProp) {
    // If the current value was a boolean, return a boolean
    if (typeof currentValue === 'boolean') {
        return Boolean(checked);
    } // If the currentValue was not a boolean we want to return an array


    var currentArrayOfValues = [];
    var isValueInArray = false;
    var index = -1;

    if (!Array.isArray(currentValue)) {
        // eslint-disable-next-line eqeqeq
        if (!valueProp || valueProp == 'true' || valueProp == 'false') {
            return Boolean(checked);
        }
    } else {
        // If the current value is already an array, use it
        currentArrayOfValues = currentValue;
        index = currentValue.indexOf(valueProp);
        isValueInArray = index >= 0;
    } // If the checkbox was checked and the value is not already present in the aray we want to add the new value to the array of values


    if (checked && valueProp && !isValueInArray) {
        return currentArrayOfValues.concat(valueProp);
    } // If the checkbox was unchecked and the value is not in the array, simply return the already existing array of values


    if (!isValueInArray) {
        return currentArrayOfValues;
    } // If the checkbox was unchecked and the value is in the array, remove the value and return the array


    return currentArrayOfValues.slice(0, index).concat(currentArrayOfValues.slice(index + 1));
} // React currently throws a warning when using useLayoutEffect on the server.
// To get around it, we can conditionally useEffect on the server (no-op) and
// useLayoutEffect in the browser.
// @see https://gist.github.com/gaearon/e7d97cdf38a2907924ea12e4ebdf3c85


var useIsomorphicLayoutEffect = typeof window !== 'undefined' && typeof window.document !== 'undefined' && typeof window.document.createElement !== 'undefined' ? React.useLayoutEffect : React.useEffect;

function useEventCallback(fn) {
    var ref = React.useRef(fn); // we copy a ref to the callback scoped to the current state/props on each render

    useIsomorphicLayoutEffect(function () {
        ref.current = fn;
    });
    return React.useCallback(function () {
        for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
        }

        return ref.current.apply(void 0, args);
    }, []);
}

function useField(propsOrFieldName) {
    var formik = useFormikContext();
    var getFieldProps = formik.getFieldProps,
        getFieldMeta = formik.getFieldMeta,
        getFieldHelpers = formik.getFieldHelpers,
        registerField = formik.registerField,
        unregisterField = formik.unregisterField;
    var isAnObject = isObject$1(propsOrFieldName); // Normalize propsOrFieldName to FieldHookConfig<Val>

    var props = isAnObject ? propsOrFieldName : {
        name: propsOrFieldName
    };
    var fieldName = props.name,
        validateFn = props.validate;
    React.useEffect(function () {
        if (fieldName) {
            registerField(fieldName, {
                validate: validateFn
            });
        }

        return function () {
            if (fieldName) {
                unregisterField(fieldName);
            }
        };
    }, [registerField, unregisterField, fieldName, validateFn]);
    return [getFieldProps(props), getFieldMeta(fieldName), getFieldHelpers(fieldName)];
}

function Field(_ref) {
    var validate = _ref.validate,
        name = _ref.name,
        render = _ref.render,
        children = _ref.children,
        is = _ref.as,
        component = _ref.component,
        props = _objectWithoutPropertiesLoose$1(_ref, ["validate", "name", "render", "children", "as", "component"]);

    var _useFormikContext = useFormikContext(),
        formik = _objectWithoutPropertiesLoose$1(_useFormikContext, ["validate", "validationSchema"]);


    var registerField = formik.registerField,
        unregisterField = formik.unregisterField;
    React.useEffect(function () {
        registerField(name, {
            validate: validate
        });
        return function () {
            unregisterField(name);
        };
    }, [registerField, unregisterField, name, validate]);
    var field = formik.getFieldProps(_extends$1({
        name: name
    }, props));
    var meta = formik.getFieldMeta(name);
    var legacyBag = {
        field: field,
        form: formik
    };

    if (render) {
        return render(_extends$1({}, legacyBag, {
            meta: meta
        }));
    }

    if (isFunction$1(children)) {
        return children(_extends$1({}, legacyBag, {
            meta: meta
        }));
    }

    if (component) {
        // This behavior is backwards compat with earlier Formik 0.9 to 1.x
        if (typeof component === 'string') {
            var innerRef = props.innerRef,
                rest = _objectWithoutPropertiesLoose$1(props, ["innerRef"]);

            return /*#__PURE__*/React.createElement(component, _extends$1({
                ref: innerRef
            }, field, rest), children);
        } // We don't pass `meta` for backwards compat


        return /*#__PURE__*/React.createElement(component, _extends$1({
            field: field,
            form: formik
        }, props), children);
    } // default to input here so we can check for both `as` and `children` above


    var asElement = is || 'input';

    if (typeof asElement === 'string') {
        var _innerRef = props.innerRef,
            _rest = _objectWithoutPropertiesLoose$1(props, ["innerRef"]);

        return /*#__PURE__*/React.createElement(asElement, _extends$1({
            ref: _innerRef
        }, field, _rest), children);
    }

    return /*#__PURE__*/React.createElement(asElement, _extends$1({}, field, props), children);
}

var Form = /*#__PURE__*/React.forwardRef(function (props, ref) {
    // iOS needs an "action" attribute for nice input: https://stackoverflow.com/a/39485162/406725
    // We default the action to "#" in case the preventDefault fails (just updates the URL hash)
    var action = props.action,
        rest = _objectWithoutPropertiesLoose$1(props, ["action"]);

    var _action = action || '#';

    var _useFormikContext = useFormikContext(),
        handleReset = _useFormikContext.handleReset,
        handleSubmit = _useFormikContext.handleSubmit;

    return /*#__PURE__*/React.createElement("form", Object.assign({
        onSubmit: handleSubmit,
        ref: ref,
        onReset: handleReset,
        action: _action
    }, rest));
});
Form.displayName = 'Form';
/**
 * Connect any component to Formik context, and inject as a prop called `formik`;
 * @param Comp React Component
 */


function connect(Comp) {
    var C = function C(props) {
        return /*#__PURE__*/React.createElement(FormikConsumer, null, function (formik) {
            return /*#__PURE__*/React.createElement(Comp, Object.assign({}, props, {
                formik: formik
            }));
        });
    };

    var componentDisplayName = Comp.displayName || Comp.name || Comp.constructor && Comp.constructor.name || 'Component'; // Assign Comp to C.WrappedComponent so we can access the inner component in tests
    // For example, <Field.WrappedComponent /> gets us <FieldInner/>

    C.WrappedComponent = Comp;
    C.displayName = "FormikConnect(" + componentDisplayName + ")";
    return hoistNonReactStatics_cjs(C, Comp // cast type to ComponentClass (even if SFC)
    );
}
/**
 * Some array helpers!
 */


var move = function move(array, from, to) {
    var copy = copyArrayLike(array);
    var value = copy[from];
    copy.splice(from, 1);
    copy.splice(to, 0, value);
    return copy;
};

var swap = function swap(arrayLike, indexA, indexB) {
    var copy = copyArrayLike(arrayLike);
    var a = copy[indexA];
    copy[indexA] = copy[indexB];
    copy[indexB] = a;
    return copy;
};

var insert = function insert(arrayLike, index, value) {
    var copy = copyArrayLike(arrayLike);
    copy.splice(index, 0, value);
    return copy;
};

var replace$1 = function replace(arrayLike, index, value) {
    var copy = copyArrayLike(arrayLike);
    copy[index] = value;
    return copy;
};

var copyArrayLike = function copyArrayLike(arrayLike) {
    if (!arrayLike) {
        return [];
    } else if (Array.isArray(arrayLike)) {
        return [].concat(arrayLike);
    } else {
        var maxIndex = Object.keys(arrayLike).map(function (key) {
            return parseInt(key);
        }).reduce(function (max, el) {
            return el > max ? el : max;
        }, 0);
        return Array.from(_extends$1({}, arrayLike, {
            length: maxIndex + 1
        }));
    }
};

var FieldArrayInner = /*#__PURE__*/function (_React$Component) {
    _inheritsLoose(FieldArrayInner, _React$Component);

    function FieldArrayInner(props) {
        var _this;

        _this = _React$Component.call(this, props) || this;

        _this.updateArrayField = function (fn, alterTouched, alterErrors) {
            var _this$props = _this.props,
                name = _this$props.name,
                setFormikState = _this$props.formik.setFormikState;
            setFormikState(function (prevState) {
                var updateErrors = typeof alterErrors === 'function' ? alterErrors : fn;
                var updateTouched = typeof alterTouched === 'function' ? alterTouched : fn; // values fn should be executed before updateErrors and updateTouched,
                // otherwise it causes an error with unshift.

                var values = setIn(prevState.values, name, fn(getIn(prevState.values, name)));
                var fieldError = alterErrors ? updateErrors(getIn(prevState.errors, name)) : undefined;
                var fieldTouched = alterTouched ? updateTouched(getIn(prevState.touched, name)) : undefined;

                if (isEmptyArray(fieldError)) {
                    fieldError = undefined;
                }

                if (isEmptyArray(fieldTouched)) {
                    fieldTouched = undefined;
                }

                return _extends$1({}, prevState, {
                    values: values,
                    errors: alterErrors ? setIn(prevState.errors, name, fieldError) : prevState.errors,
                    touched: alterTouched ? setIn(prevState.touched, name, fieldTouched) : prevState.touched
                });
            });
        };

        _this.push = function (value) {
            return _this.updateArrayField(function (arrayLike) {
                return [].concat(copyArrayLike(arrayLike), [cloneDeep(value)]);
            }, false, false);
        };

        _this.handlePush = function (value) {
            return function () {
                return _this.push(value);
            };
        };

        _this.swap = function (indexA, indexB) {
            return _this.updateArrayField(function (array) {
                return swap(array, indexA, indexB);
            }, true, true);
        };

        _this.handleSwap = function (indexA, indexB) {
            return function () {
                return _this.swap(indexA, indexB);
            };
        };

        _this.move = function (from, to) {
            return _this.updateArrayField(function (array) {
                return move(array, from, to);
            }, true, true);
        };

        _this.handleMove = function (from, to) {
            return function () {
                return _this.move(from, to);
            };
        };

        _this.insert = function (index, value) {
            return _this.updateArrayField(function (array) {
                return insert(array, index, value);
            }, function (array) {
                return insert(array, index, null);
            }, function (array) {
                return insert(array, index, null);
            });
        };

        _this.handleInsert = function (index, value) {
            return function () {
                return _this.insert(index, value);
            };
        };

        _this.replace = function (index, value) {
            return _this.updateArrayField(function (array) {
                return replace$1(array, index, value);
            }, false, false);
        };

        _this.handleReplace = function (index, value) {
            return function () {
                return _this.replace(index, value);
            };
        };

        _this.unshift = function (value) {
            var length = -1;

            _this.updateArrayField(function (array) {
                var arr = array ? [value].concat(array) : [value];

                if (length < 0) {
                    length = arr.length;
                }

                return arr;
            }, function (array) {
                var arr = array ? [null].concat(array) : [null];

                if (length < 0) {
                    length = arr.length;
                }

                return arr;
            }, function (array) {
                var arr = array ? [null].concat(array) : [null];

                if (length < 0) {
                    length = arr.length;
                }

                return arr;
            });

            return length;
        };

        _this.handleUnshift = function (value) {
            return function () {
                return _this.unshift(value);
            };
        };

        _this.handleRemove = function (index) {
            return function () {
                return _this.remove(index);
            };
        };

        _this.handlePop = function () {
            return function () {
                return _this.pop();
            };
        }; // We need TypeScript generics on these, so we'll bind them in the constructor
        // @todo Fix TS 3.2.1


        _this.remove = _this.remove.bind(_assertThisInitialized$1(_this));
        _this.pop = _this.pop.bind(_assertThisInitialized$1(_this));
        return _this;
    }

    var _proto = FieldArrayInner.prototype;

    _proto.componentDidUpdate = function componentDidUpdate(prevProps) {
        if (this.props.validateOnChange && this.props.formik.validateOnChange && !exportedEqual(getIn(prevProps.formik.values, prevProps.name), getIn(this.props.formik.values, this.props.name))) {
            this.props.formik.validateForm(this.props.formik.values);
        }
    };

    _proto.remove = function remove(index) {
        // We need to make sure we also remove relevant pieces of `touched` and `errors`
        var result;
        this.updateArrayField( // so this gets call 3 times
        function (array) {
            var copy = array ? copyArrayLike(array) : [];

            if (!result) {
                result = copy[index];
            }

            if (isFunction$1(copy.splice)) {
                copy.splice(index, 1);
            }

            return copy;
        }, true, true);
        return result;
    };

    _proto.pop = function pop() {
        // Remove relevant pieces of `touched` and `errors` too!
        var result;
        this.updateArrayField( // so this gets call 3 times
        function (array) {
            var tmp = array;

            if (!result) {
                result = tmp && tmp.pop && tmp.pop();
            }

            return tmp;
        }, true, true);
        return result;
    };

    _proto.render = function render() {
        var arrayHelpers = {
            push: this.push,
            pop: this.pop,
            swap: this.swap,
            move: this.move,
            insert: this.insert,
            replace: this.replace,
            unshift: this.unshift,
            remove: this.remove,
            handlePush: this.handlePush,
            handlePop: this.handlePop,
            handleSwap: this.handleSwap,
            handleMove: this.handleMove,
            handleInsert: this.handleInsert,
            handleReplace: this.handleReplace,
            handleUnshift: this.handleUnshift,
            handleRemove: this.handleRemove
        };

        var _this$props2 = this.props,
            component = _this$props2.component,
            render = _this$props2.render,
            children = _this$props2.children,
            name = _this$props2.name,
            _this$props2$formik = _this$props2.formik,
            restOfFormik = _objectWithoutPropertiesLoose$1(_this$props2$formik, ["validate", "validationSchema"]);

        var props = _extends$1({}, arrayHelpers, {
            form: restOfFormik,
            name: name
        });

        return component ? /*#__PURE__*/React.createElement(component, props) : render ? render(props) : children // children come last, always called
        ? typeof children === 'function' ? children(props) : !isEmptyChildren(children) ? React.Children.only(children) : null : null;
    };

    return FieldArrayInner;
}(React.Component);

FieldArrayInner.defaultProps = {
    validateOnChange: true
};
var FieldArray = /*#__PURE__*/connect(FieldArrayInner);

var ErrorMessageImpl = /*#__PURE__*/function (_React$Component) {
    _inheritsLoose(ErrorMessageImpl, _React$Component);

    function ErrorMessageImpl() {
        return _React$Component.apply(this, arguments) || this;
    }

    var _proto = ErrorMessageImpl.prototype;

    _proto.shouldComponentUpdate = function shouldComponentUpdate(props) {
        if (getIn(this.props.formik.errors, this.props.name) !== getIn(props.formik.errors, this.props.name) || getIn(this.props.formik.touched, this.props.name) !== getIn(props.formik.touched, this.props.name) || Object.keys(this.props).length !== Object.keys(props).length) {
            return true;
        } else {
            return false;
        }
    };

    _proto.render = function render() {
        var _this$props = this.props,
            component = _this$props.component,
            formik = _this$props.formik,
            render = _this$props.render,
            children = _this$props.children,
            name = _this$props.name,
            rest = _objectWithoutPropertiesLoose$1(_this$props, ["component", "formik", "render", "children", "name"]);

        var touch = getIn(formik.touched, name);
        var error = getIn(formik.errors, name);
        return !!touch && !!error ? render ? isFunction$1(render) ? render(error) : null : children ? isFunction$1(children) ? children(error) : null : component ? /*#__PURE__*/React.createElement(component, rest, error) : error : null;
    };

    return ErrorMessageImpl;
}(React.Component);

var ErrorMessage = /*#__PURE__*/connect(ErrorMessageImpl);

var HTML5_INPUT_TYPES = {
    // Map XForm field types to <input type>
    barcode: false,
    file: 'file',
    binary: 'file',
    // wq.db <1.3
    date: 'date',
    dateTime: 'datetime-local',
    decimal: 'number',
    geopoint: false,
    geoshape: false,
    geotrace: false,
    int: 'number',
    select: false,
    select1: false,
    string: 'text',
    time: 'time',
    // String subtypes
    password: 'password',
    email: 'email',
    phone: 'tel',
    text: false,
    note: false
};
function useHtmlInput(_ref) {
    var name = _ref.name,
        type = _ref.type,
        length = _ref['wq:length'];
    return {
        name: name,
        type: HTML5_INPUT_TYPES[type] || 'text',
        maxLength: length && +length
    };
}
function Input(props) {
    var inputProps = useHtmlInput(props),
        name = props.name,
        label = props.label;
    return /*#__PURE__*/React__default['default'].createElement("div", {
        style: {
            marginBottom: '0.5em'
        }
    }, /*#__PURE__*/React__default['default'].createElement("div", {
        style: {
            display: 'flex'
        }
    }, /*#__PURE__*/React__default['default'].createElement("label", {
        htmlFor: name,
        style: {
            width: '25%'
        }
    }, label), /*#__PURE__*/React__default['default'].createElement(Field, _extends({
        style: {
            flex: 1
        }
    }, inputProps))), /*#__PURE__*/React__default['default'].createElement(ErrorMessage, {
        name: name
    }));
}
Input.propTypes = {
    name: PropTypes__default['default'].string,
    type: PropTypes__default['default'].string,
    label: PropTypes__default['default'].string
};

var RouteContext = /*#__PURE__*/React__default['default'].createContext({
    name: '@@CURRENT'
});

function useCurrentRoute() {
    return React.useContext(RouteContext).name;
}

function useRenderContext(routeName) {
    var context = reactRedux.useSelector(function (state) {
        return state.context;
    }),
        currentRoute = useCurrentRoute();
    return context && context[routeName || currentRoute] || {};
}
function useRouteInfo(routeName) {
    var currentRoute = useCurrentRoute(),
        routeInfos = reactRedux.useSelector(function (state) {
        return state.routeInfo;
    }),
        routeInfo = routeInfos && routeInfos[routeName || currentRoute],
        context = useRenderContext(routeName),
        getRouteInfo = useApp().router.getRouteInfo;
    return getRouteInfo(context, routeInfo);
}
function useSiteTitle() {
    var siteTitle = useConfig().site_title,
        contextTitle = useContextTitle();
    return siteTitle || contextTitle;
}
function useContextTitle() {
    var context = useRenderContext(),
        routeInfo = useRouteInfo(),
        getContextTitle = useApp().router.getContextTitle;
    return getContextTitle(context, routeInfo);
}
function useRouteTitle(routeName) {
    var app = useApp(),
        getRouteTitle = app.router.getRouteTitle,
        config = useConfig();

    function routeTitle(routeName) {
        var _app$splitRoute = app.splitRoute(routeName),
            _app$splitRoute2 = _slicedToArray(_app$splitRoute, 3),
            name = _app$splitRoute2[0],
            mode = _app$splitRoute2[1],
            variant = _app$splitRoute2[2];

        var page_config = config.pages[name] || {
            name: name
        };
        return getRouteTitle({
            page_config: page_config,
            mode: mode,
            variant: variant
        });
    }

    if (routeName) {
        return routeTitle(routeName);
    } else {
        return routeTitle;
    }
}
function useReverse() {
    var location = reactRedux.useSelector(reduxFirstRouter.selectLocationState);
    return React.useCallback(function (name, payload, query) {
        var action = {
            type: name.toUpperCase()
        };

        if (!location.routesMap[action.type]) {
            throw new Error("Unknown route: ".concat(action.type));
        }

        if (payload) {
            if (_typeof(payload) === 'object') {
                action.payload = payload;
            } else {
                action.payload = {
                    slug: payload
                };
            }
        }

        if (query) {
            action.meta = {
                query: query
            };
        }

        return action;
    }, [location]);
}
function useIndexRoute() {
    // FIXME: This should be read from the configuration
    return 'index';
}
function useBreadcrumbs() {
    var title = useContextTitle(),
        _useRouteInfo = useRouteInfo(),
        name = _useRouteInfo.name,
        page = _useRouteInfo.page,
        page_config = _useRouteInfo.page_config,
        item_id = _useRouteInfo.item_id,
        mode = _useRouteInfo.mode,
        full_path = _useRouteInfo.full_path,
        parent_id = _useRouteInfo.parent_id,
        parent_label = _useRouteInfo.parent_label,
        parent_conf = _useRouteInfo.parent_conf,
        reverse = useReverse(),
        index = useIndexRoute(),
        getRouteTitle = useApp().router.getRouteTitle;

    if (name === index) {
        return null;
    }

    var links = [],
        addLink = function addLink(url, label) {
        return links.push({
            url: url,
            label: label
        });
    },
        addCurrentPage = function addCurrentPage(label) {
        return addLink(full_path, label);
    };

    addLink(reverse(index), 'Home');

    if (parent_id && parent_conf) {
        addLink(reverse("".concat(parent_conf.page, "_list")), getRouteTitle({
            page_config: parent_conf,
            mode: 'list'
        }));
        addLink(reverse("".concat(parent_conf.page, "_detail"), parent_id), parent_label);
    }

    if (item_id) {
        addLink(reverse("".concat(page_config.name, "_list")), getRouteTitle({
            page_config: page_config,
            mode: 'list'
        }));

        if (mode !== 'detail') {
            var currentTitle = getRouteTitle({
                page_config: page_config,
                mode: mode
            }),
                detailTitle = getRouteTitle({
                page_config: page_config,
                mode: 'detail'
            });
            addLink(reverse("".concat(page, "_detail"), item_id), title === currentTitle ? detailTitle : title);
            addCurrentPage(mode);
        } else {
            addCurrentPage(title);
        }
    } else {
        addCurrentPage(title);
    }

    return links;
}
function useSitemap() {
    var config = useConfig(),
        pages = Object.values(config.pages).filter(function (page) {
        return page.show_in_index !== false;
    }),
        options = pages.filter(function (page) {
        return !page.list;
    }),
        models = pages.filter(function (page) {
        return page.list;
    });
    return {
        options: options,
        models: models
    };
}
function useSpinner() {
    var spinner = reactRedux.useSelector(function (state) {
        return state.spinner;
    });
    return spinner;
}
var AppContext = /*#__PURE__*/React__default['default'].createContext({
    app: {
        plugins: {},
        models: {}
    }
});
function useComponents() {
    return usePluginComponentMap('react', 'components');
}
function useInputComponents() {
    return usePluginComponentMap('react', 'inputs');
}
function useIconComponents() {
    return usePluginComponentMap('react', 'icons');
}
function useIcon(icon) {
    var icons = useIconComponents();

    if (typeof icon === 'string') {
        if (icons[icon]) {
            return icons[icon];
        } else {
            return null;
        }
    } else if (typeof icon === 'function') {
        return icon;
    } else {
        return null;
    }
}
function useViewComponents() {
    return usePluginComponentMap('react', 'views');
}
function useApp() {
    return React.useContext(AppContext).app;
}
function useConfig() {
    var app = useApp();
    return app.config;
}
function useModel(name, filter) {
    var app = useApp(),
        model = app.models[name];

    if (!model) {
        throw new Error("Unknown model name ".concat(name));
    }

    var selector;

    if (typeof filter === 'function' || _typeof(filter) === 'object' && !Array.isArray(filter)) {
        // Filter by query
        selector = reduxOrm.createSelector(model.orm, function (session) {
            return model.getQuerySet(session).filter(filter).toRefArray();
        });
    } else if (filter) {
        // Filter by id (default ModelSelectorSpec behavior)
        selector = function selector(state) {
            return reduxOrm.createSelector(model.orm[name])(state, filter);
        };
    } else {
        // All objects (use getQuerySet() to leverage config.ordering)
        selector = reduxOrm.createSelector(model.orm, function (session) {
            return model.getQuerySet(session).toRefArray();
        });
    }

    return reactRedux.useSelector(selector);
}
function useOutbox() {
    var outbox = reactRedux.useSelector(function (state) {
        return state.offline.outbox;
    }) || [],
        _useApp = useApp(),
        parseOutbox = _useApp.outbox.parseOutbox;

    return parseOutbox(outbox);
}
function useUnsynced(modelConf) {
    var outbox = useOutbox(),
        _useApp2 = useApp(),
        filterUnsynced = _useApp2.outbox.filterUnsynced;

    return filterUnsynced(outbox, modelConf);
}
function useList() {
    var _useRenderContext = useRenderContext(),
        _useRenderContext$lis = _useRenderContext.list,
        contextList = _useRenderContext$lis === void 0 ? [] : _useRenderContext$lis,
        show_unsynced = _useRenderContext.show_unsynced,
        _useRouteInfo2 = useRouteInfo(),
        page_config = _useRouteInfo2.page_config,
        modelList = useModel(page_config.page),
        unsynced = useUnsynced(page_config);

    var list;

    if (show_unsynced) {
        // Context list should generally already equal model list, unless
        // there has been a sync or other model update since last RENDER.
        var seen = {};
        modelList.forEach(function (row) {
            return seen[row.id] = true;
        });
        list = modelList.concat(contextList.filter(function (row) {
            return !seen[row.id];
        }));
    } else {
        // Context list probably came directly from server, ignore local model
        list = contextList;
    }

    var empty = !list || !list.length;
    return {
        page_config: page_config,
        list: list,
        unsynced: show_unsynced ? unsynced : [],
        empty: empty
    };
}
function usePlugin(name) {
    var _useApp3 = useApp(),
        plugins = _useApp3.plugins;

    return plugins[name];
}
function usePluginComponentMap(pluginName, mapName) {
    var plugin = usePlugin(pluginName) || {},
        _plugin$config = plugin.config,
        config = _plugin$config === void 0 ? {} : _plugin$config,
        _config$mapName = config[mapName],
        componentMap = _config$mapName === void 0 ? {} : _config$mapName;
    Object.entries(componentMap).forEach(function (_ref) {
        var _ref2 = _slicedToArray(_ref, 2),
            key = _ref2[0],
            val = _ref2[1];

        componentMap[paramCase(key)] = val;
    });
    return componentMap;
}
function usePluginState(name) {
    var plugin = usePlugin(name),
        pluginState = reactRedux.useSelector(function (state) {
        return state[name];
    });

    if (plugin) {
        return pluginState;
    } else {
        return null;
    }
}
function usePluginContent() {
    var app = useApp(),
        components = useComponents(),
        routeInfo = useRouteInfo();
    var content = React.useMemo(function () {
        return app.callPlugins('runComponent', [routeInfo]).map(function (name) {
            return name ? components[name] : null;
        }).filter(function (component) {
            return !!component;
        });
    }, [routeInfo]);
    return React.useCallback(function PluginContent() {
        if (!content.length) {
            return null;
        } else {
            return /*#__PURE__*/React__default['default'].createElement(React__default['default'].Fragment, null, content.map(function (Component, i) {
                return /*#__PURE__*/React__default['default'].createElement(Component, {
                    key: i
                });
            }));
        }
    }, [content]);
}
function useMessages() {
    var _usePlugin = usePlugin('react'),
        config = _usePlugin.config;

    return config.messages;
}
function useValidate() {
    var app = useApp();
    return React.useCallback(function (values, modelConf) {
        return app.outbox.validate(values, modelConf);
    }, [app]);
}

var HTML = '@@HTML',
    // @wq/router
CURRENT = '@@CURRENT'; // @wq/router

function App(_ref) {
    var route = _ref.route;

    if (!route) {
        route = CURRENT;
    }

    return /*#__PURE__*/React__default['default'].createElement(RouteContext.Provider, {
        value: {
            name: route
        }
    }, /*#__PURE__*/React__default['default'].createElement(AppLayout, {
        showHeader: route === CURRENT
    }));
}
App.propTypes = {
    route: PropTypes__default['default'].string
};

function AppLayout(_ref2) {
    var showHeader = _ref2.showHeader;

    var context = useRenderContext(),
        routeInfo = useRouteInfo(),
        views = useViewComponents(),
        PluginContent = usePluginContent(),
        _useComponents = useComponents(),
        Container = _useComponents.Container,
        Header = _useComponents.Header,
        Footer = _useComponents.Footer,
        Main = _useComponents.Main,
        Spinner = _useComponents.Spinner;

    var name;

    if (routeInfo.pending) {
        name = 'loading';
    } else if (context[HTML]) {
        name = 'server';
    } else if (views[routeInfo.template]) {
        name = routeInfo.template;
    } else if (typeof routeInfo.template === 'string' && views[routeInfo.template.replace('_', '-')]) {
        name = routeInfo.template.replace('_', '-');
    } else if (views[routeInfo.name]) {
        name = routeInfo.name;
    } else if (routeInfo.mode) {
        var page = routeInfo.page,
            mode = routeInfo.mode,
            names = ["".concat(page, "_").concat(mode), "".concat(page, "-").concat(mode), "default-".concat(mode), 'default'];
        name = names.find(function (name) {
            return views[name];
        });
    } else {
        name = 'default';
    }

    var View = views[name];

    if (!View) {
        return /*#__PURE__*/React__default['default'].createElement(Container, null, "Missing ".concat(name, " view!"));
    }

    if (View.fullscreen) {
        return /*#__PURE__*/React__default['default'].createElement(Container, null, /*#__PURE__*/React__default['default'].createElement(View, null), /*#__PURE__*/React__default['default'].createElement(Spinner, null));
    } else {
        return /*#__PURE__*/React__default['default'].createElement(Container, null, showHeader && /*#__PURE__*/React__default['default'].createElement(Header, null), /*#__PURE__*/React__default['default'].createElement(Main, null, /*#__PURE__*/React__default['default'].createElement(View, null), !routeInfo.pending && /*#__PURE__*/React__default['default'].createElement(PluginContent, null)), /*#__PURE__*/React__default['default'].createElement(Footer, null), /*#__PURE__*/React__default['default'].createElement(Spinner, null));
    }
}

AppLayout.propTypes = {
    showHeader: PropTypes__default['default'].bool
};

var messages = {
    // Index
    OTHER_PAGES: 'Options',
    MODEL_PAGES: 'Content',
    // AutoForm, Login
    CANCEL: 'Cancel',
    SUBMIT: 'Submit',
    // DefaultList
    LIST_IS_EMPTY: 'Empty list.',
    SYNCED_ITEMS: 'Synced Items',
    // DeleteForm
    CONFIRM_DELETE: 'Are you sure you want to delete this record?',
    // DeleteForm.native
    CONFIRM_DELETE_TITLE: 'Confirm Deletion',
    CONFIRM_DELETE_OK: 'Yes, Delete',
    CONFIRM_DELETE_CANCEL: 'Cancel',
    // OutboxList
    EMPTY_OUTBOX: 'Empty Outbox',
    RETRY_ALL: 'Retry All',
    OUTBOX_IS_EMPTY: 'No items in outbox.',
    SYNC_ERROR: 'One or more errors found.',
    SYNC_SUCCESS: 'Successfully synced.',
    UNSYNCED_ITEMS: 'Unsynced Items',
    // Logout
    LOGGED_OUT: 'Logged out.',
    LOGGING_OUT: 'Logging out...',
    // Loading
    LOADING: 'Loading...',
    // Geo
    GEO_POINT_NEW: 'Click the {TOOL_ICON} tool to draw a new point.',
    GEO_POINT_EDIT: 'Select the existing point to move it, or click the {TOOL_ICON} tool to draw a new point.',
    GEO_LINE_STRING_NEW: 'Click the {TOOL_ICON} tool to draw a new line.',
    GEO_LINE_STRING_EDIT: 'Select the existing line to move it or its vertices.',
    GEO_POLYGON_NEW: 'Click the {TOOL_ICON} tool to draw a new polygon.',
    GEO_POLYGON_EDIT: 'Select the existing polygon to move it or its vertices.'
};

function Container(_ref) {
    var children = _ref.children;
    return /*#__PURE__*/React__default['default'].createElement(React__default['default'].Fragment, null, children);
}
Container.propTypes = {
    children: PropTypes__default['default'].node
};

function Header() {
    var title = useSiteTitle(),
        links = useBreadcrumbs(),
        _useComponents = useComponents(),
        Breadcrumbs = _useComponents.Breadcrumbs;

    return /*#__PURE__*/React__default['default'].createElement("header", null, /*#__PURE__*/React__default['default'].createElement("h1", null, title), /*#__PURE__*/React__default['default'].createElement(Breadcrumbs, {
        links: links
    }));
}

function Main(_ref) {
    var children = _ref.children;
    return /*#__PURE__*/React__default['default'].createElement("main", null, children);
}
Main.propTypes = {
    children: PropTypes__default['default'].node
};

function Footer() {
    var _useComponents = useComponents(),
        FooterContent = _useComponents.FooterContent;

    return /*#__PURE__*/React__default['default'].createElement("center", null, /*#__PURE__*/React__default['default'].createElement("small", null, /*#__PURE__*/React__default['default'].createElement(FooterContent, null)));
}

function FooterContent() {
    return /*#__PURE__*/React__default['default'].createElement(React__default['default'].Fragment, null, "Powered by", ' ', /*#__PURE__*/React__default['default'].createElement("a", {
        href: "https://wq.io/"
    }, /*#__PURE__*/React__default['default'].createElement("b", null, "wq")));
}

function View(props) {
    return /*#__PURE__*/React__default['default'].createElement("div", props);
}

function ScrollView(_ref) {
    var children = _ref.children;
    return /*#__PURE__*/React__default['default'].createElement("div", {
        style: {
            overflowX: 'hidden',
            overflowY: 'auto'
        }
    }, children);
}
ScrollView.propTypes = {
    children: PropTypes__default['default'].node
};

function HorizontalView(_ref) {
    var children = _ref.children,
        style = _ref.style,
        rest = _objectWithoutProperties(_ref, ["children", "style"]);

    return /*#__PURE__*/React__default['default'].createElement("div", _extends({
        style: _objectSpread2({
            display: 'flex',
            justifyContent: 'space-between'
        }, style)
    }, rest), children);
}
HorizontalView.propTypes = {
    children: PropTypes__default['default'].node,
    style: PropTypes__default['default'].object
};

var variants = {
    default: 'p',
    h1: 'h1',
    h2: 'h2',
    h3: 'h3',
    h4: 'h4',
    h5: 'h5',
    h6: 'h6',
    subtitle1: 'h6',
    subtitle2: 'h6',
    body1: 'p',
    body2: 'p',
    caption: 'small'
};
function Typography(_ref) {
    var variant = _ref.variant,
        rest = _objectWithoutProperties(_ref, ["variant"]);

    var Component = variants[variant] || variants.default;
    return /*#__PURE__*/React__default['default'].createElement(Component, rest);
}
Typography.propTypes = {
    variant: PropTypes__default['default'].string
};

function FormatJson(_ref) {
    var json = _ref.json;
    return /*#__PURE__*/React__default['default'].createElement("pre", null, /*#__PURE__*/React__default['default'].createElement("code", null, JSON.stringify(json, null, 4)));
}
FormatJson.propTypes = {
    json: PropTypes__default['default'].object
};

function Message(_ref) {
    var id = _ref.id;
    var messages = useMessages(),
        message = messages[id] || id;
    return /*#__PURE__*/React__default['default'].createElement(React__default['default'].Fragment, null, message);
}
Message.propTypes = {
    id: PropTypes__default['default'].string
};

function Link(props) {
    return /*#__PURE__*/React__default['default'].createElement(reduxFirstRouterLink.NavLink, props);
}

function Button(_ref) {
    var _ref$type = _ref.type,
        type = _ref$type === void 0 ? 'button' : _ref$type,
        rest = _objectWithoutProperties(_ref, ["type"]);

    return /*#__PURE__*/React__default['default'].createElement("button", _extends({
        type: type
    }, rest));
}
Button.propTypes = {
    type: PropTypes__default['default'].string
};

function ButtonLink(props) {
    return /*#__PURE__*/React__default['default'].createElement(reduxFirstRouterLink.NavLink, _extends({
        style: {
            textDecoration: 'none',
            border: '1px solid #eee',
            borderRadius: '0.2em',
            padding: '0.2em'
        }
    }, props));
}

function IconButton(_ref) {
    var icon = _ref.icon,
        _ref$type = _ref.type,
        type = _ref$type === void 0 ? 'button' : _ref$type,
        rest = _objectWithoutProperties(_ref, ["icon", "type"]);

    var Icon = useIcon(icon);
    return /*#__PURE__*/React__default['default'].createElement("button", _extends({
        type: type
    }, rest), /*#__PURE__*/React__default['default'].createElement(Icon, null));
}
IconButton.propTypes = {
    icon: PropTypes__default['default'].string,
    type: PropTypes__default['default'].string
};

function Fab(_ref) {
    var icon = _ref.icon,
        to = _ref.to,
        rest = _objectWithoutProperties(_ref, ["icon", "to"]);

    var _useComponents = useComponents(),
        Link = _useComponents.Link,
        Icon = useIcon(icon);

    return /*#__PURE__*/React__default['default'].createElement(Link, _extends({
        to: to
    }, rest), /*#__PURE__*/React__default['default'].createElement(Icon, null));
}
Fab.propTypes = {
    icon: PropTypes__default['default'].string,
    to: PropTypes__default['default'].oneOfType([PropTypes__default['default'].string, PropTypes__default['default'].object])
};

function Chip(_ref) {
    var label = _ref.label,
        icon = _ref.icon,
        onDelete = _ref.onDelete,
        rest = _objectWithoutProperties(_ref, ["label", "icon", "onDelete"]);

    var _useComponents = useComponents(),
        IconButton = _useComponents.IconButton,
        Icon = useIcon(icon);

    return /*#__PURE__*/React__default['default'].createElement("span", _extends({
        style: {
            border: '1px solid blue',
            'border-radius': '1em',
            padding: '0.25em'
        }
    }, rest), Icon && /*#__PURE__*/React__default['default'].createElement(Icon, null), label, onDelete && /*#__PURE__*/React__default['default'].createElement(IconButton, {
        icon: "delete",
        onClick: onDelete
    }));
}
Chip.propTypes = {
    label: PropTypes__default['default'].node,
    icon: PropTypes__default['default'].string,
    onDelete: PropTypes__default['default'].func
};

function List(props) {
    return /*#__PURE__*/React__default['default'].createElement("ul", props);
}

function ListItem(_ref) {
    var children = _ref.children,
        description = _ref.description,
        icon = _ref.icon,
        rest = _objectWithoutProperties(_ref, ["children", "description", "icon"]);

    var Icon = useIcon(icon);
    return /*#__PURE__*/React__default['default'].createElement("li", rest, Icon && /*#__PURE__*/React__default['default'].createElement(Icon, null), children, description && /*#__PURE__*/React__default['default'].createElement("small", null, description));
}
ListItem.propTypes = {
    children: PropTypes__default['default'].node,
    description: PropTypes__default['default'].node,
    icon: PropTypes__default['default'].string
};

function ListItemLink(_ref) {
    var children = _ref.children,
        icon = _ref.icon,
        description = _ref.description,
        rest = _objectWithoutProperties(_ref, ["children", "icon", "description"]);

    var _useComponents = useComponents(),
        ListItem = _useComponents.ListItem,
        Link = _useComponents.Link;

    return /*#__PURE__*/React__default['default'].createElement(ListItem, {
        icon: icon,
        description: description
    }, /*#__PURE__*/React__default['default'].createElement(Link, rest, children));
}
ListItemLink.propTypes = {
    children: PropTypes__default['default'].node,
    description: PropTypes__default['default'].node,
    icon: PropTypes__default['default'].string
};

function ListSubheader(props) {
    return /*#__PURE__*/React__default['default'].createElement("li", _extends({
        style: {
            marginTop: 8,
            borderBottom: '1px solid #999',
            color: '#999',
            listStyleType: 'none'
        }
    }, props));
}

function ExpansionPanel(_ref) {
    var summary = _ref.summary,
        children = _ref.children,
        open = _ref.open,
        onToggle = _ref.onToggle;
    var handleToggle;

    if (onToggle) {
        handleToggle = function handleToggle(evt) {
            return onToggle(evt.target.open);
        };
    }

    return /*#__PURE__*/React__default['default'].createElement("details", {
        open: open,
        onToggle: handleToggle
    }, /*#__PURE__*/React__default['default'].createElement("summary", null, summary), children);
}
ExpansionPanel.propTypes = {
    summary: PropTypes__default['default'].node,
    children: PropTypes__default['default'].node,
    open: PropTypes__default['default'].bool,
    onToggle: PropTypes__default['default'].func
};

function Divider() {
    return /*#__PURE__*/React__default['default'].createElement("hr", null);
}

function Table(props) {
    return /*#__PURE__*/React__default['default'].createElement("table", props);
}

function TableHead(props) {
    return /*#__PURE__*/React__default['default'].createElement("thead", props);
}

function TableBody(props) {
    return /*#__PURE__*/React__default['default'].createElement("tbody", props);
}

function TableRow(props) {
    return /*#__PURE__*/React__default['default'].createElement("tr", props);
}

function TableTitle(props) {
    return /*#__PURE__*/React__default['default'].createElement("th", props);
}

function TableCell(props) {
    return /*#__PURE__*/React__default['default'].createElement("td", props);
}

function AutoForm(_ref) {
    var action = _ref.action,
        cancel = _ref.cancel,
        method = _ref.method,
        storage = _ref.storage,
        backgroundSync = _ref.backgroundSync,
        outboxId = _ref.outboxId,
        _ref$form = _ref.form,
        form = _ref$form === void 0 ? [] : _ref$form,
        modelConf = _ref.modelConf,
        data = _ref.data,
        error = _ref.error,
        children = _ref.children;

    var _useComponents = useComponents(),
        Message = _useComponents.Message,
        AutoInput = _useComponents.AutoInput,
        Form = _useComponents.Form,
        FormError = _useComponents.FormError,
        HorizontalView = _useComponents.HorizontalView,
        CancelButton = _useComponents.CancelButton,
        SubmitButton = _useComponents.SubmitButton;

    var formData = initData(form, data);

    if (!modelConf) {
        modelConf = {
            form: form
        };
    }

    return /*#__PURE__*/React__default['default'].createElement(Form, {
        action: action,
        method: method,
        data: formData,
        modelConf: modelConf,
        error: error,
        storage: storage,
        backgroundSync: backgroundSync,
        outboxId: outboxId
    }, (form || []).map(function (_ref2) {
        var name = _ref2.name,
            subform = _ref2.children,
            rest = _objectWithoutProperties(_ref2, ["name", "children"]);

        return /*#__PURE__*/React__default['default'].createElement(AutoInput, _extends({
            key: name,
            name: name,
            subform: subform
        }, rest));
    }), /*#__PURE__*/React__default['default'].createElement(FormError, null), /*#__PURE__*/React__default['default'].createElement(HorizontalView, null, cancel && /*#__PURE__*/React__default['default'].createElement(CancelButton, {
        to: cancel
    }, /*#__PURE__*/React__default['default'].createElement(Message, {
        id: "CANCEL"
    })), /*#__PURE__*/React__default['default'].createElement(SubmitButton, null, /*#__PURE__*/React__default['default'].createElement(Message, {
        id: "SUBMIT"
    }))), children);
}
AutoForm.propTypes = {
    action: PropTypes__default['default'].string,
    cancel: PropTypes__default['default'].object,
    method: PropTypes__default['default'].string,
    storage: PropTypes__default['default'].string,
    backgroundSync: PropTypes__default['default'].bool,
    outboxId: PropTypes__default['default'].number,
    form: PropTypes__default['default'].arrayOf(PropTypes__default['default'].object),
    modelConf: PropTypes__default['default'].object,
    data: PropTypes__default['default'].object,
    error: PropTypes__default['default'].oneOfType([PropTypes__default['default'].object, PropTypes__default['default'].string]),
    children: PropTypes__default['default'].node
};
function initData(form, data) {
    if (!data) {
        data = {};
    }

    var formData = {};

    if (data.id) {
        formData.id = data.id;
    }

    form.forEach(function (field) {
        var fieldName = field['wq:ForeignKey'] ? "".concat(field.name, "_id") : field.name;
        var value;

        if (field.type === 'repeat') {
            value = (data[fieldName] || []).map(function (row) {
                return initData(field.children, row);
            });
        } else if (field.type === 'group') {
            if (fieldName) {
                value = initData(field.children, data[fieldName] || {});
            } else {
                value = initData(field.children, data);
            }
        } else if (fieldName in data) {
            value = data[fieldName];
        } else {
            value = defaultValue(field);
        }

        if (fieldName) {
            formData[fieldName] = value;
        } else {
            Object.assign(formData, value);
        }
    });
    return formData;

    function defaultValue(field) {
        if (field.type === 'select') {
            return [];
        } else if (field.type === 'date' || field.type === 'time' || field.type === 'dateTime') {
            return null;
        } else {
            return '';
        }
    }
}

function pascalCaseTransform(input, index) {
    var firstChar = input.charAt(0);
    var lowerChars = input.substr(1).toLowerCase();

    if (index > 0 && firstChar >= "0" && firstChar <= "9") {
        return "_" + firstChar + lowerChars;
    }

    return "" + firstChar.toUpperCase() + lowerChars;
}
function pascalCase(input, options) {
    if (options === void 0) {
        options = {};
    }

    return noCase(input, _assign({
        delimiter: "",
        transform: pascalCaseTransform
    }, options));
}

function AutoInput(_ref) {
    var name = _ref.name,
        choices = _ref.choices,
        type = _ref.type,
        _ref$bind = _ref.bind,
        bind = _ref$bind === void 0 ? {} : _ref$bind,
        rest = _objectWithoutProperties(_ref, ["name", "choices", "type", "bind"]);

    var inputs = useInputComponents(),
        _useComponents = useComponents(),
        AutoSubform = _useComponents.AutoSubform,
        AutoSubformArray = _useComponents.AutoSubformArray,
        Text = _useComponents.Text,
        context = useRenderContext();

    if (type === 'group') {
        return /*#__PURE__*/React__default['default'].createElement(AutoSubform, _extends({
            name: name
        }, rest));
    } else if (type === 'repeat') {
        return /*#__PURE__*/React__default['default'].createElement(AutoSubformArray, _extends({
            name: name
        }, rest));
    }

    var inputType,
        required = bind.required;

    if (rest['wq:ForeignKey']) {
        var choicesFn = context[name.replace(/\[\d+\]/, '') + '_list'];
        choices = choicesFn ? choicesFn.call(context) : [];
        choices = choices.map(function (_ref2) {
            var id = _ref2.id,
                label = _ref2.label,
                outbox = _ref2.outbox;
            return {
                name: id,
                label: outbox ? "* ".concat(label) : label
            };
        });
        name = "".concat(name, "_id");
        inputType = 'select';
    } else if (type === 'select1' || type === 'select one') {
        if (!choices) {
            choices = [];
        }

        if (choices.length < 5) {
            inputType = 'toggle';
        } else if (choices.length < 10) {
            inputType = 'radio';
        } else {
            inputType = 'select';
        }
    } else if (inputs[type]) {
        inputType = type;
    } else {
        if (type === 'picture' || type === 'photo') {
            inputType = 'image';
        } else if (type === 'video' || type === 'audio') {
            inputType = 'file';
        } else if (type === 'binary') {
            // wq.db <1.3
            inputType = 'file';
        } else {
            inputType = 'input';
        }
    }

    if (rest.control && rest.control.appearance) {
        inputType = rest.control.appearance;
    }

    var Input = inputs[inputType];

    if (!Input) {
        return /*#__PURE__*/React__default['default'].createElement(Text, null, "Unknown input type \"", inputType, "\". Perhaps you need to define inputs.", pascalCase(inputType), " in a plugin?");
    }

    return /*#__PURE__*/React__default['default'].createElement(Input, _extends({
        name: name,
        choices: choices,
        type: type,
        required: required
    }, rest));
}
AutoInput.propTypes = {
    name: PropTypes__default['default'].string,
    type: PropTypes__default['default'].string,
    bind: PropTypes__default['default'].object,
    'wq:ForeignKey': PropTypes__default['default'].string,
    choices: PropTypes__default['default'].arrayOf(PropTypes__default['default'].object)
};

function AutoSubform(_ref) {
    var name = _ref.name,
        label = _ref.label,
        subform = _ref.subform,
        component = _ref.component,
        rest = _objectWithoutProperties(_ref, ["name", "label", "subform", "component"]);

    var components = useComponents(),
        AutoInput = components.AutoInput,
        componentName = rest.control && rest.control.appearance;
    var Fieldset;

    if (component) {
        // Passed in from parent AutoSubformArray
        Fieldset = component;
    } else if (componentName) {
        // Defined in XLSForm config
        Fieldset = components[componentName];

        if (!Fieldset) {
            // eslint-disable-next-line
            Fieldset = function Fieldset(_ref2) {
                var children = _ref2.children,
                    rest = _objectWithoutProperties(_ref2, ["children"]);

                var Text = components.Text,
                    Fieldset = components.Fieldset;
                return /*#__PURE__*/React__default['default'].createElement(Fieldset, rest, /*#__PURE__*/React__default['default'].createElement(Text, null, "Unknown fieldset type \"", componentName, "\". Perhaps you need to define components.", pascalCase(componentName), " in a plugin?"), children);
            };
        }
    } else {
        // Default (or global default override)
        Fieldset = components.Fieldset;
    }

    var prefix = name ? "".concat(name, ".") : '';
    return /*#__PURE__*/React__default['default'].createElement(Fieldset, {
        name: name,
        label: label
    }, subform.map(function (_ref3) {
        var fieldName = _ref3.name,
            subform = _ref3.children,
            rest = _objectWithoutProperties(_ref3, ["name", "children"]);

        return /*#__PURE__*/React__default['default'].createElement(AutoInput, _extends({
            key: fieldName,
            name: "".concat(prefix).concat(fieldName),
            subform: subform
        }, rest));
    }));
}
AutoSubform.propTypes = {
    name: PropTypes__default['default'].string,
    label: PropTypes__default['default'].string,
    subform: PropTypes__default['default'].arrayOf(PropTypes__default['default'].object),
    component: PropTypes__default['default'].elementType
};

function AutoSubformArray(_ref) {
    var name = _ref.name,
        label = _ref.label,
        subform = _ref.subform,
        rest = _objectWithoutProperties(_ref, ["name", "label", "subform"]);

    var components = useComponents(),
        AutoSubform = components.AutoSubform,
        componentName = rest.control && rest.control.appearance;
    var FieldsetArray;

    if (componentName) {
        // Defined in XLSForm config
        FieldsetArray = components[componentName];

        if (!FieldsetArray) {
            // eslint-disable-next-line
            FieldsetArray = function FieldsetArray(_ref2) {
                var children = _ref2.children,
                    rest = _objectWithoutProperties(_ref2, ["children"]);

                var Text = components.Text,
                    FieldsetArray = components.FieldsetArray;
                return /*#__PURE__*/React__default['default'].createElement(FieldsetArray, rest, /*#__PURE__*/React__default['default'].createElement(Text, null, "Unknown fieldset array type \"", componentName, "\". Perhaps you need to define components.", pascalCase(componentName), " in a plugin?"), children);
            };
        }
    } else if (subform.length === 1 && (subform[0].type === 'file' || subform[0].type === 'image')) {
        // Special case for subforms containing only a single file field
        FieldsetArray = components.FileArray;
    } else {
        // Default (or global default override)
        FieldsetArray = components.FieldsetArray;
    }

    var SubformArray = React.useCallback(function (_ref3) {
        var formikContext = _ref3.form,
            push = _ref3.push,
            pop = _ref3.pop;
        var values = formikContext.values,
            list = getIn(values, name) || [];

        function addRow(vals) {
            var row = initData(subform, vals || {});
            push(row);
        }

        var removeLastRow = pop;
        return /*#__PURE__*/React__default['default'].createElement(FieldsetArray, _extends({
            name: name,
            label: label,
            subform: subform,
            addRow: addRow,
            removeLastRow: removeLastRow
        }, rest), list.map(function (row, i) {
            return /*#__PURE__*/React__default['default'].createElement(AutoSubform, {
                key: i,
                label: "".concat(label, " ").concat(i + 1),
                name: "".concat(name, "[").concat(i, "]"),
                subform: subform,
                component: FieldsetArray.Fieldset
            });
        }));
    }, [name, label, subform, FieldsetArray, AutoSubform]);
    SubformArray.displayName = 'SubformArray';
    return /*#__PURE__*/React__default['default'].createElement(FieldArray, {
        name: name,
        component: SubformArray,
        label: label,
        subform: subform
    });
}
AutoSubformArray.propTypes = {
    name: PropTypes__default['default'].string,
    label: PropTypes__default['default'].string,
    subform: PropTypes__default['default'].arrayOf(PropTypes__default['default'].object)
};

var Value = function Value(_ref) {
    var values = _ref.values,
        field = _ref.field;

    var _useComponents = useComponents(),
        FormatJson = _useComponents.FormatJson,
        value = values[field.name];

    if (field['wq:ForeignKey']) {
        if (value && _typeof(value) === 'object' && value.label) {
            return value.label;
        } else {
            return values[field.name + '_label'] || values[field.name + '_id'];
        }
    } else if (_typeof(value) === 'object') {
        return /*#__PURE__*/React__default['default'].createElement(FormatJson, {
            json: value
        });
    } else {
        return value + '';
    }
};

function PropertyTable(_ref2) {
    var form = _ref2.form,
        values = _ref2.values;

    var _useComponents2 = useComponents(),
        Table = _useComponents2.Table,
        TableBody = _useComponents2.TableBody,
        TableRow = _useComponents2.TableRow,
        TableCell = _useComponents2.TableCell,
        rootFieldset = form.find(function (field) {
        return field.name === '' && field.type === 'group';
    }),
        fields = rootFieldset ? rootFieldset.children.concat(form.filter(function (field) {
        return field !== rootFieldset;
    })) : form;

    return /*#__PURE__*/React__default['default'].createElement(Table, null, /*#__PURE__*/React__default['default'].createElement(TableBody, null, fields.map(function (field) {
        return /*#__PURE__*/React__default['default'].createElement(TableRow, {
            key: field.name
        }, /*#__PURE__*/React__default['default'].createElement(TableCell, null, field.label || field.name), /*#__PURE__*/React__default['default'].createElement(TableCell, null, /*#__PURE__*/React__default['default'].createElement(Value, {
            values: values,
            field: field
        })));
    })));
}
PropertyTable.propTypes = {
    form: PropTypes__default['default'].arrayOf(PropTypes__default['default'].object),
    values: PropTypes__default['default'].object
};

function Form$1(_ref) {
    var action = _ref.action,
        method = _ref.method,
        onSubmit = _ref.onSubmit,
        storage = _ref.storage,
        backgroundSync = _ref.backgroundSync,
        outboxId = _ref.outboxId,
        preserve = _ref.preserve,
        modelConf = _ref.modelConf,
        _ref$data = _ref.data,
        data = _ref$data === void 0 ? {} : _ref$data,
        error = _ref.error,
        children = _ref.children;

    var app = useApp(),
        _validate = useValidate(),
        _useComponents = useComponents(),
        FormRoot = _useComponents.FormRoot;

    if (backgroundSync === undefined) {
        backgroundSync = app.config.backgroundSync;
    }

    function handleSubmit(_x, _x2) {
        return _handleSubmit.apply(this, arguments);
    }

    function _handleSubmit() {
        _handleSubmit = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime__default['default'].mark(function _callee(values, _ref2) {
            var setSubmitting, setTouched, setErrors, result, has_files, _yield$app$submitForm, _yield$app$submitForm2, item, error, _errors;

            return _regeneratorRuntime__default['default'].wrap(function _callee$(_context) {
                while (1) {
                    switch (_context.prev = _context.next) {
                        case 0:
                            setSubmitting = _ref2.setSubmitting, setTouched = _ref2.setTouched, setErrors = _ref2.setErrors;

                            if (!onSubmit) {
                                _context.next = 8;
                                break;
                            }

                            _context.next = 4;
                            return onSubmit(values);

                        case 4:
                            result = _context.sent;

                            if (result) {
                                _context.next = 8;
                                break;
                            }

                            setSubmitting(false);
                            return _context.abrupt("return");

                        case 8:
                            has_files = checkForFiles(values);
                            _context.next = 11;
                            return app.submitForm({
                                url: action,
                                storage: storage,
                                backgroundSync: backgroundSync,
                                has_files: has_files,
                                outboxId: outboxId,
                                preserve: preserve,
                                data: _objectSpread2({
                                    _method: method
                                }, values)
                            });

                        case 11:
                            _yield$app$submitForm = _context.sent;
                            _yield$app$submitForm2 = _slicedToArray(_yield$app$submitForm, 2);
                            item = _yield$app$submitForm2[0];
                            error = _yield$app$submitForm2[1];

                            if (error) {
                                _errors = parseApiError(item.error, values);
                                setErrors(_errors);
                                setTouched(_errors, false);
                            }

                            setSubmitting(false);

                        case 17:
                        case "end":
                            return _context.stop();
                    }
                }
            }, _callee);
        }));
        return _handleSubmit.apply(this, arguments);
    }

    var errors = parseApiError(error, data);
    return /*#__PURE__*/React__default['default'].createElement(Formik, {
        initialValues: data,
        initialErrors: errors,
        initialTouched: errors,
        validate: function validate(values) {
            return _validate(values, modelConf);
        },
        validateOnBlur: true,
        validateOnChange: false,
        onSubmit: handleSubmit,
        enableReinitialize: true
    }, /*#__PURE__*/React__default['default'].createElement(FormRoot, null, children));
}
Form$1.propTypes = {
    action: PropTypes__default['default'].string,
    method: PropTypes__default['default'].string,
    onSubmit: PropTypes__default['default'].func,
    storage: PropTypes__default['default'].string,
    backgroundSync: PropTypes__default['default'].bool,
    outboxId: PropTypes__default['default'].number,
    preserve: PropTypes__default['default'].arrayOf(PropTypes__default['default'].string),
    modelConf: PropTypes__default['default'].object,
    data: PropTypes__default['default'].object,
    error: PropTypes__default['default'].oneOfType([PropTypes__default['default'].object, PropTypes__default['default'].string]),
    children: PropTypes__default['default'].node
};

function parseApiError(error, values) {
    if (!error) {
        return;
    }

    var errors = {};

    if (typeof error === 'string') {
        errors['__other__'] = error;
    } else {
        Object.entries(error).map(function (_ref3) {
            var _ref4 = _slicedToArray(_ref3, 2),
                key = _ref4[0],
                error = _ref4[1];

            if (!(key in values)) {
                key = '__other__';
            }

            if (Array.isArray(error)) {
                if (_typeof(error[0]) === 'object') {
                    errors[key] = error.map(function (err, i) {
                        return parseApiError(err, (values[key] || [])[i] || {});
                    });
                    return;
                }
            } else if (_typeof(error) === 'object') {
                errors[key] = parseApiError(error, values[key] || {});
                return;
            } else {
                error = [error];
            }

            if (errors[key]) {
                error = [errors[key]].concat(_toConsumableArray(error));
            }

            errors[key] = error.join('; ');
        });
    }

    return errors;
}

function checkForFiles(values) {
    if (!values || _typeof(values) !== 'object') {
        return false;
    }

    if (values.name && values.type && values.body) {
        return true;
    }

    if (Array.isArray(values)) {
        return values.some(checkForFiles);
    }

    return Object.values(values).some(checkForFiles);
}

function FormRoot(_ref) {
    var children = _ref.children;
    return /*#__PURE__*/React__default['default'].createElement(Form, {
        style: {
            padding: '1em'
        }
    }, children);
}
FormRoot.propTypes = {
    children: PropTypes__default['default'].node
};

function FormError() {
    var _useField = useField('__other__'),
        _useField2 = _slicedToArray(_useField, 2),
        error = _useField2[1].error;

    if (!error) {
        return null;
    }

    return error;
}

function Fieldset(_ref) {
    var label = _ref.label,
        children = _ref.children;
    return /*#__PURE__*/React__default['default'].createElement("fieldset", null, /*#__PURE__*/React__default['default'].createElement("legend", null, label), children);
}
Fieldset.propTypes = {
    label: PropTypes__default['default'].string,
    children: PropTypes__default['default'].node
};

function FlatFieldset(_ref) {
    var label = _ref.label,
        children = _ref.children;
    return /*#__PURE__*/React__default['default'].createElement(React__default['default'].Fragment, null, /*#__PURE__*/React__default['default'].createElement("h6", null, label), children);
}
FlatFieldset.propTypes = {
    label: PropTypes__default['default'].string,
    children: PropTypes__default['default'].node
};

function FieldsetArray(_ref) {
    var label = _ref.label,
        children = _ref.children,
        addRow = _ref.addRow;

    var _useComponents = useComponents(),
        View = _useComponents.View,
        Button = _useComponents.Button;

    return /*#__PURE__*/React__default['default'].createElement(View, null, children, addRow && /*#__PURE__*/React__default['default'].createElement(Button, {
        onClick: function onClick() {
            return addRow();
        }
    }, "Add ".concat(label)));
}
FieldsetArray.propTypes = {
    label: PropTypes__default['default'].string,
    children: PropTypes__default['default'].node,
    addRow: PropTypes__default['default'].func
};

function SubmitButton(props) {
    var _useComponents = useComponents(),
        Button = _useComponents.Button,
        _useFormikContext = useFormikContext(),
        isSubmitting = _useFormikContext.isSubmitting;

    return /*#__PURE__*/React__default['default'].createElement(Button, _extends({
        type: "submit",
        disabled: isSubmitting
    }, props));
}

function IconSubmitButton(props) {
    var _useComponents = useComponents(),
        IconButton = _useComponents.IconButton,
        _useFormikContext = useFormikContext(),
        isSubmitting = _useFormikContext.isSubmitting;

    return /*#__PURE__*/React__default['default'].createElement(IconButton, _extends({
        type: "submit",
        disabled: isSubmitting
    }, props));
}

function DeleteForm(_ref) {
    var action = _ref.action;

    var _useComponents = useComponents(),
        Form = _useComponents.Form,
        SubmitButton = _useComponents.SubmitButton,
        View = _useComponents.View,
        HorizontalView = _useComponents.HorizontalView,
        _useMessages = useMessages(),
        CONFIRM_DELETE = _useMessages.CONFIRM_DELETE;

    function confirmSubmit() {
        return window.confirm(CONFIRM_DELETE);
    }

    return /*#__PURE__*/React__default['default'].createElement(Form, {
        action: action,
        method: "DELETE",
        backgroundSync: false,
        onSubmit: confirmSubmit
    }, /*#__PURE__*/React__default['default'].createElement(HorizontalView, null, /*#__PURE__*/React__default['default'].createElement(View, null), /*#__PURE__*/React__default['default'].createElement(SubmitButton, null, "Delete")));
}
DeleteForm.propTypes = {
    action: PropTypes__default['default'].string
};

var style = {
    position: 'absolute',
    top: '1em',
    right: '1em',
    color: 'gray'
};
function Spinner() {
    var _useSpinner = useSpinner(),
        active = _useSpinner.active;

    if (!active) {
        return null;
    } // FIXME: text, type


    return /*#__PURE__*/React__default['default'].createElement("div", {
        style: style
    }, "(Working...)");
}

function Breadcrumbs(_ref) {
    var links = _ref.links;

    var _useComponents = useComponents(),
        Link = _useComponents.Link;

    if (!links) {
        return null;
    }

    links[links.length - 1].last = true;
    return /*#__PURE__*/React__default['default'].createElement("div", null, links.map(function (_ref2, i) {
        var url = _ref2.url,
            label = _ref2.label,
            last = _ref2.last;
        return /*#__PURE__*/React__default['default'].createElement(React__default['default'].Fragment, {
            key: i
        }, /*#__PURE__*/React__default['default'].createElement(Link, {
            key: i,
            to: url
        }, label), !last && /*#__PURE__*/React__default['default'].createElement(React__default['default'].Fragment, null, " > "));
    }));
}
Breadcrumbs.propTypes = {
    links: PropTypes__default['default'].arrayOf(PropTypes__default['default'].object)
};

function Pagination() {
    var _useComponents = useComponents(),
        Link = _useComponents.Link,
        _useRenderContext = useRenderContext(),
        multiple = _useRenderContext.multiple,
        pageNum = _useRenderContext.page,
        pages = _useRenderContext.pages,
        per_page = _useRenderContext.per_page,
        previous = _useRenderContext.previous,
        next = _useRenderContext.next,
        previous_is_local = _useRenderContext.previous_is_local,
        current_is_local = _useRenderContext.current_is_local;

    if (!(multiple && pages && per_page)) {
        return null;
    }

    return /*#__PURE__*/React__default['default'].createElement("p", null, previous && /*#__PURE__*/React__default['default'].createElement(Link, {
        to: previous
    }, "<", ' ', previous_is_local ? 'Local Cache' : "Previous ".concat(per_page)), !current_is_local && /*#__PURE__*/React__default['default'].createElement(React__default['default'].Fragment, null, "Page ", pageNum, " of ", pages), next && /*#__PURE__*/React__default['default'].createElement(Link, {
        to: next
    }, current_is_local ? 'All Data' : "Next ".concat(per_page), " >"));
}

var SKIP = ['app_config', 'wq_config', 'router_info', 'rt', 'svc', 'user', 'is_authenticated', 'csrf_token', 'native', 'unsynced', 'local', '_refreshCount'];
function DebugContext() {
    var context = useRenderContext(),
        routeInfo = useRouteInfo(),
        _useComponents = useComponents(),
        List = _useComponents.List,
        ListSubheader = _useComponents.ListSubheader,
        FormatJson = _useComponents.FormatJson;

    var main = _objectSpread2({}, context),
        other = {};

    SKIP.forEach(function (skip) {
        other[skip] = main[skip];
        delete main[skip];
    });
    return /*#__PURE__*/React__default['default'].createElement(List, null, /*#__PURE__*/React__default['default'].createElement(ListSubheader, null, "Context"), /*#__PURE__*/React__default['default'].createElement(FormatJson, {
        json: main
    }), /*#__PURE__*/React__default['default'].createElement(ListSubheader, null, "Route Info"), /*#__PURE__*/React__default['default'].createElement(FormatJson, {
        json: routeInfo
    }), /*#__PURE__*/React__default['default'].createElement(ListSubheader, null, "Additional Context"), /*#__PURE__*/React__default['default'].createElement(FormatJson, {
        json: other
    }));
}

var components = /*#__PURE__*/Object.freeze({
__proto__: null,
Container: Container,
Header: Header,
Main: Main,
Footer: Footer,
FooterContent: FooterContent,
View: View,
ScrollView: ScrollView,
HorizontalView: HorizontalView,
Text: React.Fragment,
Typography: Typography,
FormatJson: FormatJson,
Link: Link,
Button: Button,
ButtonLink: ButtonLink,
IconButton: IconButton,
Fab: Fab,
Chip: Chip,
Message: Message,
List: List,
ListItem: ListItem,
ListItemLink: ListItemLink,
ListSubheader: ListSubheader,
ExpansionPanel: ExpansionPanel,
Divider: Divider,
Table: Table,
TableHead: TableHead,
TableBody: TableBody,
TableRow: TableRow,
TableTitle: TableTitle,
TableCell: TableCell,
AutoForm: AutoForm,
AutoInput: AutoInput,
AutoSubform: AutoSubform,
AutoSubformArray: AutoSubformArray,
PropertyTable: PropertyTable,
Form: Form$1,
FormRoot: FormRoot,
FormError: FormError,
Fieldset: Fieldset,
FlatFieldset: FlatFieldset,
FieldsetArray: FieldsetArray,
FileArray: FieldsetArray,
CancelButton: ButtonLink,
SubmitButton: SubmitButton,
IconSubmitButton: IconSubmitButton,
DeleteForm: DeleteForm,
Spinner: Spinner,
Breadcrumbs: Breadcrumbs,
Pagination: Pagination,
DebugContext: DebugContext
});

function File(_ref) {
    var name = _ref.name,
        label = _ref.label,
        rest = _objectWithoutProperties(_ref, ["name", "label"]);

    var _useField = useField(name),
        _useField2 = _slicedToArray(_useField, 3),
        _useField2$ = _useField2[1],
        value = _useField2$.value,
        initialValue = _useField2$.initialValue,
        setValue = _useField2[2].setValue;

    function setFile(evt) {
        if (evt.target.files) {
            var _evt$target$files$ = evt.target.files[0],
                _name = _evt$target$files$.name,
                type = _evt$target$files$.type;
            setValue({
                name: _name,
                type: type,
                body: evt.target.files[0]
            });
        } else {
            setValue(initialValue || null);
        }
    }

    var hasValue = value && value !== '__clear__';
    return /*#__PURE__*/React__default['default'].createElement("div", {
        style: {
            marginBottom: '0.5em'
        }
    }, /*#__PURE__*/React__default['default'].createElement("div", {
        style: {
            display: 'flex'
        }
    }, /*#__PURE__*/React__default['default'].createElement("label", {
        htmlFor: name,
        style: {
            width: '25%'
        }
    }, label), /*#__PURE__*/React__default['default'].createElement("input", _extends({
        style: {
            flex: 1
        },
        name: name,
        onChange: setFile
    }, rest, {
        type: "file"
    }))), hasValue && /*#__PURE__*/React__default['default'].createElement("p", null, "Current: ", value.name ? value.name : value, /*#__PURE__*/React__default['default'].createElement("button", {
        onClick: function onClick() {
            return setValue(initialValue ? '__clear__' : null);
        }
    }, "Clear")), /*#__PURE__*/React__default['default'].createElement(ErrorMessage, {
        name: name
    }));
}
File.propTypes = {
    name: PropTypes__default['default'].string,
    label: PropTypes__default['default'].string
};

function Image(props) {
    return /*#__PURE__*/React__default['default'].createElement(File, _extends({
        accept: "image/*"
    }, props));
}

function Select(_ref) {
    var name = _ref.name,
        type = _ref.type,
        label = _ref.label,
        choices = _ref.choices;
    var multiple = type === 'select';
    return /*#__PURE__*/React__default['default'].createElement("div", {
        style: {
            marginBottom: '0.5em'
        }
    }, /*#__PURE__*/React__default['default'].createElement("div", {
        style: {
            display: 'flex'
        }
    }, /*#__PURE__*/React__default['default'].createElement("label", {
        htmlFor: name,
        style: {
            width: '25%'
        }
    }, label), /*#__PURE__*/React__default['default'].createElement(Field, {
        as: "select",
        style: {
            flex: 1
        },
        name: name,
        multiple: multiple
    }, !multiple && /*#__PURE__*/React__default['default'].createElement("option", {
        value: ""
    }, "Select one..."), choices.map(function (_ref2) {
        var name = _ref2.name,
            label = _ref2.label;
        return /*#__PURE__*/React__default['default'].createElement("option", {
            key: name,
            value: name
        }, label);
    }))), /*#__PURE__*/React__default['default'].createElement(ErrorMessage, {
        name: name
    }));
}
Select.propTypes = {
    name: PropTypes__default['default'].string,
    type: PropTypes__default['default'].string,
    label: PropTypes__default['default'].string,
    choices: PropTypes__default['default'].arrayOf(PropTypes__default['default'].object)
};

function Radio(_ref) {
    var name = _ref.name,
        label = _ref.label,
        choices = _ref.choices,
        horizontal = _ref.horizontal;
    var style = {
        display: 'flex',
        flexDirection: horizontal ? 'row' : 'column'
    };
    return /*#__PURE__*/React__default['default'].createElement("div", {
        style: {
            marginBottom: '0.5em'
        }
    }, /*#__PURE__*/React__default['default'].createElement("fieldset", null, /*#__PURE__*/React__default['default'].createElement("legend", null, label), /*#__PURE__*/React__default['default'].createElement("div", {
        style: style
    }, choices.map(function (_ref2) {
        var value = _ref2.name,
            label = _ref2.label;
        return /*#__PURE__*/React__default['default'].createElement("label", {
            key: value
        }, /*#__PURE__*/React__default['default'].createElement(Field, {
            name: name,
            type: "radio",
            value: value
        }), label);
    }))), /*#__PURE__*/React__default['default'].createElement(ErrorMessage, {
        name: name
    }));
}
Radio.propTypes = {
    name: PropTypes__default['default'].string,
    type: PropTypes__default['default'].string,
    label: PropTypes__default['default'].string,
    horizontal: PropTypes__default['default'].bool,
    choices: PropTypes__default['default'].arrayOf(PropTypes__default['default'].object)
};

function Toggle(props) {
    return /*#__PURE__*/React__default['default'].createElement(Radio, _extends({
        horizontal: true
    }, props));
}

function Hidden(props) {
    var name = props.name;
    return /*#__PURE__*/React__default['default'].createElement(React__default['default'].Fragment, null, /*#__PURE__*/React__default['default'].createElement(Field, _extends({}, props, {
        type: "hidden"
    })), /*#__PURE__*/React__default['default'].createElement(ErrorMessage, {
        name: name
    }));
}
Hidden.propTypes = {
    name: PropTypes__default['default'].string
};

function HelperText(_ref) {
    var name = _ref.name,
        hint = _ref.hint;

    var _useFormikContext = useFormikContext(),
        errors = _useFormikContext.errors,
        touched = _useFormikContext.touched,
        error = getIn(errors, name),
        showError = !!error && !!getIn(touched, name);

    if (showError) {
        hint = error;
    }

    if (!hint) {
        return null;
    }

    return /*#__PURE__*/React__default['default'].createElement("p", {
        style: showError && {
            color: 'red'
        }
    }, hint);
}
HelperText.propTypes = {
    name: PropTypes__default['default'].string,
    hint: PropTypes__default['default'].string
};

var Date$1 = Input;
var Time = Input;
var dateTime = Input;

var inputs = /*#__PURE__*/Object.freeze({
__proto__: null,
Input: Input,
Checkbox: Input,
DateTime: Input,
Date: Date$1,
Time: Time,
dateTime: dateTime,
File: File,
Image: Image,
Select: Select,
Radio: Radio,
Toggle: Toggle,
Hidden: Hidden,
HelperText: HelperText
});

function Add() {
    return "\u2795"; // Plus
}
function Edit() {
    return "\u270F"; // Pencil
}
function Delete() {
    return "\uD83D\uDDD1"; // Wastebasket
}
function Success() {
    return "\u2714"; // Check Mark
}
function Error$1() {
    return "\u274C"; // Cross Mark
}
function Pending() {
    return "\u23F3"; // Hourglass Not Done
}
function GpsStart() {
    return "\uD83D\uDEF0\uFE0F"; // Satellite
}
function GpsStop() {
    return "\uD83D\uDED1"; // Stop Sign
}
function Search() {
    return "\uD83D\uDD0D"; // Magnifying Glass
}

var icons = /*#__PURE__*/Object.freeze({
__proto__: null,
Add: Add,
Edit: Edit,
Delete: Delete,
Success: Success,
Error: Error$1,
Pending: Pending,
GpsStart: GpsStart,
GpsStop: GpsStop,
Search: Search
});

function Default() {
    var _useRouteInfo = useRouteInfo(),
        name = _useRouteInfo.name,
        _useComponents = useComponents(),
        View = _useComponents.View,
        Text = _useComponents.Text,
        DebugContext = _useComponents.DebugContext;

    return /*#__PURE__*/React__default['default'].createElement(View, null, /*#__PURE__*/React__default['default'].createElement(Text, null, "To customize this view, define views.", pascalCase(name), " in a plugin."), /*#__PURE__*/React__default['default'].createElement(DebugContext, null));
}

function DefaultList() {
    var reverse = useReverse(),
        _useList = useList(),
        list = _useList.list,
        unsynced = _useList.unsynced,
        empty = _useList.empty,
        page_config = _useList.page_config,
        _useComponents = useComponents(),
        Message = _useComponents.Message,
        ScrollView = _useComponents.ScrollView,
        List = _useComponents.List,
        ListSubheader = _useComponents.ListSubheader,
        ListItem = _useComponents.ListItem,
        ListItemLink = _useComponents.ListItemLink,
        Pagination = _useComponents.Pagination,
        Fab = _useComponents.Fab,
        _useViewComponents = useViewComponents(),
        OutboxList = _useViewComponents.OutboxList,
        page = page_config.page,
        can_add = page_config.can_add,
        can_view = page_config.can_view,
        hasUnsynced = unsynced.length > 0;

    function Row(_ref) {
        var id = _ref.id,
            label = _ref.label;

        if (can_view === false) {
            return /*#__PURE__*/React__default['default'].createElement(ListItem, null, label);
        } else {
            return /*#__PURE__*/React__default['default'].createElement(ListItemLink, {
                to: reverse("".concat(page, "_detail"), id)
            }, label);
        }
    }

    return /*#__PURE__*/React__default['default'].createElement(React__default['default'].Fragment, null, /*#__PURE__*/React__default['default'].createElement(ScrollView, null, hasUnsynced ? /*#__PURE__*/React__default['default'].createElement(React__default['default'].Fragment, null, /*#__PURE__*/React__default['default'].createElement(OutboxList, {
        modelConf: page_config
    }), !empty && /*#__PURE__*/React__default['default'].createElement(List, null, /*#__PURE__*/React__default['default'].createElement(ListSubheader, null, /*#__PURE__*/React__default['default'].createElement(Message, {
        id: "SYNCED_ITEMS"
    })), list.map(function (row) {
        return /*#__PURE__*/React__default['default'].createElement(Row, _extends({
            key: row.id
        }, row));
    }))) : /*#__PURE__*/React__default['default'].createElement(List, null, empty ? /*#__PURE__*/React__default['default'].createElement(ListItem, null, /*#__PURE__*/React__default['default'].createElement(Message, {
        id: "LIST_IS_EMPTY"
    })) : list.map(function (row) {
        return /*#__PURE__*/React__default['default'].createElement(Row, _extends({
            key: row.id
        }, row));
    })), /*#__PURE__*/React__default['default'].createElement(Pagination, null)), can_add !== false && /*#__PURE__*/React__default['default'].createElement(Fab, {
        icon: "add",
        to: reverse("".concat(page, "_edit:new"))
    }));
}

function DefaultDetail() {
    var reverse = useReverse(),
        context = useRenderContext(),
        _useRouteInfo = useRouteInfo(),
        page = _useRouteInfo.page,
        item_id = _useRouteInfo.item_id,
        page_config = _useRouteInfo.page_config,
        _useComponents = useComponents(),
        ScrollView = _useComponents.ScrollView,
        PropertyTable = _useComponents.PropertyTable,
        Fab = _useComponents.Fab,
        form = page_config.form || [{
        name: 'label'
    }],
        editUrl = reverse("".concat(page, "_edit"), item_id);

    return /*#__PURE__*/React__default['default'].createElement(React__default['default'].Fragment, null, /*#__PURE__*/React__default['default'].createElement(ScrollView, null, /*#__PURE__*/React__default['default'].createElement(PropertyTable, {
        form: form,
        values: context
    })), page_config.can_change !== false && /*#__PURE__*/React__default['default'].createElement(Fab, {
        icon: "edit",
        to: editUrl
    }));
}

function DefaultEdit() {
    var reverse = useReverse(),
        context = useRenderContext(),
        _useRouteInfo = useRouteInfo(),
        page = _useRouteInfo.page,
        variant = _useRouteInfo.variant,
        page_config = _useRouteInfo.page_config,
        outbox_id = _useRouteInfo.outbox_id,
        form = page_config.form,
        _useComponents = useComponents(),
        ScrollView = _useComponents.ScrollView,
        AutoForm = _useComponents.AutoForm,
        DeleteForm = _useComponents.DeleteForm;

    var backUrl;

    if (outbox_id || variant === 'new') {
        backUrl = reverse("".concat(page_config.name, "_list"));
    } else {
        backUrl = reverse("".concat(page, "_detail"), context.id);
    }

    var submitUrl, method;

    if (context.id) {
        submitUrl = "".concat(page_config.url, "/").concat(context.id);
        method = 'PUT';
    } else {
        submitUrl = "".concat(page_config.url, "/");
        method = 'POST';
    }

    return /*#__PURE__*/React__default['default'].createElement(ScrollView, null, context.id && page_config.can_delete !== false && /*#__PURE__*/React__default['default'].createElement(DeleteForm, {
        action: submitUrl
    }), /*#__PURE__*/React__default['default'].createElement(AutoForm, {
        action: submitUrl,
        cancel: backUrl,
        method: method,
        backgroundSync: page_config.background_sync,
        outboxId: outbox_id,
        data: context,
        error: outbox_id ? context.error : null,
        form: form,
        modelConf: page_config
    }));
}

function Index() {
    var reverse = useReverse(),
        routeTitle = useRouteTitle(),
        _useSitemap = useSitemap(),
        options = _useSitemap.options,
        models = _useSitemap.models,
        _useComponents = useComponents(),
        Message = _useComponents.Message,
        ScrollView = _useComponents.ScrollView,
        List = _useComponents.List,
        ListSubheader = _useComponents.ListSubheader,
        ListItemLink = _useComponents.ListItemLink;

    function PageLink(_ref) {
        var name = _ref.name;
        var to = reverse(name),
            title = routeTitle(name);
        return /*#__PURE__*/React__default['default'].createElement(ListItemLink, {
            to: to
        }, title);
    }

    PageLink.propTypes = {
        name: PropTypes__default['default'].string
    };
    var subheadings = models.length > 0 && options.length > 0;
    return /*#__PURE__*/React__default['default'].createElement(ScrollView, null, /*#__PURE__*/React__default['default'].createElement(List, null, subheadings && /*#__PURE__*/React__default['default'].createElement(ListSubheader, null, /*#__PURE__*/React__default['default'].createElement(Message, {
        id: "OTHER_PAGES"
    })), options.map(function (page) {
        return /*#__PURE__*/React__default['default'].createElement(PageLink, {
            key: page.name,
            name: page.name
        });
    }), subheadings && /*#__PURE__*/React__default['default'].createElement(ListSubheader, null, /*#__PURE__*/React__default['default'].createElement(Message, {
        id: "MODEL_PAGES"
    })), models.map(function (page) {
        return /*#__PURE__*/React__default['default'].createElement(PageLink, {
            key: page.name,
            name: "".concat(page.name, "_list")
        });
    })));
}

function Login() {
    var reverse = useReverse(),
        _useComponents = useComponents(),
        Message = _useComponents.Message,
        Form = _useComponents.Form,
        FormError = _useComponents.FormError,
        HorizontalView = _useComponents.HorizontalView,
        CancelButton = _useComponents.CancelButton,
        SubmitButton = _useComponents.SubmitButton,
        View = _useComponents.View,
        Text = _useComponents.Text,
        ButtonLink = _useComponents.ButtonLink,
        _useInputComponents = useInputComponents(),
        Input = _useInputComponents.Input,
        _useRenderContext = useRenderContext(),
        is_authenticated = _useRenderContext.is_authenticated,
        user = _useRenderContext.user;

    if (is_authenticated) {
        return /*#__PURE__*/React__default['default'].createElement(View, null, /*#__PURE__*/React__default['default'].createElement(Text, null, "Logged in as ", user.label || user.username), /*#__PURE__*/React__default['default'].createElement(HorizontalView, null, /*#__PURE__*/React__default['default'].createElement(ButtonLink, {
            to: reverse('logout')
        }, "Log Out"), /*#__PURE__*/React__default['default'].createElement(ButtonLink, {
            to: reverse('index')
        }, "Return to Home")));
    }

    return /*#__PURE__*/React__default['default'].createElement(React__default['default'].Fragment, null, /*#__PURE__*/React__default['default'].createElement(Form, {
        action: "login",
        method: "POST",
        storage: "temporary",
        backgroundSync: false
    }, /*#__PURE__*/React__default['default'].createElement(Input, {
        name: "username",
        label: "Username"
    }), /*#__PURE__*/React__default['default'].createElement(Input, {
        name: "password",
        type: "password",
        label: "Password"
    }), /*#__PURE__*/React__default['default'].createElement(FormError, null), /*#__PURE__*/React__default['default'].createElement(HorizontalView, null, /*#__PURE__*/React__default['default'].createElement(CancelButton, {
        to: reverse('index')
    }, /*#__PURE__*/React__default['default'].createElement(Message, {
        id: "CANCEL"
    })), /*#__PURE__*/React__default['default'].createElement(SubmitButton, null, /*#__PURE__*/React__default['default'].createElement(Message, {
        id: "SUBMIT"
    })))));
}

function Logout() {
    var _useRenderContext = useRenderContext(),
        is_authenticated = _useRenderContext.is_authenticated,
        _useComponents = useComponents(),
        Message = _useComponents.Message,
        View = _useComponents.View,
        Text = _useComponents.Text;

    return /*#__PURE__*/React__default['default'].createElement(View, null, /*#__PURE__*/React__default['default'].createElement(Text, null, /*#__PURE__*/React__default['default'].createElement(Message, {
        id: is_authenticated ? 'LOGGING_OUT' : 'LOGGED_OUT'
    })));
}

function OutboxList(_ref) {
    var modelConf = _ref.modelConf;

    var app = useApp(),
        reverse = useReverse(),
        routeTitle = useRouteTitle(),
        items = useUnsynced(modelConf),
        _useComponents = useComponents(),
        Message = _useComponents.Message,
        List = _useComponents.List,
        ListItem = _useComponents.ListItem,
        ListItemLink = _useComponents.ListItemLink,
        ListSubheader = _useComponents.ListSubheader,
        ScrollView = _useComponents.ScrollView,
        HorizontalView = _useComponents.HorizontalView,
        Button = _useComponents.Button;

    var empty = !items.length;

    function getIcon(item) {
        if (item.synced) {
            return 'success';
        } else if (item.error) {
            return 'error';
        } else {
            return 'pending';
        }
    }

    function getTitle(item) {
        if (item.options.modelConf && !modelConf) {
            var pageName = routeTitle("".concat(item.options.modelConf.name, "_detail"));
            return "".concat(pageName, ": ").concat(item.label);
        } else {
            return item.label;
        }
    }

    function getStatus(item) {
        if (item.synced) {
            return 'SYNC_SUCCESS';
        } else if (item.error) {
            if (typeof item.error === 'string') {
                return item.error;
            } else {
                return 'SYNC_ERROR';
            }
        } else {
            return null;
        }
    }

    function OutboxItems() {
        return /*#__PURE__*/React__default['default'].createElement(React__default['default'].Fragment, null, empty && /*#__PURE__*/React__default['default'].createElement(ListItem, null, /*#__PURE__*/React__default['default'].createElement(Message, {
            id: "OUTBOX_IS_EMPTY"
        })), items.map(function (item) {
            return /*#__PURE__*/React__default['default'].createElement(ListItemLink, {
                key: item.id,
                to: reverse('outbox_edit', item.id),
                icon: getIcon(item),
                description: /*#__PURE__*/React__default['default'].createElement(Message, {
                    id: getStatus(item)
                })
            }, getTitle(item));
        }));
    }

    if (modelConf) {
        return /*#__PURE__*/React__default['default'].createElement(List, null, /*#__PURE__*/React__default['default'].createElement(ListSubheader, null, /*#__PURE__*/React__default['default'].createElement(Message, {
            id: "UNSYNCED_ITEMS"
        })), /*#__PURE__*/React__default['default'].createElement(OutboxItems, null));
    } else {
        return /*#__PURE__*/React__default['default'].createElement(React__default['default'].Fragment, null, /*#__PURE__*/React__default['default'].createElement(ScrollView, null, /*#__PURE__*/React__default['default'].createElement(List, null, /*#__PURE__*/React__default['default'].createElement(OutboxItems, null))), !empty && /*#__PURE__*/React__default['default'].createElement(HorizontalView, null, /*#__PURE__*/React__default['default'].createElement(Button, {
            onClick: function onClick() {
                return app.emptyOutbox(true);
            }
        }, /*#__PURE__*/React__default['default'].createElement(Message, {
            id: "EMPTY_OUTBOX"
        })), /*#__PURE__*/React__default['default'].createElement(Button, {
            onClick: function onClick() {
                return app.retryAll();
            }
        }, /*#__PURE__*/React__default['default'].createElement(Message, {
            id: "RETRY_ALL"
        }))));
    }
}
OutboxList.propTypes = {
    modelConf: PropTypes__default['default'].object
};

function Loading() {
    var _useComponents = useComponents(),
        Message = _useComponents.Message,
        Text = _useComponents.Text;

    return /*#__PURE__*/React__default['default'].createElement(Text, null, /*#__PURE__*/React__default['default'].createElement(Message, {
        id: "LOADING"
    }));
}

function NotFound() {
    var _useRenderContext = useRenderContext(),
        url = _useRenderContext.url;

    return /*#__PURE__*/React__default['default'].createElement(React__default['default'].Fragment, null, "Page ", url, " not found.");
}

var HTML$1 = '@@HTML';
function Server() {
    var html = useRenderContext()[HTML$1];
    return /*#__PURE__*/React__default['default'].createElement(React__default['default'].Fragment, null, /*#__PURE__*/React__default['default'].createElement("p", null, "This renderer does not (yet) support server-rendered HTML."), /*#__PURE__*/React__default['default'].createElement("pre", null, /*#__PURE__*/React__default['default'].createElement("code", null, html)));
}

var views = /*#__PURE__*/Object.freeze({
__proto__: null,
Default: Default,
DefaultList: DefaultList,
DefaultDetail: DefaultDetail,
DefaultEdit: DefaultEdit,
Index: Index,
Login: Login,
Logout: Logout,
OutboxList: OutboxList,
Loading: Loading,
NotFound: NotFound,
Server: Server
});

function init() {
    if (!this.root) {
        this.root = document.body.appendChild(document.createElement('div'));
        this.root.id = 'wq-app-root';
    }
}
function start() {
    var RootComponent = this.getRootComponent();
    ReactDOM__default['default'].render( /*#__PURE__*/React__default['default'].createElement(RootComponent, null), this.root);
}
function unmount() {
    ReactDOM__default['default'].unmountComponentAtNode(this.root);
}

function validate(values, modelConf) {
    var labels = [],
        errors = validateRequired(values, modelConf && modelConf.form, labels);

    if (errors && labels.length) {
        errors['__other__'] = 'The following fields are required: ' + labels.filter(function (label, i) {
            return labels.indexOf(label) === i;
        }).join(', ');
    }

    return errors || {};
}

function validateRequired(values, form) {
    var labels = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;

    if (!values || !form) {
        return null;
    }

    var errors = {};
    form.forEach(function (field) {
        var name = field['wq:ForeignKey'] ? "".concat(field.name, "_id") : field.name,
            value = values[name];

        if (isMissing(value, field)) {
            errors[name] = 'This field is required.';

            if (labels) {
                labels.push(field.label);
            }
        } else if (value && field.type === 'repeat') {
            var nestedErrors = value.map(function (row) {
                return validateRequired(row, field.children, labels);
            });

            if (nestedErrors.some(function (row) {
                return row;
            })) {
                errors[name] = nestedErrors;
            }
        } else if (field.type === 'group') {
            if (name === '') {
                Object.assign(errors, validateRequired(values, field.children, labels));
            } else if (value) {
                var _nestedErrors = validateRequired(value, field.children, labels);

                if (_nestedErrors) {
                    errors[name] = _nestedErrors;
                }
            }
        }
    });
    return Object.keys(errors).length > 0 ? errors : null;
}

function isMissing(value, field) {
    if (field.required || field.bind && field.bind.required) {
        return value === undefined || value === null || value === '';
    } else {
        return false;
    }
}

var reactRenderer = {
    name: 'react',
    type: 'renderer',
    config: {
        messages: _objectSpread2({}, messages),
        components: _objectSpread2({
            App: App
        }, components),
        inputs: _objectSpread2({}, inputs),
        icons: _objectSpread2({}, icons),
        views: _objectSpread2({}, views)
    },
    init: function init$1(config) {
        var _this = this;

        if (config) {
            Object.assign(this.config, config);
        }

        Object.values(this.app.plugins).forEach(function (plugin) {
            if (plugin.messages) {
                Object.assign(_this.config.messages, plugin.messages);
            }

            if (plugin.components) {
                Object.assign(_this.config.components, plugin.components);
            }

            if (plugin.inputs) {
                Object.assign(_this.config.inputs, plugin.inputs);
            }

            if (plugin.icons) {
                Object.assign(_this.config.icons, plugin.icons);
            }

            if (plugin.views) {
                Object.assign(_this.config.views, plugin.views);
            }
        });

        init.call(this);
    },
    getRootComponent: function getRootComponent() {
        var _this2 = this;

        var app = this.app,
            config = this.config,
            components = config.components,
            App = components.App;

        var AppRoot = function AppRoot() {
            return /*#__PURE__*/React__default['default'].createElement(reactRedux.Provider, {
                store: _this2.app.store._store
            }, /*#__PURE__*/React__default['default'].createElement(AppContext.Provider, {
                value: {
                    app: app
                }
            }, /*#__PURE__*/React__default['default'].createElement(App, null)));
        };

        AppRoot.displayName = 'AppRoot';
        return AppRoot;
    },
    start: start,
    validate: validate,
    createInstance: function createInstance(component, root, app) {
        var _this3 = this;

        if (!app) {
            app = this.app;
        }

        var tempPlugin = {
            app: _objectSpread2(_objectSpread2({}, app), {}, {
                plugins: _objectSpread2({}, app.plugins)
            }),
            config: {
                components: {},
                inputs: {},
                icons: {},
                views: {}
            },
            root: root,
            getRootComponent: this.getRootComponent
        };
        this.init.call(tempPlugin);
        tempPlugin.app.plugins.react = tempPlugin;
        tempPlugin.config.components.App = component;
        return {
            start: function start() {
                return _this3.start.call(tempPlugin);
            },
            getRootComponent: function getRootComponent() {
                return tempPlugin.getRootComponent();
            },
            stop: function stop() {
                return unmount.call(tempPlugin);
            }
        };
    },
    attach: function attach(component, root, app) {
        var instance = this.createInstance(component, root, app);
        instance.start();
        return function () {
            return instance.stop();
        };
    },
    wrap: function wrap(component, app) {
        var emptyRoot = {},
            instance = this.createInstance(component, emptyRoot, app);
        return instance.getRootComponent();
    }
};

function useBasemapComponents() {
    return usePluginComponentMap('map', 'basemaps');
}
function useOverlayComponents() {
    return usePluginComponentMap('map', 'overlays');
} // Load map configuration for the given page
function useMapState() {
    var state = usePluginState('map');

    if (state && state.basemaps && state.overlays) {
        return state;
    } else {
        return null;
    }
}

function checkGroupLayers(layerconf) {
    var type = layerconf.type,
        _layerconf$layers = layerconf.layers,
        layers = _layerconf$layers === void 0 ? [] : _layerconf$layers;

    if (type !== 'group') {
        return layerconf;
    }

    return _objectSpread2(_objectSpread2({}, layerconf), {}, {
        layers: layers.map(function (layer, i) {
            if (layer.name) {
                return layer;
            }

            return _objectSpread2(_objectSpread2({}, layer), {}, {
                name: "".concat(layerconf.name, "-").concat(i)
            });
        })
    });
}

function routeMapConf(config, routeInfo) {
    var context = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
    var page = routeInfo.page,
        mode = routeInfo.mode,
        path = routeInfo.path,
        params = routeInfo.params,
        item_id = routeInfo.item_id,
        page_config = routeInfo.page_config,
        conf = config.maps[page === 'outbox' ? page_config.name : page];

    if (!conf) {
        return null;
    } // FIXME: custom mapname


    var mapname = 'main'; // Start with defaults, override with mode-specific options

    var mapconf = _objectSpread2(_objectSpread2(_objectSpread2({}, conf.defaults.maps[mapname] || {}), (conf[mode] || {
        maps: {}
    }).maps[mapname] || {}), {}, {
        basemaps: config.maps.basemaps.map(checkGroupLayers),
        bounds: config.bounds
    });

    if (config.mapProps) {
        mapconf.mapProps = config.mapProps;
    } // Combine (rather than overwrite) defaults + mode-specific layers


    if (mode && mode !== 'defaults' && conf.defaults.maps[mapname] && conf.defaults.maps[mapname].layers) {
        mapconf.layers = conf.defaults.maps[mapname].layers.concat(mapconf.layers || []);
    }

    if (!mapconf.name) {
        mapconf.name = conf.name;
    }

    if (!mapconf.url) {
        mapconf.url = conf.url;
    } // Compute default layer configuration for wq REST API


    if (mapconf.autoLayers && mode !== 'edit') {
        var defaultLayer = {
            name: mapconf.name,
            type: 'geojson'
        };

        if (!mode || mode === 'list') {
            Object.assign(defaultLayer, {
                url: '{{rt}}/{{{url}}}.geojson',
                popup: page,
                cluster: true
            });
        } else {
            Object.assign(defaultLayer, {
                url: '{{rt}}/' + mapconf.url + '/{{{id}}}.geojson',
                popup: page
            });
        }

        mapconf.layers.push(defaultLayer);
    }

    mapconf.layers = mapconf.layers.map(checkGroupLayers).map(function (layerconf) {
        // FIXME: recalculate
        var baseurl = path.replace(/\/$/, '');
        layerconf = _objectSpread2({
            active: true
        }, layerconf);

        if (layerconf.noAutoAdd) {
            // FIXME: Remove in 2.0
            console.warn(new Error('set active: false instead of noAutoAdd: true'));
            layerconf.active = false;
            delete layerconf.noAutoAdd;
        }

        if (layerconf.url && layerconf.url.indexOf('{{') > -1) {
            layerconf.url = Mustache__default['default'].render(layerconf.url, _objectSpread2(_objectSpread2({}, context), {}, {
                id: item_id,
                url: baseurl
            }));

            if (params) {
                var pstr = new URLSearchParams(params).toString();

                if (layerconf.url.indexOf('?') > -1) {
                    layerconf.url += '&' + pstr;
                } else {
                    layerconf.url += '?' + pstr;
                }
            }
        }

        return layerconf;
    });
    return mapconf;
}
var _cache = {};
function useGeoJSON(url, data) {
    var app = useApp(),
        _useState = React.useState(),
        _useState2 = _slicedToArray(_useState, 2),
        geojson = _useState2[0],
        setGeojson = _useState2[1];

    if (!(url.indexOf('/') === 0 || url.indexOf('http') === 0)) {
        console.warn(new Error("Use \"{{rt}}/".concat(url, "\" instead of relative URL")));
        url = app.service + '/' + url;
    }

    React.useEffect(function () {
        if (data) {
            setGeojson(data);
            return;
        }

        if (_cache[url]) {
            setGeojson(_cache[url]);
            return;
        }

        if (url.match(/\/(new)?(\/edit)?\.geojson$/)) {
            // Ignore requests for "new.geojson"
            setGeojson(null);
            return;
        }

        app.spin.start();
        app.store.ajax(url).then(function (data) {
            app.spin.stop();
            _cache[url] = data;
            setGeojson(data);
        }, function () {
            app.spin.stop();
            setGeojson(null);
        });
    }, [url, data, app]);
    return geojson;
}

function AutoMap(_ref) {
    var containerStyle = _ref.containerStyle,
        state = _ref.state,
        children = _ref.children;

    var mapState = useMapState(),
        _useComponents = useComponents(),
        Map = _useComponents.Map,
        MapInteraction = _useComponents.MapInteraction,
        AutoBasemap = _useComponents.AutoBasemap,
        AutoOverlay = _useComponents.AutoOverlay,
        Legend = _useComponents.Legend,
        BasemapToggle = _useComponents.BasemapToggle,
        OverlayToggle = _useComponents.OverlayToggle,
        _useOverlayComponents = useOverlayComponents(),
        Highlight = _useOverlayComponents.Highlight;

    if (!state) {
        state = mapState;
    }

    if (!state) {
        return null;
    }

    var _state = state,
        basemaps = _state.basemaps,
        overlays = _state.overlays,
        bounds = _state.bounds,
        mapProps = _state.mapProps,
        highlight = _state.highlight;
    return /*#__PURE__*/React__default['default'].createElement(Map, {
        bounds: bounds,
        mapProps: mapProps,
        containerStyle: containerStyle
    }, /*#__PURE__*/React__default['default'].createElement(MapInteraction, null), /*#__PURE__*/React__default['default'].createElement(Legend, null, basemaps.map(function (conf, i) {
        return /*#__PURE__*/React__default['default'].createElement(BasemapToggle, {
            key: i,
            name: conf.name,
            active: conf.active
        }, /*#__PURE__*/React__default['default'].createElement(AutoBasemap, conf));
    }), overlays.map(function (conf, i) {
        return /*#__PURE__*/React__default['default'].createElement(OverlayToggle, {
            key: i,
            name: conf.name,
            active: conf.active
        }, /*#__PURE__*/React__default['default'].createElement(AutoOverlay, conf));
    })), highlight && /*#__PURE__*/React__default['default'].createElement(Highlight, {
        data: highlight
    }), children);
}
AutoMap.propTypes = {
    containerStyle: PropTypes__default['default'].object,
    state: PropTypes__default['default'].object,
    children: PropTypes__default['default'].node
};
/*
        if (defaults.autoZoom.sticky) {
            m.fitBounds(defaults.lastBounds || defaults.bounds);
        }

    Promise.all(results).then(autoZoom);

    function autoZoom() {
        if (mapconf.autoZoom !== undefined && !mapconf.autoZoom) {
            return;
        }
        if (!map.config.defaults.autoZoom) {
            return;
        }
        var lnames = Object.keys(layers);
        if (!lnames.length) {
            return;
        }
        var bounds;
        lnames.forEach(function(lname) {
            if (!layers[lname].getBounds) {
                return;
            }
            if (!m.hasLayer(layers[lname])) {
                return;
            }
            var layerBounds = layers[lname].getBounds();
            if (bounds) {
                bounds.extend(layerBounds);
            } else if (layerBounds.isValid()) {
                bounds = layerBounds;
            }
        });
        if (mapconf.minBounds) {
            if (bounds) {
                bounds.extend(mapconf.minBounds);
            } else {
                bounds = mapconf.minBounds;
            }
        } else if (!bounds) {
            bounds = map.config.defaults.bounds;
        }
        setTimeout(function() {
            m.fitBounds(bounds, map.config.defaults.autoZoom);
        }, map.config.defaults.autoZoom.wait * 1000);
    }

    if (map.config.defaults.autoZoom.sticky) {
        m.on('moveend', function() {
            const bounds = m.getBounds();
            if (!bounds.isValid()) {
                return;
            }
            if (bounds.getSouthWest().equals(bounds.getNorthEast())) {
                return;
            }
            map.config.defaults.lastBounds = bounds;
        });
    }
*/

function AutoBasemap(_ref) {
    var type = _ref.type,
        conf = _objectWithoutProperties(_ref, ["type"]);

    var basemaps = useBasemapComponents(),
        Basemap = basemaps[type];

    if (type === 'empty') {
        return Basemap ? /*#__PURE__*/React__default['default'].createElement(Basemap, {
            active: conf.active
        }) : null;
    } else if (type === 'group') {
        var Group = Basemap || React__default['default'].Fragment;
        return /*#__PURE__*/React__default['default'].createElement(Group, null, conf.layers.map(function (layer) {
            return /*#__PURE__*/React__default['default'].createElement(AutoBasemap, _extends({
                key: layer.name,
                active: conf.active
            }, layer));
        }));
    } else if (!Basemap) {
        console.warn("Skipping unrecognized layer type \"".concat(type, "\""));
        return null;
    }

    return /*#__PURE__*/React__default['default'].createElement(Basemap, conf);
}
AutoBasemap.propTypes = {
    type: PropTypes__default['default'].string.isRequired
};

function AutoOverlay(_ref) {
    var type = _ref.type,
        conf = _objectWithoutProperties(_ref, ["type"]);

    var overlays = useOverlayComponents(),
        Overlay = overlays[type];

    if (type === 'empty') {
        return Overlay ? /*#__PURE__*/React__default['default'].createElement(Overlay, {
            active: conf.active
        }) : null;
    } else if (type === 'group') {
        var Group = Overlay || React__default['default'].Fragment;
        return /*#__PURE__*/React__default['default'].createElement(Group, null, conf.layers.map(function (layer) {
            return /*#__PURE__*/React__default['default'].createElement(AutoOverlay, _extends({
                key: layer.name,
                active: conf.active
            }, layer));
        }));
    } else if (!Overlay) {
        console.warn("Skipping unrecognized layer type \"".concat(type, "\""));
        return null;
    }

    return /*#__PURE__*/React__default['default'].createElement(Overlay, conf);
}
AutoOverlay.propTypes = {
    type: PropTypes__default['default'].string.isRequired
};

function StickyMap(_ref) {
    var mapId = _ref.mapId,
        containerStyle = _ref.containerStyle,
        invisibleStyle = _ref.invisibleStyle,
        children = _ref.children;

    var state = useMapState(),
        _useComponents = useComponents(),
        AutoMap = _useComponents.AutoMap,
        _useState = React.useState(null),
        _useState2 = _slicedToArray(_useState, 2),
        stickyState = _useState2[0],
        setStickyState = _useState2[1],
        visible = state && mapId && state.mapId === mapId;

    React.useEffect(function () {
        if (visible) {
            setStickyState(state);
        }
    }, [visible, state]);

    if (!stickyState) {
        return null;
    }

    if (!visible) {
        containerStyle = _objectSpread2(_objectSpread2({}, containerStyle), {}, {
            position: 'absolute',
            top: '-2000px',
            width: '100vw',
            height: 'calc(100vh - 120px)'
        }, invisibleStyle);
    }

    return /*#__PURE__*/React__default['default'].createElement(AutoMap, {
        containerStyle: containerStyle,
        state: stickyState
    }, children);
}
StickyMap.propTypes = {
    mapId: PropTypes__default['default'].string,
    containerStyle: PropTypes__default['default'].object,
    invisibleStyle: PropTypes__default['default'].object,
    children: PropTypes__default['default'].node
};

function Map$1(_ref) {
    var children = _ref.children;
    return /*#__PURE__*/React__default['default'].createElement("div", {
        style: {
            flex: '1',
            minHeight: 200
        }
    }, /*#__PURE__*/React__default['default'].createElement("p", null, "No map integration library loaded - use @wq/leaflet or @wq/map-gl."), children);
}
Map$1.propTypes = {
    children: PropTypes__default['default'].node
};

function Legend(_ref) {
    var children = _ref.children;
    return /*#__PURE__*/React__default['default'].createElement("table", null, /*#__PURE__*/React__default['default'].createElement("thead", null, /*#__PURE__*/React__default['default'].createElement("tr", null, /*#__PURE__*/React__default['default'].createElement("th", null, "Group"), /*#__PURE__*/React__default['default'].createElement("th", null, "Name"), /*#__PURE__*/React__default['default'].createElement("th", null, "Active"), /*#__PURE__*/React__default['default'].createElement("th", null, "Detail"))), /*#__PURE__*/React__default['default'].createElement("tbody", null, children));
}
Legend.propTypes = {
    children: PropTypes__default['default'].node
};
function BasemapToggle(_ref2) {
    var name = _ref2.name,
        active = _ref2.active,
        children = _ref2.children;
    return /*#__PURE__*/React__default['default'].createElement("tr", null, /*#__PURE__*/React__default['default'].createElement("td", null, "Basemap"), /*#__PURE__*/React__default['default'].createElement("td", null, name), /*#__PURE__*/React__default['default'].createElement("td", null, active ? 'Y' : 'N'), /*#__PURE__*/React__default['default'].createElement("td", null, children));
}
BasemapToggle.propTypes = {
    name: PropTypes__default['default'].string,
    active: PropTypes__default['default'].bool,
    children: PropTypes__default['default'].node
};
function OverlayToggle(_ref3) {
    var name = _ref3.name,
        active = _ref3.active,
        children = _ref3.children;
    return /*#__PURE__*/React__default['default'].createElement("tr", null, /*#__PURE__*/React__default['default'].createElement("td", null, "Overlay"), /*#__PURE__*/React__default['default'].createElement("td", null, name), /*#__PURE__*/React__default['default'].createElement("td", null, active ? 'Y' : 'N'), /*#__PURE__*/React__default['default'].createElement("td", null, children));
}
OverlayToggle.propTypes = {
    name: PropTypes__default['default'].string,
    active: PropTypes__default['default'].bool,
    children: PropTypes__default['default'].node
};

var FORWARD_REF_STATICS$1 = {
    '$$typeof': true,
    render: true,
    defaultProps: true,
    displayName: true,
    propTypes: true
};
var MEMO_STATICS$1 = {
    '$$typeof': true,
    compare: true,
    defaultProps: true,
    displayName: true,
    propTypes: true,
    type: true
};
var TYPE_STATICS$1 = {};
TYPE_STATICS$1[reactIs__default['default'].ForwardRef] = FORWARD_REF_STATICS$1;
TYPE_STATICS$1[reactIs__default['default'].Memo] = MEMO_STATICS$1;

function _objectWithoutPropertiesLoose$2(source, excluded) {
    if (source == null) return {};
    var target = {};
    var sourceKeys = Object.keys(source);
    var key, i;

    for (i = 0; i < sourceKeys.length; i++) {
        key = sourceKeys[i];
        if (excluded.indexOf(key) >= 0) continue;
        target[key] = source[key];
    }

    return target;
}
/** @private is the given object an Object? */


var isObject$2 = function isObject(obj) {
    return obj !== null && _typeof(obj) === 'object';
};

var FormikContext$1 = /*#__PURE__*/React.createContext(undefined);
var FormikProvider$1 = FormikContext$1.Provider;
var FormikConsumer$1 = FormikContext$1.Consumer;

function useFormikContext$1() {
    var formik = React.useContext(FormikContext$1);
    return formik;
}

function useField$1(propsOrFieldName) {
    var formik = useFormikContext$1();
    var getFieldProps = formik.getFieldProps,
        getFieldMeta = formik.getFieldMeta,
        getFieldHelpers = formik.getFieldHelpers,
        registerField = formik.registerField,
        unregisterField = formik.unregisterField;
    var isAnObject = isObject$2(propsOrFieldName); // Normalize propsOrFieldName to FieldHookConfig<Val>

    var props = isAnObject ? propsOrFieldName : {
        name: propsOrFieldName
    };
    var fieldName = props.name,
        validateFn = props.validate;
    React.useEffect(function () {
        if (fieldName) {
            registerField(fieldName, {
                validate: validateFn
            });
        }

        return function () {
            if (fieldName) {
                unregisterField(fieldName);
            }
        };
    }, [registerField, unregisterField, fieldName, validateFn]);
    return [getFieldProps(props), getFieldMeta(fieldName), getFieldHelpers(fieldName)];
}

var Form$2 = /*#__PURE__*/React.forwardRef(function (props, ref) {
    // iOS needs an "action" attribute for nice input: https://stackoverflow.com/a/39485162/406725
    // We default the action to "#" in case the preventDefault fails (just updates the URL hash)
    var action = props.action,
        rest = _objectWithoutPropertiesLoose$2(props, ["action"]);

    var _action = action || '#';

    var _useFormikContext = useFormikContext$1(),
        handleReset = _useFormikContext.handleReset,
        handleSubmit = _useFormikContext.handleSubmit;

    return /*#__PURE__*/React.createElement("form", Object.assign({
        onSubmit: handleSubmit,
        ref: ref,
        onReset: handleReset,
        action: _action
    }, rest));
});
Form$2.displayName = 'Form';

var TYPE_MAP = {
    geopoint: 'point',
    geotrace: 'line_string',
    geoshape: 'polygon'
};
var LOOKUP_METHODS = [{
    name: 'gps',
    label: 'Current'
}, {
    name: 'geocode',
    label: 'Address'
}, {
    name: 'manual',
    label: 'Lat/Lng'
}];
function Geo(_ref) {
    var name = _ref.name,
        type = _ref.type,
        required = _ref.required,
        label = _ref.label,
        hint = _ref.hint,
        _ref$inset = _ref.inset,
        inset = _ref$inset === void 0 ? true : _ref$inset;

    var _useComponents = useComponents(),
        DefaultFieldset = _useComponents.Fieldset,
        FlatFieldset = _useComponents.FlatFieldset,
        AutoMap = _useComponents.AutoMap,
        View = _useComponents.View,
        Button = _useComponents.Button,
        IconButton = _useComponents.IconButton,
        Typography = _useComponents.Typography,
        _useInputComponents = useInputComponents(),
        Input = _useInputComponents.Input,
        Toggle = _useInputComponents.Toggle,
        HelperText = _useInputComponents.HelperText,
        _useOverlayComponents = useOverlayComponents(),
        Draw = _useOverlayComponents.Draw,
        _useField = useField$1(name),
        _useField2 = _slicedToArray(_useField, 3),
        value = _useField2[1].value,
        setValue = _useField2[2].setValue,
        _useField3 = useField$1(name + '_method'),
        _useField4 = _slicedToArray(_useField3, 2),
        method = _useField4[1].value,
        _useField5 = useField$1(name + '_address'),
        _useField6 = _slicedToArray(_useField5, 3),
        address = _useField6[1].value,
        _useField6$ = _useField6[2],
        setAddress = _useField6$.setValue,
        setAddressError = _useField6$.setError,
        _useField7 = useField$1(name + '_latitude'),
        _useField8 = _slicedToArray(_useField7, 3),
        latitude = _useField8[1].value,
        setLatitude = _useField8[2].setValue,
        _useField9 = useField$1(name + '_longitude'),
        _useField10 = _slicedToArray(_useField9, 3),
        longitude = _useField10[1].value,
        setLongitude = _useField10[2].setValue,
        _useField11 = useField$1(name + '_accuracy'),
        _useField12 = _slicedToArray(_useField11, 3),
        setAccuracy = _useField12[2].setValue,
        _usePlugin = usePlugin('map'),
        setBounds = _usePlugin.setBounds,
        config = _usePlugin.config,
        _useState = React.useState(''),
        _useState2 = _slicedToArray(_useState, 2),
        gpsStatus = _useState2[0],
        setGpsStatus = _useState2[1],
        _useState3 = React.useState(''),
        _useState4 = _slicedToArray(_useState3, 2),
        gpsWatch = _useState4[0],
        setGpsWatch = _useState4[1],
        _useState5 = React.useState(null),
        _useState6 = _slicedToArray(_useState5, 2),
        geocodeStatus = _useState6[0],
        setGeocodeStatus = _useState6[1],
        maxGeometries = 1; // FIXME;


    var _useFormikContext = useFormikContext$1(),
        values = _useFormikContext.values;

    var geojson = useFeatureCollection(value),
        drawType = TYPE_MAP[type] || 'all',
        iconClass = "mapbox-gl-draw_".concat(drawType == 'line_string' ? 'line' : drawType),
        messageId = "GEO_".concat(drawType.toUpperCase(), "_").concat(value ? 'EDIT' : 'NEW'),
        _useMessages = useMessages(),
        messageTemplate = _useMessages[messageId],
        message = [];

    if (messageTemplate) {
        messageTemplate.split('{TOOL_ICON}').forEach(function (part) {
            if (message.length > 0) {
                message.push( /*#__PURE__*/React__default['default'].createElement("span", {
                    className: iconClass,
                    style: {
                        display: 'inline-block',
                        width: 18,
                        height: 18,
                        verticalAlign: 'middle'
                    }
                }));
            }

            message.push(part);
        });
    }

    function geocode() {
        return _geocode.apply(this, arguments);
    }

    function _geocode() {
        _geocode = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime__default['default'].mark(function _callee2() {
            var result, geometry;
            return _regeneratorRuntime__default['default'].wrap(function _callee2$(_context2) {
                while (1) {
                    switch (_context2.prev = _context2.next) {
                        case 0:
                            setAddressError(null);
                            setGeocodeStatus('Looking up location...');
                            _context2.prev = 2;
                            _context2.next = 5;
                            return config.geocoder(address);

                        case 5:
                            result = _context2.sent;
                            geometry = flatten(result.geometry);

                            if (type === 'geopoint') {
                                setValue(geometry);
                            }

                            if (geometry) {
                                recenterMap(geometry.coordinates[1], geometry.coordinates[0]);
                            }

                            setGeocodeStatus(result.label || 'Location found!');
                            _context2.next = 16;
                            break;

                        case 12:
                            _context2.prev = 12;
                            _context2.t0 = _context2["catch"](2);
                            setAddressError(_context2.t0.message || '' + _context2.t0);
                            setGeocodeStatus(null);

                        case 16:
                        case "end":
                            return _context2.stop();
                    }
                }
            }, _callee2, null, [[2, 12]]);
        }));
        return _geocode.apply(this, arguments);
    }

    function handleChange(geojson) {
        geojson = flatten(geojson);

        if (geojson && geojson.type === 'GeometryCollection' && geojson.geometries.length > maxGeometries) {
            geojson = geojson.geometries[geojson.geometries.length - 1];
        }

        if (method === 'manual' && type === 'geopoint' && geojson && geojson.type === 'Point') {
            setLongitude(+geojson.coordinates[0].toFixed(6));
            setLatitude(+geojson.coordinates[1].toFixed(6));
        }

        setValue(geojson);
    }

    React.useEffect(function () {
        if (gpsWatch && method !== 'gps') {
            stopGps();
        }
    }, [gpsWatch, method]);
    React.useEffect(function () {
        if (address === undefined && method === 'geocode' && config.geocoderAddress) {
            setDefaultAddress();
        }

        function setDefaultAddress() {
            return _setDefaultAddress.apply(this, arguments);
        }

        function _setDefaultAddress() {
            _setDefaultAddress = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime__default['default'].mark(function _callee() {
                return _regeneratorRuntime__default['default'].wrap(function _callee$(_context) {
                    while (1) {
                        switch (_context.prev = _context.next) {
                            case 0:
                                _context.t0 = setAddress;
                                _context.next = 3;
                                return config.geocoderAddress(values);

                            case 3:
                                _context.t1 = _context.sent;
                                (0, _context.t0)(_context.t1);

                            case 5:
                            case "end":
                                return _context.stop();
                        }
                    }
                }, _callee);
            }));
            return _setDefaultAddress.apply(this, arguments);
        }
    }, [address, method, values]);

    function saveLatLong() {
        if (!latitude || !longitude || Math.abs(latitude) > 90 || Math.abs(longitude) > 180) {
            return;
        }

        if (type === 'geopoint') {
            setValue({
                type: 'Point',
                coordinates: [longitude, latitude]
            });
        }

        recenterMap(latitude, longitude);
    }

    function recenterMap(lat, lng) {
        setBounds([[lng - 0.0005, lat - 0.0005], [lng + 0.0005, lat + 0.0005]]);
    }

    function startGps() {
        if (gpsWatch) {
            return;
        }

        if (!('geolocation' in navigator)) {
            setGpsStatus('Geolocation not supported');
            return;
        }

        var watchId = navigator.geolocation.watchPosition(onPosition, onError, {
            enableHighAccuracy: true,
            timeout: 60 * 1000
        });
        setGpsWatch(watchId);
        setGpsStatus('Determining location...');
    }

    var methods = config.geocoder ? LOOKUP_METHODS : LOOKUP_METHODS.filter(function (method) {
        return method.name !== 'geocode';
    });

    function onPosition(evt) {
        var lat = +evt.coords.latitude.toFixed(6),
            lng = +evt.coords.longitude.toFixed(6),
            acc = +evt.coords.accuracy.toFixed(3);
        setAccuracy(acc);

        if (type === 'geopoint') {
            setValue({
                type: 'Point',
                coordinates: [lng, lat]
            });
        }

        var latFmt = lat > 0 ? lat + '°N' : -lat + '°S',
            lngFmt = lng > 0 ? lng + '°E' : -lng + '°W',
            accFmt = acc > 1000 ? '~' + Math.round(acc / 1000) + 'km' : acc > 1 ? '~' + Math.round(acc) + 'm' : acc + 'm';
        setGpsStatus("".concat(latFmt, " ").concat(lngFmt, " (").concat(accFmt, ")"));
        recenterMap(lat, lng);
    }

    function onError(error) {
        setGpsStatus(error.message);
        stopGps();
    }

    function stopGps() {
        if (gpsWatch) {
            navigator.geolocation.clearWatch(gpsWatch);
        }

        setGpsWatch(null);
    }

    var gpsActive = !!gpsWatch,
        Fieldset = inset ? DefaultFieldset : FlatFieldset;
    return /*#__PURE__*/React__default['default'].createElement(Fieldset, {
        label: label
    }, /*#__PURE__*/React__default['default'].createElement(View, {
        style: {
            display: 'flex',
            flexDirection: 'row',
            alignItems: 'center'
        }
    }, /*#__PURE__*/React__default['default'].createElement(View, {
        style: {
            marginRight: 8
        }
    }, /*#__PURE__*/React__default['default'].createElement(Toggle, {
        name: name + '_method',
        choices: methods
    })), !method && message.length > 0 && /*#__PURE__*/React__default['default'].createElement(Typography, {
        color: "textSecondary",
        style: {
            flex: 1,
            textAlign: 'right'
        }
    }, message), method === 'gps' && /*#__PURE__*/React__default['default'].createElement(React__default['default'].Fragment, null, /*#__PURE__*/React__default['default'].createElement(Typography, {
        style: {
            marginRight: 8,
            flex: 1,
            textAlign: 'center'
        },
        color: "textSecondary"
    }, gpsStatus), /*#__PURE__*/React__default['default'].createElement(Button, {
        icon: gpsActive ? 'gps-stop' : 'gps-start',
        style: {
            minWidth: 140
        },
        variant: gpsActive ? 'contained' : 'outlined',
        color: "secondary",
        onClick: gpsActive ? stopGps : startGps
    }, gpsActive ? 'Stop GPS' : 'Start GPS')), method === 'geocode' && /*#__PURE__*/React__default['default'].createElement(React__default['default'].Fragment, null, /*#__PURE__*/React__default['default'].createElement(Input, {
        name: name + '_address',
        label: "Address",
        helperText: geocodeStatus || 'Enter address or city name'
    }), /*#__PURE__*/React__default['default'].createElement(IconButton, {
        onClick: geocode,
        icon: "search",
        color: "secondary"
    })), method === 'manual' && /*#__PURE__*/React__default['default'].createElement(React__default['default'].Fragment, null, /*#__PURE__*/React__default['default'].createElement(Input, {
        name: name + '_latitude',
        label: "Latitude",
        type: "decimal",
        inputProps: {
            step: 0.000001,
            min: -90,
            max: 90
        },
        InputLabelProps: {
            shrink: true
        },
        style: {
            marginRight: 4
        }
    }), /*#__PURE__*/React__default['default'].createElement(Input, {
        name: name + '_longitude',
        label: "Longitude",
        type: "decimal",
        inputProps: {
            step: 0.000001,
            min: -180,
            max: 180
        },
        InputLabelProps: {
            shrink: true
        },
        style: {
            marginLeft: 4
        }
    }), /*#__PURE__*/React__default['default'].createElement(IconButton, {
        onClick: saveLatLong,
        icon: "search",
        variant: "filled",
        color: "secondary"
    }))), /*#__PURE__*/React__default['default'].createElement(AutoMap, {
        containerStyle: {
            minHeight: 400
        }
    }, /*#__PURE__*/React__default['default'].createElement(Draw, {
        type: drawType,
        required: required,
        data: geojson,
        setData: handleChange
    })), /*#__PURE__*/React__default['default'].createElement(HelperText, {
        name: name,
        hint: hint
    }));
}
Geo.propTypes = {
    name: PropTypes__default['default'].string,
    type: PropTypes__default['default'].string,
    required: PropTypes__default['default'].boolean,
    label: PropTypes__default['default'].string,
    hint: PropTypes__default['default'].string,
    inset: PropTypes__default['default'].boolean
};
function flatten(geojson) {
    var geoms = [];

    if (geojson.type === 'FeatureCollection') {
        geojson.features.forEach(function (feature) {
            addGeometry(feature.geometry);
        });
    } else if (geojson.type === 'Feature') {
        addGeometry(geojson.geometry);
    } else {
        addGeometry(geojson);
    }

    if (geoms.length == 0) {
        return null;
    } else if (geoms.length == 1) {
        return geoms[0];
    } else {
        return {
            type: 'GeometryCollection',
            geometries: geoms
        };
    }

    function addGeometry(geometry) {
        if (geometry.type == 'GeometryCollection') {
            geometry.geometries.forEach(addGeometry);
        } else {
            geoms.push(geometry);
        }
    }
}
function useFeatureCollection(value) {
    return React.useMemo(function () {
        return asFeatureCollection(value);
    }, [value]);
}

function asFeatureCollection(geojson) {
    if (typeof geojson === 'string') {
        try {
            geojson = JSON.parse(geojson);
        } catch (e) {
            geojson = null;
        }
    }

    if (!geojson || !geojson.type) {
        return geojson;
    }

    var geometry = flatten(geojson);

    if (!geometry) {
        return null;
    }

    var features;

    if (geometry.type === 'GeometryCollection') {
        features = geometry.geometries.map(function (geometry) {
            return {
                type: 'Feature',
                properties: {},
                geometry: geometry
            };
        });
    } else {
        features = [{
            type: 'Feature',
            properties: {},
            geometry: geometry
        }];
    }

    return {
        type: 'FeatureCollection',
        features: features
    };
}

function EmbeddedGeo(_ref) {
    var type = _ref.type,
        value = _ref.value,
        setValue = _ref.setValue;

    var _useComponents = useComponents(),
        AutoMap = _useComponents.AutoMap,
        _useOverlayComponents = useOverlayComponents(),
        Draw = _useOverlayComponents.Draw,
        drawType = TYPE_MAP[type] || 'all',
        geojson = useFeatureCollection(value);

    function handleChange(geojson) {
        setValue(flatten(geojson));
    }

    return /*#__PURE__*/React__default['default'].createElement(AutoMap, null, /*#__PURE__*/React__default['default'].createElement(Draw, {
        type: drawType,
        data: geojson,
        setData: handleChange
    }));
}

EmbeddedGeo.makeComponent = function (props) {
    function Component() {
        return /*#__PURE__*/React__default['default'].createElement(EmbeddedGeo, props);
    }

    return Component;
};

EmbeddedGeo.propTypes = {
    type: PropTypes__default['default'].string,
    value: PropTypes__default['default'].object,
    setValue: PropTypes__default['default'].func
};

var RENDER = 'RENDER';
var MAP_READY = 'MAP_READY',
    MAP_SHOW_OVERLAY = 'MAP_SHOW_OVERLAY',
    MAP_HIDE_OVERLAY = 'MAP_HIDE_OVERLAY',
    MAP_SET_BASEMAP = 'MAP_SET_BASEMAP',
    MAP_SET_HIGHLIGHT = 'MAP_SET_HIGHLIGHT',
    MAP_ADD_HIGHLIGHT = 'MAP_ADD_HIGHLIGHT',
    MAP_TOGGLE_HIGHLIGHT = 'MAP_TOGGLE_HIGHLIGHT',
    MAP_REMOVE_HIGHLIGHT = 'MAP_REMOVE_HIGHLIGHT',
    MAP_CLEAR_HIGHLIGHT = 'MAP_CLEAR_HIGHLIGHT',
    MAP_SET_BOUNDS = 'MAP_SET_BOUNDS';
var _lastRouteInfo = null;
function reducer() {
    var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    var action = arguments.length > 1 ? arguments[1] : undefined;
    var config = arguments.length > 2 ? arguments[2] : undefined;

    switch (action.type) {
        case RENDER:
            {
                var context = action.payload,
                    routeInfo = context.router_info,
                    conf = routeMapConf(config, routeInfo, context);

                if (routeInfo === _lastRouteInfo) {
                    return state;
                } else {
                    _lastRouteInfo = routeInfo;
                    var nextState = {};
                    var stickyMaps = state.stickyMaps;

                    if (!conf) {
                        nextState = {
                            stickyMaps: stickyMaps
                        };
                    } else {
                        var mapId = conf.mapId,
                            _ref = mapId && stickyMaps && stickyMaps[mapId] || {},
                            _ref$highlight = _ref.highlight,
                            highlight = _ref$highlight === void 0 ? null : _ref$highlight,
                            _ref$instance = _ref.instance,
                            instance = _ref$instance === void 0 ? null : _ref$instance;

                        nextState = {
                            basemaps: reduceBasemaps(state.basemaps, conf.basemaps),
                            overlays: reduceOverlays(state.overlays, conf.layers),
                            bounds: conf.bounds,
                            mapProps: conf.mapProps,
                            highlight: highlight,
                            instance: instance,
                            mapId: mapId,
                            stickyMaps: stickyMaps
                        };
                    }

                    if (!nextState.stickyMaps) {
                        delete nextState.stickyMaps;
                    }

                    return nextState;
                }
            }

        case MAP_READY:
            return reduceMapState(_objectSpread2(_objectSpread2({}, state), {}, {
                instance: action.payload
            }));

        case MAP_SHOW_OVERLAY:
            return _objectSpread2(_objectSpread2({}, state), {}, {
                overlays: state.overlays && state.overlays.map(function (overlay) {
                    if (overlay.name === action.payload) {
                        return _objectSpread2(_objectSpread2({}, overlay), {}, {
                            active: true
                        });
                    } else {
                        return overlay;
                    }
                })
            });

        case MAP_HIDE_OVERLAY:
            return _objectSpread2(_objectSpread2({}, state), {}, {
                overlays: state.overlays && state.overlays.map(function (overlay) {
                    if (overlay.name === action.payload) {
                        return _objectSpread2(_objectSpread2({}, overlay), {}, {
                            active: false
                        });
                    } else {
                        return overlay;
                    }
                })
            });

        case MAP_SET_BASEMAP:
            return _objectSpread2(_objectSpread2({}, state), {}, {
                basemaps: state.basemaps && state.basemaps.map(function (basemap) {
                    if (basemap.name === action.payload) {
                        return _objectSpread2(_objectSpread2({}, basemap), {}, {
                            active: true
                        });
                    } else if (basemap.active) {
                        return _objectSpread2(_objectSpread2({}, basemap), {}, {
                            active: false
                        });
                    } else {
                        return basemap;
                    }
                })
            });

        case MAP_SET_HIGHLIGHT:
            return reduceMapState(_objectSpread2(_objectSpread2({}, state), {}, {
                highlight: action.payload
            }));

        case MAP_ADD_HIGHLIGHT:
            {
                if (!state.highlight) {
                    return reduceMapState(_objectSpread2(_objectSpread2({}, state), {}, {
                        highlight: action.payload
                    }));
                }

                var features = {};
                var hasNew = false;
                state.highlight.features.forEach(function (feature) {
                    return features[feature.id] = feature;
                });
                action.payload.features.forEach(function (feature) {
                    if (!features[feature.id]) {
                        hasNew = true;
                        features[feature.id] = feature;
                    }
                });

                if (!hasNew) {
                    return state;
                }

                return reduceMapState(_objectSpread2(_objectSpread2({}, state), {}, {
                    highlight: {
                        type: 'FeatureCollection',
                        features: Object.values(features)
                    }
                }));
            }

        case MAP_TOGGLE_HIGHLIGHT:
            {
                if (!state.highlight) {
                    return reduceMapState(_objectSpread2(_objectSpread2({}, state), {}, {
                        highlight: action.payload
                    }));
                }

                var _features = {};
                state.highlight.features.forEach(function (feature) {
                    return _features[feature.id] = feature;
                });
                action.payload.features.forEach(function (feature) {
                    if (_features[feature.id]) {
                        delete _features[feature.id];
                    } else {
                        _features[feature.id] = feature;
                    }
                });
                return reduceMapState(_objectSpread2(_objectSpread2({}, state), {}, {
                    highlight: checkEmpty({
                        type: 'FeatureCollection',
                        features: Object.values(_features)
                    })
                }));
            }

        case MAP_REMOVE_HIGHLIGHT:
            {
                if (!state.highlight) {
                    return state;
                }

                var remove = {};
                action.payload.features.forEach(function (feature) {
                    return remove[feature.id] = true;
                });
                return reduceMapState(_objectSpread2(_objectSpread2({}, state), {}, {
                    highlight: checkEmpty({
                        type: 'FeatureCollection',
                        features: state.highlight.features.filter(function (feature) {
                            return !remove[feature.id];
                        })
                    })
                }));
            }

        case MAP_CLEAR_HIGHLIGHT:
            if (!state.highlight) {
                return state;
            } else {
                return reduceMapState(_objectSpread2(_objectSpread2({}, state), {}, {
                    highlight: null
                }));
            }

        case MAP_SET_BOUNDS:
            return _objectSpread2(_objectSpread2({}, state), {}, {
                bounds: action.payload
            });

        default:
            return state;
    }
}

function reduceBasemaps(lastBasemaps, nextBasemaps) {
    if (!nextBasemaps || nextBasemaps.length === 0) {
        return;
    }

    var activeBasemap = (lastBasemaps || []).filter(function (basemap) {
        return basemap.active;
    })[0],
        basemaps = nextBasemaps.map(function (basemap) {
        if (activeBasemap && activeBasemap.name === basemap.name) {
            return _objectSpread2(_objectSpread2({}, basemap), {}, {
                active: true
            });
        } else {
            return _objectSpread2(_objectSpread2({}, basemap), {}, {
                active: false
            });
        }
    });

    if (!basemaps.some(function (basemap) {
        return basemap.active;
    })) {
        basemaps[0].active = true;
    }

    if (sameLayers(basemaps, lastBasemaps)) {
        return lastBasemaps;
    } else {
        return basemaps;
    }
}

function reduceOverlays(lastOverlays, nextOverlays) {
    if (!nextOverlays || nextOverlays.length === 0) {
        return [];
    }

    var lastActive = {};
    (lastOverlays || []).forEach(function (overlay) {
        lastActive[overlay.name] = overlay.active;
    });
    var overlays = nextOverlays.map(function (overlay) {
        if (lastActive[overlay.name]) {
            return _objectSpread2(_objectSpread2({}, overlay), {}, {
                active: true
            });
        } else if (overlay.active) {
            return _objectSpread2({}, overlay);
        } else {
            return _objectSpread2(_objectSpread2({}, overlay), {}, {
                active: false
            });
        }
    });

    if (sameLayers(overlays, lastOverlays)) {
        return lastOverlays;
    } else {
        return overlays;
    }
}

function sameLayers(arr1, arr2) {
    if (arr1.length !== (arr2 || []).length) {
        return false;
    }

    return arr1.every(function (layer, i) {
        return layer.name === arr2[i].name && layer.active === arr2[i].active;
    });
}

function checkEmpty(geojson) {
    if (geojson.features.length === 0) {
        return null;
    } else {
        return geojson;
    }
}

function reduceMapState(state) {
    var mapId = state.mapId,
        instance = state.instance,
        highlight = state.highlight;

    if (mapId) {
        var stickyMaps = state.stickyMaps || {};
        return _objectSpread2(_objectSpread2({}, state), {}, {
            stickyMaps: _objectSpread2(_objectSpread2({}, stickyMaps), {}, _defineProperty({}, mapId, {
                instance: instance,
                highlight: highlight
            }))
        });
    } else {
        return state;
    }
}

var map = {
    name: 'map',
    reducer: function reducer$1(state, action) {
        return reducer(state, action, this.config);
    },
    actions: {
        ready: function ready(instance) {
            return {
                type: MAP_READY,
                payload: instance
            };
        },
        setBasemap: function setBasemap(name) {
            return {
                type: MAP_SET_BASEMAP,
                payload: name
            };
        },
        showOverlay: function showOverlay(name) {
            return {
                type: MAP_SHOW_OVERLAY,
                payload: name
            };
        },
        hideOverlay: function hideOverlay(name) {
            return {
                type: MAP_HIDE_OVERLAY,
                payload: name
            };
        },
        setHighlight: function setHighlight(geojson) {
            return {
                type: MAP_SET_HIGHLIGHT,
                payload: asFeatureCollection$1(geojson)
            };
        },
        addHighlight: function addHighlight(geojson) {
            return {
                type: MAP_ADD_HIGHLIGHT,
                payload: asFeatureCollection$1(geojson)
            };
        },
        toggleHighlight: function toggleHighlight(geojson) {
            return {
                type: MAP_TOGGLE_HIGHLIGHT,
                payload: asFeatureCollection$1(geojson)
            };
        },
        removeHighlight: function removeHighlight(geojson) {
            return {
                type: MAP_REMOVE_HIGHLIGHT,
                payload: asFeatureCollection$1(geojson)
            };
        },
        clearHighlight: function clearHighlight() {
            return {
                type: MAP_CLEAR_HIGHLIGHT
            };
        },
        setBounds: function setBounds(bounds) {
            return {
                type: MAP_SET_BOUNDS,
                payload: bounds
            };
        }
    },
    components: {
        AutoMap: AutoMap,
        AutoBasemap: AutoBasemap,
        AutoOverlay: AutoOverlay,
        StickyMap: StickyMap,
        Map: Map$1,
        MapInteraction: function MapInteraction() {
            return null;
        },
        Legend: Legend,
        BasemapToggle: BasemapToggle,
        OverlayToggle: OverlayToggle
    },
    inputs: {
        Geo: Geo,
        geopoint: Geo,
        geotrace: Geo,
        geoshape: Geo
    },
    config: {
        bounds: [[-4, -4], [4, 4]],
        autoZoom: {
            wait: 0.5,
            // How long to wait before triggering autoZoom
            sticky: true,
            // Start new maps in same location as old maps
            // Settings for fitBounds
            maxZoom: 13,
            animate: true
        },
        basemaps: {
            Tile: function Tile(_ref) {
                var url = _ref.url;
                return "Tile at ".concat(url);
            }
        },
        overlays: {
            Geojson: function Geojson(_ref2) {
                var url = _ref2.url,
                    data = _ref2.data;

                if (data) {
                    return "GeoJSON ".concat(data.type);
                } else {
                    return "GeoJSON at ".concat(url);
                }
            },
            Highlight: function Highlight(_ref3) {
                var data = _ref3.data;
                return "Highlight ".concat(data.type);
            },
            Draw: function Draw(_ref4) {
                var type = _ref4.type,
                    data = _ref4.data;
                return "Draw ".concat(data ? data.type : type);
            }
        },
        maps: {
            basemaps: _defaultBasemaps()
        }
    }
}; // This will be called by app.init()

map.init = function (config) {
    var _this = this;

    var app = this.app;
    Object.values(app.plugins).forEach(function (plugin) {
        if (plugin.basemaps) {
            Object.assign(_this.config.basemaps, plugin.basemaps);
        }

        if (plugin.overlays) {
            Object.assign(_this.config.overlays, plugin.overlays);
        }

        if (plugin.geocoder) {
            _this.config.geocoder = function (address) {
                return plugin.geocoder(address);
            };
        }

        if (plugin.geocoderAddress) {
            _this.config.geocoderAddress = function (values) {
                return plugin.geocoderAddress(values);
            };
        }
    }); // FIXME: loadDraw();

    if (config) {
        ['basemaps', 'overlays', 'maps'].forEach(function (key) {
            if (config[key]) {
                config[key] = _objectSpread2(_objectSpread2({}, _this.config[key]), config[key]);
            }
        });
        Object.assign(this.config, config);
    } // Define map configuration for all app pages with map=True


    Object.keys(app.config.pages).forEach(function (page) {
        var pconf = app.config.pages[page],
            mconf = pconf.map;

        if (!mconf) {
            return;
        } else if (mconf === true) {
            mconf = [];
        } else if (!Array.isArray(mconf)) {
            mconf = [mconf];
        }

        var _ref5 = mconf[0] || {},
            mapId = _ref5.mapId;

        var mapconf = {
            name: pconf.name,
            url: pconf.url,
            mapId: mapId,
            defaults: {
                maps: {
                    main: {
                        layers: []
                    }
                }
            }
        }; // Initialize map configurations for each page display mode

        mconf.forEach(function (conf) {
            var mode = conf.mode || 'defaults',
                map = conf.map || 'main';

            if (mode === 'all') {
                mode = 'defaults';
            }

            if (!mapconf[mode]) {
                mapconf[mode] = {
                    maps: {}
                };
            }

            mapconf[mode].maps[map] = conf;
        }); // Ensure map configurations exist for all list page modes

        var modes = [];

        if (pconf.modes) {
            modes = pconf.modes;
        } else if (pconf.list) {
            modes = ['list', 'detail', 'edit'];
        }

        modes.forEach(function (mode) {
            if (mapconf[mode]) {
                if (mapconf[mode].maps && mapconf[mode].maps.main && mapconf[mode].maps.main.autoLayers && !mapconf[mode].maps.main.layers) {
                    mapconf[mode].maps.main.layers = [];
                }

                return;
            }

            mapconf[mode] = {
                maps: {
                    main: {
                        autoLayers: true,
                        layers: []
                    }
                }
            };
        });
        map.config.maps[page] = mapconf;
    });
}; // Plugin API


map.runComponent = function (_ref6) {
    var page = _ref6.page,
        mode = _ref6.mode;
    var mapconf = map.config.maps[page];

    if (mapconf && mode !== 'edit' && !mapconf.mapId) {
        return 'AutoMap';
    } else {
        return null;
    }
}; // FIXME: Drop this function in 2.0


map.run = function ($page, routeInfo) {
    var _this2 = this;

    var mapconf = map.config.maps[routeInfo.page],
        mode = routeInfo.mode,
        form = routeInfo.form,
        maps = [];

    if (!mapconf) {
        return;
    }

    if (mapconf[mode] && mapconf[mode].maps) {
        maps = Object.keys(mapconf[mode].maps);
    } else {
        maps = ['main'];
    }

    maps.forEach(function (mapname) {
        var divid = map.getMapId(routeInfo, mapname) + '-map',
            $div = $page.find('#' + divid);
        var Component;

        if (mode === 'edit') {
            var fieldName = mapname === 'main' ? 'geometry' : mapname,
                _ref7 = form.find(function (field) {
                return field.name === fieldName;
            }) || {},
                type = _ref7.type,
                $field = $page.find("[name=".concat(fieldName, "]")),
                value = routeInfo.context[fieldName],
                setValue = function setValue(data) {
                return $field.val(JSON.stringify(data));
            };

            Component = EmbeddedGeo.makeComponent({
                type: type,
                value: value,
                setValue: setValue
            });
        } else {
            Component = AutoMap;
        }

        var detach = reactRenderer.attach(Component, $div[0], _this2.app);
        $page.on('pagehide', detach);
    });
}; // Default base map configuration - override to customize


function _defaultBasemaps() {
    var cdn = 'https://stamen-tiles-{s}.a.ssl.fastly.net/terrain/{z}/{x}/{y}.jpg';
    var attr = 'Map tiles by <a href="http://stamen.com">Stamen Design</a>, under <a href="http://creativecommons.org/licenses/by/3.0">CC BY 3.0</a>. Data by <a href="http://openstreetmap.org">OpenStreetMap</a>, under <a href="http://www.openstreetmap.org/copyright">ODbL</a>.';
    return [{
        name: 'Stamen Terrain',
        type: 'tile',
        url: cdn,
        attribution: attr
    }];
} // FIXME: Drop this function in 2.0


map.getMapId = function (routeInfo, mapname) {
    var rt = routeInfo,
        parts = [];

    if (rt.item_id || rt.mode === 'edit' && rt.variant === 'new') {
        if (rt.mode === 'detail') {
            parts = [rt.page, rt.item_id];
        } else {
            parts = [rt.page, rt.item_id || rt.variant, rt.mode];
        }
    } else if (routeInfo.parent_page) {
        parts = [rt.parent_page, rt.parent_id, rt.page];
    } else {
        parts = [rt.page];
    }

    if (mapname && mapname !== 'main') {
        parts.push(mapname);
    }

    return parts.join('-');
};

function asFeatureCollection$1(geojson) {
    if (!geojson) {
        geojson = [];
    } else if (geojson.type && geojson.type !== 'FeatureCollection') {
        geojson = [geojson];
    }

    if (Array.isArray(geojson)) {
        geojson = {
            type: 'FeatureCollection',
            features: geojson
        };
    } else if (!geojson.type) {
        throw new Error('Invalid GeoJSON');
    }

    return geojson;
}

function _extends$2() {
    _extends$2 = Object.assign || function (target) {
        for (var i = 1; i < arguments.length; i++) {
            var source = arguments[i];

            for (var key in source) {
                if (Object.prototype.hasOwnProperty.call(source, key)) {
                    target[key] = source[key];
                }
            }
        }

        return target;
    };

    return _extends$2.apply(this, arguments);
}

/**
 * Copyright 2015, Yahoo! Inc.
 * Copyrights licensed under the New BSD License. See the accompanying LICENSE file for terms.
 */


var REACT_STATICS$1 = {
    childContextTypes: true,
    contextType: true,
    contextTypes: true,
    defaultProps: true,
    displayName: true,
    getDefaultProps: true,
    getDerivedStateFromError: true,
    getDerivedStateFromProps: true,
    mixins: true,
    propTypes: true,
    type: true
};
var KNOWN_STATICS$1 = {
    name: true,
    length: true,
    prototype: true,
    caller: true,
    callee: true,
    arguments: true,
    arity: true
};
var FORWARD_REF_STATICS$2 = {
    '$$typeof': true,
    render: true,
    defaultProps: true,
    displayName: true,
    propTypes: true
};
var MEMO_STATICS$2 = {
    '$$typeof': true,
    compare: true,
    defaultProps: true,
    displayName: true,
    propTypes: true,
    type: true
};
var TYPE_STATICS$2 = {};
TYPE_STATICS$2[reactIs__default['default'].ForwardRef] = FORWARD_REF_STATICS$2;
TYPE_STATICS$2[reactIs__default['default'].Memo] = MEMO_STATICS$2;

function getStatics$1(component) {
    // React v16.11 and below
    if (reactIs__default['default'].isMemo(component)) {
        return MEMO_STATICS$2;
    } // React v16.12 and above


    return TYPE_STATICS$2[component['$$typeof']] || REACT_STATICS$1;
}

var defineProperty$2 = Object.defineProperty;
var getOwnPropertyNames$1 = Object.getOwnPropertyNames;
var getOwnPropertySymbols$1 = Object.getOwnPropertySymbols;
var getOwnPropertyDescriptor$1 = Object.getOwnPropertyDescriptor;
var getPrototypeOf$1 = Object.getPrototypeOf;
var objectPrototype$1 = Object.prototype;

function hoistNonReactStatics$1(targetComponent, sourceComponent, blacklist) {
    if (typeof sourceComponent !== 'string') {
        // don't hoist over string (html) components
        if (objectPrototype$1) {
            var inheritedComponent = getPrototypeOf$1(sourceComponent);

            if (inheritedComponent && inheritedComponent !== objectPrototype$1) {
                hoistNonReactStatics$1(targetComponent, inheritedComponent, blacklist);
            }
        }

        var keys = getOwnPropertyNames$1(sourceComponent);

        if (getOwnPropertySymbols$1) {
            keys = keys.concat(getOwnPropertySymbols$1(sourceComponent));
        }

        var targetStatics = getStatics$1(targetComponent);
        var sourceStatics = getStatics$1(sourceComponent);

        for (var i = 0; i < keys.length; ++i) {
            var key = keys[i];

            if (!KNOWN_STATICS$1[key] && !(blacklist && blacklist[key]) && !(sourceStatics && sourceStatics[key]) && !(targetStatics && targetStatics[key])) {
                var descriptor = getOwnPropertyDescriptor$1(sourceComponent, key);

                try {
                    // Avoid failures from read-only properties
                    defineProperty$2(targetComponent, key, descriptor);
                } catch (e) {}
            }
        }
    }

    return targetComponent;
}

var hoistNonReactStatics_cjs$1 = hoistNonReactStatics$1;

var leafletContext = /*#__PURE__*/React.createContext({});
var useLeaflet = function useLeaflet() {
    return React.useContext(leafletContext);
};
var LeafletConsumer = leafletContext.Consumer;
var LeafletProvider = leafletContext.Provider;
var withLeaflet = function withLeaflet(WrappedComponent) {
    var WithLeafletComponent = function WithLeafletComponent(props, ref) {
        return /*#__PURE__*/React__default['default'].createElement(LeafletConsumer, null, function (leaflet) {
            return /*#__PURE__*/React__default['default'].createElement(WrappedComponent, _extends$2({}, props, {
                leaflet: leaflet,
                ref: ref
            }));
        });
    };

    var name = // flowlint-next-line sketchy-null-string:off
    WrappedComponent.displayName || WrappedComponent.name || 'Component';
    WithLeafletComponent.displayName = "Leaflet(" + name + ")";
    var LeafletComponent = /*#__PURE__*/React.forwardRef(WithLeafletComponent);
    hoistNonReactStatics_cjs$1(LeafletComponent, WrappedComponent);
    return LeafletComponent;
};

function _inheritsLoose$1(subClass, superClass) {
    subClass.prototype = Object.create(superClass.prototype);
    subClass.prototype.constructor = subClass;
    subClass.__proto__ = superClass;
}

function _assertThisInitialized$2(self) {
    if (self === void 0) {
        throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }

    return self;
}

function _defineProperty$1(obj, key, value) {
    if (key in obj) {
        Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
        });
    } else {
        obj[key] = value;
    }

    return obj;
}

var MapControl = /*#__PURE__*/function (_Component) {
    _inheritsLoose$1(MapControl, _Component);

    function MapControl(props) {
        var _this;

        _this = _Component.call(this, props) || this;

        _defineProperty$1(_assertThisInitialized$2(_this), "leafletElement", void 0);

        _this.leafletElement = _this.createLeafletElement(_this.props);
        return _this;
    }

    var _proto = MapControl.prototype;

    _proto.createLeafletElement = function createLeafletElement(_props) {
        throw new Error('createLeafletElement() must be implemented');
    };

    _proto.updateLeafletElement = function updateLeafletElement(fromProps, toProps) {
        if (toProps.position !== fromProps.position) {
            this.leafletElement.setPosition(toProps.position);
        }
    };

    _proto.componentDidMount = function componentDidMount() {
        this.leafletElement.addTo(this.props.leaflet.map);
    };

    _proto.componentDidUpdate = function componentDidUpdate(prevProps) {
        this.updateLeafletElement(prevProps, this.props);
    };

    _proto.componentWillUnmount = function componentWillUnmount() {
        this.leafletElement.remove();
    };

    _proto.render = function render() {
        return null;
    };

    return MapControl;
}(React.Component);

function _objectWithoutPropertiesLoose$3(source, excluded) {
    if (source == null) return {};
    var target = {};
    var sourceKeys = Object.keys(source);
    var key, i;

    for (i = 0; i < sourceKeys.length; i++) {
        key = sourceKeys[i];
        if (excluded.indexOf(key) >= 0) continue;
        target[key] = source[key];
    }

    return target;
}

function equal$1(a, b) {
    if (a === b) return true;

    if (a && b && _typeof(a) == 'object' && _typeof(b) == 'object') {
        if (a.constructor !== b.constructor) return false;
        var length, i, keys;

        if (Array.isArray(a)) {
            length = a.length;
            if (length != b.length) return false;

            for (i = length; i-- !== 0;) {
                if (!equal$1(a[i], b[i])) return false;
            }

            return true;
        }

        if (a.constructor === RegExp) return a.source === b.source && a.flags === b.flags;
        if (a.valueOf !== Object.prototype.valueOf) return a.valueOf() === b.valueOf();
        if (a.toString !== Object.prototype.toString) return a.toString() === b.toString();
        keys = Object.keys(a);
        length = keys.length;
        if (length !== Object.keys(b).length) return false;

        for (i = length; i-- !== 0;) {
            if (!Object.prototype.hasOwnProperty.call(b, keys[i])) return false;
        }

        for (i = length; i-- !== 0;) {
            var key = keys[i];
            if (!equal$1(a[key], b[key])) return false;
        }

        return true;
    } // true if both NaN, false otherwise


    return a !== a && b !== b;
}

function _defineProperties$1(target, props) {
    for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor) descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
    }
}

function _createClass$1(Constructor, protoProps, staticProps) {
    if (protoProps) _defineProperties$1(Constructor.prototype, protoProps);
    if (staticProps) _defineProperties$1(Constructor, staticProps);
    return Constructor;
}

var EVENTS_RE = /^on(.+)$/i;

var MapEvented = /*#__PURE__*/function (_Component) {
    _inheritsLoose$1(MapEvented, _Component);

    function MapEvented(props) {
        var _this;

        _this = _Component.call(this, props) || this;

        _defineProperty$1(_assertThisInitialized$2(_this), "_leafletEvents", void 0);

        _defineProperty$1(_assertThisInitialized$2(_this), "leafletElement", void 0);

        _this._leafletEvents = _this.extractLeafletEvents(props);
        return _this;
    }

    var _proto = MapEvented.prototype;

    _proto.componentDidMount = function componentDidMount() {
        this.bindLeafletEvents(this._leafletEvents);
    };

    _proto.componentDidUpdate = function componentDidUpdate(_prevProps) {
        this._leafletEvents = this.bindLeafletEvents(this.extractLeafletEvents(this.props), this._leafletEvents);
    };

    _proto.componentWillUnmount = function componentWillUnmount() {
        var _this2 = this;

        var el = this.leafletElement;
        if (!el) return;
        Object.keys(this._leafletEvents).forEach(function (ev) {
            el.off(ev, _this2._leafletEvents[ev]);
        });
    };

    _proto.extractLeafletEvents = function extractLeafletEvents(props) {
        return Object.keys(props).reduce(function (res, prop) {
            if (EVENTS_RE.test(prop)) {
                if (props[prop] != null) {
                    var _key = prop.replace(EVENTS_RE, function (match, p) {
                        return p.toLowerCase();
                    });

                    res[_key] = props[prop];
                }
            }

            return res;
        }, {});
    };

    _proto.bindLeafletEvents = function bindLeafletEvents(next, prev) {
        if (next === void 0) {
            next = {};
        }

        if (prev === void 0) {
            prev = {};
        }

        var el = this.leafletElement;
        if (el == null || el.on == null) return {};

        var diff = _extends$2({}, prev);

        Object.keys(prev).forEach(function (ev) {
            if (next[ev] == null || prev[ev] !== next[ev]) {
                delete diff[ev];
                el.off(ev, prev[ev]);
            }
        });
        Object.keys(next).forEach(function (ev) {
            if (prev[ev] == null || next[ev] !== prev[ev]) {
                diff[ev] = next[ev];
                el.on(ev, next[ev]);
            }
        });
        return diff;
    };

    _proto.fireLeafletEvent = function fireLeafletEvent(type, data) {
        var el = this.leafletElement;
        if (el) el.fire(type, data);
    };

    return MapEvented;
}(React.Component);

var MapComponent = /*#__PURE__*/function (_MapEvented) {
    _inheritsLoose$1(MapComponent, _MapEvented);

    function MapComponent() {
        return _MapEvented.apply(this, arguments) || this;
    }

    var _proto = MapComponent.prototype;

    _proto.getOptions = function getOptions(props) {
        if (props.pane != null) {
            return props;
        }

        if (props.leaflet != null && props.leaflet.pane != null) {
            return _extends$2(_extends$2({}, props), {}, {
                pane: props.leaflet.pane
            });
        }

        return props;
    };

    return MapComponent;
}(MapEvented);

var MapLayer = /*#__PURE__*/function (_MapComponent) {
    _inheritsLoose$1(MapLayer, _MapComponent);

    function MapLayer(props) {
        var _this;

        _this = _MapComponent.call(this, props) || this;

        _defineProperty$1(_assertThisInitialized$2(_this), "contextValue", void 0);

        _defineProperty$1(_assertThisInitialized$2(_this), "leafletElement", void 0);

        _this.leafletElement = _this.createLeafletElement(props);
        return _this;
    }

    var _proto = MapLayer.prototype;

    _proto.createLeafletElement = function createLeafletElement(_props) {
        throw new Error('createLeafletElement() must be implemented');
    };

    _proto.updateLeafletElement = function updateLeafletElement(_fromProps, _toProps) {};

    _proto.componentDidMount = function componentDidMount() {
        _MapComponent.prototype.componentDidMount.call(this);

        this.layerContainer.addLayer(this.leafletElement);
    };

    _proto.componentDidUpdate = function componentDidUpdate(prevProps) {
        _MapComponent.prototype.componentDidUpdate.call(this, prevProps);

        if (this.props.attribution !== prevProps.attribution) {
            var map = this.props.leaflet.map;

            if (map != null && map.attributionControl != null) {
                map.attributionControl.removeAttribution(prevProps.attribution);
                map.attributionControl.addAttribution(this.props.attribution);
            }
        }

        this.updateLeafletElement(prevProps, this.props);
    };

    _proto.componentWillUnmount = function componentWillUnmount() {
        _MapComponent.prototype.componentWillUnmount.call(this);

        this.layerContainer.removeLayer(this.leafletElement);
    };

    _proto.render = function render() {
        var children = this.props.children;

        if (children == null) {
            return null;
        }

        return this.contextValue == null ? /*#__PURE__*/React__default['default'].createElement(React.Fragment, null, children) : /*#__PURE__*/React__default['default'].createElement(LeafletProvider, {
            value: this.contextValue
        }, children);
    };

    _createClass$1(MapLayer, [{
        key: "layerContainer",
        get: function get() {
            return this.props.leaflet.layerContainer || this.props.leaflet.map;
        }
    }]);

    return MapLayer;
}(MapComponent);

function pick(object, keys) {
    return keys.reduce(function (obj, key) {
        if (typeof object[key] !== 'undefined') {
            obj[key] = object[key];
        }

        return obj;
    }, {});
}

var OPTIONS = ['stroke', 'color', 'weight', 'opacity', 'lineCap', 'lineJoin', 'dashArray', 'dashOffset', 'fill', 'fillColor', 'fillOpacity', 'fillRule', 'bubblingMouseEvents', 'renderer', 'className', // Interactive Layer
'interactive', // Layer
'pane', 'attribution'];

var Path = /*#__PURE__*/function (_MapLayer) {
    _inheritsLoose$1(Path, _MapLayer);

    function Path(props) {
        var _this;

        _this = _MapLayer.call(this, props) || this;

        if (_this.contextValue == null) {
            _this.contextValue = _extends$2(_extends$2({}, props.leaflet), {}, {
                popupContainer: _this.leafletElement
            });
        }

        return _this;
    }

    var _proto = Path.prototype;

    _proto.componentDidUpdate = function componentDidUpdate(prevProps) {
        _MapLayer.prototype.componentDidUpdate.call(this, prevProps);

        this.setStyleIfChanged(prevProps, this.props);
    };

    _proto.getPathOptions = function getPathOptions(props) {
        return pick(props, OPTIONS);
    };

    _proto.setStyle = function setStyle(options) {
        if (options === void 0) {
            options = {};
        }

        this.leafletElement.setStyle(options);
    };

    _proto.setStyleIfChanged = function setStyleIfChanged(fromProps, toProps) {
        var nextStyle = this.getPathOptions(toProps);

        if (!equal$1(nextStyle, this.getPathOptions(fromProps))) {
            this.setStyle(nextStyle);
        }
    };

    return Path;
}(MapLayer);

var splitClassName = function splitClassName(className) {
    if (className === void 0) {
        className = '';
    }

    return className.split(' ').filter(Boolean);
};

var addClassName = function addClassName(container, className) {
    splitClassName(className).forEach(function (cls) {
        L$1.DomUtil.addClass(container, cls);
    });
};
var removeClassName = function removeClassName(container, className) {
    splitClassName(className).forEach(function (cls) {
        L$1.DomUtil.removeClass(container, cls);
    });
};
var updateClassName = (function (container, prevClassName, nextClassName) {
    if (container != null && nextClassName !== prevClassName) {
        if (prevClassName != null && prevClassName.length > 0) {
            removeClassName(container, prevClassName);
        }

        if (nextClassName != null && nextClassName.length > 0) {
            addClassName(container, nextClassName);
        }
    }
});

var FeatureGroup = /*#__PURE__*/function (_Path) {
    _inheritsLoose$1(FeatureGroup, _Path);

    function FeatureGroup() {
        return _Path.apply(this, arguments) || this;
    }

    var _proto = FeatureGroup.prototype;

    _proto.createLeafletElement = function createLeafletElement(props) {
        var el = new L$1.FeatureGroup(this.getOptions(props));
        this.contextValue = _extends$2(_extends$2({}, props.leaflet), {}, {
            layerContainer: el,
            popupContainer: el
        });
        return el;
    };

    _proto.componentDidMount = function componentDidMount() {
        _Path.prototype.componentDidMount.call(this);

        this.setStyle(this.props);
    };

    return FeatureGroup;
}(Path);

var FeatureGroup$1 = withLeaflet(FeatureGroup);

var GeoJSON = /*#__PURE__*/function (_Path) {
    _inheritsLoose$1(GeoJSON, _Path);

    function GeoJSON() {
        return _Path.apply(this, arguments) || this;
    }

    var _proto = GeoJSON.prototype;

    _proto.createLeafletElement = function createLeafletElement(props) {
        return new L$1.GeoJSON(props.data, this.getOptions(props));
    };

    _proto.updateLeafletElement = function updateLeafletElement(fromProps, toProps) {
        if (typeof toProps.style === 'function') {
            this.leafletElement.setStyle(toProps.style);
        } else {
            this.setStyleIfChanged(fromProps, toProps);
        }
    };

    return GeoJSON;
}(Path);

var GeoJSON$1 = withLeaflet(GeoJSON);

var GridLayer = /*#__PURE__*/function (_MapLayer) {
    _inheritsLoose$1(GridLayer, _MapLayer);

    function GridLayer() {
        return _MapLayer.apply(this, arguments) || this;
    }

    var _proto = GridLayer.prototype;

    _proto.createLeafletElement = function createLeafletElement(props) {
        return new L$1.GridLayer(this.getOptions(props));
    };

    _proto.updateLeafletElement = function updateLeafletElement(fromProps, toProps) {
        var opacity = toProps.opacity,
            zIndex = toProps.zIndex;

        if (opacity !== fromProps.opacity) {
            this.leafletElement.setOpacity(opacity);
        }

        if (zIndex !== fromProps.zIndex) {
            this.leafletElement.setZIndex(zIndex);
        }
    };

    _proto.getOptions = function getOptions(props) {
        var options = _extends$2({}, _MapLayer.prototype.getOptions.call(this, props));

        var map = props.leaflet.map;

        if (map != null) {
            // $FlowFixMe: Object spread
            if (options.maxZoom == null && map.options.maxZoom != null) {
                // $FlowFixMe: Object spread
                options.maxZoom = map.options.maxZoom;
            } // $FlowFixMe: Object spread


            if (options.minZoom == null && map.options.minZoom != null) {
                // $FlowFixMe: Object spread
                options.minZoom = map.options.minZoom;
            }
        }

        return options;
    };

    _proto.render = function render() {
        return null;
    };

    return GridLayer;
}(MapLayer);

var LayerGroup = /*#__PURE__*/function (_MapLayer) {
    _inheritsLoose$1(LayerGroup, _MapLayer);

    function LayerGroup() {
        return _MapLayer.apply(this, arguments) || this;
    }

    var _proto = LayerGroup.prototype;

    _proto.createLeafletElement = function createLeafletElement(props) {
        var el = new L$1.LayerGroup([], this.getOptions(props));
        this.contextValue = _extends$2(_extends$2({}, props.leaflet), {}, {
            layerContainer: el
        });
        return el;
    };

    return LayerGroup;
}(MapLayer);

var Group = withLeaflet(LayerGroup);

var ControlledLayer = /*#__PURE__*/function (_Component) {
    _inheritsLoose$1(ControlledLayer, _Component);

    function ControlledLayer() {
        var _this;

        for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
        }

        _this = _Component.call.apply(_Component, [this].concat(args)) || this;

        _defineProperty$1(_assertThisInitialized$2(_this), "contextValue", void 0);

        _defineProperty$1(_assertThisInitialized$2(_this), "layer", void 0);

        return _this;
    }

    var _proto = ControlledLayer.prototype;

    _proto.componentDidUpdate = function componentDidUpdate(_ref) {
        var checked = _ref.checked;

        if (this.props.leaflet.map == null) {
            return;
        } // Handle dynamically (un)checking the layer => adding/removing from the map


        if (this.props.checked === true && (checked == null || checked === false)) {
            this.props.leaflet.map.addLayer(this.layer);
        } else if (checked === true && (this.props.checked == null || this.props.checked === false)) {
            this.props.leaflet.map.removeLayer(this.layer);
        }
    };

    _proto.componentWillUnmount = function componentWillUnmount() {
        this.props.removeLayerControl(this.layer);
    };

    _proto.addLayer = function addLayer() {
        throw new Error('Must be implemented in extending class');
    };

    _proto.removeLayer = function removeLayer(layer) {
        this.props.removeLayer(layer);
    };

    _proto.render = function render() {
        var children = this.props.children;
        return children ? /*#__PURE__*/React__default['default'].createElement(LeafletProvider, {
            value: this.contextValue
        }, children) : null;
    };

    return ControlledLayer;
}(React.Component);

var BaseLayer = /*#__PURE__*/function (_ControlledLayer) {
    _inheritsLoose$1(BaseLayer, _ControlledLayer);

    function BaseLayer(props) {
        var _this2;

        _this2 = _ControlledLayer.call(this, props) || this;

        _defineProperty$1(_assertThisInitialized$2(_this2), "addLayer", function (layer) {
            _this2.layer = layer; // Keep layer reference to handle dynamic changes of props

            var _this2$props = _this2.props,
                addBaseLayer = _this2$props.addBaseLayer,
                checked = _this2$props.checked,
                name = _this2$props.name;
            addBaseLayer(layer, name, checked);
        });

        _this2.contextValue = _extends$2(_extends$2({}, props.leaflet), {}, {
            layerContainer: {
                addLayer: _this2.addLayer.bind(_assertThisInitialized$2(_this2)),
                removeLayer: _this2.removeLayer.bind(_assertThisInitialized$2(_this2))
            }
        });
        return _this2;
    }

    return BaseLayer;
}(ControlledLayer);

var Overlay = /*#__PURE__*/function (_ControlledLayer2) {
    _inheritsLoose$1(Overlay, _ControlledLayer2);

    function Overlay(props) {
        var _this3;

        _this3 = _ControlledLayer2.call(this, props) || this;

        _defineProperty$1(_assertThisInitialized$2(_this3), "addLayer", function (layer) {
            _this3.layer = layer; // Keep layer reference to handle dynamic changes of props

            var _this3$props = _this3.props,
                addOverlay = _this3$props.addOverlay,
                checked = _this3$props.checked,
                name = _this3$props.name;
            addOverlay(layer, name, checked);
        });

        _this3.contextValue = _extends$2(_extends$2({}, props.leaflet), {}, {
            layerContainer: {
                addLayer: _this3.addLayer.bind(_assertThisInitialized$2(_this3)),
                removeLayer: _this3.removeLayer.bind(_assertThisInitialized$2(_this3))
            }
        });
        return _this3;
    }

    return Overlay;
}(ControlledLayer);

var LayersControl = /*#__PURE__*/function (_MapControl) {
    _inheritsLoose$1(LayersControl, _MapControl);

    function LayersControl(props) {
        var _this4;

        _this4 = _MapControl.call(this, props) || this;

        _defineProperty$1(_assertThisInitialized$2(_this4), "controlProps", void 0);

        _this4.controlProps = {
            addBaseLayer: _this4.addBaseLayer.bind(_assertThisInitialized$2(_this4)),
            addOverlay: _this4.addOverlay.bind(_assertThisInitialized$2(_this4)),
            leaflet: props.leaflet,
            removeLayer: _this4.removeLayer.bind(_assertThisInitialized$2(_this4)),
            removeLayerControl: _this4.removeLayerControl.bind(_assertThisInitialized$2(_this4))
        };
        return _this4;
    }

    var _proto2 = LayersControl.prototype;

    _proto2.createLeafletElement = function createLeafletElement(props) {
        var _children = props.children,
            options = _objectWithoutPropertiesLoose$3(props, ["children"]);

        return new L$1.Control.Layers(undefined, undefined, options);
    };

    _proto2.updateLeafletElement = function updateLeafletElement(fromProps, toProps) {
        _MapControl.prototype.updateLeafletElement.call(this, fromProps, toProps);

        if (toProps.collapsed !== fromProps.collapsed) {
            if (toProps.collapsed === true) {
                this.leafletElement.collapse();
            } else {
                this.leafletElement.expand();
            }
        }
    };

    _proto2.componentWillUnmount = function componentWillUnmount() {
        var _this5 = this;

        setTimeout(function () {
            _MapControl.prototype.componentWillUnmount.call(_this5);
        }, 0);
    };

    _proto2.addBaseLayer = function addBaseLayer(layer, name, checked) {
        if (checked === void 0) {
            checked = false;
        }

        if (checked && this.props.leaflet.map != null) {
            this.props.leaflet.map.addLayer(layer);
        }

        this.leafletElement.addBaseLayer(layer, name);
    };

    _proto2.addOverlay = function addOverlay(layer, name, checked) {
        if (checked === void 0) {
            checked = false;
        }

        if (checked && this.props.leaflet.map != null) {
            this.props.leaflet.map.addLayer(layer);
        }

        this.leafletElement.addOverlay(layer, name);
    };

    _proto2.removeLayer = function removeLayer(layer) {
        if (this.props.leaflet.map != null) {
            this.props.leaflet.map.removeLayer(layer);
        }
    };

    _proto2.removeLayerControl = function removeLayerControl(layer) {
        this.leafletElement.removeLayer(layer);
    };

    _proto2.render = function render() {
        var _this6 = this;

        var children = React.Children.map(this.props.children, function (child) {
            return child ? /*#__PURE__*/React.cloneElement(child, _this6.controlProps) : null;
        });
        return /*#__PURE__*/React__default['default'].createElement(React.Fragment, null, children);
    };

    return LayersControl;
}(MapControl);

var LayersControlExport = withLeaflet(LayersControl);
LayersControlExport.BaseLayer = BaseLayer;
LayersControlExport.Overlay = Overlay;

function omit(obj) {
    for (var _len = arguments.length, keysToOmit = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
        keysToOmit[_key - 1] = arguments[_key];
    }

    return Object.keys(obj).reduce(function (acc, key) {
        if (keysToOmit.indexOf(key) === -1) {
            acc[key] = obj[key];
        }

        return acc;
    }, {});
}

var OTHER_PROPS = ['children', 'className', 'id', 'style', 'useFlyTo', 'whenReady'];

var normalizeCenter = function normalizeCenter(pos) {
    return Array.isArray(pos) ? [pos[0], pos[1]] : [pos.lat, pos.lon ? pos.lon : pos.lng];
};

var Map$2 = /*#__PURE__*/function (_MapEvented) {
    _inheritsLoose$1(Map, _MapEvented);

    function Map(props) {
        var _this;

        _this = _MapEvented.call(this, props) || this;

        _defineProperty$1(_assertThisInitialized$2(_this), "className", void 0);

        _defineProperty$1(_assertThisInitialized$2(_this), "contextValue", void 0);

        _defineProperty$1(_assertThisInitialized$2(_this), "container", void 0);

        _defineProperty$1(_assertThisInitialized$2(_this), "viewport", {
            center: undefined,
            zoom: undefined
        });

        _defineProperty$1(_assertThisInitialized$2(_this), "_ready", false);

        _defineProperty$1(_assertThisInitialized$2(_this), "_updating", false);

        _defineProperty$1(_assertThisInitialized$2(_this), "onViewportChange", function () {
            var center = _this.leafletElement.getCenter();

            _this.viewport = {
                center: center ? [center.lat, center.lng] : undefined,
                zoom: _this.leafletElement.getZoom()
            };

            if (_this.props.onViewportChange && !_this._updating) {
                _this.props.onViewportChange(_this.viewport);
            }
        });

        _defineProperty$1(_assertThisInitialized$2(_this), "onViewportChanged", function () {
            if (_this.props.onViewportChanged && !_this._updating) {
                _this.props.onViewportChanged(_this.viewport);
            }
        });

        _defineProperty$1(_assertThisInitialized$2(_this), "bindContainer", function (container) {
            _this.container = container;
        });

        _this.className = props.className;
        return _this;
    }

    var _proto = Map.prototype;

    _proto.createLeafletElement = function createLeafletElement(props) {
        var viewport = props.viewport,
            options = _objectWithoutPropertiesLoose$3(props, ["viewport"]);

        if (viewport) {
            if (viewport.center) {
                options.center = viewport.center;
            }

            if (typeof viewport.zoom === 'number') {
                options.zoom = viewport.zoom;
            }
        }

        return new L$1.Map(this.container, options);
    };

    _proto.updateLeafletElement = function updateLeafletElement(fromProps, toProps) {
        this._updating = true;
        var bounds = toProps.bounds,
            boundsOptions = toProps.boundsOptions,
            boxZoom = toProps.boxZoom,
            center = toProps.center,
            className = toProps.className,
            doubleClickZoom = toProps.doubleClickZoom,
            dragging = toProps.dragging,
            keyboard = toProps.keyboard,
            maxBounds = toProps.maxBounds,
            scrollWheelZoom = toProps.scrollWheelZoom,
            tap = toProps.tap,
            touchZoom = toProps.touchZoom,
            useFlyTo = toProps.useFlyTo,
            viewport = toProps.viewport,
            zoom = toProps.zoom;
        updateClassName(this.container, fromProps.className, className);

        if (viewport && viewport !== fromProps.viewport) {
            var c = viewport.center ? viewport.center : center;
            var z = viewport.zoom == null ? zoom : viewport.zoom;

            if (useFlyTo === true) {
                this.leafletElement.flyTo(c, z, this.getZoomPanOptions(toProps));
            } else {
                this.leafletElement.setView(c, z, this.getZoomPanOptions(toProps));
            }
        } else if (center && this.shouldUpdateCenter(center, fromProps.center)) {
            if (useFlyTo === true) {
                this.leafletElement.flyTo(center, zoom, this.getZoomPanOptions(toProps));
            } else {
                this.leafletElement.setView(center, zoom, this.getZoomPanOptions(toProps));
            }
        } else if (typeof zoom === 'number' && zoom !== fromProps.zoom) {
            if (fromProps.zoom == null) {
                this.leafletElement.setView(center, zoom, this.getZoomPanOptions(toProps));
            } else {
                this.leafletElement.setZoom(zoom, this.getZoomPanOptions(toProps));
            }
        }

        if (maxBounds && this.shouldUpdateBounds(maxBounds, fromProps.maxBounds)) {
            this.leafletElement.setMaxBounds(maxBounds);
        }

        if (bounds && (this.shouldUpdateBounds(bounds, fromProps.bounds) || boundsOptions !== fromProps.boundsOptions)) {
            if (useFlyTo === true) {
                this.leafletElement.flyToBounds(bounds, this.getFitBoundsOptions(toProps));
            } else {
                this.leafletElement.fitBounds(bounds, this.getFitBoundsOptions(toProps));
            }
        }

        if (boxZoom !== fromProps.boxZoom) {
            if (boxZoom === true) {
                this.leafletElement.boxZoom.enable();
            } else {
                this.leafletElement.boxZoom.disable();
            }
        }

        if (doubleClickZoom !== fromProps.doubleClickZoom) {
            if (doubleClickZoom === true || typeof doubleClickZoom === 'string') {
                this.leafletElement.options.doubleClickZoom = doubleClickZoom;
                this.leafletElement.doubleClickZoom.enable();
            } else {
                this.leafletElement.doubleClickZoom.disable();
            }
        }

        if (dragging !== fromProps.dragging) {
            if (dragging === true) {
                this.leafletElement.dragging.enable();
            } else {
                this.leafletElement.dragging.disable();
            }
        }

        if (keyboard !== fromProps.keyboard) {
            if (keyboard === true) {
                this.leafletElement.keyboard.enable();
            } else {
                this.leafletElement.keyboard.disable();
            }
        }

        if (scrollWheelZoom !== fromProps.scrollWheelZoom) {
            if (scrollWheelZoom === true || typeof scrollWheelZoom === 'string') {
                this.leafletElement.options.scrollWheelZoom = scrollWheelZoom;
                this.leafletElement.scrollWheelZoom.enable();
            } else {
                this.leafletElement.scrollWheelZoom.disable();
            }
        }

        if (tap !== fromProps.tap) {
            if (tap === true) {
                this.leafletElement.tap.enable();
            } else {
                this.leafletElement.tap.disable();
            }
        }

        if (touchZoom !== fromProps.touchZoom) {
            if (touchZoom === true || typeof touchZoom === 'string') {
                this.leafletElement.options.touchZoom = touchZoom;
                this.leafletElement.touchZoom.enable();
            } else {
                this.leafletElement.touchZoom.disable();
            }
        }

        this._updating = false;
    };

    _proto.getZoomPanOptions = function getZoomPanOptions(props) {
        var animate = props.animate,
            duration = props.duration,
            easeLinearity = props.easeLinearity,
            noMoveStart = props.noMoveStart;
        return {
            animate: animate,
            duration: duration,
            easeLinearity: easeLinearity,
            noMoveStart: noMoveStart
        };
    };

    _proto.getFitBoundsOptions = function getFitBoundsOptions(props) {
        var zoomPanOptions = this.getZoomPanOptions(props);
        return _extends$2(_extends$2({}, zoomPanOptions), props.boundsOptions);
    };

    _proto.componentDidMount = function componentDidMount() {
        var props = omit.apply(void 0, [this.props].concat(OTHER_PROPS));
        this.leafletElement = this.createLeafletElement(props);
        this.leafletElement.on('move', this.onViewportChange);
        this.leafletElement.on('moveend', this.onViewportChanged);

        if (props.bounds != null) {
            this.leafletElement.fitBounds(props.bounds, this.getFitBoundsOptions(props));
        }

        this.contextValue = {
            layerContainer: this.leafletElement,
            map: this.leafletElement
        };

        _MapEvented.prototype.componentDidMount.call(this);

        this.forceUpdate(); // Re-render now that leafletElement is created
    };

    _proto.componentDidUpdate = function componentDidUpdate(prevProps) {
        if (this._ready === false) {
            this._ready = true;

            if (this.props.whenReady) {
                this.leafletElement.whenReady(this.props.whenReady);
            }
        }

        _MapEvented.prototype.componentDidUpdate.call(this, prevProps);

        this.updateLeafletElement(prevProps, this.props);
    };

    _proto.componentWillUnmount = function componentWillUnmount() {
        _MapEvented.prototype.componentWillUnmount.call(this);

        this.leafletElement.off('move', this.onViewportChange);
        this.leafletElement.off('moveend', this.onViewportChanged); // The canvas renderer uses requestAnimationFrame, making a deferred call to a deleted object
        // When preferCanvas is set, use simpler teardown logic

        if (this.props.preferCanvas === true) {
            this.leafletElement._initEvents(true);

            this.leafletElement._stop();
        } else {
            this.leafletElement.remove();
        }
    };

    _proto.shouldUpdateCenter = function shouldUpdateCenter(next, prev) {
        if (!prev) return true;
        next = normalizeCenter(next);
        prev = normalizeCenter(prev);
        return next[0] !== prev[0] || next[1] !== prev[1];
    };

    _proto.shouldUpdateBounds = function shouldUpdateBounds(next, prev) {
        return prev ? !L$1.latLngBounds(next).equals(L$1.latLngBounds(prev)) : true;
    };

    _proto.render = function render() {
        return /*#__PURE__*/React__default['default'].createElement("div", {
            className: this.className,
            id: this.props.id,
            ref: this.bindContainer,
            style: this.props.style
        }, this.contextValue ? /*#__PURE__*/React__default['default'].createElement(LeafletProvider, {
            value: this.contextValue
        }, this.props.children) : null);
    };

    return Map;
}(MapEvented);

var TileLayer = /*#__PURE__*/function (_GridLayer) {
    _inheritsLoose$1(TileLayer, _GridLayer);

    function TileLayer() {
        return _GridLayer.apply(this, arguments) || this;
    }

    var _proto = TileLayer.prototype;

    _proto.createLeafletElement = function createLeafletElement(props) {
        return new L$1.TileLayer(props.url, this.getOptions(props));
    };

    _proto.updateLeafletElement = function updateLeafletElement(fromProps, toProps) {
        _GridLayer.prototype.updateLeafletElement.call(this, fromProps, toProps);

        if (toProps.url !== fromProps.url) {
            this.leafletElement.setUrl(toProps.url);
        }
    };

    return TileLayer;
}(GridLayer);

var TileLayer$1 = withLeaflet(TileLayer);

function Ready() {
    var _ref = usePlugin('map') || {},
        ready = _ref.ready,
        _useLeaflet = useLeaflet(),
        map = _useLeaflet.map;

    React.useEffect(function () {
        ready && map && ready(map);
    }, [ready, map]);
    return null;
}

function Map$3(_ref2) {
    var bounds = _ref2.bounds,
        children = _ref2.children,
        mapProps = _ref2.mapProps,
        containerStyle = _ref2.containerStyle;
    var fitBounds = React.useMemo(function () {
        if (!bounds) {
            return bounds;
        }

        var _bounds = _slicedToArray(bounds, 2),
            _bounds$ = _slicedToArray(_bounds[0], 2),
            xmin = _bounds$[0],
            ymin = _bounds$[1],
            _bounds$2 = _slicedToArray(_bounds[1], 2),
            xmax = _bounds$2[0],
            ymax = _bounds$2[1];

        return [[ymin, xmin], [ymax, xmax]];
    }, [bounds]);

    var style = _objectSpread2({
        flex: '1',
        minHeight: 200
    }, containerStyle);

    var maxZoom = mapProps && mapProps.maxZoom || 18;
    return /*#__PURE__*/React__default['default'].createElement(Map$2, _extends({
        bounds: fitBounds,
        style: style,
        maxZoom: maxZoom
    }, mapProps), /*#__PURE__*/React__default['default'].createElement(Ready, null), children);
}
Map$3.propTypes = {
    bounds: PropTypes__default['default'].array,
    children: PropTypes__default['default'].node,
    mapProps: PropTypes__default['default'].object,
    containerStyle: PropTypes__default['default'].object
};

var BaseLayer$1 = LayersControlExport.BaseLayer,
    Overlay$1 = LayersControlExport.Overlay;
function Legend$1(_ref) {
    var position = _ref.position,
        collapsed = _ref.collapsed,
        children = _ref.children;

    if (!position) {
        position = 'topright';
    }

    if (collapsed === undefined) {
        collapsed = true;
    }

    return /*#__PURE__*/React__default['default'].createElement(LayersControlExport, {
        position: position,
        collapsed: collapsed
    }, children);
}
Legend$1.propTypes = {
    position: PropTypes__default['default'].object,
    collapsed: PropTypes__default['default'].bool,
    children: PropTypes__default['default'].node
};
function BasemapToggle$1(_ref2) {
    var name = _ref2.name,
        active = _ref2.active,
        children = _ref2.children,
        rest = _objectWithoutProperties(_ref2, ["name", "active", "children"]);

    return /*#__PURE__*/React__default['default'].createElement(BaseLayer$1, _extends({
        name: name,
        checked: active
    }, rest), children);
}
BasemapToggle$1.propTypes = {
    name: PropTypes__default['default'].string,
    active: PropTypes__default['default'].bool,
    children: PropTypes__default['default'].node
};
function OverlayToggle$1(_ref3) {
    var name = _ref3.name,
        active = _ref3.active,
        children = _ref3.children,
        rest = _objectWithoutProperties(_ref3, ["name", "active", "children"]);

    return /*#__PURE__*/React__default['default'].createElement(Overlay$1, _extends({
        name: name,
        checked: active
    }, rest), children);
}
OverlayToggle$1.propTypes = {
    name: PropTypes__default['default'].string,
    active: PropTypes__default['default'].bool,
    children: PropTypes__default['default'].node
};

function Tile(props) {
    return /*#__PURE__*/React__default['default'].createElement(TileLayer$1, props);
}

var MarkerClusterGroup = /*#__PURE__*/function (_MapLayer) {
    _inherits(MarkerClusterGroup, _MapLayer);

    var _super = _createSuper(MarkerClusterGroup);

    function MarkerClusterGroup() {
        _classCallCheck(this, MarkerClusterGroup);

        return _super.apply(this, arguments);
    }

    _createClass(MarkerClusterGroup, [{
        key: "createLeafletElement",
        value: function createLeafletElement(_ref) {
            var children = _ref.children,
                map = _ref.leaflet.map,
                props = _objectWithoutProperties(_ref, ["children", "leaflet"]);

            var clusterProps = {};
            var clusterEvents = {}; // Splitting props and events to different objects

            Object.entries(props).forEach(function (_ref2) {
                var _ref3 = _slicedToArray(_ref2, 2),
                    propName = _ref3[0],
                    prop = _ref3[1];

                return propName.startsWith('on') ? clusterEvents[propName] = prop : clusterProps[propName] = prop;
            }); // Creating markerClusterGroup Leaflet element

            var markerClusterGroup = new L__default['default'].markerClusterGroup(clusterProps);
            this.contextValue = {
                layerContainer: markerClusterGroup,
                map: map
            }; // Initializing event listeners

            Object.entries(clusterEvents).forEach(function (_ref4) {
                var _ref5 = _slicedToArray(_ref4, 2),
                    eventAsProp = _ref5[0],
                    callback = _ref5[1];

                var clusterEvent = "cluster".concat(eventAsProp.substring(2).toLowerCase());
                markerClusterGroup.on(clusterEvent, callback);
            });
            return markerClusterGroup;
        }
    }]);

    return MarkerClusterGroup;
}(MapLayer);

var MarkerClusterGroup$1 = withLeaflet(MarkerClusterGroup);

function Geojson(_ref) {
    var url = _ref.url,
        data = _ref.data,
        style = _ref.style,
        icon = _ref.icon,
        popup = _ref.popup,
        oneach = _ref.oneach,
        cluster = _ref.cluster,
        clusterIcon = _ref.clusterIcon;

    var _usePlugin = usePlugin('leaflet'),
        config = _usePlugin.config,
        _ref2 = usePlugin('jqmrenderer') || {},
        jqmConfig = _ref2.config,
        geojson = useGeoJSON(url, data),
        options = {};

    if (!geojson || !geojson.type) {
        return null;
    }

    if (popup) {
        var template = config.popups[popup] || jqmConfig && jqmConfig.templates["".concat(popup, "_popup")] || popup;

        popup = function popup(_ref3, layer) {
            var id = _ref3.id,
                properties = _ref3.properties;
            layer.bindPopup(Mustache__default['default'].render(template, _objectSpread2({
                id: id
            }, properties)));
        };
    }

    if (oneach && popup) {
        options.onEachFeature = function (feat, layer) {
            popup(feat, layer);
            oneach(feat, layer);
        };
    } else if (oneach) {
        options.onEachFeature = oneach;
    } else if (popup) {
        options.onEachFeature = popup;
    }

    if (icon) {
        options.pointToLayer = function pointToLayer(geojson, latlng) {
            // Define icon as a function to customize per-feature
            var key;

            if (typeof icon == 'function') {
                key = icon(geojson.properties);
            } else if (icon.indexOf('{{') > -1) {
                key = Mustache__default['default'].render(icon, geojson.properties);
            } else {
                key = icon;
            }

            return L__default['default'].marker(latlng, {
                icon: config.icons[key]
            });
        };
    }

    var Component;

    if (cluster) {
        Component = MarkerCluster;
        options.clusterIcon = clusterIcon;
    } else {
        Component = GeoJSON$1;
    }

    return /*#__PURE__*/React__default['default'].createElement(Component, _extends({
        data: geojson,
        style: style
    }, options));
}
Geojson.propTypes = {
    url: PropTypes__default['default'].string,
    data: PropTypes__default['default'].object,
    style: PropTypes__default['default'].func,
    icon: PropTypes__default['default'].oneOfType([PropTypes__default['default'].string, PropTypes__default['default'].func]),
    popup: PropTypes__default['default'].string,
    oneach: PropTypes__default['default'].func,
    cluster: PropTypes__default['default'].bool,
    clusterIcon: PropTypes__default['default'].oneOfType([PropTypes__default['default'].string, PropTypes__default['default'].func])
};

function MarkerCluster(_ref4) {
    var clusterIcon = _ref4.clusterIcon,
        rest = _objectWithoutProperties(_ref4, ["clusterIcon"]);

    var options = {};

    if (clusterIcon) {
        options.iconCreateFunction = function clusterDiv(cluster) {
            var cls;
            var context = {
                count: cluster.getChildCount()
            };

            if (context.count >= 100) {
                context.large = true;
            } else if (context.count >= 10) {
                context.medium = true;
            } else {
                context.small = true;
            }

            if (typeof clusterIcon == 'function') {
                cls = clusterIcon(context);
            } else if (clusterIcon.indexOf('{{') > -1) {
                cls = Mustache__default['default'].render(clusterIcon, context);
            } else {
                cls = clusterIcon;
            }

            var html = Mustache__default['default'].render('<div><span>{{count}}</span></div>', context);
            return new L__default['default'].DivIcon({
                html: html,
                className: 'marker-cluster ' + cls,
                iconSize: new L__default['default'].Point(40, 40)
            });
        };
    }

    return /*#__PURE__*/React__default['default'].createElement(MarkerClusterGroup$1, options, /*#__PURE__*/React__default['default'].createElement(GeoJSON$1, rest));
}

MarkerCluster.propTypes = {
    clusterIcon: PropTypes__default['default'].oneOfType([PropTypes__default['default'].string, PropTypes__default['default'].func])
};

function Highlight(_ref) {
    var data = _ref.data;

    function style() {
        return {
            color: '#00ffff'
        };
    }

    return /*#__PURE__*/React__default['default'].createElement(GeoJSON$1, {
        data: data,
        style: style
    });
}
Highlight.propTypes = {
    data: PropTypes__default['default'].object
};

/*
 Leaflet.draw 1.0.4, a plugin that adds drawing and editing tools to Leaflet powered maps.
 (c) 2012-2017, Jacob Toye, Jon West, Smartrak, Leaflet

 https://github.com/Leaflet/Leaflet.draw
 http://leafletjs.com
 */
!function (t, e, i) {
    function o(t, e) {
        for (; (t = t.parentElement) && !t.classList.contains(e);) {
        }

        return t;
    }

    L.drawVersion = "1.0.4", L.Draw = {}, L.drawLocal = {
        draw: {
            toolbar: {
                actions: {
                    title: "Cancel drawing",
                    text: "Cancel"
                },
                finish: {
                    title: "Finish drawing",
                    text: "Finish"
                },
                undo: {
                    title: "Delete last point drawn",
                    text: "Delete last point"
                },
                buttons: {
                    polyline: "Draw a polyline",
                    polygon: "Draw a polygon",
                    rectangle: "Draw a rectangle",
                    circle: "Draw a circle",
                    marker: "Draw a marker",
                    circlemarker: "Draw a circlemarker"
                }
            },
            handlers: {
                circle: {
                    tooltip: {
                        start: "Click and drag to draw circle."
                    },
                    radius: "Radius"
                },
                circlemarker: {
                    tooltip: {
                        start: "Click map to place circle marker."
                    }
                },
                marker: {
                    tooltip: {
                        start: "Click map to place marker."
                    }
                },
                polygon: {
                    tooltip: {
                        start: "Click to start drawing shape.",
                        cont: "Click to continue drawing shape.",
                        end: "Click first point to close this shape."
                    }
                },
                polyline: {
                    error: "<strong>Error:</strong> shape edges cannot cross!",
                    tooltip: {
                        start: "Click to start drawing line.",
                        cont: "Click to continue drawing line.",
                        end: "Click last point to finish line."
                    }
                },
                rectangle: {
                    tooltip: {
                        start: "Click and drag to draw rectangle."
                    }
                },
                simpleshape: {
                    tooltip: {
                        end: "Release mouse to finish drawing."
                    }
                }
            }
        },
        edit: {
            toolbar: {
                actions: {
                    save: {
                        title: "Save changes",
                        text: "Save"
                    },
                    cancel: {
                        title: "Cancel editing, discards all changes",
                        text: "Cancel"
                    },
                    clearAll: {
                        title: "Clear all layers",
                        text: "Clear All"
                    }
                },
                buttons: {
                    edit: "Edit layers",
                    editDisabled: "No layers to edit",
                    remove: "Delete layers",
                    removeDisabled: "No layers to delete"
                }
            },
            handlers: {
                edit: {
                    tooltip: {
                        text: "Drag handles or markers to edit features.",
                        subtext: "Click cancel to undo changes."
                    }
                },
                remove: {
                    tooltip: {
                        text: "Click on a feature to remove."
                    }
                }
            }
        }
    }, L.Draw.Event = {}, L.Draw.Event.CREATED = "draw:created", L.Draw.Event.EDITED = "draw:edited", L.Draw.Event.DELETED = "draw:deleted", L.Draw.Event.DRAWSTART = "draw:drawstart", L.Draw.Event.DRAWSTOP = "draw:drawstop", L.Draw.Event.DRAWVERTEX = "draw:drawvertex", L.Draw.Event.EDITSTART = "draw:editstart", L.Draw.Event.EDITMOVE = "draw:editmove", L.Draw.Event.EDITRESIZE = "draw:editresize", L.Draw.Event.EDITVERTEX = "draw:editvertex", L.Draw.Event.EDITSTOP = "draw:editstop", L.Draw.Event.DELETESTART = "draw:deletestart", L.Draw.Event.DELETESTOP = "draw:deletestop", L.Draw.Event.TOOLBAROPENED = "draw:toolbaropened", L.Draw.Event.TOOLBARCLOSED = "draw:toolbarclosed", L.Draw.Event.MARKERCONTEXT = "draw:markercontext", L.Draw = L.Draw || {}, L.Draw.Feature = L.Handler.extend({
        initialize: function initialize(t, e) {
            this._map = t, this._container = t._container, this._overlayPane = t._panes.overlayPane, this._popupPane = t._panes.popupPane, e && e.shapeOptions && (e.shapeOptions = L.Util.extend({}, this.options.shapeOptions, e.shapeOptions)), L.setOptions(this, e);
            var i = L.version.split(".");
            1 === parseInt(i[0], 10) && parseInt(i[1], 10) >= 2 ? L.Draw.Feature.include(L.Evented.prototype) : L.Draw.Feature.include(L.Mixin.Events);
        },
        enable: function enable() {
            this._enabled || (L.Handler.prototype.enable.call(this), this.fire("enabled", {
                handler: this.type
            }), this._map.fire(L.Draw.Event.DRAWSTART, {
                layerType: this.type
            }));
        },
        disable: function disable() {
            this._enabled && (L.Handler.prototype.disable.call(this), this._map.fire(L.Draw.Event.DRAWSTOP, {
                layerType: this.type
            }), this.fire("disabled", {
                handler: this.type
            }));
        },
        addHooks: function addHooks() {
            var t = this._map;
            t && (L.DomUtil.disableTextSelection(), t.getContainer().focus(), this._tooltip = new L.Draw.Tooltip(this._map), L.DomEvent.on(this._container, "keyup", this._cancelDrawing, this));
        },
        removeHooks: function removeHooks() {
            this._map && (L.DomUtil.enableTextSelection(), this._tooltip.dispose(), this._tooltip = null, L.DomEvent.off(this._container, "keyup", this._cancelDrawing, this));
        },
        setOptions: function setOptions(t) {
            L.setOptions(this, t);
        },
        _fireCreatedEvent: function _fireCreatedEvent(t) {
            this._map.fire(L.Draw.Event.CREATED, {
                layer: t,
                layerType: this.type
            });
        },
        _cancelDrawing: function _cancelDrawing(t) {
            27 === t.keyCode && (this._map.fire("draw:canceled", {
                layerType: this.type
            }), this.disable());
        }
    }), L.Draw.Polyline = L.Draw.Feature.extend({
        statics: {
            TYPE: "polyline"
        },
        Poly: L.Polyline,
        options: {
            allowIntersection: !0,
            repeatMode: !1,
            drawError: {
                color: "#b00b00",
                timeout: 2500
            },
            icon: new L.DivIcon({
                iconSize: new L.Point(8, 8),
                className: "leaflet-div-icon leaflet-editing-icon"
            }),
            touchIcon: new L.DivIcon({
                iconSize: new L.Point(20, 20),
                className: "leaflet-div-icon leaflet-editing-icon leaflet-touch-icon"
            }),
            guidelineDistance: 20,
            maxGuideLineLength: 4e3,
            shapeOptions: {
                stroke: !0,
                color: "#3388ff",
                weight: 4,
                opacity: .5,
                fill: !1,
                clickable: !0
            },
            metric: !0,
            feet: !0,
            nautic: !1,
            showLength: !0,
            zIndexOffset: 2e3,
            factor: 1,
            maxPoints: 0
        },
        initialize: function initialize(t, e) {
            L.Browser.touch && (this.options.icon = this.options.touchIcon), this.options.drawError.message = L.drawLocal.draw.handlers.polyline.error, e && e.drawError && (e.drawError = L.Util.extend({}, this.options.drawError, e.drawError)), this.type = L.Draw.Polyline.TYPE, L.Draw.Feature.prototype.initialize.call(this, t, e);
        },
        addHooks: function addHooks() {
            L.Draw.Feature.prototype.addHooks.call(this), this._map && (this._markers = [], this._markerGroup = new L.LayerGroup(), this._map.addLayer(this._markerGroup), this._poly = new L.Polyline([], this.options.shapeOptions), this._tooltip.updateContent(this._getTooltipText()), this._mouseMarker || (this._mouseMarker = L.marker(this._map.getCenter(), {
                icon: L.divIcon({
                    className: "leaflet-mouse-marker",
                    iconAnchor: [20, 20],
                    iconSize: [40, 40]
                }),
                opacity: 0,
                zIndexOffset: this.options.zIndexOffset
            })), this._mouseMarker.on("mouseout", this._onMouseOut, this).on("mousemove", this._onMouseMove, this).on("mousedown", this._onMouseDown, this).on("mouseup", this._onMouseUp, this).addTo(this._map), this._map.on("mouseup", this._onMouseUp, this).on("mousemove", this._onMouseMove, this).on("zoomlevelschange", this._onZoomEnd, this).on("touchstart", this._onTouch, this).on("zoomend", this._onZoomEnd, this));
        },
        removeHooks: function removeHooks() {
            L.Draw.Feature.prototype.removeHooks.call(this), this._clearHideErrorTimeout(), this._cleanUpShape(), this._map.removeLayer(this._markerGroup), delete this._markerGroup, delete this._markers, this._map.removeLayer(this._poly), delete this._poly, this._mouseMarker.off("mousedown", this._onMouseDown, this).off("mouseout", this._onMouseOut, this).off("mouseup", this._onMouseUp, this).off("mousemove", this._onMouseMove, this), this._map.removeLayer(this._mouseMarker), delete this._mouseMarker, this._clearGuides(), this._map.off("mouseup", this._onMouseUp, this).off("mousemove", this._onMouseMove, this).off("zoomlevelschange", this._onZoomEnd, this).off("zoomend", this._onZoomEnd, this).off("touchstart", this._onTouch, this).off("click", this._onTouch, this);
        },
        deleteLastVertex: function deleteLastVertex() {
            if (!(this._markers.length <= 1)) {
                var t = this._markers.pop(),
                    e = this._poly,
                    i = e.getLatLngs(),
                    o = i.splice(-1, 1)[0];

                this._poly.setLatLngs(i), this._markerGroup.removeLayer(t), e.getLatLngs().length < 2 && this._map.removeLayer(e), this._vertexChanged(o, !1);
            }
        },
        addVertex: function addVertex(t) {
            if (this._markers.length >= 2 && !this.options.allowIntersection && this._poly.newLatLngIntersects(t)) return void this._showErrorTooltip();
            this._errorShown && this._hideErrorTooltip(), this._markers.push(this._createMarker(t)), this._poly.addLatLng(t), 2 === this._poly.getLatLngs().length && this._map.addLayer(this._poly), this._vertexChanged(t, !0);
        },
        completeShape: function completeShape() {
            this._markers.length <= 1 || !this._shapeIsValid() || (this._fireCreatedEvent(), this.disable(), this.options.repeatMode && this.enable());
        },
        _finishShape: function _finishShape() {
            var t = this._poly._defaultShape ? this._poly._defaultShape() : this._poly.getLatLngs(),
                e = this._poly.newLatLngIntersects(t[t.length - 1]);

            if (!this.options.allowIntersection && e || !this._shapeIsValid()) return void this._showErrorTooltip();
            this._fireCreatedEvent(), this.disable(), this.options.repeatMode && this.enable();
        },
        _shapeIsValid: function _shapeIsValid() {
            return !0;
        },
        _onZoomEnd: function _onZoomEnd() {
            null !== this._markers && this._updateGuide();
        },
        _onMouseMove: function _onMouseMove(t) {
            var e = this._map.mouseEventToLayerPoint(t.originalEvent),
                i = this._map.layerPointToLatLng(e);

            this._currentLatLng = i, this._updateTooltip(i), this._updateGuide(e), this._mouseMarker.setLatLng(i), L.DomEvent.preventDefault(t.originalEvent);
        },
        _vertexChanged: function _vertexChanged(t, e) {
            this._map.fire(L.Draw.Event.DRAWVERTEX, {
                layers: this._markerGroup
            }), this._updateFinishHandler(), this._updateRunningMeasure(t, e), this._clearGuides(), this._updateTooltip();
        },
        _onMouseDown: function _onMouseDown(t) {
            if (!this._clickHandled && !this._touchHandled && !this._disableMarkers) {
                this._onMouseMove(t), this._clickHandled = !0, this._disableNewMarkers();
                var e = t.originalEvent,
                    i = e.clientX,
                    o = e.clientY;

                this._startPoint.call(this, i, o);
            }
        },
        _startPoint: function _startPoint(t, e) {
            this._mouseDownOrigin = L.point(t, e);
        },
        _onMouseUp: function _onMouseUp(t) {
            var e = t.originalEvent,
                i = e.clientX,
                o = e.clientY;
            this._endPoint.call(this, i, o, t), this._clickHandled = null;
        },
        _endPoint: function _endPoint(e, i, o) {
            if (this._mouseDownOrigin) {
                var a = L.point(e, i).distanceTo(this._mouseDownOrigin),
                    n = this._calculateFinishDistance(o.latlng);

                this.options.maxPoints > 1 && this.options.maxPoints == this._markers.length + 1 ? (this.addVertex(o.latlng), this._finishShape()) : n < 10 && L.Browser.touch ? this._finishShape() : Math.abs(a) < 9 * (t.devicePixelRatio || 1) && this.addVertex(o.latlng), this._enableNewMarkers();
            }

            this._mouseDownOrigin = null;
        },
        _onTouch: function _onTouch(t) {
            var e,
                i,
                o = t.originalEvent;
            !o.touches || !o.touches[0] || this._clickHandled || this._touchHandled || this._disableMarkers || (e = o.touches[0].clientX, i = o.touches[0].clientY, this._disableNewMarkers(), this._touchHandled = !0, this._startPoint.call(this, e, i), this._endPoint.call(this, e, i, t), this._touchHandled = null), this._clickHandled = null;
        },
        _onMouseOut: function _onMouseOut() {
            this._tooltip && this._tooltip._onMouseOut.call(this._tooltip);
        },
        _calculateFinishDistance: function _calculateFinishDistance(t) {
            var e;

            if (this._markers.length > 0) {
                var i;
                if (this.type === L.Draw.Polyline.TYPE) i = this._markers[this._markers.length - 1];else {
                    if (this.type !== L.Draw.Polygon.TYPE) return 1 / 0;
                    i = this._markers[0];
                }

                var o = this._map.latLngToContainerPoint(i.getLatLng()),
                    a = new L.Marker(t, {
                    icon: this.options.icon,
                    zIndexOffset: 2 * this.options.zIndexOffset
                }),
                    n = this._map.latLngToContainerPoint(a.getLatLng());

                e = o.distanceTo(n);
            } else e = 1 / 0;

            return e;
        },
        _updateFinishHandler: function _updateFinishHandler() {
            var t = this._markers.length;
            t > 1 && this._markers[t - 1].on("click", this._finishShape, this), t > 2 && this._markers[t - 2].off("click", this._finishShape, this);
        },
        _createMarker: function _createMarker(t) {
            var e = new L.Marker(t, {
                icon: this.options.icon,
                zIndexOffset: 2 * this.options.zIndexOffset
            });
            return this._markerGroup.addLayer(e), e;
        },
        _updateGuide: function _updateGuide(t) {
            var e = this._markers ? this._markers.length : 0;
            e > 0 && (t = t || this._map.latLngToLayerPoint(this._currentLatLng), this._clearGuides(), this._drawGuide(this._map.latLngToLayerPoint(this._markers[e - 1].getLatLng()), t));
        },
        _updateTooltip: function _updateTooltip(t) {
            var e = this._getTooltipText();

            t && this._tooltip.updatePosition(t), this._errorShown || this._tooltip.updateContent(e);
        },
        _drawGuide: function _drawGuide(t, e) {
            var i,
                o,
                a,
                n = Math.floor(Math.sqrt(Math.pow(e.x - t.x, 2) + Math.pow(e.y - t.y, 2))),
                s = this.options.guidelineDistance,
                r = this.options.maxGuideLineLength,
                l = n > r ? n - r : s;

            for (this._guidesContainer || (this._guidesContainer = L.DomUtil.create("div", "leaflet-draw-guides", this._overlayPane)); l < n; l += this.options.guidelineDistance) {
                i = l / n, o = {
                    x: Math.floor(t.x * (1 - i) + i * e.x),
                    y: Math.floor(t.y * (1 - i) + i * e.y)
                }, a = L.DomUtil.create("div", "leaflet-draw-guide-dash", this._guidesContainer), a.style.backgroundColor = this._errorShown ? this.options.drawError.color : this.options.shapeOptions.color, L.DomUtil.setPosition(a, o);
            }
        },
        _updateGuideColor: function _updateGuideColor(t) {
            if (this._guidesContainer) for (var e = 0, i = this._guidesContainer.childNodes.length; e < i; e++) {
                this._guidesContainer.childNodes[e].style.backgroundColor = t;
            }
        },
        _clearGuides: function _clearGuides() {
            if (this._guidesContainer) for (; this._guidesContainer.firstChild;) {
                this._guidesContainer.removeChild(this._guidesContainer.firstChild);
            }
        },
        _getTooltipText: function _getTooltipText() {
            var t,
                e,
                i = this.options.showLength;
            return 0 === this._markers.length ? t = {
                text: L.drawLocal.draw.handlers.polyline.tooltip.start
            } : (e = i ? this._getMeasurementString() : "", t = 1 === this._markers.length ? {
                text: L.drawLocal.draw.handlers.polyline.tooltip.cont,
                subtext: e
            } : {
                text: L.drawLocal.draw.handlers.polyline.tooltip.end,
                subtext: e
            }), t;
        },
        _updateRunningMeasure: function _updateRunningMeasure(t, e) {
            var i,
                o,
                a = this._markers.length;
            1 === this._markers.length ? this._measurementRunningTotal = 0 : (i = a - (e ? 2 : 1), o = L.GeometryUtil.isVersion07x() ? t.distanceTo(this._markers[i].getLatLng()) * (this.options.factor || 1) : this._map.distance(t, this._markers[i].getLatLng()) * (this.options.factor || 1), this._measurementRunningTotal += o * (e ? 1 : -1));
        },
        _getMeasurementString: function _getMeasurementString() {
            var t,
                e = this._currentLatLng,
                i = this._markers[this._markers.length - 1].getLatLng();

            return t = L.GeometryUtil.isVersion07x() ? i && e && e.distanceTo ? this._measurementRunningTotal + e.distanceTo(i) * (this.options.factor || 1) : this._measurementRunningTotal || 0 : i && e ? this._measurementRunningTotal + this._map.distance(e, i) * (this.options.factor || 1) : this._measurementRunningTotal || 0, L.GeometryUtil.readableDistance(t, this.options.metric, this.options.feet, this.options.nautic, this.options.precision);
        },
        _showErrorTooltip: function _showErrorTooltip() {
            this._errorShown = !0, this._tooltip.showAsError().updateContent({
                text: this.options.drawError.message
            }), this._updateGuideColor(this.options.drawError.color), this._poly.setStyle({
                color: this.options.drawError.color
            }), this._clearHideErrorTimeout(), this._hideErrorTimeout = setTimeout(L.Util.bind(this._hideErrorTooltip, this), this.options.drawError.timeout);
        },
        _hideErrorTooltip: function _hideErrorTooltip() {
            this._errorShown = !1, this._clearHideErrorTimeout(), this._tooltip.removeError().updateContent(this._getTooltipText()), this._updateGuideColor(this.options.shapeOptions.color), this._poly.setStyle({
                color: this.options.shapeOptions.color
            });
        },
        _clearHideErrorTimeout: function _clearHideErrorTimeout() {
            this._hideErrorTimeout && (clearTimeout(this._hideErrorTimeout), this._hideErrorTimeout = null);
        },
        _disableNewMarkers: function _disableNewMarkers() {
            this._disableMarkers = !0;
        },
        _enableNewMarkers: function _enableNewMarkers() {
            setTimeout(function () {
                this._disableMarkers = !1;
            }.bind(this), 50);
        },
        _cleanUpShape: function _cleanUpShape() {
            this._markers.length > 1 && this._markers[this._markers.length - 1].off("click", this._finishShape, this);
        },
        _fireCreatedEvent: function _fireCreatedEvent() {
            var t = new this.Poly(this._poly.getLatLngs(), this.options.shapeOptions);

            L.Draw.Feature.prototype._fireCreatedEvent.call(this, t);
        }
    }), L.Draw.Polygon = L.Draw.Polyline.extend({
        statics: {
            TYPE: "polygon"
        },
        Poly: L.Polygon,
        options: {
            showArea: !1,
            showLength: !1,
            shapeOptions: {
                stroke: !0,
                color: "#3388ff",
                weight: 4,
                opacity: .5,
                fill: !0,
                fillColor: null,
                fillOpacity: .2,
                clickable: !0
            },
            metric: !0,
            feet: !0,
            nautic: !1,
            precision: {}
        },
        initialize: function initialize(t, e) {
            L.Draw.Polyline.prototype.initialize.call(this, t, e), this.type = L.Draw.Polygon.TYPE;
        },
        _updateFinishHandler: function _updateFinishHandler() {
            var t = this._markers.length;
            1 === t && this._markers[0].on("click", this._finishShape, this), t > 2 && (this._markers[t - 1].on("dblclick", this._finishShape, this), t > 3 && this._markers[t - 2].off("dblclick", this._finishShape, this));
        },
        _getTooltipText: function _getTooltipText() {
            var t, e;
            return 0 === this._markers.length ? t = L.drawLocal.draw.handlers.polygon.tooltip.start : this._markers.length < 3 ? (t = L.drawLocal.draw.handlers.polygon.tooltip.cont, e = this._getMeasurementString()) : (t = L.drawLocal.draw.handlers.polygon.tooltip.end, e = this._getMeasurementString()), {
                text: t,
                subtext: e
            };
        },
        _getMeasurementString: function _getMeasurementString() {
            var t = this._area,
                e = "";
            return t || this.options.showLength ? (this.options.showLength && (e = L.Draw.Polyline.prototype._getMeasurementString.call(this)), t && (e += "<br>" + L.GeometryUtil.readableArea(t, this.options.metric, this.options.precision)), e) : null;
        },
        _shapeIsValid: function _shapeIsValid() {
            return this._markers.length >= 3;
        },
        _vertexChanged: function _vertexChanged(t, e) {
            var i;
            !this.options.allowIntersection && this.options.showArea && (i = this._poly.getLatLngs(), this._area = L.GeometryUtil.geodesicArea(i)), L.Draw.Polyline.prototype._vertexChanged.call(this, t, e);
        },
        _cleanUpShape: function _cleanUpShape() {
            var t = this._markers.length;
            t > 0 && (this._markers[0].off("click", this._finishShape, this), t > 2 && this._markers[t - 1].off("dblclick", this._finishShape, this));
        }
    }), L.SimpleShape = {}, L.Draw.SimpleShape = L.Draw.Feature.extend({
        options: {
            repeatMode: !1
        },
        initialize: function initialize(t, e) {
            this._endLabelText = L.drawLocal.draw.handlers.simpleshape.tooltip.end, L.Draw.Feature.prototype.initialize.call(this, t, e);
        },
        addHooks: function addHooks() {
            L.Draw.Feature.prototype.addHooks.call(this), this._map && (this._mapDraggable = this._map.dragging.enabled(), this._mapDraggable && this._map.dragging.disable(), this._container.style.cursor = "crosshair", this._tooltip.updateContent({
                text: this._initialLabelText
            }), this._map.on("mousedown", this._onMouseDown, this).on("mousemove", this._onMouseMove, this).on("touchstart", this._onMouseDown, this).on("touchmove", this._onMouseMove, this), e.addEventListener("touchstart", L.DomEvent.preventDefault, {
                passive: !1
            }));
        },
        removeHooks: function removeHooks() {
            L.Draw.Feature.prototype.removeHooks.call(this), this._map && (this._mapDraggable && this._map.dragging.enable(), this._container.style.cursor = "", this._map.off("mousedown", this._onMouseDown, this).off("mousemove", this._onMouseMove, this).off("touchstart", this._onMouseDown, this).off("touchmove", this._onMouseMove, this), L.DomEvent.off(e, "mouseup", this._onMouseUp, this), L.DomEvent.off(e, "touchend", this._onMouseUp, this), e.removeEventListener("touchstart", L.DomEvent.preventDefault), this._shape && (this._map.removeLayer(this._shape), delete this._shape)), this._isDrawing = !1;
        },
        _getTooltipText: function _getTooltipText() {
            return {
                text: this._endLabelText
            };
        },
        _onMouseDown: function _onMouseDown(t) {
            this._isDrawing = !0, this._startLatLng = t.latlng, L.DomEvent.on(e, "mouseup", this._onMouseUp, this).on(e, "touchend", this._onMouseUp, this).preventDefault(t.originalEvent);
        },
        _onMouseMove: function _onMouseMove(t) {
            var e = t.latlng;
            this._tooltip.updatePosition(e), this._isDrawing && (this._tooltip.updateContent(this._getTooltipText()), this._drawShape(e));
        },
        _onMouseUp: function _onMouseUp() {
            this._shape && this._fireCreatedEvent(), this.disable(), this.options.repeatMode && this.enable();
        }
    }), L.Draw.Rectangle = L.Draw.SimpleShape.extend({
        statics: {
            TYPE: "rectangle"
        },
        options: {
            shapeOptions: {
                stroke: !0,
                color: "#3388ff",
                weight: 4,
                opacity: .5,
                fill: !0,
                fillColor: null,
                fillOpacity: .2,
                clickable: !0
            },
            showArea: !0,
            metric: !0
        },
        initialize: function initialize(t, e) {
            this.type = L.Draw.Rectangle.TYPE, this._initialLabelText = L.drawLocal.draw.handlers.rectangle.tooltip.start, L.Draw.SimpleShape.prototype.initialize.call(this, t, e);
        },
        disable: function disable() {
            this._enabled && (this._isCurrentlyTwoClickDrawing = !1, L.Draw.SimpleShape.prototype.disable.call(this));
        },
        _onMouseUp: function _onMouseUp(t) {
            if (!this._shape && !this._isCurrentlyTwoClickDrawing) return void (this._isCurrentlyTwoClickDrawing = !0);
            this._isCurrentlyTwoClickDrawing && !o(t.target, "leaflet-pane") || L.Draw.SimpleShape.prototype._onMouseUp.call(this);
        },
        _drawShape: function _drawShape(t) {
            this._shape ? this._shape.setBounds(new L.LatLngBounds(this._startLatLng, t)) : (this._shape = new L.Rectangle(new L.LatLngBounds(this._startLatLng, t), this.options.shapeOptions), this._map.addLayer(this._shape));
        },
        _fireCreatedEvent: function _fireCreatedEvent() {
            var t = new L.Rectangle(this._shape.getBounds(), this.options.shapeOptions);

            L.Draw.SimpleShape.prototype._fireCreatedEvent.call(this, t);
        },
        _getTooltipText: function _getTooltipText() {
            var t,
                e,
                i,
                o = L.Draw.SimpleShape.prototype._getTooltipText.call(this),
                a = this._shape,
                n = this.options.showArea;

            return a && (t = this._shape._defaultShape ? this._shape._defaultShape() : this._shape.getLatLngs(), e = L.GeometryUtil.geodesicArea(t), i = n ? L.GeometryUtil.readableArea(e, this.options.metric) : ""), {
                text: o.text,
                subtext: i
            };
        }
    }), L.Draw.Marker = L.Draw.Feature.extend({
        statics: {
            TYPE: "marker"
        },
        options: {
            icon: new L.Icon.Default(),
            repeatMode: !1,
            zIndexOffset: 2e3
        },
        initialize: function initialize(t, e) {
            this.type = L.Draw.Marker.TYPE, this._initialLabelText = L.drawLocal.draw.handlers.marker.tooltip.start, L.Draw.Feature.prototype.initialize.call(this, t, e);
        },
        addHooks: function addHooks() {
            L.Draw.Feature.prototype.addHooks.call(this), this._map && (this._tooltip.updateContent({
                text: this._initialLabelText
            }), this._mouseMarker || (this._mouseMarker = L.marker(this._map.getCenter(), {
                icon: L.divIcon({
                    className: "leaflet-mouse-marker",
                    iconAnchor: [20, 20],
                    iconSize: [40, 40]
                }),
                opacity: 0,
                zIndexOffset: this.options.zIndexOffset
            })), this._mouseMarker.on("click", this._onClick, this).addTo(this._map), this._map.on("mousemove", this._onMouseMove, this), this._map.on("click", this._onTouch, this));
        },
        removeHooks: function removeHooks() {
            L.Draw.Feature.prototype.removeHooks.call(this), this._map && (this._map.off("click", this._onClick, this).off("click", this._onTouch, this), this._marker && (this._marker.off("click", this._onClick, this), this._map.removeLayer(this._marker), delete this._marker), this._mouseMarker.off("click", this._onClick, this), this._map.removeLayer(this._mouseMarker), delete this._mouseMarker, this._map.off("mousemove", this._onMouseMove, this));
        },
        _onMouseMove: function _onMouseMove(t) {
            var e = t.latlng;
            this._tooltip.updatePosition(e), this._mouseMarker.setLatLng(e), this._marker ? (e = this._mouseMarker.getLatLng(), this._marker.setLatLng(e)) : (this._marker = this._createMarker(e), this._marker.on("click", this._onClick, this), this._map.on("click", this._onClick, this).addLayer(this._marker));
        },
        _createMarker: function _createMarker(t) {
            return new L.Marker(t, {
                icon: this.options.icon,
                zIndexOffset: this.options.zIndexOffset
            });
        },
        _onClick: function _onClick() {
            this._fireCreatedEvent(), this.disable(), this.options.repeatMode && this.enable();
        },
        _onTouch: function _onTouch(t) {
            this._onMouseMove(t), this._onClick();
        },
        _fireCreatedEvent: function _fireCreatedEvent() {
            var t = new L.Marker.Touch(this._marker.getLatLng(), {
                icon: this.options.icon
            });

            L.Draw.Feature.prototype._fireCreatedEvent.call(this, t);
        }
    }), L.Draw.CircleMarker = L.Draw.Marker.extend({
        statics: {
            TYPE: "circlemarker"
        },
        options: {
            stroke: !0,
            color: "#3388ff",
            weight: 4,
            opacity: .5,
            fill: !0,
            fillColor: null,
            fillOpacity: .2,
            clickable: !0,
            zIndexOffset: 2e3
        },
        initialize: function initialize(t, e) {
            this.type = L.Draw.CircleMarker.TYPE, this._initialLabelText = L.drawLocal.draw.handlers.circlemarker.tooltip.start, L.Draw.Feature.prototype.initialize.call(this, t, e);
        },
        _fireCreatedEvent: function _fireCreatedEvent() {
            var t = new L.CircleMarker(this._marker.getLatLng(), this.options);

            L.Draw.Feature.prototype._fireCreatedEvent.call(this, t);
        },
        _createMarker: function _createMarker(t) {
            return new L.CircleMarker(t, this.options);
        }
    }), L.Draw.Circle = L.Draw.SimpleShape.extend({
        statics: {
            TYPE: "circle"
        },
        options: {
            shapeOptions: {
                stroke: !0,
                color: "#3388ff",
                weight: 4,
                opacity: .5,
                fill: !0,
                fillColor: null,
                fillOpacity: .2,
                clickable: !0
            },
            showRadius: !0,
            metric: !0,
            feet: !0,
            nautic: !1
        },
        initialize: function initialize(t, e) {
            this.type = L.Draw.Circle.TYPE, this._initialLabelText = L.drawLocal.draw.handlers.circle.tooltip.start, L.Draw.SimpleShape.prototype.initialize.call(this, t, e);
        },
        _drawShape: function _drawShape(t) {
            if (L.GeometryUtil.isVersion07x()) var e = this._startLatLng.distanceTo(t);else var e = this._map.distance(this._startLatLng, t);
            this._shape ? this._shape.setRadius(e) : (this._shape = new L.Circle(this._startLatLng, e, this.options.shapeOptions), this._map.addLayer(this._shape));
        },
        _fireCreatedEvent: function _fireCreatedEvent() {
            var t = new L.Circle(this._startLatLng, this._shape.getRadius(), this.options.shapeOptions);

            L.Draw.SimpleShape.prototype._fireCreatedEvent.call(this, t);
        },
        _onMouseMove: function _onMouseMove(t) {
            var e,
                i = t.latlng,
                o = this.options.showRadius,
                a = this.options.metric;

            if (this._tooltip.updatePosition(i), this._isDrawing) {
                this._drawShape(i), e = this._shape.getRadius().toFixed(1);
                var n = "";
                o && (n = L.drawLocal.draw.handlers.circle.radius + ": " + L.GeometryUtil.readableDistance(e, a, this.options.feet, this.options.nautic)), this._tooltip.updateContent({
                    text: this._endLabelText,
                    subtext: n
                });
            }
        }
    }), L.Edit = L.Edit || {}, L.Edit.Marker = L.Handler.extend({
        initialize: function initialize(t, e) {
            this._marker = t, L.setOptions(this, e);
        },
        addHooks: function addHooks() {
            var t = this._marker;
            t.dragging.enable(), t.on("dragend", this._onDragEnd, t), this._toggleMarkerHighlight();
        },
        removeHooks: function removeHooks() {
            var t = this._marker;
            t.dragging.disable(), t.off("dragend", this._onDragEnd, t), this._toggleMarkerHighlight();
        },
        _onDragEnd: function _onDragEnd(t) {
            var e = t.target;
            e.edited = !0, this._map.fire(L.Draw.Event.EDITMOVE, {
                layer: e
            });
        },
        _toggleMarkerHighlight: function _toggleMarkerHighlight() {
            var t = this._marker._icon;
            t && (t.style.display = "none", L.DomUtil.hasClass(t, "leaflet-edit-marker-selected") ? (L.DomUtil.removeClass(t, "leaflet-edit-marker-selected"), this._offsetMarker(t, -4)) : (L.DomUtil.addClass(t, "leaflet-edit-marker-selected"), this._offsetMarker(t, 4)), t.style.display = "");
        },
        _offsetMarker: function _offsetMarker(t, e) {
            var i = parseInt(t.style.marginTop, 10) - e,
                o = parseInt(t.style.marginLeft, 10) - e;
            t.style.marginTop = i + "px", t.style.marginLeft = o + "px";
        }
    }), L.Marker.addInitHook(function () {
        L.Edit.Marker && (this.editing = new L.Edit.Marker(this), this.options.editable && this.editing.enable());
    }), L.Edit = L.Edit || {}, L.Edit.Poly = L.Handler.extend({
        initialize: function initialize(t) {
            this.latlngs = [t._latlngs], t._holes && (this.latlngs = this.latlngs.concat(t._holes)), this._poly = t, this._poly.on("revert-edited", this._updateLatLngs, this);
        },
        _defaultShape: function _defaultShape() {
            return L.Polyline._flat ? L.Polyline._flat(this._poly._latlngs) ? this._poly._latlngs : this._poly._latlngs[0] : this._poly._latlngs;
        },
        _eachVertexHandler: function _eachVertexHandler(t) {
            for (var e = 0; e < this._verticesHandlers.length; e++) {
                t(this._verticesHandlers[e]);
            }
        },
        addHooks: function addHooks() {
            this._initHandlers(), this._eachVertexHandler(function (t) {
                t.addHooks();
            });
        },
        removeHooks: function removeHooks() {
            this._eachVertexHandler(function (t) {
                t.removeHooks();
            });
        },
        updateMarkers: function updateMarkers() {
            this._eachVertexHandler(function (t) {
                t.updateMarkers();
            });
        },
        _initHandlers: function _initHandlers() {
            this._verticesHandlers = [];

            for (var t = 0; t < this.latlngs.length; t++) {
                this._verticesHandlers.push(new L.Edit.PolyVerticesEdit(this._poly, this.latlngs[t], this._poly.options.poly));
            }
        },
        _updateLatLngs: function _updateLatLngs(t) {
            this.latlngs = [t.layer._latlngs], t.layer._holes && (this.latlngs = this.latlngs.concat(t.layer._holes));
        }
    }), L.Edit.PolyVerticesEdit = L.Handler.extend({
        options: {
            icon: new L.DivIcon({
                iconSize: new L.Point(8, 8),
                className: "leaflet-div-icon leaflet-editing-icon"
            }),
            touchIcon: new L.DivIcon({
                iconSize: new L.Point(20, 20),
                className: "leaflet-div-icon leaflet-editing-icon leaflet-touch-icon"
            }),
            drawError: {
                color: "#b00b00",
                timeout: 1e3
            }
        },
        initialize: function initialize(t, e, i) {
            L.Browser.touch && (this.options.icon = this.options.touchIcon), this._poly = t, i && i.drawError && (i.drawError = L.Util.extend({}, this.options.drawError, i.drawError)), this._latlngs = e, L.setOptions(this, i);
        },
        _defaultShape: function _defaultShape() {
            return L.Polyline._flat ? L.Polyline._flat(this._latlngs) ? this._latlngs : this._latlngs[0] : this._latlngs;
        },
        addHooks: function addHooks() {
            var t = this._poly,
                e = t._path;
            t instanceof L.Polygon || (t.options.fill = !1, t.options.editing && (t.options.editing.fill = !1)), e && t.options.editing && t.options.editing.className && (t.options.original.className && t.options.original.className.split(" ").forEach(function (t) {
                L.DomUtil.removeClass(e, t);
            }), t.options.editing.className.split(" ").forEach(function (t) {
                L.DomUtil.addClass(e, t);
            })), t.setStyle(t.options.editing), this._poly._map && (this._map = this._poly._map, this._markerGroup || this._initMarkers(), this._poly._map.addLayer(this._markerGroup));
        },
        removeHooks: function removeHooks() {
            var t = this._poly,
                e = t._path;
            e && t.options.editing && t.options.editing.className && (t.options.editing.className.split(" ").forEach(function (t) {
                L.DomUtil.removeClass(e, t);
            }), t.options.original.className && t.options.original.className.split(" ").forEach(function (t) {
                L.DomUtil.addClass(e, t);
            })), t.setStyle(t.options.original), t._map && (t._map.removeLayer(this._markerGroup), delete this._markerGroup, delete this._markers);
        },
        updateMarkers: function updateMarkers() {
            this._markerGroup.clearLayers(), this._initMarkers();
        },
        _initMarkers: function _initMarkers() {
            this._markerGroup || (this._markerGroup = new L.LayerGroup()), this._markers = [];

            var t,
                e,
                i,
                o,
                a = this._defaultShape();

            for (t = 0, i = a.length; t < i; t++) {
                o = this._createMarker(a[t], t), o.on("click", this._onMarkerClick, this), o.on("contextmenu", this._onContextMenu, this), this._markers.push(o);
            }

            var n, s;

            for (t = 0, e = i - 1; t < i; e = t++) {
                (0 !== t || L.Polygon && this._poly instanceof L.Polygon) && (n = this._markers[e], s = this._markers[t], this._createMiddleMarker(n, s), this._updatePrevNext(n, s));
            }
        },
        _createMarker: function _createMarker(t, e) {
            var i = new L.Marker.Touch(t, {
                draggable: !0,
                icon: this.options.icon
            });
            return i._origLatLng = t, i._index = e, i.on("dragstart", this._onMarkerDragStart, this).on("drag", this._onMarkerDrag, this).on("dragend", this._fireEdit, this).on("touchmove", this._onTouchMove, this).on("touchend", this._fireEdit, this).on("MSPointerMove", this._onTouchMove, this).on("MSPointerUp", this._fireEdit, this), this._markerGroup.addLayer(i), i;
        },
        _onMarkerDragStart: function _onMarkerDragStart() {
            this._poly.fire("editstart");
        },
        _spliceLatLngs: function _spliceLatLngs() {
            var t = this._defaultShape(),
                e = [].splice.apply(t, arguments);

            return this._poly._convertLatLngs(t, !0), this._poly.redraw(), e;
        },
        _removeMarker: function _removeMarker(t) {
            var e = t._index;
            this._markerGroup.removeLayer(t), this._markers.splice(e, 1), this._spliceLatLngs(e, 1), this._updateIndexes(e, -1), t.off("dragstart", this._onMarkerDragStart, this).off("drag", this._onMarkerDrag, this).off("dragend", this._fireEdit, this).off("touchmove", this._onMarkerDrag, this).off("touchend", this._fireEdit, this).off("click", this._onMarkerClick, this).off("MSPointerMove", this._onTouchMove, this).off("MSPointerUp", this._fireEdit, this);
        },
        _fireEdit: function _fireEdit() {
            this._poly.edited = !0, this._poly.fire("edit"), this._poly._map.fire(L.Draw.Event.EDITVERTEX, {
                layers: this._markerGroup,
                poly: this._poly
            });
        },
        _onMarkerDrag: function _onMarkerDrag(t) {
            var e = t.target,
                i = this._poly,
                o = L.LatLngUtil.cloneLatLng(e._origLatLng);

            if (L.extend(e._origLatLng, e._latlng), i.options.poly) {
                var a = i._map._editTooltip;

                if (!i.options.poly.allowIntersection && i.intersects()) {
                    L.extend(e._origLatLng, o), e.setLatLng(o);
                    var n = i.options.color;
                    i.setStyle({
                        color: this.options.drawError.color
                    }), a && a.updateContent({
                        text: L.drawLocal.draw.handlers.polyline.error
                    }), setTimeout(function () {
                        i.setStyle({
                            color: n
                        }), a && a.updateContent({
                            text: L.drawLocal.edit.handlers.edit.tooltip.text,
                            subtext: L.drawLocal.edit.handlers.edit.tooltip.subtext
                        });
                    }, 1e3);
                }
            }

            e._middleLeft && e._middleLeft.setLatLng(this._getMiddleLatLng(e._prev, e)), e._middleRight && e._middleRight.setLatLng(this._getMiddleLatLng(e, e._next)), this._poly._bounds._southWest = L.latLng(1 / 0, 1 / 0), this._poly._bounds._northEast = L.latLng(-1 / 0, -1 / 0);

            var s = this._poly.getLatLngs();

            this._poly._convertLatLngs(s, !0), this._poly.redraw(), this._poly.fire("editdrag");
        },
        _onMarkerClick: function _onMarkerClick(t) {
            var e = L.Polygon && this._poly instanceof L.Polygon ? 4 : 3,
                i = t.target;
            this._defaultShape().length < e || (this._removeMarker(i), this._updatePrevNext(i._prev, i._next), i._middleLeft && this._markerGroup.removeLayer(i._middleLeft), i._middleRight && this._markerGroup.removeLayer(i._middleRight), i._prev && i._next ? this._createMiddleMarker(i._prev, i._next) : i._prev ? i._next || (i._prev._middleRight = null) : i._next._middleLeft = null, this._fireEdit());
        },
        _onContextMenu: function _onContextMenu(t) {
            var e = t.target;
            this._poly;
            this._poly._map.fire(L.Draw.Event.MARKERCONTEXT, {
                marker: e,
                layers: this._markerGroup,
                poly: this._poly
            }), L.DomEvent.stopPropagation;
        },
        _onTouchMove: function _onTouchMove(t) {
            var e = this._map.mouseEventToLayerPoint(t.originalEvent.touches[0]),
                i = this._map.layerPointToLatLng(e),
                o = t.target;

            L.extend(o._origLatLng, i), o._middleLeft && o._middleLeft.setLatLng(this._getMiddleLatLng(o._prev, o)), o._middleRight && o._middleRight.setLatLng(this._getMiddleLatLng(o, o._next)), this._poly.redraw(), this.updateMarkers();
        },
        _updateIndexes: function _updateIndexes(t, e) {
            this._markerGroup.eachLayer(function (i) {
                i._index > t && (i._index += e);
            });
        },
        _createMiddleMarker: function _createMiddleMarker(t, e) {
            var i,
                _o,
                _a,
                n = this._getMiddleLatLng(t, e),
                s = this._createMarker(n);

            s.setOpacity(.6), t._middleRight = e._middleLeft = s, _o = function o() {
                s.off("touchmove", _o, this);
                var a = e._index;
                s._index = a, s.off("click", i, this).on("click", this._onMarkerClick, this), n.lat = s.getLatLng().lat, n.lng = s.getLatLng().lng, this._spliceLatLngs(a, 0, n), this._markers.splice(a, 0, s), s.setOpacity(1), this._updateIndexes(a, 1), e._index++, this._updatePrevNext(t, s), this._updatePrevNext(s, e), this._poly.fire("editstart");
            }, _a = function a() {
                s.off("dragstart", _o, this), s.off("dragend", _a, this), s.off("touchmove", _o, this), this._createMiddleMarker(t, s), this._createMiddleMarker(s, e);
            }, i = function i() {
                _o.call(this), _a.call(this), this._fireEdit();
            }, s.on("click", i, this).on("dragstart", _o, this).on("dragend", _a, this).on("touchmove", _o, this), this._markerGroup.addLayer(s);
        },
        _updatePrevNext: function _updatePrevNext(t, e) {
            t && (t._next = e), e && (e._prev = t);
        },
        _getMiddleLatLng: function _getMiddleLatLng(t, e) {
            var i = this._poly._map,
                o = i.project(t.getLatLng()),
                a = i.project(e.getLatLng());
            return i.unproject(o._add(a)._divideBy(2));
        }
    }), L.Polyline.addInitHook(function () {
        this.editing || (L.Edit.Poly && (this.editing = new L.Edit.Poly(this), this.options.editable && this.editing.enable()), this.on("add", function () {
            this.editing && this.editing.enabled() && this.editing.addHooks();
        }), this.on("remove", function () {
            this.editing && this.editing.enabled() && this.editing.removeHooks();
        }));
    }), L.Edit = L.Edit || {}, L.Edit.SimpleShape = L.Handler.extend({
        options: {
            moveIcon: new L.DivIcon({
                iconSize: new L.Point(8, 8),
                className: "leaflet-div-icon leaflet-editing-icon leaflet-edit-move"
            }),
            resizeIcon: new L.DivIcon({
                iconSize: new L.Point(8, 8),
                className: "leaflet-div-icon leaflet-editing-icon leaflet-edit-resize"
            }),
            touchMoveIcon: new L.DivIcon({
                iconSize: new L.Point(20, 20),
                className: "leaflet-div-icon leaflet-editing-icon leaflet-edit-move leaflet-touch-icon"
            }),
            touchResizeIcon: new L.DivIcon({
                iconSize: new L.Point(20, 20),
                className: "leaflet-div-icon leaflet-editing-icon leaflet-edit-resize leaflet-touch-icon"
            })
        },
        initialize: function initialize(t, e) {
            L.Browser.touch && (this.options.moveIcon = this.options.touchMoveIcon, this.options.resizeIcon = this.options.touchResizeIcon), this._shape = t, L.Util.setOptions(this, e);
        },
        addHooks: function addHooks() {
            var t = this._shape;
            this._shape._map && (this._map = this._shape._map, t.setStyle(t.options.editing), t._map && (this._map = t._map, this._markerGroup || this._initMarkers(), this._map.addLayer(this._markerGroup)));
        },
        removeHooks: function removeHooks() {
            var t = this._shape;

            if (t.setStyle(t.options.original), t._map) {
                this._unbindMarker(this._moveMarker);

                for (var e = 0, i = this._resizeMarkers.length; e < i; e++) {
                    this._unbindMarker(this._resizeMarkers[e]);
                }

                this._resizeMarkers = null, this._map.removeLayer(this._markerGroup), delete this._markerGroup;
            }

            this._map = null;
        },
        updateMarkers: function updateMarkers() {
            this._markerGroup.clearLayers(), this._initMarkers();
        },
        _initMarkers: function _initMarkers() {
            this._markerGroup || (this._markerGroup = new L.LayerGroup()), this._createMoveMarker(), this._createResizeMarker();
        },
        _createMoveMarker: function _createMoveMarker() {},
        _createResizeMarker: function _createResizeMarker() {},
        _createMarker: function _createMarker(t, e) {
            var i = new L.Marker.Touch(t, {
                draggable: !0,
                icon: e,
                zIndexOffset: 10
            });
            return this._bindMarker(i), this._markerGroup.addLayer(i), i;
        },
        _bindMarker: function _bindMarker(t) {
            t.on("dragstart", this._onMarkerDragStart, this).on("drag", this._onMarkerDrag, this).on("dragend", this._onMarkerDragEnd, this).on("touchstart", this._onTouchStart, this).on("touchmove", this._onTouchMove, this).on("MSPointerMove", this._onTouchMove, this).on("touchend", this._onTouchEnd, this).on("MSPointerUp", this._onTouchEnd, this);
        },
        _unbindMarker: function _unbindMarker(t) {
            t.off("dragstart", this._onMarkerDragStart, this).off("drag", this._onMarkerDrag, this).off("dragend", this._onMarkerDragEnd, this).off("touchstart", this._onTouchStart, this).off("touchmove", this._onTouchMove, this).off("MSPointerMove", this._onTouchMove, this).off("touchend", this._onTouchEnd, this).off("MSPointerUp", this._onTouchEnd, this);
        },
        _onMarkerDragStart: function _onMarkerDragStart(t) {
            t.target.setOpacity(0), this._shape.fire("editstart");
        },
        _fireEdit: function _fireEdit() {
            this._shape.edited = !0, this._shape.fire("edit");
        },
        _onMarkerDrag: function _onMarkerDrag(t) {
            var e = t.target,
                i = e.getLatLng();
            e === this._moveMarker ? this._move(i) : this._resize(i), this._shape.redraw(), this._shape.fire("editdrag");
        },
        _onMarkerDragEnd: function _onMarkerDragEnd(t) {
            t.target.setOpacity(1), this._fireEdit();
        },
        _onTouchStart: function _onTouchStart(t) {
            if (L.Edit.SimpleShape.prototype._onMarkerDragStart.call(this, t), "function" == typeof this._getCorners) {
                var e = this._getCorners(),
                    i = t.target,
                    o = i._cornerIndex;

                i.setOpacity(0), this._oppositeCorner = e[(o + 2) % 4], this._toggleCornerMarkers(0, o);
            }

            this._shape.fire("editstart");
        },
        _onTouchMove: function _onTouchMove(t) {
            var e = this._map.mouseEventToLayerPoint(t.originalEvent.touches[0]),
                i = this._map.layerPointToLatLng(e);

            return t.target === this._moveMarker ? this._move(i) : this._resize(i), this._shape.redraw(), !1;
        },
        _onTouchEnd: function _onTouchEnd(t) {
            t.target.setOpacity(1), this.updateMarkers(), this._fireEdit();
        },
        _move: function _move() {},
        _resize: function _resize() {}
    }), L.Edit = L.Edit || {}, L.Edit.Rectangle = L.Edit.SimpleShape.extend({
        _createMoveMarker: function _createMoveMarker() {
            var t = this._shape.getBounds(),
                e = t.getCenter();

            this._moveMarker = this._createMarker(e, this.options.moveIcon);
        },
        _createResizeMarker: function _createResizeMarker() {
            var t = this._getCorners();

            this._resizeMarkers = [];

            for (var e = 0, i = t.length; e < i; e++) {
                this._resizeMarkers.push(this._createMarker(t[e], this.options.resizeIcon)), this._resizeMarkers[e]._cornerIndex = e;
            }
        },
        _onMarkerDragStart: function _onMarkerDragStart(t) {
            L.Edit.SimpleShape.prototype._onMarkerDragStart.call(this, t);

            var e = this._getCorners(),
                i = t.target,
                o = i._cornerIndex;

            this._oppositeCorner = e[(o + 2) % 4], this._toggleCornerMarkers(0, o);
        },
        _onMarkerDragEnd: function _onMarkerDragEnd(t) {
            var e,
                i,
                o = t.target;
            o === this._moveMarker && (e = this._shape.getBounds(), i = e.getCenter(), o.setLatLng(i)), this._toggleCornerMarkers(1), this._repositionCornerMarkers(), L.Edit.SimpleShape.prototype._onMarkerDragEnd.call(this, t);
        },
        _move: function _move(t) {
            for (var e, i = this._shape._defaultShape ? this._shape._defaultShape() : this._shape.getLatLngs(), o = this._shape.getBounds(), a = o.getCenter(), n = [], s = 0, r = i.length; s < r; s++) {
                e = [i[s].lat - a.lat, i[s].lng - a.lng], n.push([t.lat + e[0], t.lng + e[1]]);
            }

            this._shape.setLatLngs(n), this._repositionCornerMarkers(), this._map.fire(L.Draw.Event.EDITMOVE, {
                layer: this._shape
            });
        },
        _resize: function _resize(t) {
            var e;
            this._shape.setBounds(L.latLngBounds(t, this._oppositeCorner)), e = this._shape.getBounds(), this._moveMarker.setLatLng(e.getCenter()), this._map.fire(L.Draw.Event.EDITRESIZE, {
                layer: this._shape
            });
        },
        _getCorners: function _getCorners() {
            var t = this._shape.getBounds();

            return [t.getNorthWest(), t.getNorthEast(), t.getSouthEast(), t.getSouthWest()];
        },
        _toggleCornerMarkers: function _toggleCornerMarkers(t) {
            for (var e = 0, i = this._resizeMarkers.length; e < i; e++) {
                this._resizeMarkers[e].setOpacity(t);
            }
        },
        _repositionCornerMarkers: function _repositionCornerMarkers() {
            for (var t = this._getCorners(), e = 0, i = this._resizeMarkers.length; e < i; e++) {
                this._resizeMarkers[e].setLatLng(t[e]);
            }
        }
    }), L.Rectangle.addInitHook(function () {
        L.Edit.Rectangle && (this.editing = new L.Edit.Rectangle(this), this.options.editable && this.editing.enable());
    }), L.Edit = L.Edit || {}, L.Edit.CircleMarker = L.Edit.SimpleShape.extend({
        _createMoveMarker: function _createMoveMarker() {
            var t = this._shape.getLatLng();

            this._moveMarker = this._createMarker(t, this.options.moveIcon);
        },
        _createResizeMarker: function _createResizeMarker() {
            this._resizeMarkers = [];
        },
        _move: function _move(t) {
            if (this._resizeMarkers.length) {
                var e = this._getResizeMarkerPoint(t);

                this._resizeMarkers[0].setLatLng(e);
            }

            this._shape.setLatLng(t), this._map.fire(L.Draw.Event.EDITMOVE, {
                layer: this._shape
            });
        }
    }), L.CircleMarker.addInitHook(function () {
        L.Edit.CircleMarker && (this.editing = new L.Edit.CircleMarker(this), this.options.editable && this.editing.enable()), this.on("add", function () {
            this.editing && this.editing.enabled() && this.editing.addHooks();
        }), this.on("remove", function () {
            this.editing && this.editing.enabled() && this.editing.removeHooks();
        });
    }), L.Edit = L.Edit || {}, L.Edit.Circle = L.Edit.CircleMarker.extend({
        _createResizeMarker: function _createResizeMarker() {
            var t = this._shape.getLatLng(),
                e = this._getResizeMarkerPoint(t);

            this._resizeMarkers = [], this._resizeMarkers.push(this._createMarker(e, this.options.resizeIcon));
        },
        _getResizeMarkerPoint: function _getResizeMarkerPoint(t) {
            var e = this._shape._radius * Math.cos(Math.PI / 4),
                i = this._map.project(t);

            return this._map.unproject([i.x + e, i.y - e]);
        },
        _resize: function _resize(t) {
            var e = this._moveMarker.getLatLng();

            L.GeometryUtil.isVersion07x() ? radius = e.distanceTo(t) : radius = this._map.distance(e, t), this._shape.setRadius(radius), this._map.editTooltip && this._map._editTooltip.updateContent({
                text: L.drawLocal.edit.handlers.edit.tooltip.subtext + "<br />" + L.drawLocal.edit.handlers.edit.tooltip.text,
                subtext: L.drawLocal.draw.handlers.circle.radius + ": " + L.GeometryUtil.readableDistance(radius, !0, this.options.feet, this.options.nautic)
            }), this._shape.setRadius(radius), this._map.fire(L.Draw.Event.EDITRESIZE, {
                layer: this._shape
            });
        }
    }), L.Circle.addInitHook(function () {
        L.Edit.Circle && (this.editing = new L.Edit.Circle(this), this.options.editable && this.editing.enable());
    }), L.Map.mergeOptions({
        touchExtend: !0
    }), L.Map.TouchExtend = L.Handler.extend({
        initialize: function initialize(t) {
            this._map = t, this._container = t._container, this._pane = t._panes.overlayPane;
        },
        addHooks: function addHooks() {
            L.DomEvent.on(this._container, "touchstart", this._onTouchStart, this), L.DomEvent.on(this._container, "touchend", this._onTouchEnd, this), L.DomEvent.on(this._container, "touchmove", this._onTouchMove, this), this._detectIE() ? (L.DomEvent.on(this._container, "MSPointerDown", this._onTouchStart, this), L.DomEvent.on(this._container, "MSPointerUp", this._onTouchEnd, this), L.DomEvent.on(this._container, "MSPointerMove", this._onTouchMove, this), L.DomEvent.on(this._container, "MSPointerCancel", this._onTouchCancel, this)) : (L.DomEvent.on(this._container, "touchcancel", this._onTouchCancel, this), L.DomEvent.on(this._container, "touchleave", this._onTouchLeave, this));
        },
        removeHooks: function removeHooks() {
            L.DomEvent.off(this._container, "touchstart", this._onTouchStart, this), L.DomEvent.off(this._container, "touchend", this._onTouchEnd, this), L.DomEvent.off(this._container, "touchmove", this._onTouchMove, this), this._detectIE() ? (L.DomEvent.off(this._container, "MSPointerDown", this._onTouchStart, this), L.DomEvent.off(this._container, "MSPointerUp", this._onTouchEnd, this), L.DomEvent.off(this._container, "MSPointerMove", this._onTouchMove, this), L.DomEvent.off(this._container, "MSPointerCancel", this._onTouchCancel, this)) : (L.DomEvent.off(this._container, "touchcancel", this._onTouchCancel, this), L.DomEvent.off(this._container, "touchleave", this._onTouchLeave, this));
        },
        _touchEvent: function _touchEvent(t, e) {
            var i = {};

            if (void 0 !== t.touches) {
                if (!t.touches.length) return;
                i = t.touches[0];
            } else {
                if ("touch" !== t.pointerType) return;
                if (i = t, !this._filterClick(t)) return;
            }

            var o = this._map.mouseEventToContainerPoint(i),
                a = this._map.mouseEventToLayerPoint(i),
                n = this._map.layerPointToLatLng(a);

            this._map.fire(e, {
                latlng: n,
                layerPoint: a,
                containerPoint: o,
                pageX: i.pageX,
                pageY: i.pageY,
                originalEvent: t
            });
        },
        _filterClick: function _filterClick(t) {
            var e = t.timeStamp || t.originalEvent.timeStamp,
                i = L.DomEvent._lastClick && e - L.DomEvent._lastClick;
            return i && i > 100 && i < 500 || t.target._simulatedClick && !t._simulated ? (L.DomEvent.stop(t), !1) : (L.DomEvent._lastClick = e, !0);
        },
        _onTouchStart: function _onTouchStart(t) {
            if (this._map._loaded) {
                this._touchEvent(t, "touchstart");
            }
        },
        _onTouchEnd: function _onTouchEnd(t) {
            if (this._map._loaded) {
                this._touchEvent(t, "touchend");
            }
        },
        _onTouchCancel: function _onTouchCancel(t) {
            if (this._map._loaded) {
                var e = "touchcancel";
                this._detectIE() && (e = "pointercancel"), this._touchEvent(t, e);
            }
        },
        _onTouchLeave: function _onTouchLeave(t) {
            if (this._map._loaded) {
                this._touchEvent(t, "touchleave");
            }
        },
        _onTouchMove: function _onTouchMove(t) {
            if (this._map._loaded) {
                this._touchEvent(t, "touchmove");
            }
        },
        _detectIE: function _detectIE() {
            var e = t.navigator.userAgent,
                i = e.indexOf("MSIE ");
            if (i > 0) return parseInt(e.substring(i + 5, e.indexOf(".", i)), 10);

            if (e.indexOf("Trident/") > 0) {
                var o = e.indexOf("rv:");
                return parseInt(e.substring(o + 3, e.indexOf(".", o)), 10);
            }

            var a = e.indexOf("Edge/");
            return a > 0 && parseInt(e.substring(a + 5, e.indexOf(".", a)), 10);
        }
    }), L.Map.addInitHook("addHandler", "touchExtend", L.Map.TouchExtend), L.Marker.Touch = L.Marker.extend({
        _initInteraction: function _initInteraction() {
            return this.addInteractiveTarget ? L.Marker.prototype._initInteraction.apply(this) : this._initInteractionLegacy();
        },
        _initInteractionLegacy: function _initInteractionLegacy() {
            if (this.options.clickable) {
                var t = this._icon,
                    e = ["dblclick", "mousedown", "mouseover", "mouseout", "contextmenu", "touchstart", "touchend", "touchmove"];
                this._detectIE ? e.concat(["MSPointerDown", "MSPointerUp", "MSPointerMove", "MSPointerCancel"]) : e.concat(["touchcancel"]), L.DomUtil.addClass(t, "leaflet-clickable"), L.DomEvent.on(t, "click", this._onMouseClick, this), L.DomEvent.on(t, "keypress", this._onKeyPress, this);

                for (var i = 0; i < e.length; i++) {
                    L.DomEvent.on(t, e[i], this._fireMouseEvent, this);
                }

                L.Handler.MarkerDrag && (this.dragging = new L.Handler.MarkerDrag(this), this.options.draggable && this.dragging.enable());
            }
        },
        _detectIE: function _detectIE() {
            var e = t.navigator.userAgent,
                i = e.indexOf("MSIE ");
            if (i > 0) return parseInt(e.substring(i + 5, e.indexOf(".", i)), 10);

            if (e.indexOf("Trident/") > 0) {
                var o = e.indexOf("rv:");
                return parseInt(e.substring(o + 3, e.indexOf(".", o)), 10);
            }

            var a = e.indexOf("Edge/");
            return a > 0 && parseInt(e.substring(a + 5, e.indexOf(".", a)), 10);
        }
    }), L.LatLngUtil = {
        cloneLatLngs: function cloneLatLngs(t) {
            for (var e = [], i = 0, o = t.length; i < o; i++) {
                Array.isArray(t[i]) ? e.push(L.LatLngUtil.cloneLatLngs(t[i])) : e.push(this.cloneLatLng(t[i]));
            }

            return e;
        },
        cloneLatLng: function cloneLatLng(t) {
            return L.latLng(t.lat, t.lng);
        }
    }, function () {
        var t = {
            km: 2,
            ha: 2,
            m: 0,
            mi: 2,
            ac: 2,
            yd: 0,
            ft: 0,
            nm: 2
        };
        L.GeometryUtil = L.extend(L.GeometryUtil || {}, {
            geodesicArea: function geodesicArea(t) {
                var e,
                    i,
                    o = t.length,
                    a = 0,
                    n = Math.PI / 180;

                if (o > 2) {
                    for (var s = 0; s < o; s++) {
                        e = t[s], i = t[(s + 1) % o], a += (i.lng - e.lng) * n * (2 + Math.sin(e.lat * n) + Math.sin(i.lat * n));
                    }

                    a = 6378137 * a * 6378137 / 2;
                }

                return Math.abs(a);
            },
            formattedNumber: function formattedNumber(t, e) {
                var i = parseFloat(t).toFixed(e),
                    o = L.drawLocal.format && L.drawLocal.format.numeric,
                    a = o && o.delimiters,
                    n = a && a.thousands,
                    s = a && a.decimal;

                if (n || s) {
                    var r = i.split(".");
                    i = n ? r[0].replace(/(\d)(?=(\d{3})+(?!\d))/g, "$1" + n) : r[0], s = s || ".", r.length > 1 && (i = i + s + r[1]);
                }

                return i;
            },
            readableArea: function readableArea(e, i, o) {
                var a,
                    n,
                    o = L.Util.extend({}, t, o);
                return i ? (n = ["ha", "m"], type = _typeof(i), "string" === type ? n = [i] : "boolean" !== type && (n = i), a = e >= 1e6 && -1 !== n.indexOf("km") ? L.GeometryUtil.formattedNumber(1e-6 * e, o.km) + " km²" : e >= 1e4 && -1 !== n.indexOf("ha") ? L.GeometryUtil.formattedNumber(1e-4 * e, o.ha) + " ha" : L.GeometryUtil.formattedNumber(e, o.m) + " m²") : (e /= .836127, a = e >= 3097600 ? L.GeometryUtil.formattedNumber(e / 3097600, o.mi) + " mi²" : e >= 4840 ? L.GeometryUtil.formattedNumber(e / 4840, o.ac) + " acres" : L.GeometryUtil.formattedNumber(e, o.yd) + " yd²"), a;
            },
            readableDistance: function readableDistance(e, i, o, a, n) {
                var s,
                    n = L.Util.extend({}, t, n);

                switch (i ? "string" == typeof i ? i : "metric" : o ? "feet" : a ? "nauticalMile" : "yards") {
                    case "metric":
                        s = e > 1e3 ? L.GeometryUtil.formattedNumber(e / 1e3, n.km) + " km" : L.GeometryUtil.formattedNumber(e, n.m) + " m";
                        break;

                    case "feet":
                        e *= 3.28083, s = L.GeometryUtil.formattedNumber(e, n.ft) + " ft";
                        break;

                    case "nauticalMile":
                        e *= .53996, s = L.GeometryUtil.formattedNumber(e / 1e3, n.nm) + " nm";
                        break;

                    case "yards":
                    default:
                        e *= 1.09361, s = e > 1760 ? L.GeometryUtil.formattedNumber(e / 1760, n.mi) + " miles" : L.GeometryUtil.formattedNumber(e, n.yd) + " yd";
                }

                return s;
            },
            isVersion07x: function isVersion07x() {
                var t = L.version.split(".");
                return 0 === parseInt(t[0], 10) && 7 === parseInt(t[1], 10);
            }
        });
    }(), L.Util.extend(L.LineUtil, {
        segmentsIntersect: function segmentsIntersect(t, e, i, o) {
            return this._checkCounterclockwise(t, i, o) !== this._checkCounterclockwise(e, i, o) && this._checkCounterclockwise(t, e, i) !== this._checkCounterclockwise(t, e, o);
        },
        _checkCounterclockwise: function _checkCounterclockwise(t, e, i) {
            return (i.y - t.y) * (e.x - t.x) > (e.y - t.y) * (i.x - t.x);
        }
    }), L.Polyline.include({
        intersects: function intersects() {
            var t,
                e,
                i,
                o = this._getProjectedPoints(),
                a = o ? o.length : 0;

            if (this._tooFewPointsForIntersection()) return !1;

            for (t = a - 1; t >= 3; t--) {
                if (e = o[t - 1], i = o[t], this._lineSegmentsIntersectsRange(e, i, t - 2)) return !0;
            }

            return !1;
        },
        newLatLngIntersects: function newLatLngIntersects(t, e) {
            return !!this._map && this.newPointIntersects(this._map.latLngToLayerPoint(t), e);
        },
        newPointIntersects: function newPointIntersects(t, e) {
            var i = this._getProjectedPoints(),
                o = i ? i.length : 0,
                a = i ? i[o - 1] : null,
                n = o - 2;

            return !this._tooFewPointsForIntersection(1) && this._lineSegmentsIntersectsRange(a, t, n, e ? 1 : 0);
        },
        _tooFewPointsForIntersection: function _tooFewPointsForIntersection(t) {
            var e = this._getProjectedPoints(),
                i = e ? e.length : 0;

            return i += t || 0, !e || i <= 3;
        },
        _lineSegmentsIntersectsRange: function _lineSegmentsIntersectsRange(t, e, i, o) {
            var a,
                n,
                s = this._getProjectedPoints();

            o = o || 0;

            for (var r = i; r > o; r--) {
                if (a = s[r - 1], n = s[r], L.LineUtil.segmentsIntersect(t, e, a, n)) return !0;
            }

            return !1;
        },
        _getProjectedPoints: function _getProjectedPoints() {
            if (!this._defaultShape) return this._originalPoints;

            for (var t = [], e = this._defaultShape(), i = 0; i < e.length; i++) {
                t.push(this._map.latLngToLayerPoint(e[i]));
            }

            return t;
        }
    }), L.Polygon.include({
        intersects: function intersects() {
            var t,
                e,
                i,
                o,
                a = this._getProjectedPoints();

            return !this._tooFewPointsForIntersection() && (!!L.Polyline.prototype.intersects.call(this) || (t = a.length, e = a[0], i = a[t - 1], o = t - 2, this._lineSegmentsIntersectsRange(i, e, o, 1)));
        }
    }), L.Control.Draw = L.Control.extend({
        options: {
            position: "topleft",
            draw: {},
            edit: !1
        },
        initialize: function initialize(t) {
            if (L.version < "0.7") throw new Error("Leaflet.draw 0.2.3+ requires Leaflet 0.7.0+. Download latest from https://github.com/Leaflet/Leaflet/");
            L.Control.prototype.initialize.call(this, t);
            var e;
            this._toolbars = {}, L.DrawToolbar && this.options.draw && (e = new L.DrawToolbar(this.options.draw), this._toolbars[L.DrawToolbar.TYPE] = e, this._toolbars[L.DrawToolbar.TYPE].on("enable", this._toolbarEnabled, this)), L.EditToolbar && this.options.edit && (e = new L.EditToolbar(this.options.edit), this._toolbars[L.EditToolbar.TYPE] = e, this._toolbars[L.EditToolbar.TYPE].on("enable", this._toolbarEnabled, this)), L.toolbar = this;
        },
        onAdd: function onAdd(t) {
            var e,
                i = L.DomUtil.create("div", "leaflet-draw"),
                o = !1;

            for (var a in this._toolbars) {
                this._toolbars.hasOwnProperty(a) && (e = this._toolbars[a].addToolbar(t)) && (o || (L.DomUtil.hasClass(e, "leaflet-draw-toolbar-top") || L.DomUtil.addClass(e.childNodes[0], "leaflet-draw-toolbar-top"), o = !0), i.appendChild(e));
            }

            return i;
        },
        onRemove: function onRemove() {
            for (var t in this._toolbars) {
                this._toolbars.hasOwnProperty(t) && this._toolbars[t].removeToolbar();
            }
        },
        setDrawingOptions: function setDrawingOptions(t) {
            for (var e in this._toolbars) {
                this._toolbars[e] instanceof L.DrawToolbar && this._toolbars[e].setOptions(t);
            }
        },
        _toolbarEnabled: function _toolbarEnabled(t) {
            var e = t.target;

            for (var i in this._toolbars) {
                this._toolbars[i] !== e && this._toolbars[i].disable();
            }
        }
    }), L.Map.mergeOptions({
        drawControlTooltips: !0,
        drawControl: !1
    }), L.Map.addInitHook(function () {
        this.options.drawControl && (this.drawControl = new L.Control.Draw(), this.addControl(this.drawControl));
    }), L.Toolbar = L.Class.extend({
        initialize: function initialize(t) {
            L.setOptions(this, t), this._modes = {}, this._actionButtons = [], this._activeMode = null;
            var e = L.version.split(".");
            1 === parseInt(e[0], 10) && parseInt(e[1], 10) >= 2 ? L.Toolbar.include(L.Evented.prototype) : L.Toolbar.include(L.Mixin.Events);
        },
        enabled: function enabled() {
            return null !== this._activeMode;
        },
        disable: function disable() {
            this.enabled() && this._activeMode.handler.disable();
        },
        addToolbar: function addToolbar(t) {
            var e,
                i = L.DomUtil.create("div", "leaflet-draw-section"),
                o = 0,
                a = this._toolbarClass || "",
                n = this.getModeHandlers(t);

            for (this._toolbarContainer = L.DomUtil.create("div", "leaflet-draw-toolbar leaflet-bar"), this._map = t, e = 0; e < n.length; e++) {
                n[e].enabled && this._initModeHandler(n[e].handler, this._toolbarContainer, o++, a, n[e].title);
            }

            if (o) return this._lastButtonIndex = --o, this._actionsContainer = L.DomUtil.create("ul", "leaflet-draw-actions"), i.appendChild(this._toolbarContainer), i.appendChild(this._actionsContainer), i;
        },
        removeToolbar: function removeToolbar() {
            for (var t in this._modes) {
                this._modes.hasOwnProperty(t) && (this._disposeButton(this._modes[t].button, this._modes[t].handler.enable, this._modes[t].handler), this._modes[t].handler.disable(), this._modes[t].handler.off("enabled", this._handlerActivated, this).off("disabled", this._handlerDeactivated, this));
            }

            this._modes = {};

            for (var e = 0, i = this._actionButtons.length; e < i; e++) {
                this._disposeButton(this._actionButtons[e].button, this._actionButtons[e].callback, this);
            }

            this._actionButtons = [], this._actionsContainer = null;
        },
        _initModeHandler: function _initModeHandler(t, e, i, o, a) {
            var n = t.type;
            this._modes[n] = {}, this._modes[n].handler = t, this._modes[n].button = this._createButton({
                type: n,
                title: a,
                className: o + "-" + n,
                container: e,
                callback: this._modes[n].handler.enable,
                context: this._modes[n].handler
            }), this._modes[n].buttonIndex = i, this._modes[n].handler.on("enabled", this._handlerActivated, this).on("disabled", this._handlerDeactivated, this);
        },
        _detectIOS: function _detectIOS() {
            return /iPad|iPhone|iPod/.test(navigator.userAgent) && !t.MSStream;
        },
        _createButton: function _createButton(t) {
            var e = L.DomUtil.create("a", t.className || "", t.container),
                i = L.DomUtil.create("span", "sr-only", t.container);
            e.href = "#", e.appendChild(i), t.title && (e.title = t.title, i.innerHTML = t.title), t.text && (e.innerHTML = t.text, i.innerHTML = t.text);
            var o = this._detectIOS() ? "touchstart" : "click";
            return L.DomEvent.on(e, "click", L.DomEvent.stopPropagation).on(e, "mousedown", L.DomEvent.stopPropagation).on(e, "dblclick", L.DomEvent.stopPropagation).on(e, "touchstart", L.DomEvent.stopPropagation).on(e, "click", L.DomEvent.preventDefault).on(e, o, t.callback, t.context), e;
        },
        _disposeButton: function _disposeButton(t, e) {
            var i = this._detectIOS() ? "touchstart" : "click";
            L.DomEvent.off(t, "click", L.DomEvent.stopPropagation).off(t, "mousedown", L.DomEvent.stopPropagation).off(t, "dblclick", L.DomEvent.stopPropagation).off(t, "touchstart", L.DomEvent.stopPropagation).off(t, "click", L.DomEvent.preventDefault).off(t, i, e);
        },
        _handlerActivated: function _handlerActivated(t) {
            this.disable(), this._activeMode = this._modes[t.handler], L.DomUtil.addClass(this._activeMode.button, "leaflet-draw-toolbar-button-enabled"), this._showActionsToolbar(), this.fire("enable");
        },
        _handlerDeactivated: function _handlerDeactivated() {
            this._hideActionsToolbar(), L.DomUtil.removeClass(this._activeMode.button, "leaflet-draw-toolbar-button-enabled"), this._activeMode = null, this.fire("disable");
        },
        _createActions: function _createActions(t) {
            var e,
                i,
                o,
                a,
                n = this._actionsContainer,
                s = this.getActions(t),
                r = s.length;

            for (i = 0, o = this._actionButtons.length; i < o; i++) {
                this._disposeButton(this._actionButtons[i].button, this._actionButtons[i].callback);
            }

            for (this._actionButtons = []; n.firstChild;) {
                n.removeChild(n.firstChild);
            }

            for (var l = 0; l < r; l++) {
                "enabled" in s[l] && !s[l].enabled || (e = L.DomUtil.create("li", "", n), a = this._createButton({
                    title: s[l].title,
                    text: s[l].text,
                    container: e,
                    callback: s[l].callback,
                    context: s[l].context
                }), this._actionButtons.push({
                    button: a,
                    callback: s[l].callback
                }));
            }
        },
        _showActionsToolbar: function _showActionsToolbar() {
            var t = this._activeMode.buttonIndex,
                e = this._lastButtonIndex,
                i = this._activeMode.button.offsetTop - 1;
            this._createActions(this._activeMode.handler), this._actionsContainer.style.top = i + "px", 0 === t && (L.DomUtil.addClass(this._toolbarContainer, "leaflet-draw-toolbar-notop"), L.DomUtil.addClass(this._actionsContainer, "leaflet-draw-actions-top")), t === e && (L.DomUtil.addClass(this._toolbarContainer, "leaflet-draw-toolbar-nobottom"), L.DomUtil.addClass(this._actionsContainer, "leaflet-draw-actions-bottom")), this._actionsContainer.style.display = "block", this._map.fire(L.Draw.Event.TOOLBAROPENED);
        },
        _hideActionsToolbar: function _hideActionsToolbar() {
            this._actionsContainer.style.display = "none", L.DomUtil.removeClass(this._toolbarContainer, "leaflet-draw-toolbar-notop"), L.DomUtil.removeClass(this._toolbarContainer, "leaflet-draw-toolbar-nobottom"), L.DomUtil.removeClass(this._actionsContainer, "leaflet-draw-actions-top"), L.DomUtil.removeClass(this._actionsContainer, "leaflet-draw-actions-bottom"), this._map.fire(L.Draw.Event.TOOLBARCLOSED);
        }
    }), L.Draw = L.Draw || {}, L.Draw.Tooltip = L.Class.extend({
        initialize: function initialize(t) {
            this._map = t, this._popupPane = t._panes.popupPane, this._visible = !1, this._container = t.options.drawControlTooltips ? L.DomUtil.create("div", "leaflet-draw-tooltip", this._popupPane) : null, this._singleLineLabel = !1, this._map.on("mouseout", this._onMouseOut, this);
        },
        dispose: function dispose() {
            this._map.off("mouseout", this._onMouseOut, this), this._container && (this._popupPane.removeChild(this._container), this._container = null);
        },
        updateContent: function updateContent(t) {
            return this._container ? (t.subtext = t.subtext || "", 0 !== t.subtext.length || this._singleLineLabel ? t.subtext.length > 0 && this._singleLineLabel && (L.DomUtil.removeClass(this._container, "leaflet-draw-tooltip-single"), this._singleLineLabel = !1) : (L.DomUtil.addClass(this._container, "leaflet-draw-tooltip-single"), this._singleLineLabel = !0), this._container.innerHTML = (t.subtext.length > 0 ? '<span class="leaflet-draw-tooltip-subtext">' + t.subtext + "</span><br />" : "") + "<span>" + t.text + "</span>", t.text || t.subtext ? (this._visible = !0, this._container.style.visibility = "inherit") : (this._visible = !1, this._container.style.visibility = "hidden"), this) : this;
        },
        updatePosition: function updatePosition(t) {
            var e = this._map.latLngToLayerPoint(t),
                i = this._container;

            return this._container && (this._visible && (i.style.visibility = "inherit"), L.DomUtil.setPosition(i, e)), this;
        },
        showAsError: function showAsError() {
            return this._container && L.DomUtil.addClass(this._container, "leaflet-error-draw-tooltip"), this;
        },
        removeError: function removeError() {
            return this._container && L.DomUtil.removeClass(this._container, "leaflet-error-draw-tooltip"), this;
        },
        _onMouseOut: function _onMouseOut() {
            this._container && (this._container.style.visibility = "hidden");
        }
    }), L.DrawToolbar = L.Toolbar.extend({
        statics: {
            TYPE: "draw"
        },
        options: {
            polyline: {},
            polygon: {},
            rectangle: {},
            circle: {},
            marker: {},
            circlemarker: {}
        },
        initialize: function initialize(t) {
            for (var e in this.options) {
                this.options.hasOwnProperty(e) && t[e] && (t[e] = L.extend({}, this.options[e], t[e]));
            }

            this._toolbarClass = "leaflet-draw-draw", L.Toolbar.prototype.initialize.call(this, t);
        },
        getModeHandlers: function getModeHandlers(t) {
            return [{
                enabled: this.options.polyline,
                handler: new L.Draw.Polyline(t, this.options.polyline),
                title: L.drawLocal.draw.toolbar.buttons.polyline
            }, {
                enabled: this.options.polygon,
                handler: new L.Draw.Polygon(t, this.options.polygon),
                title: L.drawLocal.draw.toolbar.buttons.polygon
            }, {
                enabled: this.options.rectangle,
                handler: new L.Draw.Rectangle(t, this.options.rectangle),
                title: L.drawLocal.draw.toolbar.buttons.rectangle
            }, {
                enabled: this.options.circle,
                handler: new L.Draw.Circle(t, this.options.circle),
                title: L.drawLocal.draw.toolbar.buttons.circle
            }, {
                enabled: this.options.marker,
                handler: new L.Draw.Marker(t, this.options.marker),
                title: L.drawLocal.draw.toolbar.buttons.marker
            }, {
                enabled: this.options.circlemarker,
                handler: new L.Draw.CircleMarker(t, this.options.circlemarker),
                title: L.drawLocal.draw.toolbar.buttons.circlemarker
            }];
        },
        getActions: function getActions(t) {
            return [{
                enabled: t.completeShape,
                title: L.drawLocal.draw.toolbar.finish.title,
                text: L.drawLocal.draw.toolbar.finish.text,
                callback: t.completeShape,
                context: t
            }, {
                enabled: t.deleteLastVertex,
                title: L.drawLocal.draw.toolbar.undo.title,
                text: L.drawLocal.draw.toolbar.undo.text,
                callback: t.deleteLastVertex,
                context: t
            }, {
                title: L.drawLocal.draw.toolbar.actions.title,
                text: L.drawLocal.draw.toolbar.actions.text,
                callback: this.disable,
                context: this
            }];
        },
        setOptions: function setOptions(t) {
            L.setOptions(this, t);

            for (var e in this._modes) {
                this._modes.hasOwnProperty(e) && t.hasOwnProperty(e) && this._modes[e].handler.setOptions(t[e]);
            }
        }
    }), L.EditToolbar = L.Toolbar.extend({
        statics: {
            TYPE: "edit"
        },
        options: {
            edit: {
                selectedPathOptions: {
                    dashArray: "10, 10",
                    fill: !0,
                    fillColor: "#fe57a1",
                    fillOpacity: .1,
                    maintainColor: !1
                }
            },
            remove: {},
            poly: null,
            featureGroup: null
        },
        initialize: function initialize(t) {
            t.edit && (void 0 === t.edit.selectedPathOptions && (t.edit.selectedPathOptions = this.options.edit.selectedPathOptions), t.edit.selectedPathOptions = L.extend({}, this.options.edit.selectedPathOptions, t.edit.selectedPathOptions)), t.remove && (t.remove = L.extend({}, this.options.remove, t.remove)), t.poly && (t.poly = L.extend({}, this.options.poly, t.poly)), this._toolbarClass = "leaflet-draw-edit", L.Toolbar.prototype.initialize.call(this, t), this._selectedFeatureCount = 0;
        },
        getModeHandlers: function getModeHandlers(t) {
            var e = this.options.featureGroup;
            return [{
                enabled: this.options.edit,
                handler: new L.EditToolbar.Edit(t, {
                    featureGroup: e,
                    selectedPathOptions: this.options.edit.selectedPathOptions,
                    poly: this.options.poly
                }),
                title: L.drawLocal.edit.toolbar.buttons.edit
            }, {
                enabled: this.options.remove,
                handler: new L.EditToolbar.Delete(t, {
                    featureGroup: e
                }),
                title: L.drawLocal.edit.toolbar.buttons.remove
            }];
        },
        getActions: function getActions(t) {
            var e = [{
                title: L.drawLocal.edit.toolbar.actions.save.title,
                text: L.drawLocal.edit.toolbar.actions.save.text,
                callback: this._save,
                context: this
            }, {
                title: L.drawLocal.edit.toolbar.actions.cancel.title,
                text: L.drawLocal.edit.toolbar.actions.cancel.text,
                callback: this.disable,
                context: this
            }];
            return t.removeAllLayers && e.push({
                title: L.drawLocal.edit.toolbar.actions.clearAll.title,
                text: L.drawLocal.edit.toolbar.actions.clearAll.text,
                callback: this._clearAllLayers,
                context: this
            }), e;
        },
        addToolbar: function addToolbar(t) {
            var e = L.Toolbar.prototype.addToolbar.call(this, t);
            return this._checkDisabled(), this.options.featureGroup.on("layeradd layerremove", this._checkDisabled, this), e;
        },
        removeToolbar: function removeToolbar() {
            this.options.featureGroup.off("layeradd layerremove", this._checkDisabled, this), L.Toolbar.prototype.removeToolbar.call(this);
        },
        disable: function disable() {
            this.enabled() && (this._activeMode.handler.revertLayers(), L.Toolbar.prototype.disable.call(this));
        },
        _save: function _save() {
            this._activeMode.handler.save(), this._activeMode && this._activeMode.handler.disable();
        },
        _clearAllLayers: function _clearAllLayers() {
            this._activeMode.handler.removeAllLayers(), this._activeMode && this._activeMode.handler.disable();
        },
        _checkDisabled: function _checkDisabled() {
            var t,
                e = this.options.featureGroup,
                i = 0 !== e.getLayers().length;
            this.options.edit && (t = this._modes[L.EditToolbar.Edit.TYPE].button, i ? L.DomUtil.removeClass(t, "leaflet-disabled") : L.DomUtil.addClass(t, "leaflet-disabled"), t.setAttribute("title", i ? L.drawLocal.edit.toolbar.buttons.edit : L.drawLocal.edit.toolbar.buttons.editDisabled)), this.options.remove && (t = this._modes[L.EditToolbar.Delete.TYPE].button, i ? L.DomUtil.removeClass(t, "leaflet-disabled") : L.DomUtil.addClass(t, "leaflet-disabled"), t.setAttribute("title", i ? L.drawLocal.edit.toolbar.buttons.remove : L.drawLocal.edit.toolbar.buttons.removeDisabled));
        }
    }), L.EditToolbar.Edit = L.Handler.extend({
        statics: {
            TYPE: "edit"
        },
        initialize: function initialize(t, e) {
            if (L.Handler.prototype.initialize.call(this, t), L.setOptions(this, e), this._featureGroup = e.featureGroup, !(this._featureGroup instanceof L.FeatureGroup)) throw new Error("options.featureGroup must be a L.FeatureGroup");
            this._uneditedLayerProps = {}, this.type = L.EditToolbar.Edit.TYPE;
            var i = L.version.split(".");
            1 === parseInt(i[0], 10) && parseInt(i[1], 10) >= 2 ? L.EditToolbar.Edit.include(L.Evented.prototype) : L.EditToolbar.Edit.include(L.Mixin.Events);
        },
        enable: function enable() {
            !this._enabled && this._hasAvailableLayers() && (this.fire("enabled", {
                handler: this.type
            }), this._map.fire(L.Draw.Event.EDITSTART, {
                handler: this.type
            }), L.Handler.prototype.enable.call(this), this._featureGroup.on("layeradd", this._enableLayerEdit, this).on("layerremove", this._disableLayerEdit, this));
        },
        disable: function disable() {
            this._enabled && (this._featureGroup.off("layeradd", this._enableLayerEdit, this).off("layerremove", this._disableLayerEdit, this), L.Handler.prototype.disable.call(this), this._map.fire(L.Draw.Event.EDITSTOP, {
                handler: this.type
            }), this.fire("disabled", {
                handler: this.type
            }));
        },
        addHooks: function addHooks() {
            var t = this._map;
            t && (t.getContainer().focus(), this._featureGroup.eachLayer(this._enableLayerEdit, this), this._tooltip = new L.Draw.Tooltip(this._map), this._tooltip.updateContent({
                text: L.drawLocal.edit.handlers.edit.tooltip.text,
                subtext: L.drawLocal.edit.handlers.edit.tooltip.subtext
            }), t._editTooltip = this._tooltip, this._updateTooltip(), this._map.on("mousemove", this._onMouseMove, this).on("touchmove", this._onMouseMove, this).on("MSPointerMove", this._onMouseMove, this).on(L.Draw.Event.EDITVERTEX, this._updateTooltip, this));
        },
        removeHooks: function removeHooks() {
            this._map && (this._featureGroup.eachLayer(this._disableLayerEdit, this), this._uneditedLayerProps = {}, this._tooltip.dispose(), this._tooltip = null, this._map.off("mousemove", this._onMouseMove, this).off("touchmove", this._onMouseMove, this).off("MSPointerMove", this._onMouseMove, this).off(L.Draw.Event.EDITVERTEX, this._updateTooltip, this));
        },
        revertLayers: function revertLayers() {
            this._featureGroup.eachLayer(function (t) {
                this._revertLayer(t);
            }, this);
        },
        save: function save() {
            var t = new L.LayerGroup();
            this._featureGroup.eachLayer(function (e) {
                e.edited && (t.addLayer(e), e.edited = !1);
            }), this._map.fire(L.Draw.Event.EDITED, {
                layers: t
            });
        },
        _backupLayer: function _backupLayer(t) {
            var e = L.Util.stamp(t);
            this._uneditedLayerProps[e] || (t instanceof L.Polyline || t instanceof L.Polygon || t instanceof L.Rectangle ? this._uneditedLayerProps[e] = {
                latlngs: L.LatLngUtil.cloneLatLngs(t.getLatLngs())
            } : t instanceof L.Circle ? this._uneditedLayerProps[e] = {
                latlng: L.LatLngUtil.cloneLatLng(t.getLatLng()),
                radius: t.getRadius()
            } : (t instanceof L.Marker || t instanceof L.CircleMarker) && (this._uneditedLayerProps[e] = {
                latlng: L.LatLngUtil.cloneLatLng(t.getLatLng())
            }));
        },
        _getTooltipText: function _getTooltipText() {
            return {
                text: L.drawLocal.edit.handlers.edit.tooltip.text,
                subtext: L.drawLocal.edit.handlers.edit.tooltip.subtext
            };
        },
        _updateTooltip: function _updateTooltip() {
            this._tooltip.updateContent(this._getTooltipText());
        },
        _revertLayer: function _revertLayer(t) {
            var e = L.Util.stamp(t);
            t.edited = !1, this._uneditedLayerProps.hasOwnProperty(e) && (t instanceof L.Polyline || t instanceof L.Polygon || t instanceof L.Rectangle ? t.setLatLngs(this._uneditedLayerProps[e].latlngs) : t instanceof L.Circle ? (t.setLatLng(this._uneditedLayerProps[e].latlng), t.setRadius(this._uneditedLayerProps[e].radius)) : (t instanceof L.Marker || t instanceof L.CircleMarker) && t.setLatLng(this._uneditedLayerProps[e].latlng), t.fire("revert-edited", {
                layer: t
            }));
        },
        _enableLayerEdit: function _enableLayerEdit(t) {
            var e,
                i,
                o = t.layer || t.target || t;
            this._backupLayer(o), this.options.poly && (i = L.Util.extend({}, this.options.poly), o.options.poly = i), this.options.selectedPathOptions && (e = L.Util.extend({}, this.options.selectedPathOptions), e.maintainColor && (e.color = o.options.color, e.fillColor = o.options.fillColor), o.options.original = L.extend({}, o.options), o.options.editing = e), o instanceof L.Marker ? (o.editing && o.editing.enable(), o.dragging.enable(), o.on("dragend", this._onMarkerDragEnd).on("touchmove", this._onTouchMove, this).on("MSPointerMove", this._onTouchMove, this).on("touchend", this._onMarkerDragEnd, this).on("MSPointerUp", this._onMarkerDragEnd, this)) : o.editing.enable();
        },
        _disableLayerEdit: function _disableLayerEdit(t) {
            var e = t.layer || t.target || t;
            e.edited = !1, e.editing && e.editing.disable(), delete e.options.editing, delete e.options.original, this._selectedPathOptions && (e instanceof L.Marker ? this._toggleMarkerHighlight(e) : (e.setStyle(e.options.previousOptions), delete e.options.previousOptions)), e instanceof L.Marker ? (e.dragging.disable(), e.off("dragend", this._onMarkerDragEnd, this).off("touchmove", this._onTouchMove, this).off("MSPointerMove", this._onTouchMove, this).off("touchend", this._onMarkerDragEnd, this).off("MSPointerUp", this._onMarkerDragEnd, this)) : e.editing.disable();
        },
        _onMouseMove: function _onMouseMove(t) {
            this._tooltip.updatePosition(t.latlng);
        },
        _onMarkerDragEnd: function _onMarkerDragEnd(t) {
            var e = t.target;
            e.edited = !0, this._map.fire(L.Draw.Event.EDITMOVE, {
                layer: e
            });
        },
        _onTouchMove: function _onTouchMove(t) {
            var e = t.originalEvent.changedTouches[0],
                i = this._map.mouseEventToLayerPoint(e),
                o = this._map.layerPointToLatLng(i);

            t.target.setLatLng(o);
        },
        _hasAvailableLayers: function _hasAvailableLayers() {
            return 0 !== this._featureGroup.getLayers().length;
        }
    }), L.EditToolbar.Delete = L.Handler.extend({
        statics: {
            TYPE: "remove"
        },
        initialize: function initialize(t, e) {
            if (L.Handler.prototype.initialize.call(this, t), L.Util.setOptions(this, e), this._deletableLayers = this.options.featureGroup, !(this._deletableLayers instanceof L.FeatureGroup)) throw new Error("options.featureGroup must be a L.FeatureGroup");
            this.type = L.EditToolbar.Delete.TYPE;
            var i = L.version.split(".");
            1 === parseInt(i[0], 10) && parseInt(i[1], 10) >= 2 ? L.EditToolbar.Delete.include(L.Evented.prototype) : L.EditToolbar.Delete.include(L.Mixin.Events);
        },
        enable: function enable() {
            !this._enabled && this._hasAvailableLayers() && (this.fire("enabled", {
                handler: this.type
            }), this._map.fire(L.Draw.Event.DELETESTART, {
                handler: this.type
            }), L.Handler.prototype.enable.call(this), this._deletableLayers.on("layeradd", this._enableLayerDelete, this).on("layerremove", this._disableLayerDelete, this));
        },
        disable: function disable() {
            this._enabled && (this._deletableLayers.off("layeradd", this._enableLayerDelete, this).off("layerremove", this._disableLayerDelete, this), L.Handler.prototype.disable.call(this), this._map.fire(L.Draw.Event.DELETESTOP, {
                handler: this.type
            }), this.fire("disabled", {
                handler: this.type
            }));
        },
        addHooks: function addHooks() {
            var t = this._map;
            t && (t.getContainer().focus(), this._deletableLayers.eachLayer(this._enableLayerDelete, this), this._deletedLayers = new L.LayerGroup(), this._tooltip = new L.Draw.Tooltip(this._map), this._tooltip.updateContent({
                text: L.drawLocal.edit.handlers.remove.tooltip.text
            }), this._map.on("mousemove", this._onMouseMove, this));
        },
        removeHooks: function removeHooks() {
            this._map && (this._deletableLayers.eachLayer(this._disableLayerDelete, this), this._deletedLayers = null, this._tooltip.dispose(), this._tooltip = null, this._map.off("mousemove", this._onMouseMove, this));
        },
        revertLayers: function revertLayers() {
            this._deletedLayers.eachLayer(function (t) {
                this._deletableLayers.addLayer(t), t.fire("revert-deleted", {
                    layer: t
                });
            }, this);
        },
        save: function save() {
            this._map.fire(L.Draw.Event.DELETED, {
                layers: this._deletedLayers
            });
        },
        removeAllLayers: function removeAllLayers() {
            this._deletableLayers.eachLayer(function (t) {
                this._removeLayer({
                    layer: t
                });
            }, this), this.save();
        },
        _enableLayerDelete: function _enableLayerDelete(t) {
            (t.layer || t.target || t).on("click", this._removeLayer, this);
        },
        _disableLayerDelete: function _disableLayerDelete(t) {
            var e = t.layer || t.target || t;
            e.off("click", this._removeLayer, this), this._deletedLayers.removeLayer(e);
        },
        _removeLayer: function _removeLayer(t) {
            var e = t.layer || t.target || t;
            this._deletableLayers.removeLayer(e), this._deletedLayers.addLayer(e), e.fire("deleted");
        },
        _onMouseMove: function _onMouseMove(t) {
            this._tooltip.updatePosition(t.latlng);
        },
        _hasAvailableLayers: function _hasAvailableLayers() {
            return 0 !== this._deletableLayers.getLayers().length;
        }
    });
}(window, document);

/**
 * Removes all key-value entries from the list cache.
 *
 * @private
 * @name clear
 * @memberOf ListCache
 */
function listCacheClear$1() {
    this.__data__ = [];
    this.size = 0;
}

/**
 * Performs a
 * [`SameValueZero`](http://ecma-international.org/ecma-262/7.0/#sec-samevaluezero)
 * comparison between two values to determine if they are equivalent.
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to compare.
 * @param {*} other The other value to compare.
 * @returns {boolean} Returns `true` if the values are equivalent, else `false`.
 * @example
 *
 * var object = { 'a': 1 };
 * var other = { 'a': 1 };
 *
 * _.eq(object, object);
 * // => true
 *
 * _.eq(object, other);
 * // => false
 *
 * _.eq('a', 'a');
 * // => true
 *
 * _.eq('a', Object('a'));
 * // => false
 *
 * _.eq(NaN, NaN);
 * // => true
 */
function eq$1(value, other) {
    return value === other || value !== value && other !== other;
}

/**
 * Gets the index at which the `key` is found in `array` of key-value pairs.
 *
 * @private
 * @param {Array} array The array to inspect.
 * @param {*} key The key to search for.
 * @returns {number} Returns the index of the matched value, else `-1`.
 */

function assocIndexOf$1(array, key) {
    var length = array.length;

    while (length--) {
        if (eq$1(array[length][0], key)) {
            return length;
        }
    }

    return -1;
}

/** Used for built-in method references. */

var arrayProto$1 = Array.prototype;
/** Built-in value references. */

var splice$1 = arrayProto$1.splice;
/**
 * Removes `key` and its value from the list cache.
 *
 * @private
 * @name delete
 * @memberOf ListCache
 * @param {string} key The key of the value to remove.
 * @returns {boolean} Returns `true` if the entry was removed, else `false`.
 */

function listCacheDelete$1(key) {
    var data = this.__data__,
        index = assocIndexOf$1(data, key);

    if (index < 0) {
        return false;
    }

    var lastIndex = data.length - 1;

    if (index == lastIndex) {
        data.pop();
    } else {
        splice$1.call(data, index, 1);
    }

    --this.size;
    return true;
}

/**
 * Gets the list cache value for `key`.
 *
 * @private
 * @name get
 * @memberOf ListCache
 * @param {string} key The key of the value to get.
 * @returns {*} Returns the entry value.
 */

function listCacheGet$1(key) {
    var data = this.__data__,
        index = assocIndexOf$1(data, key);
    return index < 0 ? undefined : data[index][1];
}

/**
 * Checks if a list cache value for `key` exists.
 *
 * @private
 * @name has
 * @memberOf ListCache
 * @param {string} key The key of the entry to check.
 * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
 */

function listCacheHas$1(key) {
    return assocIndexOf$1(this.__data__, key) > -1;
}

/**
 * Sets the list cache `key` to `value`.
 *
 * @private
 * @name set
 * @memberOf ListCache
 * @param {string} key The key of the value to set.
 * @param {*} value The value to set.
 * @returns {Object} Returns the list cache instance.
 */

function listCacheSet$1(key, value) {
    var data = this.__data__,
        index = assocIndexOf$1(data, key);

    if (index < 0) {
        ++this.size;
        data.push([key, value]);
    } else {
        data[index][1] = value;
    }

    return this;
}

/**
 * Creates an list cache object.
 *
 * @private
 * @constructor
 * @param {Array} [entries] The key-value pairs to cache.
 */

function ListCache$1(entries) {
    var index = -1,
        length = entries == null ? 0 : entries.length;
    this.clear();

    while (++index < length) {
        var entry = entries[index];
        this.set(entry[0], entry[1]);
    }
} // Add methods to `ListCache`.


ListCache$1.prototype.clear = listCacheClear$1;
ListCache$1.prototype['delete'] = listCacheDelete$1;
ListCache$1.prototype.get = listCacheGet$1;
ListCache$1.prototype.has = listCacheHas$1;
ListCache$1.prototype.set = listCacheSet$1;

/**
 * Removes all key-value entries from the stack.
 *
 * @private
 * @name clear
 * @memberOf Stack
 */

function stackClear$1() {
    this.__data__ = new ListCache$1();
    this.size = 0;
}

/**
 * Removes `key` and its value from the stack.
 *
 * @private
 * @name delete
 * @memberOf Stack
 * @param {string} key The key of the value to remove.
 * @returns {boolean} Returns `true` if the entry was removed, else `false`.
 */
function stackDelete$1(key) {
    var data = this.__data__,
        result = data['delete'](key);
    this.size = data.size;
    return result;
}

/**
 * Gets the stack value for `key`.
 *
 * @private
 * @name get
 * @memberOf Stack
 * @param {string} key The key of the value to get.
 * @returns {*} Returns the entry value.
 */
function stackGet$1(key) {
    return this.__data__.get(key);
}

/**
 * Checks if a stack value for `key` exists.
 *
 * @private
 * @name has
 * @memberOf Stack
 * @param {string} key The key of the entry to check.
 * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
 */
function stackHas$1(key) {
    return this.__data__.has(key);
}

/** Detect free variable `global` from Node.js. */
var freeGlobal$1 = (typeof global === "undefined" ? "undefined" : _typeof(global)) == 'object' && global && global.Object === Object && global;

/** Detect free variable `self`. */

var freeSelf$1 = (typeof self === "undefined" ? "undefined" : _typeof(self)) == 'object' && self && self.Object === Object && self;
/** Used as a reference to the global object. */

var root$1 = freeGlobal$1 || freeSelf$1 || Function('return this')();

/** Built-in value references. */

var _Symbol$1 = root$1.Symbol;

/** Used for built-in method references. */

var objectProto$e = Object.prototype;
/** Used to check objects for own properties. */

var hasOwnProperty$b = objectProto$e.hasOwnProperty;
/**
 * Used to resolve the
 * [`toStringTag`](http://ecma-international.org/ecma-262/7.0/#sec-object.prototype.tostring)
 * of values.
 */

var nativeObjectToString$2 = objectProto$e.toString;
/** Built-in value references. */

var symToStringTag$2 = _Symbol$1 ? _Symbol$1.toStringTag : undefined;
/**
 * A specialized version of `baseGetTag` which ignores `Symbol.toStringTag` values.
 *
 * @private
 * @param {*} value The value to query.
 * @returns {string} Returns the raw `toStringTag`.
 */

function getRawTag$1(value) {
    var isOwn = hasOwnProperty$b.call(value, symToStringTag$2),
        tag = value[symToStringTag$2];

    try {
        value[symToStringTag$2] = undefined;
        var unmasked = true;
    } catch (e) {}

    var result = nativeObjectToString$2.call(value);

    if (unmasked) {
        if (isOwn) {
            value[symToStringTag$2] = tag;
        } else {
            delete value[symToStringTag$2];
        }
    }

    return result;
}

/** Used for built-in method references. */
var objectProto$f = Object.prototype;
/**
 * Used to resolve the
 * [`toStringTag`](http://ecma-international.org/ecma-262/7.0/#sec-object.prototype.tostring)
 * of values.
 */

var nativeObjectToString$3 = objectProto$f.toString;
/**
 * Converts `value` to a string using `Object.prototype.toString`.
 *
 * @private
 * @param {*} value The value to convert.
 * @returns {string} Returns the converted string.
 */

function objectToString$1(value) {
    return nativeObjectToString$3.call(value);
}

/** `Object#toString` result references. */

var nullTag$1 = '[object Null]',
    undefinedTag$1 = '[object Undefined]';
/** Built-in value references. */

var symToStringTag$3 = _Symbol$1 ? _Symbol$1.toStringTag : undefined;
/**
 * The base implementation of `getTag` without fallbacks for buggy environments.
 *
 * @private
 * @param {*} value The value to query.
 * @returns {string} Returns the `toStringTag`.
 */

function baseGetTag$1(value) {
    if (value == null) {
        return value === undefined ? undefinedTag$1 : nullTag$1;
    }

    return symToStringTag$3 && symToStringTag$3 in Object(value) ? getRawTag$1(value) : objectToString$1(value);
}

/**
 * Checks if `value` is the
 * [language type](http://www.ecma-international.org/ecma-262/7.0/#sec-ecmascript-language-types)
 * of `Object`. (e.g. arrays, functions, objects, regexes, `new Number(0)`, and `new String('')`)
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is an object, else `false`.
 * @example
 *
 * _.isObject({});
 * // => true
 *
 * _.isObject([1, 2, 3]);
 * // => true
 *
 * _.isObject(_.noop);
 * // => true
 *
 * _.isObject(null);
 * // => false
 */
function isObject$3(value) {
    var type = _typeof(value);

    return value != null && (type == 'object' || type == 'function');
}

/** `Object#toString` result references. */

var asyncTag$1 = '[object AsyncFunction]',
    funcTag$3 = '[object Function]',
    genTag$2 = '[object GeneratorFunction]',
    proxyTag$1 = '[object Proxy]';
/**
 * Checks if `value` is classified as a `Function` object.
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a function, else `false`.
 * @example
 *
 * _.isFunction(_);
 * // => true
 *
 * _.isFunction(/abc/);
 * // => false
 */

function isFunction$2(value) {
    if (!isObject$3(value)) {
        return false;
    } // The use of `Object#toString` avoids issues with the `typeof` operator
    // in Safari 9 which returns 'object' for typed arrays and other constructors.


    var tag = baseGetTag$1(value);
    return tag == funcTag$3 || tag == genTag$2 || tag == asyncTag$1 || tag == proxyTag$1;
}

/** Used to detect overreaching core-js shims. */

var coreJsData$1 = root$1['__core-js_shared__'];

/** Used to detect methods masquerading as native. */

var maskSrcKey$1 = function () {
    var uid = /[^.]+$/.exec(coreJsData$1 && coreJsData$1.keys && coreJsData$1.keys.IE_PROTO || '');
    return uid ? 'Symbol(src)_1.' + uid : '';
}();
/**
 * Checks if `func` has its source masked.
 *
 * @private
 * @param {Function} func The function to check.
 * @returns {boolean} Returns `true` if `func` is masked, else `false`.
 */


function isMasked$1(func) {
    return !!maskSrcKey$1 && maskSrcKey$1 in func;
}

/** Used for built-in method references. */
var funcProto$3 = Function.prototype;
/** Used to resolve the decompiled source of functions. */

var funcToString$3 = funcProto$3.toString;
/**
 * Converts `func` to its source code.
 *
 * @private
 * @param {Function} func The function to convert.
 * @returns {string} Returns the source code.
 */

function toSource$1(func) {
    if (func != null) {
        try {
            return funcToString$3.call(func);
        } catch (e) {}

        try {
            return func + '';
        } catch (e) {}
    }

    return '';
}

/**
 * Used to match `RegExp`
 * [syntax characters](http://ecma-international.org/ecma-262/7.0/#sec-patterns).
 */

var reRegExpChar$1 = /[\\^$.*+?()[\]{}|]/g;
/** Used to detect host constructors (Safari). */

var reIsHostCtor$1 = /^\[object .+?Constructor\]$/;
/** Used for built-in method references. */

var funcProto$4 = Function.prototype,
    objectProto$g = Object.prototype;
/** Used to resolve the decompiled source of functions. */

var funcToString$4 = funcProto$4.toString;
/** Used to check objects for own properties. */

var hasOwnProperty$c = objectProto$g.hasOwnProperty;
/** Used to detect if a method is native. */

var reIsNative$1 = RegExp('^' + funcToString$4.call(hasOwnProperty$c).replace(reRegExpChar$1, '\\$&').replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, '$1.*?') + '$');
/**
 * The base implementation of `_.isNative` without bad shim checks.
 *
 * @private
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a native function,
 *  else `false`.
 */

function baseIsNative$1(value) {
    if (!isObject$3(value) || isMasked$1(value)) {
        return false;
    }

    var pattern = isFunction$2(value) ? reIsNative$1 : reIsHostCtor$1;
    return pattern.test(toSource$1(value));
}

/**
 * Gets the value at `key` of `object`.
 *
 * @private
 * @param {Object} [object] The object to query.
 * @param {string} key The key of the property to get.
 * @returns {*} Returns the property value.
 */
function getValue$1(object, key) {
    return object == null ? undefined : object[key];
}

/**
 * Gets the native function at `key` of `object`.
 *
 * @private
 * @param {Object} object The object to query.
 * @param {string} key The key of the method to get.
 * @returns {*} Returns the function if it's native, else `undefined`.
 */

function getNative$1(object, key) {
    var value = getValue$1(object, key);
    return baseIsNative$1(value) ? value : undefined;
}

/* Built-in method references that are verified to be native. */

var Map$4 = getNative$1(root$1, 'Map');

/* Built-in method references that are verified to be native. */

var nativeCreate$1 = getNative$1(Object, 'create');

/**
 * Removes all key-value entries from the hash.
 *
 * @private
 * @name clear
 * @memberOf Hash
 */

function hashClear$1() {
    this.__data__ = nativeCreate$1 ? nativeCreate$1(null) : {};
    this.size = 0;
}

/**
 * Removes `key` and its value from the hash.
 *
 * @private
 * @name delete
 * @memberOf Hash
 * @param {Object} hash The hash to modify.
 * @param {string} key The key of the value to remove.
 * @returns {boolean} Returns `true` if the entry was removed, else `false`.
 */
function hashDelete$1(key) {
    var result = this.has(key) && delete this.__data__[key];
    this.size -= result ? 1 : 0;
    return result;
}

/** Used to stand-in for `undefined` hash values. */

var HASH_UNDEFINED$2 = '__lodash_hash_undefined__';
/** Used for built-in method references. */

var objectProto$h = Object.prototype;
/** Used to check objects for own properties. */

var hasOwnProperty$d = objectProto$h.hasOwnProperty;
/**
 * Gets the hash value for `key`.
 *
 * @private
 * @name get
 * @memberOf Hash
 * @param {string} key The key of the value to get.
 * @returns {*} Returns the entry value.
 */

function hashGet$1(key) {
    var data = this.__data__;

    if (nativeCreate$1) {
        var result = data[key];
        return result === HASH_UNDEFINED$2 ? undefined : result;
    }

    return hasOwnProperty$d.call(data, key) ? data[key] : undefined;
}

/** Used for built-in method references. */

var objectProto$i = Object.prototype;
/** Used to check objects for own properties. */

var hasOwnProperty$e = objectProto$i.hasOwnProperty;
/**
 * Checks if a hash value for `key` exists.
 *
 * @private
 * @name has
 * @memberOf Hash
 * @param {string} key The key of the entry to check.
 * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
 */

function hashHas$1(key) {
    var data = this.__data__;
    return nativeCreate$1 ? data[key] !== undefined : hasOwnProperty$e.call(data, key);
}

/** Used to stand-in for `undefined` hash values. */

var HASH_UNDEFINED$3 = '__lodash_hash_undefined__';
/**
 * Sets the hash `key` to `value`.
 *
 * @private
 * @name set
 * @memberOf Hash
 * @param {string} key The key of the value to set.
 * @param {*} value The value to set.
 * @returns {Object} Returns the hash instance.
 */

function hashSet$1(key, value) {
    var data = this.__data__;
    this.size += this.has(key) ? 0 : 1;
    data[key] = nativeCreate$1 && value === undefined ? HASH_UNDEFINED$3 : value;
    return this;
}

/**
 * Creates a hash object.
 *
 * @private
 * @constructor
 * @param {Array} [entries] The key-value pairs to cache.
 */

function Hash$1(entries) {
    var index = -1,
        length = entries == null ? 0 : entries.length;
    this.clear();

    while (++index < length) {
        var entry = entries[index];
        this.set(entry[0], entry[1]);
    }
} // Add methods to `Hash`.


Hash$1.prototype.clear = hashClear$1;
Hash$1.prototype['delete'] = hashDelete$1;
Hash$1.prototype.get = hashGet$1;
Hash$1.prototype.has = hashHas$1;
Hash$1.prototype.set = hashSet$1;

/**
 * Removes all key-value entries from the map.
 *
 * @private
 * @name clear
 * @memberOf MapCache
 */

function mapCacheClear$1() {
    this.size = 0;
    this.__data__ = {
        'hash': new Hash$1(),
        'map': new (Map$4 || ListCache$1)(),
        'string': new Hash$1()
    };
}

/**
 * Checks if `value` is suitable for use as unique object key.
 *
 * @private
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is suitable, else `false`.
 */
function isKeyable$1(value) {
    var type = _typeof(value);

    return type == 'string' || type == 'number' || type == 'symbol' || type == 'boolean' ? value !== '__proto__' : value === null;
}

/**
 * Gets the data for `map`.
 *
 * @private
 * @param {Object} map The map to query.
 * @param {string} key The reference key.
 * @returns {*} Returns the map data.
 */

function getMapData$1(map, key) {
    var data = map.__data__;
    return isKeyable$1(key) ? data[typeof key == 'string' ? 'string' : 'hash'] : data.map;
}

/**
 * Removes `key` and its value from the map.
 *
 * @private
 * @name delete
 * @memberOf MapCache
 * @param {string} key The key of the value to remove.
 * @returns {boolean} Returns `true` if the entry was removed, else `false`.
 */

function mapCacheDelete$1(key) {
    var result = getMapData$1(this, key)['delete'](key);
    this.size -= result ? 1 : 0;
    return result;
}

/**
 * Gets the map value for `key`.
 *
 * @private
 * @name get
 * @memberOf MapCache
 * @param {string} key The key of the value to get.
 * @returns {*} Returns the entry value.
 */

function mapCacheGet$1(key) {
    return getMapData$1(this, key).get(key);
}

/**
 * Checks if a map value for `key` exists.
 *
 * @private
 * @name has
 * @memberOf MapCache
 * @param {string} key The key of the entry to check.
 * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
 */

function mapCacheHas$1(key) {
    return getMapData$1(this, key).has(key);
}

/**
 * Sets the map `key` to `value`.
 *
 * @private
 * @name set
 * @memberOf MapCache
 * @param {string} key The key of the value to set.
 * @param {*} value The value to set.
 * @returns {Object} Returns the map cache instance.
 */

function mapCacheSet$1(key, value) {
    var data = getMapData$1(this, key),
        size = data.size;
    data.set(key, value);
    this.size += data.size == size ? 0 : 1;
    return this;
}

/**
 * Creates a map cache object to store key-value pairs.
 *
 * @private
 * @constructor
 * @param {Array} [entries] The key-value pairs to cache.
 */

function MapCache$1(entries) {
    var index = -1,
        length = entries == null ? 0 : entries.length;
    this.clear();

    while (++index < length) {
        var entry = entries[index];
        this.set(entry[0], entry[1]);
    }
} // Add methods to `MapCache`.


MapCache$1.prototype.clear = mapCacheClear$1;
MapCache$1.prototype['delete'] = mapCacheDelete$1;
MapCache$1.prototype.get = mapCacheGet$1;
MapCache$1.prototype.has = mapCacheHas$1;
MapCache$1.prototype.set = mapCacheSet$1;

/** Used as the size to enable large array optimizations. */

var LARGE_ARRAY_SIZE$1 = 200;
/**
 * Sets the stack `key` to `value`.
 *
 * @private
 * @name set
 * @memberOf Stack
 * @param {string} key The key of the value to set.
 * @param {*} value The value to set.
 * @returns {Object} Returns the stack cache instance.
 */

function stackSet$1(key, value) {
    var data = this.__data__;

    if (data instanceof ListCache$1) {
        var pairs = data.__data__;

        if (!Map$4 || pairs.length < LARGE_ARRAY_SIZE$1 - 1) {
            pairs.push([key, value]);
            this.size = ++data.size;
            return this;
        }

        data = this.__data__ = new MapCache$1(pairs);
    }

    data.set(key, value);
    this.size = data.size;
    return this;
}

/**
 * Creates a stack cache object to store key-value pairs.
 *
 * @private
 * @constructor
 * @param {Array} [entries] The key-value pairs to cache.
 */

function Stack$1(entries) {
    var data = this.__data__ = new ListCache$1(entries);
    this.size = data.size;
} // Add methods to `Stack`.


Stack$1.prototype.clear = stackClear$1;
Stack$1.prototype['delete'] = stackDelete$1;
Stack$1.prototype.get = stackGet$1;
Stack$1.prototype.has = stackHas$1;
Stack$1.prototype.set = stackSet$1;

/** Used to stand-in for `undefined` hash values. */
var HASH_UNDEFINED$4 = '__lodash_hash_undefined__';
/**
 * Adds `value` to the array cache.
 *
 * @private
 * @name add
 * @memberOf SetCache
 * @alias push
 * @param {*} value The value to cache.
 * @returns {Object} Returns the cache instance.
 */

function setCacheAdd(value) {
    this.__data__.set(value, HASH_UNDEFINED$4);

    return this;
}

/**
 * Checks if `value` is in the array cache.
 *
 * @private
 * @name has
 * @memberOf SetCache
 * @param {*} value The value to search for.
 * @returns {number} Returns `true` if `value` is found, else `false`.
 */
function setCacheHas(value) {
    return this.__data__.has(value);
}

/**
 *
 * Creates an array cache object to store unique values.
 *
 * @private
 * @constructor
 * @param {Array} [values] The values to cache.
 */

function SetCache(values) {
    var index = -1,
        length = values == null ? 0 : values.length;
    this.__data__ = new MapCache$1();

    while (++index < length) {
        this.add(values[index]);
    }
} // Add methods to `SetCache`.


SetCache.prototype.add = SetCache.prototype.push = setCacheAdd;
SetCache.prototype.has = setCacheHas;

/**
 * A specialized version of `_.some` for arrays without support for iteratee
 * shorthands.
 *
 * @private
 * @param {Array} [array] The array to iterate over.
 * @param {Function} predicate The function invoked per iteration.
 * @returns {boolean} Returns `true` if any element passes the predicate check,
 *  else `false`.
 */
function arraySome(array, predicate) {
    var index = -1,
        length = array == null ? 0 : array.length;

    while (++index < length) {
        if (predicate(array[index], index, array)) {
            return true;
        }
    }

    return false;
}

/**
 * Checks if a `cache` value for `key` exists.
 *
 * @private
 * @param {Object} cache The cache to query.
 * @param {string} key The key of the entry to check.
 * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
 */
function cacheHas(cache, key) {
    return cache.has(key);
}

/** Used to compose bitmasks for value comparisons. */

var COMPARE_PARTIAL_FLAG = 1,
    COMPARE_UNORDERED_FLAG = 2;
/**
 * A specialized version of `baseIsEqualDeep` for arrays with support for
 * partial deep comparisons.
 *
 * @private
 * @param {Array} array The array to compare.
 * @param {Array} other The other array to compare.
 * @param {number} bitmask The bitmask flags. See `baseIsEqual` for more details.
 * @param {Function} customizer The function to customize comparisons.
 * @param {Function} equalFunc The function to determine equivalents of values.
 * @param {Object} stack Tracks traversed `array` and `other` objects.
 * @returns {boolean} Returns `true` if the arrays are equivalent, else `false`.
 */

function equalArrays(array, other, bitmask, customizer, equalFunc, stack) {
    var isPartial = bitmask & COMPARE_PARTIAL_FLAG,
        arrLength = array.length,
        othLength = other.length;

    if (arrLength != othLength && !(isPartial && othLength > arrLength)) {
        return false;
    } // Assume cyclic values are equal.


    var stacked = stack.get(array);

    if (stacked && stack.get(other)) {
        return stacked == other;
    }

    var index = -1,
        result = true,
        seen = bitmask & COMPARE_UNORDERED_FLAG ? new SetCache() : undefined;
    stack.set(array, other);
    stack.set(other, array); // Ignore non-index properties.

    while (++index < arrLength) {
        var arrValue = array[index],
            othValue = other[index];

        if (customizer) {
            var compared = isPartial ? customizer(othValue, arrValue, index, other, array, stack) : customizer(arrValue, othValue, index, array, other, stack);
        }

        if (compared !== undefined) {
            if (compared) {
                continue;
            }

            result = false;
            break;
        } // Recursively compare arrays (susceptible to call stack limits).


        if (seen) {
            if (!arraySome(other, function (othValue, othIndex) {
                if (!cacheHas(seen, othIndex) && (arrValue === othValue || equalFunc(arrValue, othValue, bitmask, customizer, stack))) {
                    return seen.push(othIndex);
                }
            })) {
                result = false;
                break;
            }
        } else if (!(arrValue === othValue || equalFunc(arrValue, othValue, bitmask, customizer, stack))) {
            result = false;
            break;
        }
    }

    stack['delete'](array);
    stack['delete'](other);
    return result;
}

/** Built-in value references. */

var Uint8Array$1 = root$1.Uint8Array;

/**
 * Converts `map` to its key-value pairs.
 *
 * @private
 * @param {Object} map The map to convert.
 * @returns {Array} Returns the key-value pairs.
 */
function mapToArray(map) {
    var index = -1,
        result = Array(map.size);
    map.forEach(function (value, key) {
        result[++index] = [key, value];
    });
    return result;
}

/**
 * Converts `set` to an array of its values.
 *
 * @private
 * @param {Object} set The set to convert.
 * @returns {Array} Returns the values.
 */
function setToArray(set) {
    var index = -1,
        result = Array(set.size);
    set.forEach(function (value) {
        result[++index] = value;
    });
    return result;
}

/** Used to compose bitmasks for value comparisons. */

var COMPARE_PARTIAL_FLAG$1 = 1,
    COMPARE_UNORDERED_FLAG$1 = 2;
/** `Object#toString` result references. */

var boolTag$3 = '[object Boolean]',
    dateTag$3 = '[object Date]',
    errorTag$2 = '[object Error]',
    mapTag$5 = '[object Map]',
    numberTag$3 = '[object Number]',
    regexpTag$3 = '[object RegExp]',
    setTag$5 = '[object Set]',
    stringTag$3 = '[object String]',
    symbolTag$3 = '[object Symbol]';
var arrayBufferTag$3 = '[object ArrayBuffer]',
    dataViewTag$4 = '[object DataView]';
/** Used to convert symbols to primitives and strings. */

var symbolProto$2 = _Symbol$1 ? _Symbol$1.prototype : undefined,
    symbolValueOf$1 = symbolProto$2 ? symbolProto$2.valueOf : undefined;
/**
 * A specialized version of `baseIsEqualDeep` for comparing objects of
 * the same `toStringTag`.
 *
 * **Note:** This function only supports comparing values with tags of
 * `Boolean`, `Date`, `Error`, `Number`, `RegExp`, or `String`.
 *
 * @private
 * @param {Object} object The object to compare.
 * @param {Object} other The other object to compare.
 * @param {string} tag The `toStringTag` of the objects to compare.
 * @param {number} bitmask The bitmask flags. See `baseIsEqual` for more details.
 * @param {Function} customizer The function to customize comparisons.
 * @param {Function} equalFunc The function to determine equivalents of values.
 * @param {Object} stack Tracks traversed `object` and `other` objects.
 * @returns {boolean} Returns `true` if the objects are equivalent, else `false`.
 */

function equalByTag(object, other, tag, bitmask, customizer, equalFunc, stack) {
    switch (tag) {
        case dataViewTag$4:
            if (object.byteLength != other.byteLength || object.byteOffset != other.byteOffset) {
                return false;
            }

            object = object.buffer;
            other = other.buffer;

        case arrayBufferTag$3:
            if (object.byteLength != other.byteLength || !equalFunc(new Uint8Array$1(object), new Uint8Array$1(other))) {
                return false;
            }

            return true;

        case boolTag$3:
        case dateTag$3:
        case numberTag$3:
            // Coerce booleans to `1` or `0` and dates to milliseconds.
            // Invalid dates are coerced to `NaN`.
            return eq$1(+object, +other);

        case errorTag$2:
            return object.name == other.name && object.message == other.message;

        case regexpTag$3:
        case stringTag$3:
            // Coerce regexes to strings and treat strings, primitives and objects,
            // as equal. See http://www.ecma-international.org/ecma-262/7.0/#sec-regexp.prototype.tostring
            // for more details.
            return object == other + '';

        case mapTag$5:
            var convert = mapToArray;

        case setTag$5:
            var isPartial = bitmask & COMPARE_PARTIAL_FLAG$1;
            convert || (convert = setToArray);

            if (object.size != other.size && !isPartial) {
                return false;
            } // Assume cyclic values are equal.


            var stacked = stack.get(object);

            if (stacked) {
                return stacked == other;
            }

            bitmask |= COMPARE_UNORDERED_FLAG$1; // Recursively compare objects (susceptible to call stack limits).

            stack.set(object, other);
            var result = equalArrays(convert(object), convert(other), bitmask, customizer, equalFunc, stack);
            stack['delete'](object);
            return result;

        case symbolTag$3:
            if (symbolValueOf$1) {
                return symbolValueOf$1.call(object) == symbolValueOf$1.call(other);
            }

    }

    return false;
}

/**
 * Appends the elements of `values` to `array`.
 *
 * @private
 * @param {Array} array The array to modify.
 * @param {Array} values The values to append.
 * @returns {Array} Returns `array`.
 */
function arrayPush$1(array, values) {
    var index = -1,
        length = values.length,
        offset = array.length;

    while (++index < length) {
        array[offset + index] = values[index];
    }

    return array;
}

/**
 * Checks if `value` is classified as an `Array` object.
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is an array, else `false`.
 * @example
 *
 * _.isArray([1, 2, 3]);
 * // => true
 *
 * _.isArray(document.body.children);
 * // => false
 *
 * _.isArray('abc');
 * // => false
 *
 * _.isArray(_.noop);
 * // => false
 */
var isArray$2 = Array.isArray;

/**
 * The base implementation of `getAllKeys` and `getAllKeysIn` which uses
 * `keysFunc` and `symbolsFunc` to get the enumerable property names and
 * symbols of `object`.
 *
 * @private
 * @param {Object} object The object to query.
 * @param {Function} keysFunc The function to get the keys of `object`.
 * @param {Function} symbolsFunc The function to get the symbols of `object`.
 * @returns {Array} Returns the array of property names and symbols.
 */

function baseGetAllKeys$1(object, keysFunc, symbolsFunc) {
    var result = keysFunc(object);
    return isArray$2(object) ? result : arrayPush$1(result, symbolsFunc(object));
}

/**
 * A specialized version of `_.filter` for arrays without support for
 * iteratee shorthands.
 *
 * @private
 * @param {Array} [array] The array to iterate over.
 * @param {Function} predicate The function invoked per iteration.
 * @returns {Array} Returns the new filtered array.
 */
function arrayFilter$1(array, predicate) {
    var index = -1,
        length = array == null ? 0 : array.length,
        resIndex = 0,
        result = [];

    while (++index < length) {
        var value = array[index];

        if (predicate(value, index, array)) {
            result[resIndex++] = value;
        }
    }

    return result;
}

/**
 * This method returns a new empty array.
 *
 * @static
 * @memberOf _
 * @since 4.13.0
 * @category Util
 * @returns {Array} Returns the new empty array.
 * @example
 *
 * var arrays = _.times(2, _.stubArray);
 *
 * console.log(arrays);
 * // => [[], []]
 *
 * console.log(arrays[0] === arrays[1]);
 * // => false
 */
function stubArray$1() {
    return [];
}

/** Used for built-in method references. */

var objectProto$j = Object.prototype;
/** Built-in value references. */

var propertyIsEnumerable$2 = objectProto$j.propertyIsEnumerable;
/* Built-in method references for those with the same name as other `lodash` methods. */

var nativeGetSymbols$2 = Object.getOwnPropertySymbols;
/**
 * Creates an array of the own enumerable symbols of `object`.
 *
 * @private
 * @param {Object} object The object to query.
 * @returns {Array} Returns the array of symbols.
 */

var getSymbols$1 = !nativeGetSymbols$2 ? stubArray$1 : function (object) {
    if (object == null) {
        return [];
    }

    object = Object(object);
    return arrayFilter$1(nativeGetSymbols$2(object), function (symbol) {
        return propertyIsEnumerable$2.call(object, symbol);
    });
};

/**
 * The base implementation of `_.times` without support for iteratee shorthands
 * or max array length checks.
 *
 * @private
 * @param {number} n The number of times to invoke `iteratee`.
 * @param {Function} iteratee The function invoked per iteration.
 * @returns {Array} Returns the array of results.
 */
function baseTimes$1(n, iteratee) {
    var index = -1,
        result = Array(n);

    while (++index < n) {
        result[index] = iteratee(index);
    }

    return result;
}

/**
 * Checks if `value` is object-like. A value is object-like if it's not `null`
 * and has a `typeof` result of "object".
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is object-like, else `false`.
 * @example
 *
 * _.isObjectLike({});
 * // => true
 *
 * _.isObjectLike([1, 2, 3]);
 * // => true
 *
 * _.isObjectLike(_.noop);
 * // => false
 *
 * _.isObjectLike(null);
 * // => false
 */
function isObjectLike$1(value) {
    return value != null && _typeof(value) == 'object';
}

/** `Object#toString` result references. */

var argsTag$3 = '[object Arguments]';
/**
 * The base implementation of `_.isArguments`.
 *
 * @private
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is an `arguments` object,
 */

function baseIsArguments$1(value) {
    return isObjectLike$1(value) && baseGetTag$1(value) == argsTag$3;
}

/** Used for built-in method references. */

var objectProto$k = Object.prototype;
/** Used to check objects for own properties. */

var hasOwnProperty$f = objectProto$k.hasOwnProperty;
/** Built-in value references. */

var propertyIsEnumerable$3 = objectProto$k.propertyIsEnumerable;
/**
 * Checks if `value` is likely an `arguments` object.
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is an `arguments` object,
 *  else `false`.
 * @example
 *
 * _.isArguments(function() { return arguments; }());
 * // => true
 *
 * _.isArguments([1, 2, 3]);
 * // => false
 */

var isArguments$1 = baseIsArguments$1(function () {
    return arguments;
}()) ? baseIsArguments$1 : function (value) {
    return isObjectLike$1(value) && hasOwnProperty$f.call(value, 'callee') && !propertyIsEnumerable$3.call(value, 'callee');
};

/**
 * This method returns `false`.
 *
 * @static
 * @memberOf _
 * @since 4.13.0
 * @category Util
 * @returns {boolean} Returns `false`.
 * @example
 *
 * _.times(2, _.stubFalse);
 * // => [false, false]
 */
function stubFalse$1() {
    return false;
}

/** Detect free variable `exports`. */

var freeExports$3 = (typeof exports === "undefined" ? "undefined" : _typeof(exports)) == 'object' && exports && !exports.nodeType && exports;
/** Detect free variable `module`. */

var freeModule$3 = freeExports$3 && (typeof module === "undefined" ? "undefined" : _typeof(module)) == 'object' && module && !module.nodeType && module;
/** Detect the popular CommonJS extension `module.exports`. */

var moduleExports$3 = freeModule$3 && freeModule$3.exports === freeExports$3;
/** Built-in value references. */

var Buffer$2 = moduleExports$3 ? root$1.Buffer : undefined;
/* Built-in method references for those with the same name as other `lodash` methods. */

var nativeIsBuffer$1 = Buffer$2 ? Buffer$2.isBuffer : undefined;
/**
 * Checks if `value` is a buffer.
 *
 * @static
 * @memberOf _
 * @since 4.3.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a buffer, else `false`.
 * @example
 *
 * _.isBuffer(new Buffer(2));
 * // => true
 *
 * _.isBuffer(new Uint8Array(2));
 * // => false
 */

var isBuffer$1 = nativeIsBuffer$1 || stubFalse$1;

/** Used as references for various `Number` constants. */
var MAX_SAFE_INTEGER$2 = 9007199254740991;
/** Used to detect unsigned integer values. */

var reIsUint$1 = /^(?:0|[1-9]\d*)$/;
/**
 * Checks if `value` is a valid array-like index.
 *
 * @private
 * @param {*} value The value to check.
 * @param {number} [length=MAX_SAFE_INTEGER] The upper bounds of a valid index.
 * @returns {boolean} Returns `true` if `value` is a valid index, else `false`.
 */

function isIndex$1(value, length) {
    var type = _typeof(value);

    length = length == null ? MAX_SAFE_INTEGER$2 : length;
    return !!length && (type == 'number' || type != 'symbol' && reIsUint$1.test(value)) && value > -1 && value % 1 == 0 && value < length;
}

/** Used as references for various `Number` constants. */
var MAX_SAFE_INTEGER$3 = 9007199254740991;
/**
 * Checks if `value` is a valid array-like length.
 *
 * **Note:** This method is loosely based on
 * [`ToLength`](http://ecma-international.org/ecma-262/7.0/#sec-tolength).
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a valid length, else `false`.
 * @example
 *
 * _.isLength(3);
 * // => true
 *
 * _.isLength(Number.MIN_VALUE);
 * // => false
 *
 * _.isLength(Infinity);
 * // => false
 *
 * _.isLength('3');
 * // => false
 */

function isLength$1(value) {
    return typeof value == 'number' && value > -1 && value % 1 == 0 && value <= MAX_SAFE_INTEGER$3;
}

/** `Object#toString` result references. */

var argsTag$4 = '[object Arguments]',
    arrayTag$2 = '[object Array]',
    boolTag$4 = '[object Boolean]',
    dateTag$4 = '[object Date]',
    errorTag$3 = '[object Error]',
    funcTag$4 = '[object Function]',
    mapTag$6 = '[object Map]',
    numberTag$4 = '[object Number]',
    objectTag$4 = '[object Object]',
    regexpTag$4 = '[object RegExp]',
    setTag$6 = '[object Set]',
    stringTag$4 = '[object String]',
    weakMapTag$3 = '[object WeakMap]';
var arrayBufferTag$4 = '[object ArrayBuffer]',
    dataViewTag$5 = '[object DataView]',
    float32Tag$3 = '[object Float32Array]',
    float64Tag$3 = '[object Float64Array]',
    int8Tag$3 = '[object Int8Array]',
    int16Tag$3 = '[object Int16Array]',
    int32Tag$3 = '[object Int32Array]',
    uint8Tag$3 = '[object Uint8Array]',
    uint8ClampedTag$3 = '[object Uint8ClampedArray]',
    uint16Tag$3 = '[object Uint16Array]',
    uint32Tag$3 = '[object Uint32Array]';
/** Used to identify `toStringTag` values of typed arrays. */

var typedArrayTags$1 = {};
typedArrayTags$1[float32Tag$3] = typedArrayTags$1[float64Tag$3] = typedArrayTags$1[int8Tag$3] = typedArrayTags$1[int16Tag$3] = typedArrayTags$1[int32Tag$3] = typedArrayTags$1[uint8Tag$3] = typedArrayTags$1[uint8ClampedTag$3] = typedArrayTags$1[uint16Tag$3] = typedArrayTags$1[uint32Tag$3] = true;
typedArrayTags$1[argsTag$4] = typedArrayTags$1[arrayTag$2] = typedArrayTags$1[arrayBufferTag$4] = typedArrayTags$1[boolTag$4] = typedArrayTags$1[dataViewTag$5] = typedArrayTags$1[dateTag$4] = typedArrayTags$1[errorTag$3] = typedArrayTags$1[funcTag$4] = typedArrayTags$1[mapTag$6] = typedArrayTags$1[numberTag$4] = typedArrayTags$1[objectTag$4] = typedArrayTags$1[regexpTag$4] = typedArrayTags$1[setTag$6] = typedArrayTags$1[stringTag$4] = typedArrayTags$1[weakMapTag$3] = false;
/**
 * The base implementation of `_.isTypedArray` without Node.js optimizations.
 *
 * @private
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a typed array, else `false`.
 */

function baseIsTypedArray$1(value) {
    return isObjectLike$1(value) && isLength$1(value.length) && !!typedArrayTags$1[baseGetTag$1(value)];
}

/**
 * The base implementation of `_.unary` without support for storing metadata.
 *
 * @private
 * @param {Function} func The function to cap arguments for.
 * @returns {Function} Returns the new capped function.
 */
function baseUnary$1(func) {
    return function (value) {
        return func(value);
    };
}

/** Detect free variable `exports`. */

var freeExports$4 = (typeof exports === "undefined" ? "undefined" : _typeof(exports)) == 'object' && exports && !exports.nodeType && exports;
/** Detect free variable `module`. */

var freeModule$4 = freeExports$4 && (typeof module === "undefined" ? "undefined" : _typeof(module)) == 'object' && module && !module.nodeType && module;
/** Detect the popular CommonJS extension `module.exports`. */

var moduleExports$4 = freeModule$4 && freeModule$4.exports === freeExports$4;
/** Detect free variable `process` from Node.js. */

var freeProcess$1 = moduleExports$4 && freeGlobal$1.process;
/** Used to access faster Node.js helpers. */

var nodeUtil$1 = function () {
    try {
        // Use `util.types` for Node.js 10+.
        var types = freeModule$4 && freeModule$4.require && freeModule$4.require('util').types;

        if (types) {
            return types;
        } // Legacy `process.binding('util')` for Node.js < 10.


        return freeProcess$1 && freeProcess$1.binding && freeProcess$1.binding('util');
    } catch (e) {}
}();

/* Node.js helper references. */

var nodeIsTypedArray$1 = nodeUtil$1 && nodeUtil$1.isTypedArray;
/**
 * Checks if `value` is classified as a typed array.
 *
 * @static
 * @memberOf _
 * @since 3.0.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a typed array, else `false`.
 * @example
 *
 * _.isTypedArray(new Uint8Array);
 * // => true
 *
 * _.isTypedArray([]);
 * // => false
 */

var isTypedArray$1 = nodeIsTypedArray$1 ? baseUnary$1(nodeIsTypedArray$1) : baseIsTypedArray$1;

/** Used for built-in method references. */

var objectProto$l = Object.prototype;
/** Used to check objects for own properties. */

var hasOwnProperty$g = objectProto$l.hasOwnProperty;
/**
 * Creates an array of the enumerable property names of the array-like `value`.
 *
 * @private
 * @param {*} value The value to query.
 * @param {boolean} inherited Specify returning inherited property names.
 * @returns {Array} Returns the array of property names.
 */

function arrayLikeKeys$1(value, inherited) {
    var isArr = isArray$2(value),
        isArg = !isArr && isArguments$1(value),
        isBuff = !isArr && !isArg && isBuffer$1(value),
        isType = !isArr && !isArg && !isBuff && isTypedArray$1(value),
        skipIndexes = isArr || isArg || isBuff || isType,
        result = skipIndexes ? baseTimes$1(value.length, String) : [],
        length = result.length;

    for (var key in value) {
        if ((inherited || hasOwnProperty$g.call(value, key)) && !(skipIndexes && ( // Safari 9 has enumerable `arguments.length` in strict mode.
        key == 'length' || // Node.js 0.10 has enumerable non-index properties on buffers.
        isBuff && (key == 'offset' || key == 'parent') || // PhantomJS 2 has enumerable non-index properties on typed arrays.
        isType && (key == 'buffer' || key == 'byteLength' || key == 'byteOffset') || // Skip index properties.
        isIndex$1(key, length)))) {
            result.push(key);
        }
    }

    return result;
}

/** Used for built-in method references. */
var objectProto$m = Object.prototype;
/**
 * Checks if `value` is likely a prototype object.
 *
 * @private
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a prototype, else `false`.
 */

function isPrototype$1(value) {
    var Ctor = value && value.constructor,
        proto = typeof Ctor == 'function' && Ctor.prototype || objectProto$m;
    return value === proto;
}

/**
 * Creates a unary function that invokes `func` with its argument transformed.
 *
 * @private
 * @param {Function} func The function to wrap.
 * @param {Function} transform The argument transform.
 * @returns {Function} Returns the new function.
 */
function overArg$1(func, transform) {
    return function (arg) {
        return func(transform(arg));
    };
}

/* Built-in method references for those with the same name as other `lodash` methods. */

var nativeKeys$1 = overArg$1(Object.keys, Object);

/** Used for built-in method references. */

var objectProto$n = Object.prototype;
/** Used to check objects for own properties. */

var hasOwnProperty$h = objectProto$n.hasOwnProperty;
/**
 * The base implementation of `_.keys` which doesn't treat sparse arrays as dense.
 *
 * @private
 * @param {Object} object The object to query.
 * @returns {Array} Returns the array of property names.
 */

function baseKeys$1(object) {
    if (!isPrototype$1(object)) {
        return nativeKeys$1(object);
    }

    var result = [];

    for (var key in Object(object)) {
        if (hasOwnProperty$h.call(object, key) && key != 'constructor') {
            result.push(key);
        }
    }

    return result;
}

/**
 * Checks if `value` is array-like. A value is considered array-like if it's
 * not a function and has a `value.length` that's an integer greater than or
 * equal to `0` and less than or equal to `Number.MAX_SAFE_INTEGER`.
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is array-like, else `false`.
 * @example
 *
 * _.isArrayLike([1, 2, 3]);
 * // => true
 *
 * _.isArrayLike(document.body.children);
 * // => true
 *
 * _.isArrayLike('abc');
 * // => true
 *
 * _.isArrayLike(_.noop);
 * // => false
 */

function isArrayLike$1(value) {
    return value != null && isLength$1(value.length) && !isFunction$2(value);
}

/**
 * Creates an array of the own enumerable property names of `object`.
 *
 * **Note:** Non-object values are coerced to objects. See the
 * [ES spec](http://ecma-international.org/ecma-262/7.0/#sec-object.keys)
 * for more details.
 *
 * @static
 * @since 0.1.0
 * @memberOf _
 * @category Object
 * @param {Object} object The object to query.
 * @returns {Array} Returns the array of property names.
 * @example
 *
 * function Foo() {
 *   this.a = 1;
 *   this.b = 2;
 * }
 *
 * Foo.prototype.c = 3;
 *
 * _.keys(new Foo);
 * // => ['a', 'b'] (iteration order is not guaranteed)
 *
 * _.keys('hi');
 * // => ['0', '1']
 */

function keys$1(object) {
    return isArrayLike$1(object) ? arrayLikeKeys$1(object) : baseKeys$1(object);
}

/**
 * Creates an array of own enumerable property names and symbols of `object`.
 *
 * @private
 * @param {Object} object The object to query.
 * @returns {Array} Returns the array of property names and symbols.
 */

function getAllKeys$1(object) {
    return baseGetAllKeys$1(object, keys$1, getSymbols$1);
}

/** Used to compose bitmasks for value comparisons. */

var COMPARE_PARTIAL_FLAG$2 = 1;
/** Used for built-in method references. */

var objectProto$o = Object.prototype;
/** Used to check objects for own properties. */

var hasOwnProperty$i = objectProto$o.hasOwnProperty;
/**
 * A specialized version of `baseIsEqualDeep` for objects with support for
 * partial deep comparisons.
 *
 * @private
 * @param {Object} object The object to compare.
 * @param {Object} other The other object to compare.
 * @param {number} bitmask The bitmask flags. See `baseIsEqual` for more details.
 * @param {Function} customizer The function to customize comparisons.
 * @param {Function} equalFunc The function to determine equivalents of values.
 * @param {Object} stack Tracks traversed `object` and `other` objects.
 * @returns {boolean} Returns `true` if the objects are equivalent, else `false`.
 */

function equalObjects(object, other, bitmask, customizer, equalFunc, stack) {
    var isPartial = bitmask & COMPARE_PARTIAL_FLAG$2,
        objProps = getAllKeys$1(object),
        objLength = objProps.length,
        othProps = getAllKeys$1(other),
        othLength = othProps.length;

    if (objLength != othLength && !isPartial) {
        return false;
    }

    var index = objLength;

    while (index--) {
        var key = objProps[index];

        if (!(isPartial ? key in other : hasOwnProperty$i.call(other, key))) {
            return false;
        }
    } // Assume cyclic values are equal.


    var stacked = stack.get(object);

    if (stacked && stack.get(other)) {
        return stacked == other;
    }

    var result = true;
    stack.set(object, other);
    stack.set(other, object);
    var skipCtor = isPartial;

    while (++index < objLength) {
        key = objProps[index];
        var objValue = object[key],
            othValue = other[key];

        if (customizer) {
            var compared = isPartial ? customizer(othValue, objValue, key, other, object, stack) : customizer(objValue, othValue, key, object, other, stack);
        } // Recursively compare objects (susceptible to call stack limits).


        if (!(compared === undefined ? objValue === othValue || equalFunc(objValue, othValue, bitmask, customizer, stack) : compared)) {
            result = false;
            break;
        }

        skipCtor || (skipCtor = key == 'constructor');
    }

    if (result && !skipCtor) {
        var objCtor = object.constructor,
            othCtor = other.constructor; // Non `Object` object instances with different constructors are not equal.

        if (objCtor != othCtor && 'constructor' in object && 'constructor' in other && !(typeof objCtor == 'function' && objCtor instanceof objCtor && typeof othCtor == 'function' && othCtor instanceof othCtor)) {
            result = false;
        }
    }

    stack['delete'](object);
    stack['delete'](other);
    return result;
}

/* Built-in method references that are verified to be native. */

var DataView$1 = getNative$1(root$1, 'DataView');

/* Built-in method references that are verified to be native. */

var Promise$2 = getNative$1(root$1, 'Promise');

/* Built-in method references that are verified to be native. */

var Set$1 = getNative$1(root$1, 'Set');

/* Built-in method references that are verified to be native. */

var WeakMap$2 = getNative$1(root$1, 'WeakMap');

/** `Object#toString` result references. */

var mapTag$7 = '[object Map]',
    objectTag$5 = '[object Object]',
    promiseTag$1 = '[object Promise]',
    setTag$7 = '[object Set]',
    weakMapTag$4 = '[object WeakMap]';
var dataViewTag$6 = '[object DataView]';
/** Used to detect maps, sets, and weakmaps. */

var dataViewCtorString$1 = toSource$1(DataView$1),
    mapCtorString$1 = toSource$1(Map$4),
    promiseCtorString$1 = toSource$1(Promise$2),
    setCtorString$1 = toSource$1(Set$1),
    weakMapCtorString$1 = toSource$1(WeakMap$2);
/**
 * Gets the `toStringTag` of `value`.
 *
 * @private
 * @param {*} value The value to query.
 * @returns {string} Returns the `toStringTag`.
 */

var getTag$2 = baseGetTag$1; // Fallback for data views, maps, sets, and weak maps in IE 11 and promises in Node.js < 6.

if (DataView$1 && getTag$2(new DataView$1(new ArrayBuffer(1))) != dataViewTag$6 || Map$4 && getTag$2(new Map$4()) != mapTag$7 || Promise$2 && getTag$2(Promise$2.resolve()) != promiseTag$1 || Set$1 && getTag$2(new Set$1()) != setTag$7 || WeakMap$2 && getTag$2(new WeakMap$2()) != weakMapTag$4) {
    getTag$2 = function getTag(value) {
        var result = baseGetTag$1(value),
            Ctor = result == objectTag$5 ? value.constructor : undefined,
            ctorString = Ctor ? toSource$1(Ctor) : '';

        if (ctorString) {
            switch (ctorString) {
                case dataViewCtorString$1:
                    return dataViewTag$6;

                case mapCtorString$1:
                    return mapTag$7;

                case promiseCtorString$1:
                    return promiseTag$1;

                case setCtorString$1:
                    return setTag$7;

                case weakMapCtorString$1:
                    return weakMapTag$4;
            }
        }

        return result;
    };
}

var getTag$3 = getTag$2;

/** Used to compose bitmasks for value comparisons. */

var COMPARE_PARTIAL_FLAG$3 = 1;
/** `Object#toString` result references. */

var argsTag$5 = '[object Arguments]',
    arrayTag$3 = '[object Array]',
    objectTag$6 = '[object Object]';
/** Used for built-in method references. */

var objectProto$p = Object.prototype;
/** Used to check objects for own properties. */

var hasOwnProperty$j = objectProto$p.hasOwnProperty;
/**
 * A specialized version of `baseIsEqual` for arrays and objects which performs
 * deep comparisons and tracks traversed objects enabling objects with circular
 * references to be compared.
 *
 * @private
 * @param {Object} object The object to compare.
 * @param {Object} other The other object to compare.
 * @param {number} bitmask The bitmask flags. See `baseIsEqual` for more details.
 * @param {Function} customizer The function to customize comparisons.
 * @param {Function} equalFunc The function to determine equivalents of values.
 * @param {Object} [stack] Tracks traversed `object` and `other` objects.
 * @returns {boolean} Returns `true` if the objects are equivalent, else `false`.
 */

function baseIsEqualDeep(object, other, bitmask, customizer, equalFunc, stack) {
    var objIsArr = isArray$2(object),
        othIsArr = isArray$2(other),
        objTag = objIsArr ? arrayTag$3 : getTag$3(object),
        othTag = othIsArr ? arrayTag$3 : getTag$3(other);
    objTag = objTag == argsTag$5 ? objectTag$6 : objTag;
    othTag = othTag == argsTag$5 ? objectTag$6 : othTag;
    var objIsObj = objTag == objectTag$6,
        othIsObj = othTag == objectTag$6,
        isSameTag = objTag == othTag;

    if (isSameTag && isBuffer$1(object)) {
        if (!isBuffer$1(other)) {
            return false;
        }

        objIsArr = true;
        objIsObj = false;
    }

    if (isSameTag && !objIsObj) {
        stack || (stack = new Stack$1());
        return objIsArr || isTypedArray$1(object) ? equalArrays(object, other, bitmask, customizer, equalFunc, stack) : equalByTag(object, other, objTag, bitmask, customizer, equalFunc, stack);
    }

    if (!(bitmask & COMPARE_PARTIAL_FLAG$3)) {
        var objIsWrapped = objIsObj && hasOwnProperty$j.call(object, '__wrapped__'),
            othIsWrapped = othIsObj && hasOwnProperty$j.call(other, '__wrapped__');

        if (objIsWrapped || othIsWrapped) {
            var objUnwrapped = objIsWrapped ? object.value() : object,
                othUnwrapped = othIsWrapped ? other.value() : other;
            stack || (stack = new Stack$1());
            return equalFunc(objUnwrapped, othUnwrapped, bitmask, customizer, stack);
        }
    }

    if (!isSameTag) {
        return false;
    }

    stack || (stack = new Stack$1());
    return equalObjects(object, other, bitmask, customizer, equalFunc, stack);
}

/**
 * The base implementation of `_.isEqual` which supports partial comparisons
 * and tracks traversed objects.
 *
 * @private
 * @param {*} value The value to compare.
 * @param {*} other The other value to compare.
 * @param {boolean} bitmask The bitmask flags.
 *  1 - Unordered comparison
 *  2 - Partial comparison
 * @param {Function} [customizer] The function to customize comparisons.
 * @param {Object} [stack] Tracks traversed `value` and `other` objects.
 * @returns {boolean} Returns `true` if the values are equivalent, else `false`.
 */

function baseIsEqual(value, other, bitmask, customizer, stack) {
    if (value === other) {
        return true;
    }

    if (value == null || other == null || !isObjectLike$1(value) && !isObjectLike$1(other)) {
        return value !== value && other !== other;
    }

    return baseIsEqualDeep(value, other, bitmask, customizer, baseIsEqual, stack);
}

/**
 * Performs a deep comparison between two values to determine if they are
 * equivalent.
 *
 * **Note:** This method supports comparing arrays, array buffers, booleans,
 * date objects, error objects, maps, numbers, `Object` objects, regexes,
 * sets, strings, symbols, and typed arrays. `Object` objects are compared
 * by their own, not inherited, enumerable properties. Functions and DOM
 * nodes are compared by strict equality, i.e. `===`.
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Lang
 * @param {*} value The value to compare.
 * @param {*} other The other value to compare.
 * @returns {boolean} Returns `true` if the values are equivalent, else `false`.
 * @example
 *
 * var object = { 'a': 1 };
 * var other = { 'a': 1 };
 *
 * _.isEqual(object, other);
 * // => true
 *
 * object === other;
 * // => false
 */

function isEqual(value, other) {
    return baseIsEqual(value, other);
}

function _objectSpread(target) {
    for (var i = 1; i < arguments.length; i++) {
        var source = arguments[i] != null ? arguments[i] : {};
        var ownKeys = Object.keys(source);

        if (typeof Object.getOwnPropertySymbols === 'function') {
            ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) {
                return Object.getOwnPropertyDescriptor(source, sym).enumerable;
            }));
        }

        ownKeys.forEach(function (key) {
            _defineProperty$2(target, key, source[key]);
        });
    }

    return target;
}

function _typeof$1(obj) {
    if (typeof Symbol === "function" && _typeof(Symbol.iterator) === "symbol") {
        _typeof$1 = function _typeof$1(obj) {
            return _typeof(obj);
        };
    } else {
        _typeof$1 = function _typeof$1(obj) {
            return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : _typeof(obj);
        };
    }

    return _typeof$1(obj);
}

function _classCallCheck$1(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
    }
}

function _defineProperties$2(target, props) {
    for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor) descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
    }
}

function _createClass$2(Constructor, protoProps, staticProps) {
    if (protoProps) _defineProperties$2(Constructor.prototype, protoProps);
    if (staticProps) _defineProperties$2(Constructor, staticProps);
    return Constructor;
}

function _possibleConstructorReturn$1(self, call) {
    if (call && (_typeof$1(call) === "object" || typeof call === "function")) {
        return call;
    }

    return _assertThisInitialized$3(self);
}

function _get(target, property, receiver) {
    if (typeof Reflect !== "undefined" && Reflect.get) {
        _get = Reflect.get;
    } else {
        _get = function _get(target, property, receiver) {
            var base = _superPropBase(target, property);

            if (!base) return;
            var desc = Object.getOwnPropertyDescriptor(base, property);

            if (desc.get) {
                return desc.get.call(receiver);
            }

            return desc.value;
        };
    }

    return _get(target, property, receiver || target);
}

function _superPropBase(object, property) {
    while (!Object.prototype.hasOwnProperty.call(object, property)) {
        object = _getPrototypeOf$1(object);
        if (object === null) break;
    }

    return object;
}

function _getPrototypeOf$1(o) {
    _getPrototypeOf$1 = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
        return o.__proto__ || Object.getPrototypeOf(o);
    };
    return _getPrototypeOf$1(o);
}

function _inherits$1(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
        throw new TypeError("Super expression must either be null or a function");
    }

    subClass.prototype = Object.create(superClass && superClass.prototype, {
        constructor: {
            value: subClass,
            writable: true,
            configurable: true
        }
    });
    if (superClass) _setPrototypeOf$1(subClass, superClass);
}

function _setPrototypeOf$1(o, p) {
    _setPrototypeOf$1 = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
        o.__proto__ = p;
        return o;
    };

    return _setPrototypeOf$1(o, p);
}

function _assertThisInitialized$3(self) {
    if (self === void 0) {
        throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }

    return self;
}

function _defineProperty$2(obj, key, value) {
    if (key in obj) {
        Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
        });
    } else {
        obj[key] = value;
    }

    return obj;
}
var eventHandlers = {
    onEdited: 'draw:edited',
    onDrawStart: 'draw:drawstart',
    onDrawStop: 'draw:drawstop',
    onDrawVertex: 'draw:drawvertex',
    onEditStart: 'draw:editstart',
    onEditMove: 'draw:editmove',
    onEditResize: 'draw:editresize',
    onEditVertex: 'draw:editvertex',
    onEditStop: 'draw:editstop',
    onDeleted: 'draw:deleted',
    onDeleteStart: 'draw:deletestart',
    onDeleteStop: 'draw:deletestop'
};

var EditControl = /*#__PURE__*/function (_MapControl) {
    _inherits$1(EditControl, _MapControl);

    function EditControl() {
        var _getPrototypeOf2;

        var _this;

        _classCallCheck$1(this, EditControl);

        for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
        }

        _this = _possibleConstructorReturn$1(this, (_getPrototypeOf2 = _getPrototypeOf$1(EditControl)).call.apply(_getPrototypeOf2, [this].concat(args)));

        _defineProperty$2(_assertThisInitialized$3(_assertThisInitialized$3(_this)), "onDrawCreate", function (e) {
            var onCreated = _this.props.onCreated;
            var layerContainer = _this.props.leaflet.layerContainer;
            layerContainer.addLayer(e.layer);
            onCreated && onCreated(e);
        });

        return _this;
    }

    _createClass$2(EditControl, [{
        key: "createLeafletElement",
        value: function createLeafletElement(props) {
            return createDrawElement(props);
        }
    }, {
        key: "componentDidMount",
        value: function componentDidMount() {
            _get(_getPrototypeOf$1(EditControl.prototype), "componentDidMount", this).call(this);

            var map = this.props.leaflet.map;
            var onMounted = this.props.onMounted;

            for (var key in eventHandlers) {
                if (this.props[key]) {
                    map.on(eventHandlers[key], this.props[key]);
                }
            }

            map.on(L__default['default'].Draw.Event.CREATED, this.onDrawCreate);
            onMounted && onMounted(this.leafletElement);
        }
    }, {
        key: "componentWillUnmount",
        value: function componentWillUnmount() {
            _get(_getPrototypeOf$1(EditControl.prototype), "componentWillUnmount", this).call(this);

            var map = this.props.leaflet.map;
            map.off(L__default['default'].Draw.Event.CREATED, this.onDrawCreate);

            for (var key in eventHandlers) {
                if (this.props[key]) {
                    map.off(eventHandlers[key], this.props[key]);
                }
            }
        }
    }, {
        key: "componentDidUpdate",
        value: function componentDidUpdate(prevProps) {
            // super updates positions if thats all that changed so call this first
            _get(_getPrototypeOf$1(EditControl.prototype), "componentDidUpdate", this).call(this, prevProps);

            if (isEqual(this.props.draw, prevProps.draw) || this.props.position !== prevProps.position) {
                return false;
            }

            var map = this.props.leaflet.map;
            this.leafletElement.remove(map);
            this.leafletElement = createDrawElement(this.props);
            this.leafletElement.addTo(map);
            return null;
        }
    }]);

    return EditControl;
}(MapControl);

_defineProperty$2(EditControl, "propTypes", _objectSpread({}, Object.keys(eventHandlers).reduce(function (acc, val) {
    acc[val] = PropTypes.PropTypes.func;
    return acc;
}, {}), {
    onCreated: PropTypes.PropTypes.func,
    onMounted: PropTypes.PropTypes.func,
    draw: PropTypes.PropTypes.shape({
        polyline: PropTypes.PropTypes.oneOfType([PropTypes.PropTypes.object, PropTypes.PropTypes.bool]),
        polygon: PropTypes.PropTypes.oneOfType([PropTypes.PropTypes.object, PropTypes.PropTypes.bool]),
        rectangle: PropTypes.PropTypes.oneOfType([PropTypes.PropTypes.object, PropTypes.PropTypes.bool]),
        circle: PropTypes.PropTypes.oneOfType([PropTypes.PropTypes.object, PropTypes.PropTypes.bool]),
        marker: PropTypes.PropTypes.oneOfType([PropTypes.PropTypes.object, PropTypes.PropTypes.bool])
    }),
    edit: PropTypes.PropTypes.shape({
        edit: PropTypes.PropTypes.oneOfType([PropTypes.PropTypes.object, PropTypes.PropTypes.bool]),
        remove: PropTypes.PropTypes.oneOfType([PropTypes.PropTypes.object, PropTypes.PropTypes.bool]),
        poly: PropTypes.PropTypes.oneOfType([PropTypes.PropTypes.object, PropTypes.PropTypes.bool]),
        allowIntersection: PropTypes.PropTypes.bool
    }),
    position: PropTypes.PropTypes.oneOf(['topright', 'topleft', 'bottomright', 'bottomleft']),
    leaflet: PropTypes.PropTypes.shape({
        map: PropTypes.PropTypes.instanceOf(L$1.Map),
        layerContainer: PropTypes.PropTypes.shape({
            addLayer: PropTypes.PropTypes.func.isRequired,
            removeLayer: PropTypes.PropTypes.func.isRequired
        })
    })
}));

function createDrawElement(props) {
    var layerContainer = props.leaflet.layerContainer;
    var draw = props.draw,
        edit = props.edit,
        position = props.position;
    var options = {
        edit: _objectSpread({}, edit, {
            featureGroup: layerContainer
        })
    };

    if (draw) {
        options.draw = _objectSpread({}, draw);
    }

    if (position) {
        options.position = position;
    }

    return new L$1.Control.Draw(options);
}

var EditControl$1 = withLeaflet(EditControl);

var TYPES = {
    point: ['marker'],
    line_string: ['polyline'],
    polygon: ['polygon', 'rectangle'],
    all: ['marker', 'polyline', 'polygon', 'rectangle']
};

var FeatureImpl = /*#__PURE__*/function (_MapLayer) {
    _inherits(FeatureImpl, _MapLayer);

    var _super = _createSuper(FeatureImpl);

    function FeatureImpl() {
        _classCallCheck(this, FeatureImpl);

        return _super.apply(this, arguments);
    }

    _createClass(FeatureImpl, [{
        key: "createLeafletElement",
        value: function createLeafletElement(props) {
            return L$1.GeoJSON.geometryToLayer(props.data);
        }
    }]);

    return FeatureImpl;
}(MapLayer);

function Feature(props) {
    var leaflet = useLeaflet();
    return /*#__PURE__*/React__default['default'].createElement(FeatureImpl, _extends({
        leaflet: leaflet
    }, props));
}

function Draw(_ref) {
    var type = _ref.type,
        data = _ref.data,
        setData = _ref.setData;
    var ref = React.useRef(),
        controls = {
        polyline: false,
        polygon: false,
        rectangle: false,
        circle: false,
        marker: false,
        circlemarker: false
    },
        types = TYPES[type] || TYPES.all;
    types.forEach(function (type) {
        return controls[type] = {};
    });

    function save() {
        var _ref2 = ref && ref.current,
            leafletElement = _ref2.leafletElement;

        if (!leafletElement) {
            return;
        }

        setData(leafletElement.toGeoJSON());
    }

    return /*#__PURE__*/React__default['default'].createElement(FeatureGroup$1, {
        ref: ref
    }, /*#__PURE__*/React__default['default'].createElement(EditControl$1, {
        draw: controls,
        onCreated: save,
        onEdited: save,
        onDeleted: save
    }), data && data.features.map(function (feature, i) {
        return /*#__PURE__*/React__default['default'].createElement(Feature, {
            key: i,
            data: feature.geometry
        });
    }));
    /* FIXME
    var $submit = $geom.parents('form').find('[type=submit]');
    m.on('draw:drawstart draw:editstart draw:deletestart', function() {
        $submit.attr('disabled', true);
    });
     m.on('draw:drawstop draw:editstop draw:deletestop', function() {
        $submit.attr('disabled', false);
    });
    */
}
Draw.propTypes = {
    type: PropTypes__default['default'].string,
    data: PropTypes__default['default'].object,
    setData: PropTypes__default['default'].func
};

var index = {
    name: 'leaflet',
    dependencies: [map],
    config: {
        popups: {},
        icons: {
            default: new L__default['default'].Icon.Default()
        },
        defaults: {
            // Defaults to simplify creation of new icons of the same dimensions
            // as L.Icon.Default
            icon: {
                iconSize: [25, 41],
                iconAnchor: [12, 41],
                popupAnchor: [1, -34],
                shadowSize: [41, 41]
            }
        }
    },
    init: function init(config) {
        if (config) {
            this.config = _objectSpread2(_objectSpread2({}, this.config), config);
        }
    },
    createIcon: function createIcon(name, options) {
        return this.config.icons[name] = L__default['default'].icon(_objectSpread2(_objectSpread2({}, this.config.defaults.icon), options));
    },
    components: {
        Map: Map$3,
        Legend: Legend$1,
        BasemapToggle: BasemapToggle$1,
        OverlayToggle: OverlayToggle$1
    },
    basemaps: {
        Group: Group,
        Empty: Group,
        Tile: Tile
    },
    overlays: {
        Group: Group,
        Empty: Group,
        Geojson: Geojson,
        Highlight: Highlight,
        Draw: Draw
    }
};

return index;

});
//# sourceMappingURL=map.js.map
